require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_LIBBSM_H_)) {
    eval 'sub _LIBBSM_H_ () {1;}' unless defined(&_LIBBSM_H_);
    require 'sys/types.ph';
    require 'sys/cdefs.ph';
    require 'inttypes.ph';
    require 'time.ph';
    require 'bsm/audit.ph';
    require 'bsm/audit_record.ph';
    require 'stdio.ph';
    if(defined(&__APPLE__)) {
	require 'mach/mach.ph';
    }
    eval 'sub AUDIT_MAX_ARGS () {128;}' unless defined(&AUDIT_MAX_ARGS);
    eval 'sub AUDIT_MAX_ENV () {128;}' unless defined(&AUDIT_MAX_ENV);
    eval 'sub AU_PRS_USECACHE () {0;}' unless defined(&AU_PRS_USECACHE);
    eval 'sub AU_PRS_REREAD () {1;}' unless defined(&AU_PRS_REREAD);
    eval 'sub AU_PRS_SUCCESS () {1;}' unless defined(&AU_PRS_SUCCESS);
    eval 'sub AU_PRS_FAILURE () {2;}' unless defined(&AU_PRS_FAILURE);
    eval 'sub AU_PRS_BOTH () {( &AU_PRS_SUCCESS| &AU_PRS_FAILURE);}' unless defined(&AU_PRS_BOTH);
    eval 'sub AUDIT_EVENT_FILE () {"/etc/security/audit_event";}' unless defined(&AUDIT_EVENT_FILE);
    eval 'sub AUDIT_CLASS_FILE () {"/etc/security/audit_class";}' unless defined(&AUDIT_CLASS_FILE);
    eval 'sub AUDIT_CONTROL_FILE () {"/etc/security/audit_control";}' unless defined(&AUDIT_CONTROL_FILE);
    eval 'sub AUDIT_USER_FILE () {"/etc/security/audit_user";}' unless defined(&AUDIT_USER_FILE);
    eval 'sub DIR_CONTROL_ENTRY () {"dir";}' unless defined(&DIR_CONTROL_ENTRY);
    eval 'sub DIST_CONTROL_ENTRY () {"dist";}' unless defined(&DIST_CONTROL_ENTRY);
    eval 'sub FILESZ_CONTROL_ENTRY () {"filesz";}' unless defined(&FILESZ_CONTROL_ENTRY);
    eval 'sub FLAGS_CONTROL_ENTRY () {"flags";}' unless defined(&FLAGS_CONTROL_ENTRY);
    eval 'sub HOST_CONTROL_ENTRY () {"host";}' unless defined(&HOST_CONTROL_ENTRY);
    eval 'sub MINFREE_CONTROL_ENTRY () {"minfree";}' unless defined(&MINFREE_CONTROL_ENTRY);
    eval 'sub NA_CONTROL_ENTRY () {"naflags";}' unless defined(&NA_CONTROL_ENTRY);
    eval 'sub POLICY_CONTROL_ENTRY () {"policy";}' unless defined(&POLICY_CONTROL_ENTRY);
    eval 'sub EXPIRE_AFTER_CONTROL_ENTRY () {"expire-after";}' unless defined(&EXPIRE_AFTER_CONTROL_ENTRY);
    eval 'sub AU_CLASS_NAME_MAX () {8;}' unless defined(&AU_CLASS_NAME_MAX);
    eval 'sub AU_CLASS_DESC_MAX () {72;}' unless defined(&AU_CLASS_DESC_MAX);
    eval 'sub AU_EVENT_NAME_MAX () {30;}' unless defined(&AU_EVENT_NAME_MAX);
    eval 'sub AU_EVENT_DESC_MAX () {50;}' unless defined(&AU_EVENT_DESC_MAX);
    eval 'sub AU_USER_NAME_MAX () {50;}' unless defined(&AU_USER_NAME_MAX);
    eval 'sub AU_LINE_MAX () {256;}' unless defined(&AU_LINE_MAX);
    eval 'sub MAX_AUDITSTRING_LEN () {256;}' unless defined(&MAX_AUDITSTRING_LEN);
    eval 'sub BSM_TEXTBUFSZ () { &MAX_AUDITSTRING_LEN;}' unless defined(&BSM_TEXTBUFSZ);
    eval 'sub AU_TO_NO_WRITE () {0;}' unless defined(&AU_TO_NO_WRITE);
    eval 'sub AU_TO_WRITE () {1;}' unless defined(&AU_TO_WRITE);
    eval 'sub AU_OFLAG_NONE () {0x;}' unless defined(&AU_OFLAG_NONE);
    eval 'sub AU_OFLAG_RAW () {0x1;}' unless defined(&AU_OFLAG_RAW);
    eval 'sub AU_OFLAG_SHORT () {0x2;}' unless defined(&AU_OFLAG_SHORT);
    eval 'sub AU_OFLAG_XML () {0x4;}' unless defined(&AU_OFLAG_XML);
    eval 'sub AU_OFLAG_NORESOLVE () {0x8;}' unless defined(&AU_OFLAG_NORESOLVE);
    eval 'sub ADD_TO_MASK {
        my($m, $c, $sel) = @_;
	    eval q( &do {  &if ($sel &  &AU_PRS_SUCCESS) ($m)-> &am_success |= $c;  &if ($sel &  &AU_PRS_FAILURE) ($m)-> &am_failure |= $c; }  &while (0));
    }' unless defined(&ADD_TO_MASK);
    eval 'sub SUB_FROM_MASK {
        my($m, $c, $sel) = @_;
	    eval q( &do {  &if ($sel &  &AU_PRS_SUCCESS) ($m)-> &am_success &= (($m)-> &am_success ^ $c);  &if ($sel &  &AU_PRS_FAILURE) ($m)-> &am_failure &= (($m)-> &am_failure ^ $c); }  &while (0));
    }' unless defined(&SUB_FROM_MASK);
    eval 'sub ADDMASK {
        my($m, $v) = @_;
	    eval q( &do { ($m)-> &am_success |= ($v)-> &am_success; ($m)-> &am_failure |= ($v)-> &am_failure; }  &while(0));
    }' unless defined(&ADDMASK);
    eval 'sub SUBMASK {
        my($m, $v) = @_;
	    eval q( &do { ($m)-> &am_success &= (($m)-> &am_success ^ ($v)-> &am_success); ($m)-> &am_failure &= (($m)-> &am_failure ^ ($v)-> &am_failure); }  &while(0));
    }' unless defined(&SUBMASK);
    if(defined(&__APPLE__)) {
	require 'sys/appleapiopts.ph';
	if(defined(&__APPLE_API_PRIVATE)) {
	    eval 'sub __BSM_INTERNAL_NOTIFY_KEY () {"com.apple.audit.change";}' unless defined(&__BSM_INTERNAL_NOTIFY_KEY);
	}
	if(defined(&__APPLE_API_PRIVATE)) {
	    eval 'sub AUDIT_OFF () { &AUC_NOAUDIT;}' unless defined(&AUDIT_OFF);
	    eval 'sub AUDIT_ON () { &AUC_AUDITING;}' unless defined(&AUDIT_ON);
	}
    }
    eval("sub kAUNoErr () { 0; }") unless defined(&kAUNoErr);
    eval("sub kAUBadParamErr () { -66049; }") unless defined(&kAUBadParamErr);
    eval("sub kAUStatErr () { -66048; }") unless defined(&kAUStatErr);
    eval("sub kAUSysctlErr () { -66047; }") unless defined(&kAUSysctlErr);
    eval("sub kAUOpenErr () { -66046; }") unless defined(&kAUOpenErr);
    eval("sub kAUMakeSubjectTokErr () { -66045; }") unless defined(&kAUMakeSubjectTokErr);
    eval("sub kAUWriteSubjectTokErr () { -66044; }") unless defined(&kAUWriteSubjectTokErr);
    eval("sub kAUWriteCallerTokErr () { -66043; }") unless defined(&kAUWriteCallerTokErr);
    eval("sub kAUMakeReturnTokErr () { -66042; }") unless defined(&kAUMakeReturnTokErr);
    eval("sub kAUWriteReturnTokErr () { -66041; }") unless defined(&kAUWriteReturnTokErr);
    eval("sub kAUCloseErr () { -66040; }") unless defined(&kAUCloseErr);
    eval("sub kAUMakeTextTokErr () { -66039; }") unless defined(&kAUMakeTextTokErr);
    eval("sub kAULastErr () { -66038; }") unless defined(&kAULastErr);
    if(defined(&__APPLE__)) {
	if(defined(&__APPLE_API_PRIVATE)) {
	    eval 'sub AU_UNIMPL () { &NOTIFY_STATUS_FAILED + 1;}' unless defined(&AU_UNIMPL);
	}
    }
    if(defined(&__APPLE__)) {
    }
}
1;
