require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_CAM_CAM_PERIPH_H)) {
    eval 'sub _CAM_CAM_PERIPH_H () {1;}' unless defined(&_CAM_CAM_PERIPH_H);
    require 'sys/queue.ph';
    require 'cam/cam_sim.ph';
    if(defined(&_KERNEL)) {
	require 'sys/taskqueue.ph';
	require 'cam/cam_xpt.ph';
	require 'sys/module.ph';
	eval 'sub PERIPHDRIVER_DECLARE {
	    my($name, $driver) = @_;
    	    eval q( &static \'int\' $name   &_modevent( &module_t  &mod, \'int\'  &type,  &void * &data) {  &switch ( &type) {  &case  &MOD_LOAD:  &periphdriver_register( &data);  &break;  &case  &MOD_UNLOAD:  &return ( &periphdriver_unregister( &data));  &default:  &return  &EOPNOTSUPP; }  &return 0; }  &static  &moduledata_t $name   &_mod = { $name, $name   &_modevent, ( &void *)$driver };  &DECLARE_MODULE($name, $name   &_mod,  &SI_SUB_DRIVERS,  &SI_ORDER_ANY);  &MODULE_DEPEND($name,  &cam, 1, 1, 1));
	}' unless defined(&PERIPHDRIVER_DECLARE);
	eval 'sub CAM_PERIPH_DRV_EARLY () {0x1;}' unless defined(&CAM_PERIPH_DRV_EARLY);
	eval("sub CAM_PERIPH_BIO () { 0; }") unless defined(&CAM_PERIPH_BIO);
	eval 'sub ppriv_ptr0 () { ($periph_priv->{entries[0]}->{ptr});}' unless defined(&ppriv_ptr0);
	eval 'sub ppriv_ptr1 () { ($periph_priv->{entries[1]}->{ptr});}' unless defined(&ppriv_ptr1);
	eval 'sub ppriv_field0 () { ($periph_priv->{entries[0]}->{field});}' unless defined(&ppriv_field0);
	eval 'sub ppriv_field1 () { ($periph_priv->{entries[1]}->{field});}' unless defined(&ppriv_field1);
	eval 'sub CAM_PERIPH_RUNNING () {0x1;}' unless defined(&CAM_PERIPH_RUNNING);
	eval 'sub CAM_PERIPH_LOCKED () {0x2;}' unless defined(&CAM_PERIPH_LOCKED);
	eval 'sub CAM_PERIPH_LOCK_WANTED () {0x4;}' unless defined(&CAM_PERIPH_LOCK_WANTED);
	eval 'sub CAM_PERIPH_INVALID () {0x8;}' unless defined(&CAM_PERIPH_INVALID);
	eval 'sub CAM_PERIPH_NEW_DEV_FOUND () {0x10;}' unless defined(&CAM_PERIPH_NEW_DEV_FOUND);
	eval 'sub CAM_PERIPH_RECOVERY_INPROG () {0x20;}' unless defined(&CAM_PERIPH_RECOVERY_INPROG);
	eval 'sub CAM_PERIPH_RUN_TASK () {0x40;}' unless defined(&CAM_PERIPH_RUN_TASK);
	eval 'sub CAM_PERIPH_FREE () {0x80;}' unless defined(&CAM_PERIPH_FREE);
	eval 'sub CAM_PERIPH_ANNOUNCED () {0x100;}' unless defined(&CAM_PERIPH_ANNOUNCED);
	eval 'sub CAM_PERIPH_MAXMAPS () {2;}' unless defined(&CAM_PERIPH_MAXMAPS);
	eval 'sub cam_periph_mtx {
	    my($periph) = @_;
    	    eval q({ ( &xpt_path_mtx( ($periph->{path}))); });
	}' unless defined(&cam_periph_mtx);
	eval 'sub cam_periph_owned {
	    my($periph) = @_;
    	    eval q( &mtx_owned( &xpt_path_mtx(($periph)-> &path)));
	}' unless defined(&cam_periph_owned);
	eval 'sub cam_periph_lock {
	    my($periph) = @_;
    	    eval q( &mtx_lock( &xpt_path_mtx(($periph)-> &path)));
	}' unless defined(&cam_periph_lock);
	eval 'sub cam_periph_unlock {
	    my($periph) = @_;
    	    eval q( &mtx_unlock( &xpt_path_mtx(($periph)-> &path)));
	}' unless defined(&cam_periph_unlock);
	eval 'sub cam_periph_assert {
	    my($periph, $what) = @_;
    	    eval q( &mtx_assert( &xpt_path_mtx(($periph)-> &path), ($what)));
	}' unless defined(&cam_periph_assert);
	eval 'sub cam_periph_sleep {
	    my($periph, $chan, $priority, $wmesg, $timo) = @_;
    	    eval q( &xpt_path_sleep(($periph)-> &path, ($chan), ($priority), ($wmesg), ($timo)));
	}' unless defined(&cam_periph_sleep);
	eval 'sub cam_periph_acquire_first {
	    my($driver) = @_;
    	    eval q({ \'struct cam_periph\' * &periph;  &xpt_lock_buses();  &periph =  &TAILQ_FIRST( ($driver->{units}));  &while ( &periph !=  &NULL  && ( ($periph->{flags}) &  &CAM_PERIPH_INVALID) != 0)  &periph =  &TAILQ_NEXT( &periph,  &unit_links);  &if ( &periph !=  &NULL)  ($periph->{refcount})++;  &xpt_unlock_buses(); ( &periph); });
	}' unless defined(&cam_periph_acquire_first);
	eval 'sub cam_periph_acquire_next {
	    my($pperiph) = @_;
    	    eval q({ \'struct cam_periph\' * &periph = $pperiph;  &cam_periph_assert($pperiph,  &MA_NOTOWNED);  &xpt_lock_buses();  &do {  &periph =  &TAILQ_NEXT( &periph,  &unit_links); }  &while ( &periph !=  &NULL  && ( ($periph->{flags}) &  &CAM_PERIPH_INVALID) != 0);  &if ( &periph !=  &NULL)  ($periph->{refcount})++;  &xpt_unlock_buses();  &cam_periph_release($pperiph); ( &periph); });
	}' unless defined(&cam_periph_acquire_next);
	eval 'sub CAM_PERIPH_FOREACH {
	    my($periph, $driver) = @_;
    	    eval q( &for (($periph) =  &cam_periph_acquire_first($driver); ($periph) !=  &NULL; ($periph) =  &cam_periph_acquire_next($periph)));
	}' unless defined(&CAM_PERIPH_FOREACH);
    }
}
1;
