require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_CRYPTO_CRYPTO_H_)) {
    eval 'sub _CRYPTO_CRYPTO_H_ () {1;}' unless defined(&_CRYPTO_CRYPTO_H_);
    require 'sys/ioccom.ph';
    eval 'sub CRYPTO_DRIVERS_INITIAL () {4;}' unless defined(&CRYPTO_DRIVERS_INITIAL);
    eval 'sub CRYPTO_SW_SESSIONS () {32;}' unless defined(&CRYPTO_SW_SESSIONS);
    eval 'sub NULL_HASH_LEN () {16;}' unless defined(&NULL_HASH_LEN);
    eval 'sub MD5_HASH_LEN () {16;}' unless defined(&MD5_HASH_LEN);
    eval 'sub SHA1_HASH_LEN () {20;}' unless defined(&SHA1_HASH_LEN);
    eval 'sub RIPEMD160_HASH_LEN () {20;}' unless defined(&RIPEMD160_HASH_LEN);
    eval 'sub SHA2_256_HASH_LEN () {32;}' unless defined(&SHA2_256_HASH_LEN);
    eval 'sub SHA2_384_HASH_LEN () {48;}' unless defined(&SHA2_384_HASH_LEN);
    eval 'sub SHA2_512_HASH_LEN () {64;}' unless defined(&SHA2_512_HASH_LEN);
    eval 'sub MD5_KPDK_HASH_LEN () {16;}' unless defined(&MD5_KPDK_HASH_LEN);
    eval 'sub SHA1_KPDK_HASH_LEN () {20;}' unless defined(&SHA1_KPDK_HASH_LEN);
    eval 'sub AES_GMAC_HASH_LEN () {16;}' unless defined(&AES_GMAC_HASH_LEN);
    eval 'sub HASH_MAX_LEN () { &SHA2_512_HASH_LEN;}' unless defined(&HASH_MAX_LEN);
    eval 'sub NULL_HMAC_BLOCK_LEN () {64;}' unless defined(&NULL_HMAC_BLOCK_LEN);
    eval 'sub MD5_HMAC_BLOCK_LEN () {64;}' unless defined(&MD5_HMAC_BLOCK_LEN);
    eval 'sub SHA1_HMAC_BLOCK_LEN () {64;}' unless defined(&SHA1_HMAC_BLOCK_LEN);
    eval 'sub RIPEMD160_HMAC_BLOCK_LEN () {64;}' unless defined(&RIPEMD160_HMAC_BLOCK_LEN);
    eval 'sub SHA2_256_HMAC_BLOCK_LEN () {64;}' unless defined(&SHA2_256_HMAC_BLOCK_LEN);
    eval 'sub SHA2_384_HMAC_BLOCK_LEN () {128;}' unless defined(&SHA2_384_HMAC_BLOCK_LEN);
    eval 'sub SHA2_512_HMAC_BLOCK_LEN () {128;}' unless defined(&SHA2_512_HMAC_BLOCK_LEN);
    eval 'sub HMAC_MAX_BLOCK_LEN () { &SHA2_512_HMAC_BLOCK_LEN;}' unless defined(&HMAC_MAX_BLOCK_LEN);
    eval 'sub HMAC_IPAD_VAL () {0x36;}' unless defined(&HMAC_IPAD_VAL);
    eval 'sub HMAC_OPAD_VAL () {0x5c;}' unless defined(&HMAC_OPAD_VAL);
    eval 'sub NULL_HMAC_KEY_LEN () {0;}' unless defined(&NULL_HMAC_KEY_LEN);
    eval 'sub MD5_HMAC_KEY_LEN () {16;}' unless defined(&MD5_HMAC_KEY_LEN);
    eval 'sub SHA1_HMAC_KEY_LEN () {20;}' unless defined(&SHA1_HMAC_KEY_LEN);
    eval 'sub RIPEMD160_HMAC_KEY_LEN () {20;}' unless defined(&RIPEMD160_HMAC_KEY_LEN);
    eval 'sub SHA2_256_HMAC_KEY_LEN () {32;}' unless defined(&SHA2_256_HMAC_KEY_LEN);
    eval 'sub SHA2_384_HMAC_KEY_LEN () {48;}' unless defined(&SHA2_384_HMAC_KEY_LEN);
    eval 'sub SHA2_512_HMAC_KEY_LEN () {64;}' unless defined(&SHA2_512_HMAC_KEY_LEN);
    eval 'sub AES_128_GMAC_KEY_LEN () {16;}' unless defined(&AES_128_GMAC_KEY_LEN);
    eval 'sub AES_192_GMAC_KEY_LEN () {24;}' unless defined(&AES_192_GMAC_KEY_LEN);
    eval 'sub AES_256_GMAC_KEY_LEN () {32;}' unless defined(&AES_256_GMAC_KEY_LEN);
    eval 'sub NULL_BLOCK_LEN () {4;}' unless defined(&NULL_BLOCK_LEN);
    eval 'sub DES_BLOCK_LEN () {8;}' unless defined(&DES_BLOCK_LEN);
    eval 'sub DES3_BLOCK_LEN () {8;}' unless defined(&DES3_BLOCK_LEN);
    eval 'sub BLOWFISH_BLOCK_LEN () {8;}' unless defined(&BLOWFISH_BLOCK_LEN);
    eval 'sub SKIPJACK_BLOCK_LEN () {8;}' unless defined(&SKIPJACK_BLOCK_LEN);
    eval 'sub CAST128_BLOCK_LEN () {8;}' unless defined(&CAST128_BLOCK_LEN);
    eval 'sub RIJNDAEL128_BLOCK_LEN () {16;}' unless defined(&RIJNDAEL128_BLOCK_LEN);
    eval 'sub AES_BLOCK_LEN () {16;}' unless defined(&AES_BLOCK_LEN);
    eval 'sub AES_ICM_BLOCK_LEN () {1;}' unless defined(&AES_ICM_BLOCK_LEN);
    eval 'sub ARC4_BLOCK_LEN () {1;}' unless defined(&ARC4_BLOCK_LEN);
    eval 'sub CAMELLIA_BLOCK_LEN () {16;}' unless defined(&CAMELLIA_BLOCK_LEN);
    eval 'sub EALG_MAX_BLOCK_LEN () { &AES_BLOCK_LEN;}' unless defined(&EALG_MAX_BLOCK_LEN);
    eval 'sub ARC4_IV_LEN () {1;}' unless defined(&ARC4_IV_LEN);
    eval 'sub AES_GCM_IV_LEN () {12;}' unless defined(&AES_GCM_IV_LEN);
    eval 'sub AES_XTS_IV_LEN () {8;}' unless defined(&AES_XTS_IV_LEN);
    eval 'sub AES_XTS_ALPHA () {0x87;}' unless defined(&AES_XTS_ALPHA);
    eval 'sub NULL_MIN_KEY () {0;}' unless defined(&NULL_MIN_KEY);
    eval 'sub NULL_MAX_KEY () {256;}' unless defined(&NULL_MAX_KEY);
    eval 'sub DES_MIN_KEY () {8;}' unless defined(&DES_MIN_KEY);
    eval 'sub DES_MAX_KEY () { &DES_MIN_KEY;}' unless defined(&DES_MAX_KEY);
    eval 'sub TRIPLE_DES_MIN_KEY () {24;}' unless defined(&TRIPLE_DES_MIN_KEY);
    eval 'sub TRIPLE_DES_MAX_KEY () { &TRIPLE_DES_MIN_KEY;}' unless defined(&TRIPLE_DES_MAX_KEY);
    eval 'sub BLOWFISH_MIN_KEY () {5;}' unless defined(&BLOWFISH_MIN_KEY);
    eval 'sub BLOWFISH_MAX_KEY () {56;}' unless defined(&BLOWFISH_MAX_KEY);
    eval 'sub CAST_MIN_KEY () {5;}' unless defined(&CAST_MIN_KEY);
    eval 'sub CAST_MAX_KEY () {16;}' unless defined(&CAST_MAX_KEY);
    eval 'sub SKIPJACK_MIN_KEY () {10;}' unless defined(&SKIPJACK_MIN_KEY);
    eval 'sub SKIPJACK_MAX_KEY () { &SKIPJACK_MIN_KEY;}' unless defined(&SKIPJACK_MAX_KEY);
    eval 'sub RIJNDAEL_MIN_KEY () {16;}' unless defined(&RIJNDAEL_MIN_KEY);
    eval 'sub RIJNDAEL_MAX_KEY () {32;}' unless defined(&RIJNDAEL_MAX_KEY);
    eval 'sub AES_MIN_KEY () { &RIJNDAEL_MIN_KEY;}' unless defined(&AES_MIN_KEY);
    eval 'sub AES_MAX_KEY () { &RIJNDAEL_MAX_KEY;}' unless defined(&AES_MAX_KEY);
    eval 'sub AES_XTS_MIN_KEY () {(2*  &AES_MIN_KEY);}' unless defined(&AES_XTS_MIN_KEY);
    eval 'sub AES_XTS_MAX_KEY () {(2*  &AES_MAX_KEY);}' unless defined(&AES_XTS_MAX_KEY);
    eval 'sub ARC4_MIN_KEY () {1;}' unless defined(&ARC4_MIN_KEY);
    eval 'sub ARC4_MAX_KEY () {32;}' unless defined(&ARC4_MAX_KEY);
    eval 'sub CAMELLIA_MIN_KEY () {8;}' unless defined(&CAMELLIA_MIN_KEY);
    eval 'sub CAMELLIA_MAX_KEY () {32;}' unless defined(&CAMELLIA_MAX_KEY);
    eval 'sub AALG_MAX_RESULT_LEN () {64;}' unless defined(&AALG_MAX_RESULT_LEN);
    eval 'sub CRYPTO_ALGORITHM_MIN () {1;}' unless defined(&CRYPTO_ALGORITHM_MIN);
    eval 'sub CRYPTO_DES_CBC () {1;}' unless defined(&CRYPTO_DES_CBC);
    eval 'sub CRYPTO_3DES_CBC () {2;}' unless defined(&CRYPTO_3DES_CBC);
    eval 'sub CRYPTO_BLF_CBC () {3;}' unless defined(&CRYPTO_BLF_CBC);
    eval 'sub CRYPTO_CAST_CBC () {4;}' unless defined(&CRYPTO_CAST_CBC);
    eval 'sub CRYPTO_SKIPJACK_CBC () {5;}' unless defined(&CRYPTO_SKIPJACK_CBC);
    eval 'sub CRYPTO_MD5_HMAC () {6;}' unless defined(&CRYPTO_MD5_HMAC);
    eval 'sub CRYPTO_SHA1_HMAC () {7;}' unless defined(&CRYPTO_SHA1_HMAC);
    eval 'sub CRYPTO_RIPEMD160_HMAC () {8;}' unless defined(&CRYPTO_RIPEMD160_HMAC);
    eval 'sub CRYPTO_MD5_KPDK () {9;}' unless defined(&CRYPTO_MD5_KPDK);
    eval 'sub CRYPTO_SHA1_KPDK () {10;}' unless defined(&CRYPTO_SHA1_KPDK);
    eval 'sub CRYPTO_RIJNDAEL128_CBC () {11;}' unless defined(&CRYPTO_RIJNDAEL128_CBC);
    eval 'sub CRYPTO_AES_CBC () {11;}' unless defined(&CRYPTO_AES_CBC);
    eval 'sub CRYPTO_ARC4 () {12;}' unless defined(&CRYPTO_ARC4);
    eval 'sub CRYPTO_MD5 () {13;}' unless defined(&CRYPTO_MD5);
    eval 'sub CRYPTO_SHA1 () {14;}' unless defined(&CRYPTO_SHA1);
    eval 'sub CRYPTO_NULL_HMAC () {15;}' unless defined(&CRYPTO_NULL_HMAC);
    eval 'sub CRYPTO_NULL_CBC () {16;}' unless defined(&CRYPTO_NULL_CBC);
    eval 'sub CRYPTO_DEFLATE_COMP () {17;}' unless defined(&CRYPTO_DEFLATE_COMP);
    eval 'sub CRYPTO_SHA2_256_HMAC () {18;}' unless defined(&CRYPTO_SHA2_256_HMAC);
    eval 'sub CRYPTO_SHA2_384_HMAC () {19;}' unless defined(&CRYPTO_SHA2_384_HMAC);
    eval 'sub CRYPTO_SHA2_512_HMAC () {20;}' unless defined(&CRYPTO_SHA2_512_HMAC);
    eval 'sub CRYPTO_CAMELLIA_CBC () {21;}' unless defined(&CRYPTO_CAMELLIA_CBC);
    eval 'sub CRYPTO_AES_XTS () {22;}' unless defined(&CRYPTO_AES_XTS);
    eval 'sub CRYPTO_AES_ICM () {23;}' unless defined(&CRYPTO_AES_ICM);
    eval 'sub CRYPTO_AES_NIST_GMAC () {24;}' unless defined(&CRYPTO_AES_NIST_GMAC);
    eval 'sub CRYPTO_AES_NIST_GCM_16 () {25;}' unless defined(&CRYPTO_AES_NIST_GCM_16);
    eval 'sub CRYPTO_AES_128_NIST_GMAC () {26;}' unless defined(&CRYPTO_AES_128_NIST_GMAC);
    eval 'sub CRYPTO_AES_192_NIST_GMAC () {27;}' unless defined(&CRYPTO_AES_192_NIST_GMAC);
    eval 'sub CRYPTO_AES_256_NIST_GMAC () {28;}' unless defined(&CRYPTO_AES_256_NIST_GMAC);
    eval 'sub CRYPTO_ALGORITHM_MAX () {28;}' unless defined(&CRYPTO_ALGORITHM_MAX);
    eval 'sub CRYPTO_ALGO_VALID {
        my($x) = @_;
	    eval q((($x) >=  &CRYPTO_ALGORITHM_MIN  && ($x) <=  &CRYPTO_ALGORITHM_MAX));
    }' unless defined(&CRYPTO_ALGO_VALID);
    eval 'sub CRYPTO_ALG_FLAG_SUPPORTED () {0x1;}' unless defined(&CRYPTO_ALG_FLAG_SUPPORTED);
    eval 'sub CRYPTO_ALG_FLAG_RNG_ENABLE () {0x2;}' unless defined(&CRYPTO_ALG_FLAG_RNG_ENABLE);
    eval 'sub CRYPTO_ALG_FLAG_DSA_SHA () {0x4;}' unless defined(&CRYPTO_ALG_FLAG_DSA_SHA);
    eval 'sub CRYPTO_FLAG_HARDWARE () {0x1000000;}' unless defined(&CRYPTO_FLAG_HARDWARE);
    eval 'sub CRYPTO_FLAG_SOFTWARE () {0x2000000;}' unless defined(&CRYPTO_FLAG_SOFTWARE);
    eval 'sub COP_ENCRYPT () {1;}' unless defined(&COP_ENCRYPT);
    eval 'sub COP_DECRYPT () {2;}' unless defined(&COP_DECRYPT);
    eval 'sub COP_F_BATCH () {0x8;}' unless defined(&COP_F_BATCH);
    eval 'sub CRK_MAXPARAM () {8;}' unless defined(&CRK_MAXPARAM);
    eval 'sub CRK_ALGORITM_MIN () {0;}' unless defined(&CRK_ALGORITM_MIN);
    eval 'sub CRK_MOD_EXP () {0;}' unless defined(&CRK_MOD_EXP);
    eval 'sub CRK_MOD_EXP_CRT () {1;}' unless defined(&CRK_MOD_EXP_CRT);
    eval 'sub CRK_DSA_SIGN () {2;}' unless defined(&CRK_DSA_SIGN);
    eval 'sub CRK_DSA_VERIFY () {3;}' unless defined(&CRK_DSA_VERIFY);
    eval 'sub CRK_DH_COMPUTE_KEY () {4;}' unless defined(&CRK_DH_COMPUTE_KEY);
    eval 'sub CRK_ALGORITHM_MAX () {4;}' unless defined(&CRK_ALGORITHM_MAX);
    eval 'sub CRF_MOD_EXP () {(1<<  &CRK_MOD_EXP);}' unless defined(&CRF_MOD_EXP);
    eval 'sub CRF_MOD_EXP_CRT () {(1<<  &CRK_MOD_EXP_CRT);}' unless defined(&CRF_MOD_EXP_CRT);
    eval 'sub CRF_DSA_SIGN () {(1<<  &CRK_DSA_SIGN);}' unless defined(&CRF_DSA_SIGN);
    eval 'sub CRF_DSA_VERIFY () {(1<<  &CRK_DSA_VERIFY);}' unless defined(&CRF_DSA_VERIFY);
    eval 'sub CRF_DH_COMPUTE_KEY () {(1<<  &CRK_DH_COMPUTE_KEY);}' unless defined(&CRF_DH_COMPUTE_KEY);
    eval 'sub CRIOGET () { &_IOWR(ord(\'c\'), 100,  &u_int32_t);}' unless defined(&CRIOGET);
    eval 'sub CRIOASYMFEAT () { &CIOCASYMFEAT;}' unless defined(&CRIOASYMFEAT);
    eval 'sub CRIOFINDDEV () { &CIOCFINDDEV;}' unless defined(&CRIOFINDDEV);
    eval 'sub CIOCGSESSION () { &_IOWR(ord(\'c\'), 101, \'struct session_op\');}' unless defined(&CIOCGSESSION);
    eval 'sub CIOCFSESSION () { &_IOW(ord(\'c\'), 102,  &u_int32_t);}' unless defined(&CIOCFSESSION);
    eval 'sub CIOCCRYPT () { &_IOWR(ord(\'c\'), 103, \'struct crypt_op\');}' unless defined(&CIOCCRYPT);
    eval 'sub CIOCKEY () { &_IOWR(ord(\'c\'), 104, \'struct crypt_kop\');}' unless defined(&CIOCKEY);
    eval 'sub CIOCASYMFEAT () { &_IOR(ord(\'c\'), 105,  &u_int32_t);}' unless defined(&CIOCASYMFEAT);
    eval 'sub CIOCGSESSION2 () { &_IOWR(ord(\'c\'), 106, \'struct session2_op\');}' unless defined(&CIOCGSESSION2);
    eval 'sub CIOCKEY2 () { &_IOWR(ord(\'c\'), 107, \'struct crypt_kop\');}' unless defined(&CIOCKEY2);
    eval 'sub CIOCFINDDEV () { &_IOWR(ord(\'c\'), 108, \'struct crypt_find_op\');}' unless defined(&CIOCFINDDEV);
    eval 'sub CIOCCRYPTAEAD () { &_IOWR(ord(\'c\'), 109, \'struct crypt_aead\');}' unless defined(&CIOCCRYPTAEAD);
    if(defined(&_KERNEL)) {
	if(0) {
	    eval 'sub CRYPTDEB {
	        my($s) = @_;
    		eval q( &do {  &printf(\\"%s:%d: %s\\\\n\\",  &__FILE__,  &__LINE__, $s); }  &while (0));
	    }' unless defined(&CRYPTDEB);
	} else {
	    eval 'sub CRYPTDEB {
	        my($s) = @_;
    		eval q( &do { }  &while (0));
	    }' unless defined(&CRYPTDEB);
	}
	eval 'sub CRD_F_ENCRYPT () {0x1;}' unless defined(&CRD_F_ENCRYPT);
	eval 'sub CRD_F_IV_PRESENT () {0x2;}' unless defined(&CRD_F_IV_PRESENT);
	eval 'sub CRD_F_IV_EXPLICIT () {0x4;}' unless defined(&CRD_F_IV_EXPLICIT);
	eval 'sub CRD_F_DSA_SHA_NEEDED () {0x8;}' unless defined(&CRD_F_DSA_SHA_NEEDED);
	eval 'sub CRD_F_COMP () {0xf;}' unless defined(&CRD_F_COMP);
	eval 'sub CRD_F_KEY_EXPLICIT () {0x10;}' unless defined(&CRD_F_KEY_EXPLICIT);
	eval 'sub crd_esn () { ($CRD_INI->{cri_esn});}' unless defined(&crd_esn);
	eval 'sub crd_iv () { ($CRD_INI->{cri_iv});}' unless defined(&crd_iv);
	eval 'sub crd_key () { ($CRD_INI->{cri_key});}' unless defined(&crd_key);
	eval 'sub crd_alg () { ($CRD_INI->{cri_alg});}' unless defined(&crd_alg);
	eval 'sub crd_klen () { ($CRD_INI->{cri_klen});}' unless defined(&crd_klen);
	eval 'sub CRYPTO_F_IMBUF () {0x1;}' unless defined(&CRYPTO_F_IMBUF);
	eval 'sub CRYPTO_F_IOV () {0x2;}' unless defined(&CRYPTO_F_IOV);
	eval 'sub CRYPTO_F_BATCH () {0x8;}' unless defined(&CRYPTO_F_BATCH);
	eval 'sub CRYPTO_F_CBIMM () {0x10;}' unless defined(&CRYPTO_F_CBIMM);
	eval 'sub CRYPTO_F_DONE () {0x20;}' unless defined(&CRYPTO_F_DONE);
	eval 'sub CRYPTO_F_CBIFSYNC () {0x40;}' unless defined(&CRYPTO_F_CBIFSYNC);
	eval 'sub CRYPTO_BUF_CONTIG () {0x;}' unless defined(&CRYPTO_BUF_CONTIG);
	eval 'sub CRYPTO_BUF_IOV () {0x1;}' unless defined(&CRYPTO_BUF_IOV);
	eval 'sub CRYPTO_BUF_MBUF () {0x2;}' unless defined(&CRYPTO_BUF_MBUF);
	eval 'sub CRYPTO_OP_DECRYPT () {0x;}' unless defined(&CRYPTO_OP_DECRYPT);
	eval 'sub CRYPTO_OP_ENCRYPT () {0x1;}' unless defined(&CRYPTO_OP_ENCRYPT);
	eval 'sub CRYPTO_HINT_MORE () {0x1;}' unless defined(&CRYPTO_HINT_MORE);
	eval 'sub CRYPTO_SESID2HID {
	    my($_sid) = @_;
    	    eval q(((($_sid) >> 32) & 0xffffff));
	}' unless defined(&CRYPTO_SESID2HID);
	eval 'sub CRYPTO_SESID2CAPS {
	    my($_sid) = @_;
    	    eval q(((($_sid) >> 32) & 0xff000000));
	}' unless defined(&CRYPTO_SESID2CAPS);
	eval 'sub CRYPTO_SESID2LID {
	    my($_sid) = @_;
    	    eval q(((( &u_int32_t) ($_sid)) & 0xffffffff));
	}' unless defined(&CRYPTO_SESID2LID);
	eval 'sub CRYPTOCAP_F_HARDWARE () { &CRYPTO_FLAG_HARDWARE;}' unless defined(&CRYPTOCAP_F_HARDWARE);
	eval 'sub CRYPTOCAP_F_SOFTWARE () { &CRYPTO_FLAG_SOFTWARE;}' unless defined(&CRYPTOCAP_F_SOFTWARE);
	eval 'sub CRYPTOCAP_F_SYNC () {0x4000000;}' unless defined(&CRYPTOCAP_F_SYNC);
	eval 'sub CRYPTO_SYMQ () {0x1;}' unless defined(&CRYPTO_SYMQ);
	eval 'sub CRYPTO_ASYMQ () {0x2;}' unless defined(&CRYPTO_ASYMQ);
    }
}
1;
