require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_GFMULT_H_)) {
    eval 'sub _GFMULT_H_ () {1;}' unless defined(&_GFMULT_H_);
    if(defined(&__APPLE__)) {
	eval 'sub __aligned {
	    my($x) = @_;
    	    eval q( &__attribute__(( &__aligned__($x))));
	}' unless defined(&__aligned);
	eval 'sub be64dec {
	    my($buf) = @_;
    	    eval q( &__builtin_bswap64(*( &uint64_t *)$buf));
	}' unless defined(&be64dec);
	eval 'sub be64enc {
	    my($buf, $x) = @_;
    	    eval q((*( &uint64_t *)$buf =  &__builtin_bswap64($x)));
	}' unless defined(&be64enc);
    } else {
	require 'sys/endian.ph';
    }
    if(defined(&_KERNEL)) {
	require 'sys/types.ph';
    } else {
	require 'stdint.ph';
	require 'strings.ph';
    }
    eval 'sub REQ_ALIGN () {(16* 4);}' unless defined(&REQ_ALIGN);
    eval 'sub MAKE_GF128 {
        my($a, $b) = @_;
	    eval q(({. &v = { ($a), ($b) } }));
    }' unless defined(&MAKE_GF128);
    eval 'sub GF128_EQ {
        my($a, $b) = @_;
	    eval q((((($a). $v[0] ^ ($b). $v[0]) | (($a). $v[1] ^ ($b). $v[1])) == 0));
    }' unless defined(&GF128_EQ);
    eval 'sub gf128_read {
        my($buf) = @_;
	    eval q({ \'struct gf128\'  &r;  ($r->{v[0]}) =  &be64dec($buf); $buf += $sizeof{ &uint64_t};  ($r->{v[1]}) =  &be64dec($buf);  &r; });
    }' unless defined(&gf128_read);
    eval 'sub gf128_write {
        my($v,$buf) = @_;
	    eval q({  &uint64_t  &tmp;  &be64enc($buf,  ($v->{v[0]})); $buf +=  &sizeof  &tmp;  &be64enc($buf,  ($v->{v[1]})); });
    }' unless defined(&gf128_write);
    eval 'sub gf128_add {
        my($a,$b) = @_;
	    eval q({  ($a->{v[0]}) ^=  ($b->{v[0]});  ($a->{v[1]}) ^=  ($b->{v[1]}); $a; });
    }' unless defined(&gf128_add);
}
1;
