require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&MPI_H)) {
    eval 'sub MPI_H () {1;}' unless defined(&MPI_H);
    eval 'sub MPI_VERSION_MAJOR () {(0x1);}' unless defined(&MPI_VERSION_MAJOR);
    eval 'sub MPI_VERSION_MINOR () {(0x5);}' unless defined(&MPI_VERSION_MINOR);
    eval 'sub MPI_VERSION_MAJOR_MASK () {(0xff00);}' unless defined(&MPI_VERSION_MAJOR_MASK);
    eval 'sub MPI_VERSION_MAJOR_SHIFT () {(8);}' unless defined(&MPI_VERSION_MAJOR_SHIFT);
    eval 'sub MPI_VERSION_MINOR_MASK () {(0xff);}' unless defined(&MPI_VERSION_MINOR_MASK);
    eval 'sub MPI_VERSION_MINOR_SHIFT () {(0);}' unless defined(&MPI_VERSION_MINOR_SHIFT);
    eval 'sub MPI_VERSION () {(( &MPI_VERSION_MAJOR <<  &MPI_VERSION_MAJOR_SHIFT) |  &MPI_VERSION_MINOR);}' unless defined(&MPI_VERSION);
    eval 'sub MPI_VERSION_01_00 () {(0x100);}' unless defined(&MPI_VERSION_01_00);
    eval 'sub MPI_VERSION_01_01 () {(0x101);}' unless defined(&MPI_VERSION_01_01);
    eval 'sub MPI_VERSION_01_02 () {(0x102);}' unless defined(&MPI_VERSION_01_02);
    eval 'sub MPI_VERSION_01_03 () {(0x103);}' unless defined(&MPI_VERSION_01_03);
    eval 'sub MPI_VERSION_01_05 () {(0x105);}' unless defined(&MPI_VERSION_01_05);
    eval 'sub MPI_HEADER_VERSION_UNIT () {(0x14);}' unless defined(&MPI_HEADER_VERSION_UNIT);
    eval 'sub MPI_HEADER_VERSION_DEV () {(0x);}' unless defined(&MPI_HEADER_VERSION_DEV);
    eval 'sub MPI_HEADER_VERSION_UNIT_MASK () {(0xff00);}' unless defined(&MPI_HEADER_VERSION_UNIT_MASK);
    eval 'sub MPI_HEADER_VERSION_UNIT_SHIFT () {(8);}' unless defined(&MPI_HEADER_VERSION_UNIT_SHIFT);
    eval 'sub MPI_HEADER_VERSION_DEV_MASK () {(0xff);}' unless defined(&MPI_HEADER_VERSION_DEV_MASK);
    eval 'sub MPI_HEADER_VERSION_DEV_SHIFT () {(0);}' unless defined(&MPI_HEADER_VERSION_DEV_SHIFT);
    eval 'sub MPI_HEADER_VERSION () {(( &MPI_HEADER_VERSION_UNIT << 8) |  &MPI_HEADER_VERSION_DEV);}' unless defined(&MPI_HEADER_VERSION);
    eval 'sub MPI_IOC_STATE_RESET () {(0x);}' unless defined(&MPI_IOC_STATE_RESET);
    eval 'sub MPI_IOC_STATE_READY () {(0x10000000);}' unless defined(&MPI_IOC_STATE_READY);
    eval 'sub MPI_IOC_STATE_OPERATIONAL () {(0x20000000);}' unless defined(&MPI_IOC_STATE_OPERATIONAL);
    eval 'sub MPI_IOC_STATE_FAULT () {(0x40000000);}' unless defined(&MPI_IOC_STATE_FAULT);
    eval 'sub MPI_IOC_STATE_MASK () {(0xf0000000);}' unless defined(&MPI_IOC_STATE_MASK);
    eval 'sub MPI_IOC_STATE_SHIFT () {(28);}' unless defined(&MPI_IOC_STATE_SHIFT);
    eval 'sub MPI_FAULT_REQUEST_MESSAGE_PCI_PARITY_ERROR () {(0x8111);}' unless defined(&MPI_FAULT_REQUEST_MESSAGE_PCI_PARITY_ERROR);
    eval 'sub MPI_FAULT_REQUEST_MESSAGE_PCI_BUS_FAULT () {(0x8112);}' unless defined(&MPI_FAULT_REQUEST_MESSAGE_PCI_BUS_FAULT);
    eval 'sub MPI_FAULT_REPLY_MESSAGE_PCI_PARITY_ERROR () {(0x8113);}' unless defined(&MPI_FAULT_REPLY_MESSAGE_PCI_PARITY_ERROR);
    eval 'sub MPI_FAULT_REPLY_MESSAGE_PCI_BUS_FAULT () {(0x8114);}' unless defined(&MPI_FAULT_REPLY_MESSAGE_PCI_BUS_FAULT);
    eval 'sub MPI_FAULT_DATA_SEND_PCI_PARITY_ERROR () {(0x8115);}' unless defined(&MPI_FAULT_DATA_SEND_PCI_PARITY_ERROR);
    eval 'sub MPI_FAULT_DATA_SEND_PCI_BUS_FAULT () {(0x8116);}' unless defined(&MPI_FAULT_DATA_SEND_PCI_BUS_FAULT);
    eval 'sub MPI_FAULT_DATA_RECEIVE_PCI_PARITY_ERROR () {(0x8117);}' unless defined(&MPI_FAULT_DATA_RECEIVE_PCI_PARITY_ERROR);
    eval 'sub MPI_FAULT_DATA_RECEIVE_PCI_BUS_FAULT () {(0x8118);}' unless defined(&MPI_FAULT_DATA_RECEIVE_PCI_BUS_FAULT);
    eval 'sub MPI_DOORBELL_OFFSET () {(0x);}' unless defined(&MPI_DOORBELL_OFFSET);
    eval 'sub MPI_DOORBELL_ACTIVE () {(0x8000000);}' unless defined(&MPI_DOORBELL_ACTIVE);
    eval 'sub MPI_DOORBELL_USED () {( &MPI_DOORBELL_ACTIVE);}' unless defined(&MPI_DOORBELL_USED);
    eval 'sub MPI_DOORBELL_ACTIVE_SHIFT () {(27);}' unless defined(&MPI_DOORBELL_ACTIVE_SHIFT);
    eval 'sub MPI_DOORBELL_WHO_INIT_MASK () {(0x7000000);}' unless defined(&MPI_DOORBELL_WHO_INIT_MASK);
    eval 'sub MPI_DOORBELL_WHO_INIT_SHIFT () {(24);}' unless defined(&MPI_DOORBELL_WHO_INIT_SHIFT);
    eval 'sub MPI_DOORBELL_FUNCTION_MASK () {(0xff000000);}' unless defined(&MPI_DOORBELL_FUNCTION_MASK);
    eval 'sub MPI_DOORBELL_FUNCTION_SHIFT () {(24);}' unless defined(&MPI_DOORBELL_FUNCTION_SHIFT);
    eval 'sub MPI_DOORBELL_ADD_DWORDS_MASK () {(0xff0000);}' unless defined(&MPI_DOORBELL_ADD_DWORDS_MASK);
    eval 'sub MPI_DOORBELL_ADD_DWORDS_SHIFT () {(16);}' unless defined(&MPI_DOORBELL_ADD_DWORDS_SHIFT);
    eval 'sub MPI_DOORBELL_DATA_MASK () {(0xffff);}' unless defined(&MPI_DOORBELL_DATA_MASK);
    eval 'sub MPI_DOORBELL_FUNCTION_SPECIFIC_MASK () {(0xffff);}' unless defined(&MPI_DOORBELL_FUNCTION_SPECIFIC_MASK);
    eval 'sub MPI_DB_HPBAC_VALUE_MASK () {(0xf000);}' unless defined(&MPI_DB_HPBAC_VALUE_MASK);
    eval 'sub MPI_DB_HPBAC_ENABLE_ACCESS () {(0x1);}' unless defined(&MPI_DB_HPBAC_ENABLE_ACCESS);
    eval 'sub MPI_DB_HPBAC_DISABLE_ACCESS () {(0x2);}' unless defined(&MPI_DB_HPBAC_DISABLE_ACCESS);
    eval 'sub MPI_DB_HPBAC_FREE_BUFFER () {(0x3);}' unless defined(&MPI_DB_HPBAC_FREE_BUFFER);
    eval 'sub MPI_WRITE_SEQUENCE_OFFSET () {(0x4);}' unless defined(&MPI_WRITE_SEQUENCE_OFFSET);
    eval 'sub MPI_WRSEQ_KEY_VALUE_MASK () {(0xf);}' unless defined(&MPI_WRSEQ_KEY_VALUE_MASK);
    eval 'sub MPI_WRSEQ_1ST_KEY_VALUE () {(0x4);}' unless defined(&MPI_WRSEQ_1ST_KEY_VALUE);
    eval 'sub MPI_WRSEQ_2ND_KEY_VALUE () {(0xb);}' unless defined(&MPI_WRSEQ_2ND_KEY_VALUE);
    eval 'sub MPI_WRSEQ_3RD_KEY_VALUE () {(0x2);}' unless defined(&MPI_WRSEQ_3RD_KEY_VALUE);
    eval 'sub MPI_WRSEQ_4TH_KEY_VALUE () {(0x7);}' unless defined(&MPI_WRSEQ_4TH_KEY_VALUE);
    eval 'sub MPI_WRSEQ_5TH_KEY_VALUE () {(0xd);}' unless defined(&MPI_WRSEQ_5TH_KEY_VALUE);
    eval 'sub MPI_DIAGNOSTIC_OFFSET () {(0x8);}' unless defined(&MPI_DIAGNOSTIC_OFFSET);
    eval 'sub MPI_DIAG_CLEAR_FLASH_BAD_SIG () {(0x400);}' unless defined(&MPI_DIAG_CLEAR_FLASH_BAD_SIG);
    eval 'sub MPI_DIAG_PREVENT_IOC_BOOT () {(0x200);}' unless defined(&MPI_DIAG_PREVENT_IOC_BOOT);
    eval 'sub MPI_DIAG_DRWE () {(0x80);}' unless defined(&MPI_DIAG_DRWE);
    eval 'sub MPI_DIAG_FLASH_BAD_SIG () {(0x40);}' unless defined(&MPI_DIAG_FLASH_BAD_SIG);
    eval 'sub MPI_DIAG_RESET_HISTORY () {(0x20);}' unless defined(&MPI_DIAG_RESET_HISTORY);
    eval 'sub MPI_DIAG_RW_ENABLE () {(0x10);}' unless defined(&MPI_DIAG_RW_ENABLE);
    eval 'sub MPI_DIAG_RESET_ADAPTER () {(0x4);}' unless defined(&MPI_DIAG_RESET_ADAPTER);
    eval 'sub MPI_DIAG_DISABLE_ARM () {(0x2);}' unless defined(&MPI_DIAG_DISABLE_ARM);
    eval 'sub MPI_DIAG_MEM_ENABLE () {(0x1);}' unless defined(&MPI_DIAG_MEM_ENABLE);
    eval 'sub MPI_TEST_BASE_ADDRESS_OFFSET () {(0xc);}' unless defined(&MPI_TEST_BASE_ADDRESS_OFFSET);
    eval 'sub MPI_DIAG_RW_DATA_OFFSET () {(0x10);}' unless defined(&MPI_DIAG_RW_DATA_OFFSET);
    eval 'sub MPI_DIAG_RW_ADDRESS_OFFSET () {(0x14);}' unless defined(&MPI_DIAG_RW_ADDRESS_OFFSET);
    eval 'sub MPI_HOST_INTERRUPT_STATUS_OFFSET () {(0x30);}' unless defined(&MPI_HOST_INTERRUPT_STATUS_OFFSET);
    eval 'sub MPI_HIS_IOP_DOORBELL_STATUS () {(0x80000000);}' unless defined(&MPI_HIS_IOP_DOORBELL_STATUS);
    eval 'sub MPI_HIS_REPLY_MESSAGE_INTERRUPT () {(0x8);}' unless defined(&MPI_HIS_REPLY_MESSAGE_INTERRUPT);
    eval 'sub MPI_HIS_DOORBELL_INTERRUPT () {(0x1);}' unless defined(&MPI_HIS_DOORBELL_INTERRUPT);
    eval 'sub MPI_HOST_INTERRUPT_MASK_OFFSET () {(0x34);}' unless defined(&MPI_HOST_INTERRUPT_MASK_OFFSET);
    eval 'sub MPI_HIM_RIM () {(0x8);}' unless defined(&MPI_HIM_RIM);
    eval 'sub MPI_HIM_DIM () {(0x1);}' unless defined(&MPI_HIM_DIM);
    eval 'sub MPI_REQUEST_QUEUE_OFFSET () {(0x40);}' unless defined(&MPI_REQUEST_QUEUE_OFFSET);
    eval 'sub MPI_REQUEST_POST_FIFO_OFFSET () {(0x40);}' unless defined(&MPI_REQUEST_POST_FIFO_OFFSET);
    eval 'sub MPI_REPLY_QUEUE_OFFSET () {(0x44);}' unless defined(&MPI_REPLY_QUEUE_OFFSET);
    eval 'sub MPI_REPLY_POST_FIFO_OFFSET () {(0x44);}' unless defined(&MPI_REPLY_POST_FIFO_OFFSET);
    eval 'sub MPI_REPLY_FREE_FIFO_OFFSET () {(0x44);}' unless defined(&MPI_REPLY_FREE_FIFO_OFFSET);
    eval 'sub MPI_HI_PRI_REQUEST_QUEUE_OFFSET () {(0x48);}' unless defined(&MPI_HI_PRI_REQUEST_QUEUE_OFFSET);
    eval 'sub MPI_REQ_MF_DESCRIPTOR_NB_MASK () {(0x3);}' unless defined(&MPI_REQ_MF_DESCRIPTOR_NB_MASK);
    eval 'sub MPI_REQ_MF_DESCRIPTOR_F_BIT () {(0x4);}' unless defined(&MPI_REQ_MF_DESCRIPTOR_F_BIT);
    eval 'sub MPI_REQ_MF_DESCRIPTOR_ADDRESS_MASK () {(0xfffffff8);}' unless defined(&MPI_REQ_MF_DESCRIPTOR_ADDRESS_MASK);
    eval 'sub MPI_ADDRESS_REPLY_A_BIT () {(0x80000000);}' unless defined(&MPI_ADDRESS_REPLY_A_BIT);
    eval 'sub MPI_ADDRESS_REPLY_ADDRESS_MASK () {(0x7fffffff);}' unless defined(&MPI_ADDRESS_REPLY_ADDRESS_MASK);
    eval 'sub MPI_CONTEXT_REPLY_A_BIT () {(0x80000000);}' unless defined(&MPI_CONTEXT_REPLY_A_BIT);
    eval 'sub MPI_CONTEXT_REPLY_TYPE_MASK () {(0x60000000);}' unless defined(&MPI_CONTEXT_REPLY_TYPE_MASK);
    eval 'sub MPI_CONTEXT_REPLY_TYPE_SCSI_INIT () {(0x);}' unless defined(&MPI_CONTEXT_REPLY_TYPE_SCSI_INIT);
    eval 'sub MPI_CONTEXT_REPLY_TYPE_SCSI_TARGET () {(0x1);}' unless defined(&MPI_CONTEXT_REPLY_TYPE_SCSI_TARGET);
    eval 'sub MPI_CONTEXT_REPLY_TYPE_LAN () {(0x2);}' unless defined(&MPI_CONTEXT_REPLY_TYPE_LAN);
    eval 'sub MPI_CONTEXT_REPLY_TYPE_SHIFT () {(29);}' unless defined(&MPI_CONTEXT_REPLY_TYPE_SHIFT);
    eval 'sub MPI_CONTEXT_REPLY_CONTEXT_MASK () {(0x1fffffff);}' unless defined(&MPI_CONTEXT_REPLY_CONTEXT_MASK);
    eval 'sub MPI_GET_CONTEXT_REPLY_TYPE {
        my($x) = @_;
	    eval q(((($x) &  &MPI_CONTEXT_REPLY_TYPE_MASK) >>  &MPI_CONTEXT_REPLY_TYPE_SHIFT));
    }' unless defined(&MPI_GET_CONTEXT_REPLY_TYPE);
    eval 'sub MPI_SET_CONTEXT_REPLY_TYPE {
        my($x, $typ) = @_;
	    eval q((($x) = (($x) & ~ &MPI_CONTEXT_REPLY_TYPE_MASK) | ((($typ) <<  &MPI_CONTEXT_REPLY_TYPE_SHIFT) &  &MPI_CONTEXT_REPLY_TYPE_MASK)));
    }' unless defined(&MPI_SET_CONTEXT_REPLY_TYPE);
    eval 'sub MPI_FUNCTION_SCSI_IO_REQUEST () {(0x);}' unless defined(&MPI_FUNCTION_SCSI_IO_REQUEST);
    eval 'sub MPI_FUNCTION_SCSI_TASK_MGMT () {(0x1);}' unless defined(&MPI_FUNCTION_SCSI_TASK_MGMT);
    eval 'sub MPI_FUNCTION_IOC_INIT () {(0x2);}' unless defined(&MPI_FUNCTION_IOC_INIT);
    eval 'sub MPI_FUNCTION_IOC_FACTS () {(0x3);}' unless defined(&MPI_FUNCTION_IOC_FACTS);
    eval 'sub MPI_FUNCTION_CONFIG () {(0x4);}' unless defined(&MPI_FUNCTION_CONFIG);
    eval 'sub MPI_FUNCTION_PORT_FACTS () {(0x5);}' unless defined(&MPI_FUNCTION_PORT_FACTS);
    eval 'sub MPI_FUNCTION_PORT_ENABLE () {(0x6);}' unless defined(&MPI_FUNCTION_PORT_ENABLE);
    eval 'sub MPI_FUNCTION_EVENT_NOTIFICATION () {(0x7);}' unless defined(&MPI_FUNCTION_EVENT_NOTIFICATION);
    eval 'sub MPI_FUNCTION_EVENT_ACK () {(0x8);}' unless defined(&MPI_FUNCTION_EVENT_ACK);
    eval 'sub MPI_FUNCTION_FW_DOWNLOAD () {(0x9);}' unless defined(&MPI_FUNCTION_FW_DOWNLOAD);
    eval 'sub MPI_FUNCTION_TARGET_CMD_BUFFER_POST () {(0xa);}' unless defined(&MPI_FUNCTION_TARGET_CMD_BUFFER_POST);
    eval 'sub MPI_FUNCTION_TARGET_ASSIST () {(0xb);}' unless defined(&MPI_FUNCTION_TARGET_ASSIST);
    eval 'sub MPI_FUNCTION_TARGET_STATUS_SEND () {(0xc);}' unless defined(&MPI_FUNCTION_TARGET_STATUS_SEND);
    eval 'sub MPI_FUNCTION_TARGET_MODE_ABORT () {(0xd);}' unless defined(&MPI_FUNCTION_TARGET_MODE_ABORT);
    eval 'sub MPI_FUNCTION_FC_LINK_SRVC_BUF_POST () {(0xe);}' unless defined(&MPI_FUNCTION_FC_LINK_SRVC_BUF_POST);
    eval 'sub MPI_FUNCTION_FC_LINK_SRVC_RSP () {(0xf);}' unless defined(&MPI_FUNCTION_FC_LINK_SRVC_RSP);
    eval 'sub MPI_FUNCTION_FC_EX_LINK_SRVC_SEND () {(0x10);}' unless defined(&MPI_FUNCTION_FC_EX_LINK_SRVC_SEND);
    eval 'sub MPI_FUNCTION_FC_ABORT () {(0x11);}' unless defined(&MPI_FUNCTION_FC_ABORT);
    eval 'sub MPI_FUNCTION_FW_UPLOAD () {(0x12);}' unless defined(&MPI_FUNCTION_FW_UPLOAD);
    eval 'sub MPI_FUNCTION_FC_COMMON_TRANSPORT_SEND () {(0x13);}' unless defined(&MPI_FUNCTION_FC_COMMON_TRANSPORT_SEND);
    eval 'sub MPI_FUNCTION_FC_PRIMITIVE_SEND () {(0x14);}' unless defined(&MPI_FUNCTION_FC_PRIMITIVE_SEND);
    eval 'sub MPI_FUNCTION_RAID_ACTION () {(0x15);}' unless defined(&MPI_FUNCTION_RAID_ACTION);
    eval 'sub MPI_FUNCTION_RAID_SCSI_IO_PASSTHROUGH () {(0x16);}' unless defined(&MPI_FUNCTION_RAID_SCSI_IO_PASSTHROUGH);
    eval 'sub MPI_FUNCTION_TOOLBOX () {(0x17);}' unless defined(&MPI_FUNCTION_TOOLBOX);
    eval 'sub MPI_FUNCTION_SCSI_ENCLOSURE_PROCESSOR () {(0x18);}' unless defined(&MPI_FUNCTION_SCSI_ENCLOSURE_PROCESSOR);
    eval 'sub MPI_FUNCTION_MAILBOX () {(0x19);}' unless defined(&MPI_FUNCTION_MAILBOX);
    eval 'sub MPI_FUNCTION_SMP_PASSTHROUGH () {(0x1a);}' unless defined(&MPI_FUNCTION_SMP_PASSTHROUGH);
    eval 'sub MPI_FUNCTION_SAS_IO_UNIT_CONTROL () {(0x1b);}' unless defined(&MPI_FUNCTION_SAS_IO_UNIT_CONTROL);
    eval 'sub MPI_FUNCTION_SATA_PASSTHROUGH () {(0x1c);}' unless defined(&MPI_FUNCTION_SATA_PASSTHROUGH);
    eval 'sub MPI_FUNCTION_DIAG_BUFFER_POST () {(0x1d);}' unless defined(&MPI_FUNCTION_DIAG_BUFFER_POST);
    eval 'sub MPI_FUNCTION_DIAG_RELEASE () {(0x1e);}' unless defined(&MPI_FUNCTION_DIAG_RELEASE);
    eval 'sub MPI_FUNCTION_SCSI_IO_32 () {(0x1f);}' unless defined(&MPI_FUNCTION_SCSI_IO_32);
    eval 'sub MPI_FUNCTION_LAN_SEND () {(0x20);}' unless defined(&MPI_FUNCTION_LAN_SEND);
    eval 'sub MPI_FUNCTION_LAN_RECEIVE () {(0x21);}' unless defined(&MPI_FUNCTION_LAN_RECEIVE);
    eval 'sub MPI_FUNCTION_LAN_RESET () {(0x22);}' unless defined(&MPI_FUNCTION_LAN_RESET);
    eval 'sub MPI_FUNCTION_TARGET_ASSIST_EXTENDED () {(0x23);}' unless defined(&MPI_FUNCTION_TARGET_ASSIST_EXTENDED);
    eval 'sub MPI_FUNCTION_TARGET_CMD_BUF_BASE_POST () {(0x24);}' unless defined(&MPI_FUNCTION_TARGET_CMD_BUF_BASE_POST);
    eval 'sub MPI_FUNCTION_TARGET_CMD_BUF_LIST_POST () {(0x25);}' unless defined(&MPI_FUNCTION_TARGET_CMD_BUF_LIST_POST);
    eval 'sub MPI_FUNCTION_INBAND_BUFFER_POST () {(0x28);}' unless defined(&MPI_FUNCTION_INBAND_BUFFER_POST);
    eval 'sub MPI_FUNCTION_INBAND_SEND () {(0x29);}' unless defined(&MPI_FUNCTION_INBAND_SEND);
    eval 'sub MPI_FUNCTION_INBAND_RSP () {(0x2a);}' unless defined(&MPI_FUNCTION_INBAND_RSP);
    eval 'sub MPI_FUNCTION_INBAND_ABORT () {(0x2b);}' unless defined(&MPI_FUNCTION_INBAND_ABORT);
    eval 'sub MPI_FUNCTION_IOC_MESSAGE_UNIT_RESET () {(0x40);}' unless defined(&MPI_FUNCTION_IOC_MESSAGE_UNIT_RESET);
    eval 'sub MPI_FUNCTION_IO_UNIT_RESET () {(0x41);}' unless defined(&MPI_FUNCTION_IO_UNIT_RESET);
    eval 'sub MPI_FUNCTION_HANDSHAKE () {(0x42);}' unless defined(&MPI_FUNCTION_HANDSHAKE);
    eval 'sub MPI_FUNCTION_REPLY_FRAME_REMOVAL () {(0x43);}' unless defined(&MPI_FUNCTION_REPLY_FRAME_REMOVAL);
    eval 'sub MPI_FUNCTION_HOST_PAGEBUF_ACCESS_CONTROL () {(0x44);}' unless defined(&MPI_FUNCTION_HOST_PAGEBUF_ACCESS_CONTROL);
    eval 'sub MPI_SGE_FLAGS_LAST_ELEMENT () {(0x80);}' unless defined(&MPI_SGE_FLAGS_LAST_ELEMENT);
    eval 'sub MPI_SGE_FLAGS_END_OF_BUFFER () {(0x40);}' unless defined(&MPI_SGE_FLAGS_END_OF_BUFFER);
    eval 'sub MPI_SGE_FLAGS_ELEMENT_TYPE_MASK () {(0x30);}' unless defined(&MPI_SGE_FLAGS_ELEMENT_TYPE_MASK);
    eval 'sub MPI_SGE_FLAGS_LOCAL_ADDRESS () {(0x8);}' unless defined(&MPI_SGE_FLAGS_LOCAL_ADDRESS);
    eval 'sub MPI_SGE_FLAGS_DIRECTION () {(0x4);}' unless defined(&MPI_SGE_FLAGS_DIRECTION);
    eval 'sub MPI_SGE_FLAGS_ADDRESS_SIZE () {(0x2);}' unless defined(&MPI_SGE_FLAGS_ADDRESS_SIZE);
    eval 'sub MPI_SGE_FLAGS_END_OF_LIST () {(0x1);}' unless defined(&MPI_SGE_FLAGS_END_OF_LIST);
    eval 'sub MPI_SGE_FLAGS_SHIFT () {(24);}' unless defined(&MPI_SGE_FLAGS_SHIFT);
    eval 'sub MPI_SGE_LENGTH_MASK () {(0xffffff);}' unless defined(&MPI_SGE_LENGTH_MASK);
    eval 'sub MPI_SGE_CHAIN_LENGTH_MASK () {(0xffff);}' unless defined(&MPI_SGE_CHAIN_LENGTH_MASK);
    eval 'sub MPI_SGE_FLAGS_TRANSACTION_ELEMENT () {(0x);}' unless defined(&MPI_SGE_FLAGS_TRANSACTION_ELEMENT);
    eval 'sub MPI_SGE_FLAGS_SIMPLE_ELEMENT () {(0x10);}' unless defined(&MPI_SGE_FLAGS_SIMPLE_ELEMENT);
    eval 'sub MPI_SGE_FLAGS_CHAIN_ELEMENT () {(0x30);}' unless defined(&MPI_SGE_FLAGS_CHAIN_ELEMENT);
    eval 'sub MPI_SGE_FLAGS_ELEMENT_MASK () {(0x30);}' unless defined(&MPI_SGE_FLAGS_ELEMENT_MASK);
    eval 'sub MPI_SGE_FLAGS_SYSTEM_ADDRESS () {(0x);}' unless defined(&MPI_SGE_FLAGS_SYSTEM_ADDRESS);
    eval 'sub MPI_SGE_FLAGS_IOC_TO_HOST () {(0x);}' unless defined(&MPI_SGE_FLAGS_IOC_TO_HOST);
    eval 'sub MPI_SGE_FLAGS_HOST_TO_IOC () {(0x4);}' unless defined(&MPI_SGE_FLAGS_HOST_TO_IOC);
    eval 'sub MPI_SGE_FLAGS_32_BIT_ADDRESSING () {(0x);}' unless defined(&MPI_SGE_FLAGS_32_BIT_ADDRESSING);
    eval 'sub MPI_SGE_FLAGS_64_BIT_ADDRESSING () {(0x2);}' unless defined(&MPI_SGE_FLAGS_64_BIT_ADDRESSING);
    eval 'sub MPI_SGE_FLAGS_32_BIT_CONTEXT () {(0x);}' unless defined(&MPI_SGE_FLAGS_32_BIT_CONTEXT);
    eval 'sub MPI_SGE_FLAGS_64_BIT_CONTEXT () {(0x2);}' unless defined(&MPI_SGE_FLAGS_64_BIT_CONTEXT);
    eval 'sub MPI_SGE_FLAGS_96_BIT_CONTEXT () {(0x4);}' unless defined(&MPI_SGE_FLAGS_96_BIT_CONTEXT);
    eval 'sub MPI_SGE_FLAGS_128_BIT_CONTEXT () {(0x6);}' unless defined(&MPI_SGE_FLAGS_128_BIT_CONTEXT);
    eval 'sub MPI_SGE_CHAIN_OFFSET_MASK () {(0xff0000);}' unless defined(&MPI_SGE_CHAIN_OFFSET_MASK);
    eval 'sub MPI_SGE_CHAIN_OFFSET_SHIFT () {(16);}' unless defined(&MPI_SGE_CHAIN_OFFSET_SHIFT);
    eval 'sub MPI_SGE_SET_FLAGS {
        my($f) = @_;
	    eval q((( &U32)($f) <<  &MPI_SGE_FLAGS_SHIFT));
    }' unless defined(&MPI_SGE_SET_FLAGS);
    eval 'sub MPI_SGE_GET_FLAGS {
        my($fl) = @_;
	    eval q(((($fl) & ~ &MPI_SGE_LENGTH_MASK) >>  &MPI_SGE_FLAGS_SHIFT));
    }' unless defined(&MPI_SGE_GET_FLAGS);
    eval 'sub MPI_SGE_LENGTH {
        my($fl) = @_;
	    eval q((($fl) &  &MPI_SGE_LENGTH_MASK));
    }' unless defined(&MPI_SGE_LENGTH);
    eval 'sub MPI_SGE_CHAIN_LENGTH {
        my($fl) = @_;
	    eval q((($fl) &  &MPI_SGE_CHAIN_LENGTH_MASK));
    }' unless defined(&MPI_SGE_CHAIN_LENGTH);
    eval 'sub MPI_SGE_SET_FLAGS_LENGTH {
        my($f,$l) = @_;
	    eval q(( &MPI_SGE_SET_FLAGS($f) |  &MPI_SGE_LENGTH($l)));
    }' unless defined(&MPI_SGE_SET_FLAGS_LENGTH);
    eval 'sub MPI_pSGE_GET_FLAGS {
        my($psg) = @_;
	    eval q( &MPI_SGE_GET_FLAGS(($psg)-> &FlagsLength));
    }' unless defined(&MPI_pSGE_GET_FLAGS);
    eval 'sub MPI_pSGE_GET_LENGTH {
        my($psg) = @_;
	    eval q( &MPI_SGE_LENGTH(($psg)-> &FlagsLength));
    }' unless defined(&MPI_pSGE_GET_LENGTH);
    eval 'sub MPI_pSGE_SET_FLAGS_LENGTH {
        my($psg,$f,$l) = @_;
	    eval q(($psg)-> &FlagsLength =  &MPI_SGE_SET_FLAGS_LENGTH($f,$l));
    }' unless defined(&MPI_pSGE_SET_FLAGS_LENGTH);
    eval 'sub MPI_pSGE_SET_FLAGS {
        my($psg,$f) = @_;
	    eval q(($psg)-> &FlagsLength |=  &MPI_SGE_SET_FLAGS($f));
    }' unless defined(&MPI_pSGE_SET_FLAGS);
    eval 'sub MPI_pSGE_SET_LENGTH {
        my($psg,$l) = @_;
	    eval q(($psg)-> &FlagsLength |=  &MPI_SGE_LENGTH($l));
    }' unless defined(&MPI_pSGE_SET_LENGTH);
    eval 'sub MPI_GET_CHAIN_OFFSET {
        my($x) = @_;
	    eval q((($x &MPI_SGE_CHAIN_OFFSET_MASK)>> &MPI_SGE_CHAIN_OFFSET_SHIFT));
    }' unless defined(&MPI_GET_CHAIN_OFFSET);
    eval 'sub MPI_MSGFLAGS_CONTINUATION_REPLY () {(0x80);}' unless defined(&MPI_MSGFLAGS_CONTINUATION_REPLY);
    eval 'sub MPI_IOCSTATUS_SUCCESS () {(0x);}' unless defined(&MPI_IOCSTATUS_SUCCESS);
    eval 'sub MPI_IOCSTATUS_INVALID_FUNCTION () {(0x1);}' unless defined(&MPI_IOCSTATUS_INVALID_FUNCTION);
    eval 'sub MPI_IOCSTATUS_BUSY () {(0x2);}' unless defined(&MPI_IOCSTATUS_BUSY);
    eval 'sub MPI_IOCSTATUS_INVALID_SGL () {(0x3);}' unless defined(&MPI_IOCSTATUS_INVALID_SGL);
    eval 'sub MPI_IOCSTATUS_INTERNAL_ERROR () {(0x4);}' unless defined(&MPI_IOCSTATUS_INTERNAL_ERROR);
    eval 'sub MPI_IOCSTATUS_RESERVED () {(0x5);}' unless defined(&MPI_IOCSTATUS_RESERVED);
    eval 'sub MPI_IOCSTATUS_INSUFFICIENT_RESOURCES () {(0x6);}' unless defined(&MPI_IOCSTATUS_INSUFFICIENT_RESOURCES);
    eval 'sub MPI_IOCSTATUS_INVALID_FIELD () {(0x7);}' unless defined(&MPI_IOCSTATUS_INVALID_FIELD);
    eval 'sub MPI_IOCSTATUS_INVALID_STATE () {(0x8);}' unless defined(&MPI_IOCSTATUS_INVALID_STATE);
    eval 'sub MPI_IOCSTATUS_OP_STATE_NOT_SUPPORTED () {(0x9);}' unless defined(&MPI_IOCSTATUS_OP_STATE_NOT_SUPPORTED);
    eval 'sub MPI_IOCSTATUS_CONFIG_INVALID_ACTION () {(0x20);}' unless defined(&MPI_IOCSTATUS_CONFIG_INVALID_ACTION);
    eval 'sub MPI_IOCSTATUS_CONFIG_INVALID_TYPE () {(0x21);}' unless defined(&MPI_IOCSTATUS_CONFIG_INVALID_TYPE);
    eval 'sub MPI_IOCSTATUS_CONFIG_INVALID_PAGE () {(0x22);}' unless defined(&MPI_IOCSTATUS_CONFIG_INVALID_PAGE);
    eval 'sub MPI_IOCSTATUS_CONFIG_INVALID_DATA () {(0x23);}' unless defined(&MPI_IOCSTATUS_CONFIG_INVALID_DATA);
    eval 'sub MPI_IOCSTATUS_CONFIG_NO_DEFAULTS () {(0x24);}' unless defined(&MPI_IOCSTATUS_CONFIG_NO_DEFAULTS);
    eval 'sub MPI_IOCSTATUS_CONFIG_CANT_COMMIT () {(0x25);}' unless defined(&MPI_IOCSTATUS_CONFIG_CANT_COMMIT);
    eval 'sub MPI_IOCSTATUS_SCSI_RECOVERED_ERROR () {(0x40);}' unless defined(&MPI_IOCSTATUS_SCSI_RECOVERED_ERROR);
    eval 'sub MPI_IOCSTATUS_SCSI_INVALID_BUS () {(0x41);}' unless defined(&MPI_IOCSTATUS_SCSI_INVALID_BUS);
    eval 'sub MPI_IOCSTATUS_SCSI_INVALID_TARGETID () {(0x42);}' unless defined(&MPI_IOCSTATUS_SCSI_INVALID_TARGETID);
    eval 'sub MPI_IOCSTATUS_SCSI_DEVICE_NOT_THERE () {(0x43);}' unless defined(&MPI_IOCSTATUS_SCSI_DEVICE_NOT_THERE);
    eval 'sub MPI_IOCSTATUS_SCSI_DATA_OVERRUN () {(0x44);}' unless defined(&MPI_IOCSTATUS_SCSI_DATA_OVERRUN);
    eval 'sub MPI_IOCSTATUS_SCSI_DATA_UNDERRUN () {(0x45);}' unless defined(&MPI_IOCSTATUS_SCSI_DATA_UNDERRUN);
    eval 'sub MPI_IOCSTATUS_SCSI_IO_DATA_ERROR () {(0x46);}' unless defined(&MPI_IOCSTATUS_SCSI_IO_DATA_ERROR);
    eval 'sub MPI_IOCSTATUS_SCSI_PROTOCOL_ERROR () {(0x47);}' unless defined(&MPI_IOCSTATUS_SCSI_PROTOCOL_ERROR);
    eval 'sub MPI_IOCSTATUS_SCSI_TASK_TERMINATED () {(0x48);}' unless defined(&MPI_IOCSTATUS_SCSI_TASK_TERMINATED);
    eval 'sub MPI_IOCSTATUS_SCSI_RESIDUAL_MISMATCH () {(0x49);}' unless defined(&MPI_IOCSTATUS_SCSI_RESIDUAL_MISMATCH);
    eval 'sub MPI_IOCSTATUS_SCSI_TASK_MGMT_FAILED () {(0x4a);}' unless defined(&MPI_IOCSTATUS_SCSI_TASK_MGMT_FAILED);
    eval 'sub MPI_IOCSTATUS_SCSI_IOC_TERMINATED () {(0x4b);}' unless defined(&MPI_IOCSTATUS_SCSI_IOC_TERMINATED);
    eval 'sub MPI_IOCSTATUS_SCSI_EXT_TERMINATED () {(0x4c);}' unless defined(&MPI_IOCSTATUS_SCSI_EXT_TERMINATED);
    eval 'sub MPI_IOCSTATUS_EEDP_GUARD_ERROR () {(0x4d);}' unless defined(&MPI_IOCSTATUS_EEDP_GUARD_ERROR);
    eval 'sub MPI_IOCSTATUS_EEDP_REF_TAG_ERROR () {(0x4e);}' unless defined(&MPI_IOCSTATUS_EEDP_REF_TAG_ERROR);
    eval 'sub MPI_IOCSTATUS_EEDP_APP_TAG_ERROR () {(0x4f);}' unless defined(&MPI_IOCSTATUS_EEDP_APP_TAG_ERROR);
    eval 'sub MPI_IOCSTATUS_TARGET_PRIORITY_IO () {(0x60);}' unless defined(&MPI_IOCSTATUS_TARGET_PRIORITY_IO);
    eval 'sub MPI_IOCSTATUS_TARGET_INVALID_PORT () {(0x61);}' unless defined(&MPI_IOCSTATUS_TARGET_INVALID_PORT);
    eval 'sub MPI_IOCSTATUS_TARGET_INVALID_IOCINDEX () {(0x62);}' unless defined(&MPI_IOCSTATUS_TARGET_INVALID_IOCINDEX);
    eval 'sub MPI_IOCSTATUS_TARGET_INVALID_IO_INDEX () {(0x62);}' unless defined(&MPI_IOCSTATUS_TARGET_INVALID_IO_INDEX);
    eval 'sub MPI_IOCSTATUS_TARGET_ABORTED () {(0x63);}' unless defined(&MPI_IOCSTATUS_TARGET_ABORTED);
    eval 'sub MPI_IOCSTATUS_TARGET_NO_CONN_RETRYABLE () {(0x64);}' unless defined(&MPI_IOCSTATUS_TARGET_NO_CONN_RETRYABLE);
    eval 'sub MPI_IOCSTATUS_TARGET_NO_CONNECTION () {(0x65);}' unless defined(&MPI_IOCSTATUS_TARGET_NO_CONNECTION);
    eval 'sub MPI_IOCSTATUS_TARGET_XFER_COUNT_MISMATCH () {(0x6a);}' unless defined(&MPI_IOCSTATUS_TARGET_XFER_COUNT_MISMATCH);
    eval 'sub MPI_IOCSTATUS_TARGET_STS_DATA_NOT_SENT () {(0x6b);}' unless defined(&MPI_IOCSTATUS_TARGET_STS_DATA_NOT_SENT);
    eval 'sub MPI_IOCSTATUS_TARGET_DATA_OFFSET_ERROR () {(0x6d);}' unless defined(&MPI_IOCSTATUS_TARGET_DATA_OFFSET_ERROR);
    eval 'sub MPI_IOCSTATUS_TARGET_TOO_MUCH_WRITE_DATA () {(0x6e);}' unless defined(&MPI_IOCSTATUS_TARGET_TOO_MUCH_WRITE_DATA);
    eval 'sub MPI_IOCSTATUS_TARGET_IU_TOO_SHORT () {(0x6f);}' unless defined(&MPI_IOCSTATUS_TARGET_IU_TOO_SHORT);
    eval 'sub MPI_IOCSTATUS_TARGET_ACK_NAK_TIMEOUT () {(0x70);}' unless defined(&MPI_IOCSTATUS_TARGET_ACK_NAK_TIMEOUT);
    eval 'sub MPI_IOCSTATUS_TARGET_NAK_RECEIVED () {(0x71);}' unless defined(&MPI_IOCSTATUS_TARGET_NAK_RECEIVED);
    eval 'sub MPI_IOCSTATUS_TARGET_FC_ABORTED () {(0x66);}' unless defined(&MPI_IOCSTATUS_TARGET_FC_ABORTED);
    eval 'sub MPI_IOCSTATUS_TARGET_FC_RX_ID_INVALID () {(0x67);}' unless defined(&MPI_IOCSTATUS_TARGET_FC_RX_ID_INVALID);
    eval 'sub MPI_IOCSTATUS_TARGET_FC_DID_INVALID () {(0x68);}' unless defined(&MPI_IOCSTATUS_TARGET_FC_DID_INVALID);
    eval 'sub MPI_IOCSTATUS_TARGET_FC_NODE_LOGGED_OUT () {(0x69);}' unless defined(&MPI_IOCSTATUS_TARGET_FC_NODE_LOGGED_OUT);
    eval 'sub MPI_IOCSTATUS_FC_ABORTED () {(0x66);}' unless defined(&MPI_IOCSTATUS_FC_ABORTED);
    eval 'sub MPI_IOCSTATUS_FC_RX_ID_INVALID () {(0x67);}' unless defined(&MPI_IOCSTATUS_FC_RX_ID_INVALID);
    eval 'sub MPI_IOCSTATUS_FC_DID_INVALID () {(0x68);}' unless defined(&MPI_IOCSTATUS_FC_DID_INVALID);
    eval 'sub MPI_IOCSTATUS_FC_NODE_LOGGED_OUT () {(0x69);}' unless defined(&MPI_IOCSTATUS_FC_NODE_LOGGED_OUT);
    eval 'sub MPI_IOCSTATUS_FC_EXCHANGE_CANCELED () {(0x6c);}' unless defined(&MPI_IOCSTATUS_FC_EXCHANGE_CANCELED);
    eval 'sub MPI_IOCSTATUS_LAN_DEVICE_NOT_FOUND () {(0x80);}' unless defined(&MPI_IOCSTATUS_LAN_DEVICE_NOT_FOUND);
    eval 'sub MPI_IOCSTATUS_LAN_DEVICE_FAILURE () {(0x81);}' unless defined(&MPI_IOCSTATUS_LAN_DEVICE_FAILURE);
    eval 'sub MPI_IOCSTATUS_LAN_TRANSMIT_ERROR () {(0x82);}' unless defined(&MPI_IOCSTATUS_LAN_TRANSMIT_ERROR);
    eval 'sub MPI_IOCSTATUS_LAN_TRANSMIT_ABORTED () {(0x83);}' unless defined(&MPI_IOCSTATUS_LAN_TRANSMIT_ABORTED);
    eval 'sub MPI_IOCSTATUS_LAN_RECEIVE_ERROR () {(0x84);}' unless defined(&MPI_IOCSTATUS_LAN_RECEIVE_ERROR);
    eval 'sub MPI_IOCSTATUS_LAN_RECEIVE_ABORTED () {(0x85);}' unless defined(&MPI_IOCSTATUS_LAN_RECEIVE_ABORTED);
    eval 'sub MPI_IOCSTATUS_LAN_PARTIAL_PACKET () {(0x86);}' unless defined(&MPI_IOCSTATUS_LAN_PARTIAL_PACKET);
    eval 'sub MPI_IOCSTATUS_LAN_CANCELED () {(0x87);}' unless defined(&MPI_IOCSTATUS_LAN_CANCELED);
    eval 'sub MPI_IOCSTATUS_SAS_SMP_REQUEST_FAILED () {(0x90);}' unless defined(&MPI_IOCSTATUS_SAS_SMP_REQUEST_FAILED);
    eval 'sub MPI_IOCSTATUS_SAS_SMP_DATA_OVERRUN () {(0x91);}' unless defined(&MPI_IOCSTATUS_SAS_SMP_DATA_OVERRUN);
    eval 'sub MPI_IOCSTATUS_INBAND_ABORTED () {(0x98);}' unless defined(&MPI_IOCSTATUS_INBAND_ABORTED);
    eval 'sub MPI_IOCSTATUS_INBAND_NO_CONNECTION () {(0x99);}' unless defined(&MPI_IOCSTATUS_INBAND_NO_CONNECTION);
    eval 'sub MPI_IOCSTATUS_DIAGNOSTIC_RELEASED () {(0xa0);}' unless defined(&MPI_IOCSTATUS_DIAGNOSTIC_RELEASED);
    eval 'sub MPI_IOCSTATUS_FLAG_LOG_INFO_AVAILABLE () {(0x8000);}' unless defined(&MPI_IOCSTATUS_FLAG_LOG_INFO_AVAILABLE);
    eval 'sub MPI_IOCSTATUS_MASK () {(0x7fff);}' unless defined(&MPI_IOCSTATUS_MASK);
    eval 'sub MPI_IOCLOGINFO_TYPE_MASK () {(0xf0000000);}' unless defined(&MPI_IOCLOGINFO_TYPE_MASK);
    eval 'sub MPI_IOCLOGINFO_TYPE_SHIFT () {(28);}' unless defined(&MPI_IOCLOGINFO_TYPE_SHIFT);
    eval 'sub MPI_IOCLOGINFO_TYPE_NONE () {(0x);}' unless defined(&MPI_IOCLOGINFO_TYPE_NONE);
    eval 'sub MPI_IOCLOGINFO_TYPE_SCSI () {(0x1);}' unless defined(&MPI_IOCLOGINFO_TYPE_SCSI);
    eval 'sub MPI_IOCLOGINFO_TYPE_FC () {(0x2);}' unless defined(&MPI_IOCLOGINFO_TYPE_FC);
    eval 'sub MPI_IOCLOGINFO_TYPE_SAS () {(0x3);}' unless defined(&MPI_IOCLOGINFO_TYPE_SAS);
    eval 'sub MPI_IOCLOGINFO_TYPE_ISCSI () {(0x4);}' unless defined(&MPI_IOCLOGINFO_TYPE_ISCSI);
    eval 'sub MPI_IOCLOGINFO_LOG_DATA_MASK () {(0xfffffff);}' unless defined(&MPI_IOCLOGINFO_LOG_DATA_MASK);
}
1;
