require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&__NVME_PRIVATE_H__)) {
    eval 'sub __NVME_PRIVATE_H__ () {1;}' unless defined(&__NVME_PRIVATE_H__);
    require 'sys/param.ph';
    require 'sys/bio.ph';
    require 'sys/bus.ph';
    require 'sys/kernel.ph';
    require 'sys/lock.ph';
    require 'sys/malloc.ph';
    require 'sys/mutex.ph';
    require 'sys/rman.ph';
    require 'sys/systm.ph';
    require 'sys/taskqueue.ph';
    require 'vm/uma.ph';
    require 'machine/bus.ph';
    require './dev/nvme/nvme.ph';
    eval 'sub DEVICE2SOFTC {
        my($dev) = @_;
	    eval q((  &device_get_softc($dev)));
    }' unless defined(&DEVICE2SOFTC);
    eval 'sub IDT32_PCI_ID () {0x80d0111d;}' unless defined(&IDT32_PCI_ID);
    eval 'sub IDT8_PCI_ID () {0x80d2111d;}' unless defined(&IDT8_PCI_ID);
    eval 'sub NVME_MAX_PRP_LIST_ENTRIES () {( &NVME_MAX_XFER_SIZE /  &PAGE_SIZE);}' unless defined(&NVME_MAX_PRP_LIST_ENTRIES);
    eval 'sub NVME_ADMIN_TRACKERS () {(16);}' unless defined(&NVME_ADMIN_TRACKERS);
    eval 'sub NVME_ADMIN_ENTRIES () {(128);}' unless defined(&NVME_ADMIN_ENTRIES);
    eval 'sub NVME_MIN_ADMIN_ENTRIES () {(2);}' unless defined(&NVME_MIN_ADMIN_ENTRIES);
    eval 'sub NVME_MAX_ADMIN_ENTRIES () {(4096);}' unless defined(&NVME_MAX_ADMIN_ENTRIES);
    eval 'sub NVME_IO_ENTRIES () {(256);}' unless defined(&NVME_IO_ENTRIES);
    eval 'sub NVME_IO_TRACKERS () {(128);}' unless defined(&NVME_IO_TRACKERS);
    eval 'sub NVME_MIN_IO_TRACKERS () {(4);}' unless defined(&NVME_MIN_IO_TRACKERS);
    eval 'sub NVME_MAX_IO_TRACKERS () {(1024);}' unless defined(&NVME_MAX_IO_TRACKERS);
    eval 'sub NVME_INT_COAL_TIME () {(0);}' unless defined(&NVME_INT_COAL_TIME);
    eval 'sub NVME_INT_COAL_THRESHOLD () {(0);}' unless defined(&NVME_INT_COAL_THRESHOLD);
    eval 'sub NVME_MAX_NAMESPACES () {(16);}' unless defined(&NVME_MAX_NAMESPACES);
    eval 'sub NVME_MAX_CONSUMERS () {(2);}' unless defined(&NVME_MAX_CONSUMERS);
    eval 'sub NVME_MAX_ASYNC_EVENTS () {(8);}' unless defined(&NVME_MAX_ASYNC_EVENTS);
    eval 'sub NVME_DEFAULT_TIMEOUT_PERIOD () {(30);}' unless defined(&NVME_DEFAULT_TIMEOUT_PERIOD);
    eval 'sub NVME_MIN_TIMEOUT_PERIOD () {(5);}' unless defined(&NVME_MIN_TIMEOUT_PERIOD);
    eval 'sub NVME_MAX_TIMEOUT_PERIOD () {(120);}' unless defined(&NVME_MAX_TIMEOUT_PERIOD);
    eval 'sub NVME_DEFAULT_RETRY_COUNT () {(4);}' unless defined(&NVME_DEFAULT_RETRY_COUNT);
    eval 'sub NVME_MAX_AER_LOG_SIZE () {(4096);}' unless defined(&NVME_MAX_AER_LOG_SIZE);
    unless(defined(&CACHE_LINE_SIZE)) {
	eval 'sub CACHE_LINE_SIZE () {(64);}' unless defined(&CACHE_LINE_SIZE);
    }
    if(defined(&BIO_UNMAPPED)) {
	eval 'sub NVME_UNMAPPED_BIO_SUPPORT () {1;}' unless defined(&NVME_UNMAPPED_BIO_SUPPORT);
    }
    eval 'sub NVME_REQUEST_VADDR () {1;}' unless defined(&NVME_REQUEST_VADDR);
    eval 'sub NVME_REQUEST_NULL () {2;}' unless defined(&NVME_REQUEST_NULL);
    eval 'sub NVME_REQUEST_UIO () {3;}' unless defined(&NVME_REQUEST_UIO);
    if(defined(&NVME_UNMAPPED_BIO_SUPPORT)) {
	eval 'sub NVME_REQUEST_BIO () {4;}' unless defined(&NVME_REQUEST_BIO);
    }
    eval 'sub NVME_REQUEST_CCB () {5;}' unless defined(&NVME_REQUEST_CCB);
    eval 'sub QUIRK_DELAY_B4_CHK_RDY () {1;}' unless defined(&QUIRK_DELAY_B4_CHK_RDY);
    eval 'sub nvme_mmio_offsetof {
        my($reg) = @_;
	    eval q( &offsetof(\'struct nvme_registers\', $reg));
    }' unless defined(&nvme_mmio_offsetof);
    eval 'sub nvme_mmio_read_4 {
        my($sc, $reg) = @_;
	    eval q( &bus_space_read_4(($sc)-> &bus_tag, ($sc)-> &bus_handle,  &nvme_mmio_offsetof($reg)));
    }' unless defined(&nvme_mmio_read_4);
    eval 'sub nvme_mmio_write_4 {
        my($sc, $reg, $val) = @_;
	    eval q( &bus_space_write_4(($sc)-> &bus_tag, ($sc)-> &bus_handle,  &nvme_mmio_offsetof($reg), $val));
    }' unless defined(&nvme_mmio_write_4);
    eval 'sub nvme_mmio_write_8 {
        my($sc, $reg, $val) = @_;
	    eval q( &do {  &bus_space_write_4(($sc)-> &bus_tag, ($sc)-> &bus_handle,  &nvme_mmio_offsetof($reg), $val & 0xffffffff);  &bus_space_write_4(($sc)-> &bus_tag, ($sc)-> &bus_handle,  &nvme_mmio_offsetof($reg)+4, ($val & 0xffffffff00000000) >> 32); }  &while (0););
    }' unless defined(&nvme_mmio_write_8);
    if((defined(&__FreeBSD_version) ? &__FreeBSD_version : undef) < 800054) {
	eval 'sub wmb () {
	    eval q( &__asm  &volatile(\\"sfence\\" ::: \\"memory\\"));
	}' unless defined(&wmb);
	eval 'sub mb () {
	    eval q( &__asm  &volatile(\\"mfence\\" ::: \\"memory\\"));
	}' unless defined(&mb);
    }
    eval 'sub nvme_printf () {( &ctrlr,  &fmt,  &args...)  &device_printf( ($ctrlr->{dev}),  &fmt,  &args);}' unless defined(&nvme_printf);
    eval 'sub nvme_single_map {
        my($arg,$seg,$nseg,$error) = @_;
	    eval q({  &uint64_t * &bus_addr = ( &uint64_t *)$arg;  &if ($error != 0)  &printf(\\"nvme_single_map err %d\\\\n\\", $error); * &bus_addr =  ($seg[0]->{ds_addr}); });
    }' unless defined(&nvme_single_map);
    eval 'sub _nvme_allocate_request {
        my($cb_fn,$cb_arg) = @_;
	    eval q({ \'struct nvme_request\' * &req;  &req =  &uma_zalloc( &nvme_request_zone,  &M_NOWAIT |  &M_ZERO);  &if ( &req !=  &NULL) {  ($req->{cb_fn}) = $cb_fn;  ($req->{cb_arg}) = $cb_arg;  ($req->{timeout}) =  &TRUE; } ( &req); });
    }' unless defined(&_nvme_allocate_request);
    eval 'sub nvme_allocate_request_vaddr {
        my($payload,$payload_size,$cb_fn,$cb_arg) = @_;
	    eval q({ \'struct nvme_request\' * &req;  &req =  &_nvme_allocate_request($cb_fn, $cb_arg);  &if ( &req !=  &NULL) {  ($req->{type}) =  &NVME_REQUEST_VADDR;  ($req->{u}->{payload}) = $payload;  ($req->{payload_size}) = $payload_size; } ( &req); });
    }' unless defined(&nvme_allocate_request_vaddr);
    eval 'sub nvme_allocate_request_null {
        my($cb_fn,$cb_arg) = @_;
	    eval q({ \'struct nvme_request\' * &req;  &req =  &_nvme_allocate_request($cb_fn, $cb_arg);  &if ( &req !=  &NULL)  ($req->{type}) =  &NVME_REQUEST_NULL; ( &req); });
    }' unless defined(&nvme_allocate_request_null);
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub nvme_allocate_request_bio {
        my($bio,$cb_fn,$cb_arg) = @_;
	    eval q({ \'struct nvme_request\' * &req;  &req =  &_nvme_allocate_request($cb_fn, $cb_arg);  &if ( &req !=  &NULL) { } ( &req); });
    }' unless defined(&nvme_allocate_request_bio);
    eval 'sub nvme_allocate_request_ccb {
        my($ccb,$cb_fn,$cb_arg) = @_;
	    eval q({ \'struct nvme_request\' * &req;  &req =  &_nvme_allocate_request($cb_fn, $cb_arg);  &if ( &req !=  &NULL) {  ($req->{type}) =  &NVME_REQUEST_CCB;  ($req->{u}->{payload}) = $ccb; } ( &req); });
    }' unless defined(&nvme_allocate_request_ccb);
    eval 'sub nvme_free_request {
        my($req) = @_;
	    eval q( &uma_zfree( &nvme_request_zone, $req));
    }' unless defined(&nvme_free_request);
}
1;
