require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_USB_STANDARD_H_)) {
    eval 'sub _USB_STANDARD_H_ () {1;}' unless defined(&_USB_STANDARD_H_);
    if(defined(&_KERNEL)) {
	unless(defined(&USB_GLOBAL_INCLUDE_FILE)) {
	    require './dev/usb/opt_usb.ph';
	}
	if(defined(&SYSCTL_DECL)) {
	}
	unless(defined(&USB_GLOBAL_INCLUDE_FILE)) {
	    require 'sys/malloc.ph';
	}
    }
    unless(defined(&USB_GLOBAL_INCLUDE_FILE)) {
	require 'dev/usb/usb_endian.ph';
	require 'dev/usb/usb_freebsd.ph';
    }
    eval 'sub USB_STACK_VERSION () {2000;}' unless defined(&USB_STACK_VERSION);
    eval 'sub USB_MAX_IPACKET () {8;}' unless defined(&USB_MAX_IPACKET);
    eval 'sub USB_EP_MAX () {(2*16);}' unless defined(&USB_EP_MAX);
    eval 'sub USB_ROOT_HUB_ADDR () {1;}' unless defined(&USB_ROOT_HUB_ADDR);
    eval 'sub USB_MIN_DEVICES () {2;}' unless defined(&USB_MIN_DEVICES);
    eval 'sub USB_UNCONFIG_INDEX () {0xff;}' unless defined(&USB_UNCONFIG_INDEX);
    eval 'sub USB_IFACE_INDEX_ANY () {0xff;}' unless defined(&USB_IFACE_INDEX_ANY);
    eval 'sub USB_START_ADDR () {0;}' unless defined(&USB_START_ADDR);
    eval 'sub USB_CONTROL_ENDPOINT () {0;}' unless defined(&USB_CONTROL_ENDPOINT);
    eval 'sub USB_FRAMES_PER_SECOND_FS () {1000;}' unless defined(&USB_FRAMES_PER_SECOND_FS);
    eval 'sub USB_FRAMES_PER_SECOND_HS () {8000;}' unless defined(&USB_FRAMES_PER_SECOND_HS);
    eval 'sub USB_FS_BYTES_PER_HS_UFRAME () {188;}' unless defined(&USB_FS_BYTES_PER_HS_UFRAME);
    eval 'sub USB_HS_MICRO_FRAMES_MAX () {8;}' unless defined(&USB_HS_MICRO_FRAMES_MAX);
    eval 'sub USB_ISOC_TIME_MAX () {128;}' unless defined(&USB_ISOC_TIME_MAX);
    eval 'sub USB_POWER_DOWN_TIME () {200;}' unless defined(&USB_POWER_DOWN_TIME);
    eval 'sub USB_PORT_POWER_DOWN_TIME () {100;}' unless defined(&USB_PORT_POWER_DOWN_TIME);
    eval 'sub USB_POWER_MODE_OFF () {0;}' unless defined(&USB_POWER_MODE_OFF);
    eval 'sub USB_POWER_MODE_ON () {1;}' unless defined(&USB_POWER_MODE_ON);
    eval 'sub USB_POWER_MODE_SAVE () {2;}' unless defined(&USB_POWER_MODE_SAVE);
    eval 'sub USB_POWER_MODE_SUSPEND () {3;}' unless defined(&USB_POWER_MODE_SUSPEND);
    eval 'sub USB_POWER_MODE_RESUME () {4;}' unless defined(&USB_POWER_MODE_RESUME);
    eval 'sub USB_PORT_RESET_DELAY_SPEC () {10;}' unless defined(&USB_PORT_RESET_DELAY_SPEC);
    eval 'sub USB_PORT_ROOT_RESET_DELAY_SPEC () {50;}' unless defined(&USB_PORT_ROOT_RESET_DELAY_SPEC);
    eval 'sub USB_PORT_RESET_RECOVERY_SPEC () {10;}' unless defined(&USB_PORT_RESET_RECOVERY_SPEC);
    eval 'sub USB_PORT_POWERUP_DELAY_SPEC () {100;}' unless defined(&USB_PORT_POWERUP_DELAY_SPEC);
    eval 'sub USB_PORT_RESUME_DELAY_SPEC () {20;}' unless defined(&USB_PORT_RESUME_DELAY_SPEC);
    eval 'sub USB_SET_ADDRESS_SETTLE_SPEC () {2;}' unless defined(&USB_SET_ADDRESS_SETTLE_SPEC);
    eval 'sub USB_RESUME_DELAY_SPEC () {(20*5);}' unless defined(&USB_RESUME_DELAY_SPEC);
    eval 'sub USB_RESUME_WAIT_SPEC () {10;}' unless defined(&USB_RESUME_WAIT_SPEC);
    eval 'sub USB_RESUME_RECOVERY_SPEC () {10;}' unless defined(&USB_RESUME_RECOVERY_SPEC);
    eval 'sub USB_EXTRA_POWER_UP_TIME_SPEC () {0;}' unless defined(&USB_EXTRA_POWER_UP_TIME_SPEC);
    eval 'sub USB_PORT_RESET_DELAY () {50;}' unless defined(&USB_PORT_RESET_DELAY);
    eval 'sub USB_PORT_ROOT_RESET_DELAY () {200;}' unless defined(&USB_PORT_ROOT_RESET_DELAY);
    eval 'sub USB_PORT_RESET_RECOVERY () {250;}' unless defined(&USB_PORT_RESET_RECOVERY);
    eval 'sub USB_PORT_POWERUP_DELAY () {300;}' unless defined(&USB_PORT_POWERUP_DELAY);
    eval 'sub USB_PORT_RESUME_DELAY () {(20*2);}' unless defined(&USB_PORT_RESUME_DELAY);
    eval 'sub USB_SET_ADDRESS_SETTLE () {10;}' unless defined(&USB_SET_ADDRESS_SETTLE);
    eval 'sub USB_RESUME_DELAY () {(50*5);}' unless defined(&USB_RESUME_DELAY);
    eval 'sub USB_RESUME_WAIT () {50;}' unless defined(&USB_RESUME_WAIT);
    eval 'sub USB_RESUME_RECOVERY () {50;}' unless defined(&USB_RESUME_RECOVERY);
    eval 'sub USB_EXTRA_POWER_UP_TIME () {20;}' unless defined(&USB_EXTRA_POWER_UP_TIME);
    eval 'sub USB_MIN_POWER () {100;}' unless defined(&USB_MIN_POWER);
    eval 'sub USB_MAX_POWER () {500;}' unless defined(&USB_MAX_POWER);
    eval 'sub USB_BUS_RESET_DELAY () {100;}' unless defined(&USB_BUS_RESET_DELAY);
    eval 'sub UT_WRITE () {0x;}' unless defined(&UT_WRITE);
    eval 'sub UT_READ () {0x80;}' unless defined(&UT_READ);
    eval 'sub UT_STANDARD () {0x;}' unless defined(&UT_STANDARD);
    eval 'sub UT_CLASS () {0x20;}' unless defined(&UT_CLASS);
    eval 'sub UT_VENDOR () {0x40;}' unless defined(&UT_VENDOR);
    eval 'sub UT_DEVICE () {0x;}' unless defined(&UT_DEVICE);
    eval 'sub UT_INTERFACE () {0x1;}' unless defined(&UT_INTERFACE);
    eval 'sub UT_ENDPOINT () {0x2;}' unless defined(&UT_ENDPOINT);
    eval 'sub UT_OTHER () {0x3;}' unless defined(&UT_OTHER);
    eval 'sub UT_READ_DEVICE () {( &UT_READ |  &UT_STANDARD |  &UT_DEVICE);}' unless defined(&UT_READ_DEVICE);
    eval 'sub UT_READ_INTERFACE () {( &UT_READ |  &UT_STANDARD |  &UT_INTERFACE);}' unless defined(&UT_READ_INTERFACE);
    eval 'sub UT_READ_ENDPOINT () {( &UT_READ |  &UT_STANDARD |  &UT_ENDPOINT);}' unless defined(&UT_READ_ENDPOINT);
    eval 'sub UT_WRITE_DEVICE () {( &UT_WRITE |  &UT_STANDARD |  &UT_DEVICE);}' unless defined(&UT_WRITE_DEVICE);
    eval 'sub UT_WRITE_INTERFACE () {( &UT_WRITE |  &UT_STANDARD |  &UT_INTERFACE);}' unless defined(&UT_WRITE_INTERFACE);
    eval 'sub UT_WRITE_ENDPOINT () {( &UT_WRITE |  &UT_STANDARD |  &UT_ENDPOINT);}' unless defined(&UT_WRITE_ENDPOINT);
    eval 'sub UT_READ_CLASS_DEVICE () {( &UT_READ |  &UT_CLASS |  &UT_DEVICE);}' unless defined(&UT_READ_CLASS_DEVICE);
    eval 'sub UT_READ_CLASS_INTERFACE () {( &UT_READ |  &UT_CLASS |  &UT_INTERFACE);}' unless defined(&UT_READ_CLASS_INTERFACE);
    eval 'sub UT_READ_CLASS_OTHER () {( &UT_READ |  &UT_CLASS |  &UT_OTHER);}' unless defined(&UT_READ_CLASS_OTHER);
    eval 'sub UT_READ_CLASS_ENDPOINT () {( &UT_READ |  &UT_CLASS |  &UT_ENDPOINT);}' unless defined(&UT_READ_CLASS_ENDPOINT);
    eval 'sub UT_WRITE_CLASS_DEVICE () {( &UT_WRITE |  &UT_CLASS |  &UT_DEVICE);}' unless defined(&UT_WRITE_CLASS_DEVICE);
    eval 'sub UT_WRITE_CLASS_INTERFACE () {( &UT_WRITE |  &UT_CLASS |  &UT_INTERFACE);}' unless defined(&UT_WRITE_CLASS_INTERFACE);
    eval 'sub UT_WRITE_CLASS_OTHER () {( &UT_WRITE |  &UT_CLASS |  &UT_OTHER);}' unless defined(&UT_WRITE_CLASS_OTHER);
    eval 'sub UT_WRITE_CLASS_ENDPOINT () {( &UT_WRITE |  &UT_CLASS |  &UT_ENDPOINT);}' unless defined(&UT_WRITE_CLASS_ENDPOINT);
    eval 'sub UT_READ_VENDOR_DEVICE () {( &UT_READ |  &UT_VENDOR |  &UT_DEVICE);}' unless defined(&UT_READ_VENDOR_DEVICE);
    eval 'sub UT_READ_VENDOR_INTERFACE () {( &UT_READ |  &UT_VENDOR |  &UT_INTERFACE);}' unless defined(&UT_READ_VENDOR_INTERFACE);
    eval 'sub UT_READ_VENDOR_OTHER () {( &UT_READ |  &UT_VENDOR |  &UT_OTHER);}' unless defined(&UT_READ_VENDOR_OTHER);
    eval 'sub UT_READ_VENDOR_ENDPOINT () {( &UT_READ |  &UT_VENDOR |  &UT_ENDPOINT);}' unless defined(&UT_READ_VENDOR_ENDPOINT);
    eval 'sub UT_WRITE_VENDOR_DEVICE () {( &UT_WRITE |  &UT_VENDOR |  &UT_DEVICE);}' unless defined(&UT_WRITE_VENDOR_DEVICE);
    eval 'sub UT_WRITE_VENDOR_INTERFACE () {( &UT_WRITE |  &UT_VENDOR |  &UT_INTERFACE);}' unless defined(&UT_WRITE_VENDOR_INTERFACE);
    eval 'sub UT_WRITE_VENDOR_OTHER () {( &UT_WRITE |  &UT_VENDOR |  &UT_OTHER);}' unless defined(&UT_WRITE_VENDOR_OTHER);
    eval 'sub UT_WRITE_VENDOR_ENDPOINT () {( &UT_WRITE |  &UT_VENDOR |  &UT_ENDPOINT);}' unless defined(&UT_WRITE_VENDOR_ENDPOINT);
    eval 'sub UR_GET_STATUS () {0x;}' unless defined(&UR_GET_STATUS);
    eval 'sub UR_CLEAR_FEATURE () {0x1;}' unless defined(&UR_CLEAR_FEATURE);
    eval 'sub UR_SET_FEATURE () {0x3;}' unless defined(&UR_SET_FEATURE);
    eval 'sub UR_SET_ADDRESS () {0x5;}' unless defined(&UR_SET_ADDRESS);
    eval 'sub UR_GET_DESCRIPTOR () {0x6;}' unless defined(&UR_GET_DESCRIPTOR);
    eval 'sub UDESC_DEVICE () {0x1;}' unless defined(&UDESC_DEVICE);
    eval 'sub UDESC_CONFIG () {0x2;}' unless defined(&UDESC_CONFIG);
    eval 'sub UDESC_STRING () {0x3;}' unless defined(&UDESC_STRING);
    eval 'sub USB_LANGUAGE_TABLE () {0x;}' unless defined(&USB_LANGUAGE_TABLE);
    eval 'sub UDESC_INTERFACE () {0x4;}' unless defined(&UDESC_INTERFACE);
    eval 'sub UDESC_ENDPOINT () {0x5;}' unless defined(&UDESC_ENDPOINT);
    eval 'sub UDESC_DEVICE_QUALIFIER () {0x6;}' unless defined(&UDESC_DEVICE_QUALIFIER);
    eval 'sub UDESC_OTHER_SPEED_CONFIGURATION () {0x7;}' unless defined(&UDESC_OTHER_SPEED_CONFIGURATION);
    eval 'sub UDESC_INTERFACE_POWER () {0x8;}' unless defined(&UDESC_INTERFACE_POWER);
    eval 'sub UDESC_OTG () {0x9;}' unless defined(&UDESC_OTG);
    eval 'sub UDESC_DEBUG () {0xa;}' unless defined(&UDESC_DEBUG);
    eval 'sub UDESC_IFACE_ASSOC () {0xb;}' unless defined(&UDESC_IFACE_ASSOC);
    eval 'sub UDESC_BOS () {0xf;}' unless defined(&UDESC_BOS);
    eval 'sub UDESC_DEVICE_CAPABILITY () {0x10;}' unless defined(&UDESC_DEVICE_CAPABILITY);
    eval 'sub UDESC_CS_DEVICE () {0x21;}' unless defined(&UDESC_CS_DEVICE);
    eval 'sub UDESC_CS_CONFIG () {0x22;}' unless defined(&UDESC_CS_CONFIG);
    eval 'sub UDESC_CS_STRING () {0x23;}' unless defined(&UDESC_CS_STRING);
    eval 'sub UDESC_CS_INTERFACE () {0x24;}' unless defined(&UDESC_CS_INTERFACE);
    eval 'sub UDESC_CS_ENDPOINT () {0x25;}' unless defined(&UDESC_CS_ENDPOINT);
    eval 'sub UDESC_HUB () {0x29;}' unless defined(&UDESC_HUB);
    eval 'sub UDESC_SS_HUB () {0x2a;}' unless defined(&UDESC_SS_HUB);
    eval 'sub UDESC_ENDPOINT_SS_COMP () {0x30;}' unless defined(&UDESC_ENDPOINT_SS_COMP);
    eval 'sub UR_SET_DESCRIPTOR () {0x7;}' unless defined(&UR_SET_DESCRIPTOR);
    eval 'sub UR_GET_CONFIG () {0x8;}' unless defined(&UR_GET_CONFIG);
    eval 'sub UR_SET_CONFIG () {0x9;}' unless defined(&UR_SET_CONFIG);
    eval 'sub UR_GET_INTERFACE () {0xa;}' unless defined(&UR_GET_INTERFACE);
    eval 'sub UR_SET_INTERFACE () {0xb;}' unless defined(&UR_SET_INTERFACE);
    eval 'sub UR_SYNCH_FRAME () {0xc;}' unless defined(&UR_SYNCH_FRAME);
    eval 'sub UR_SET_SEL () {0x30;}' unless defined(&UR_SET_SEL);
    eval 'sub UR_ISOCH_DELAY () {0x31;}' unless defined(&UR_ISOCH_DELAY);
    eval 'sub UR_GET_BUS_STATE () {0x2;}' unless defined(&UR_GET_BUS_STATE);
    eval 'sub UR_CLEAR_TT_BUFFER () {0x8;}' unless defined(&UR_CLEAR_TT_BUFFER);
    eval 'sub UR_RESET_TT () {0x9;}' unless defined(&UR_RESET_TT);
    eval 'sub UR_GET_TT_STATE () {0xa;}' unless defined(&UR_GET_TT_STATE);
    eval 'sub UR_STOP_TT () {0xb;}' unless defined(&UR_STOP_TT);
    eval 'sub UR_SET_AND_TEST () {0xc;}' unless defined(&UR_SET_AND_TEST);
    eval 'sub UR_SET_HUB_DEPTH () {0xc;}' unless defined(&UR_SET_HUB_DEPTH);
    eval 'sub USB_SS_HUB_DEPTH_MAX () {5;}' unless defined(&USB_SS_HUB_DEPTH_MAX);
    eval 'sub UR_GET_PORT_ERR_COUNT () {0xd;}' unless defined(&UR_GET_PORT_ERR_COUNT);
    eval 'sub UF_ENDPOINT_HALT () {0;}' unless defined(&UF_ENDPOINT_HALT);
    eval 'sub UF_DEVICE_REMOTE_WAKEUP () {1;}' unless defined(&UF_DEVICE_REMOTE_WAKEUP);
    eval 'sub UF_TEST_MODE () {2;}' unless defined(&UF_TEST_MODE);
    eval 'sub UF_U1_ENABLE () {0x30;}' unless defined(&UF_U1_ENABLE);
    eval 'sub UF_U2_ENABLE () {0x31;}' unless defined(&UF_U2_ENABLE);
    eval 'sub UF_LTM_ENABLE () {0x32;}' unless defined(&UF_LTM_ENABLE);
    eval 'sub UHF_C_HUB_LOCAL_POWER () {0;}' unless defined(&UHF_C_HUB_LOCAL_POWER);
    eval 'sub UHF_C_HUB_OVER_CURRENT () {1;}' unless defined(&UHF_C_HUB_OVER_CURRENT);
    eval 'sub UHF_PORT_CONNECTION () {0;}' unless defined(&UHF_PORT_CONNECTION);
    eval 'sub UHF_PORT_ENABLE () {1;}' unless defined(&UHF_PORT_ENABLE);
    eval 'sub UHF_PORT_SUSPEND () {2;}' unless defined(&UHF_PORT_SUSPEND);
    eval 'sub UHF_PORT_OVER_CURRENT () {3;}' unless defined(&UHF_PORT_OVER_CURRENT);
    eval 'sub UHF_PORT_RESET () {4;}' unless defined(&UHF_PORT_RESET);
    eval 'sub UHF_PORT_LINK_STATE () {5;}' unless defined(&UHF_PORT_LINK_STATE);
    eval 'sub UHF_PORT_POWER () {8;}' unless defined(&UHF_PORT_POWER);
    eval 'sub UHF_PORT_LOW_SPEED () {9;}' unless defined(&UHF_PORT_LOW_SPEED);
    eval 'sub UHF_PORT_L1 () {10;}' unless defined(&UHF_PORT_L1);
    eval 'sub UHF_C_PORT_CONNECTION () {16;}' unless defined(&UHF_C_PORT_CONNECTION);
    eval 'sub UHF_C_PORT_ENABLE () {17;}' unless defined(&UHF_C_PORT_ENABLE);
    eval 'sub UHF_C_PORT_SUSPEND () {18;}' unless defined(&UHF_C_PORT_SUSPEND);
    eval 'sub UHF_C_PORT_OVER_CURRENT () {19;}' unless defined(&UHF_C_PORT_OVER_CURRENT);
    eval 'sub UHF_C_PORT_RESET () {20;}' unless defined(&UHF_C_PORT_RESET);
    eval 'sub UHF_PORT_TEST () {21;}' unless defined(&UHF_PORT_TEST);
    eval 'sub UHF_PORT_INDICATOR () {22;}' unless defined(&UHF_PORT_INDICATOR);
    eval 'sub UHF_C_PORT_L1 () {23;}' unless defined(&UHF_C_PORT_L1);
    eval 'sub UHF_PORT_U1_TIMEOUT () {23;}' unless defined(&UHF_PORT_U1_TIMEOUT);
    eval 'sub UHF_PORT_U2_TIMEOUT () {24;}' unless defined(&UHF_PORT_U2_TIMEOUT);
    eval 'sub UHF_C_PORT_LINK_STATE () {25;}' unless defined(&UHF_C_PORT_LINK_STATE);
    eval 'sub UHF_C_PORT_CONFIG_ERROR () {26;}' unless defined(&UHF_C_PORT_CONFIG_ERROR);
    eval 'sub UHF_PORT_REMOTE_WAKE_MASK () {27;}' unless defined(&UHF_PORT_REMOTE_WAKE_MASK);
    eval 'sub UHF_BH_PORT_RESET () {28;}' unless defined(&UHF_BH_PORT_RESET);
    eval 'sub UHF_C_BH_PORT_RESET () {29;}' unless defined(&UHF_C_BH_PORT_RESET);
    eval 'sub UHF_FORCE_LINKPM_ACCEPT () {30;}' unless defined(&UHF_FORCE_LINKPM_ACCEPT);
    eval 'sub UD_USB_2_0 () {0x200;}' unless defined(&UD_USB_2_0);
    eval 'sub UD_USB_3_0 () {0x300;}' unless defined(&UD_USB_3_0);
    eval 'sub UD_IS_USB2 {
        my($d) = @_;
	    eval q((($d)-> $bcdUSB[1] == 0x2));
    }' unless defined(&UD_IS_USB2);
    eval 'sub UD_IS_USB3 {
        my($d) = @_;
	    eval q((($d)-> $bcdUSB[1] == 0x3));
    }' unless defined(&UD_IS_USB3);
    eval 'sub USB_DEVCAP_RESERVED () {0x;}' unless defined(&USB_DEVCAP_RESERVED);
    eval 'sub USB_DEVCAP_WUSB () {0x1;}' unless defined(&USB_DEVCAP_WUSB);
    eval 'sub USB_DEVCAP_USB2EXT () {0x2;}' unless defined(&USB_DEVCAP_USB2EXT);
    eval 'sub USB_DEVCAP_SUPER_SPEED () {0x3;}' unless defined(&USB_DEVCAP_SUPER_SPEED);
    eval 'sub USB_DEVCAP_CONTAINER_ID () {0x4;}' unless defined(&USB_DEVCAP_CONTAINER_ID);
    eval 'sub USB_V2EXT_LPM () {(1 << 1);}' unless defined(&USB_V2EXT_LPM);
    eval 'sub USB_V2EXT_BESL_SUPPORTED () {(1 << 2);}' unless defined(&USB_V2EXT_BESL_SUPPORTED);
    eval 'sub USB_V2EXT_BESL_BASELINE_VALID () {(1 << 3);}' unless defined(&USB_V2EXT_BESL_BASELINE_VALID);
    eval 'sub USB_V2EXT_BESL_DEEP_VALID () {(1 << 4);}' unless defined(&USB_V2EXT_BESL_DEEP_VALID);
    eval 'sub USB_V2EXT_BESL_BASELINE_GET {
        my($x) = @_;
	    eval q(((($x) >> 8) & 0xf));
    }' unless defined(&USB_V2EXT_BESL_BASELINE_GET);
    eval 'sub USB_V2EXT_BESL_DEEP_GET {
        my($x) = @_;
	    eval q(((($x) >> 12) & 0xf));
    }' unless defined(&USB_V2EXT_BESL_DEEP_GET);
    eval 'sub UDCLASS_IN_INTERFACE () {0x;}' unless defined(&UDCLASS_IN_INTERFACE);
    eval 'sub UDCLASS_COMM () {0x2;}' unless defined(&UDCLASS_COMM);
    eval 'sub UDCLASS_HUB () {0x9;}' unless defined(&UDCLASS_HUB);
    eval 'sub UDSUBCLASS_HUB () {0x;}' unless defined(&UDSUBCLASS_HUB);
    eval 'sub UDPROTO_FSHUB () {0x;}' unless defined(&UDPROTO_FSHUB);
    eval 'sub UDPROTO_HSHUBSTT () {0x1;}' unless defined(&UDPROTO_HSHUBSTT);
    eval 'sub UDPROTO_HSHUBMTT () {0x2;}' unless defined(&UDPROTO_HSHUBMTT);
    eval 'sub UDPROTO_SSHUB () {0x3;}' unless defined(&UDPROTO_SSHUB);
    eval 'sub UDCLASS_DIAGNOSTIC () {0xdc;}' unless defined(&UDCLASS_DIAGNOSTIC);
    eval 'sub UDCLASS_WIRELESS () {0xe0;}' unless defined(&UDCLASS_WIRELESS);
    eval 'sub UDSUBCLASS_RF () {0x1;}' unless defined(&UDSUBCLASS_RF);
    eval 'sub UDPROTO_BLUETOOTH () {0x1;}' unless defined(&UDPROTO_BLUETOOTH);
    eval 'sub UDCLASS_VENDOR () {0xff;}' unless defined(&UDCLASS_VENDOR);
    eval 'sub USB_UNCONFIG_NO () {0;}' unless defined(&USB_UNCONFIG_NO);
    eval 'sub UC_BUS_POWERED () {0x80;}' unless defined(&UC_BUS_POWERED);
    eval 'sub UC_SELF_POWERED () {0x40;}' unless defined(&UC_SELF_POWERED);
    eval 'sub UC_REMOTE_WAKEUP () {0x20;}' unless defined(&UC_REMOTE_WAKEUP);
    eval 'sub UC_POWER_FACTOR () {2;}' unless defined(&UC_POWER_FACTOR);
    eval 'sub UICLASS_UNSPEC () {0x;}' unless defined(&UICLASS_UNSPEC);
    eval 'sub UICLASS_AUDIO () {0x1;}' unless defined(&UICLASS_AUDIO);
    eval 'sub UISUBCLASS_AUDIOCONTROL () {1;}' unless defined(&UISUBCLASS_AUDIOCONTROL);
    eval 'sub UISUBCLASS_AUDIOSTREAM () {2;}' unless defined(&UISUBCLASS_AUDIOSTREAM);
    eval 'sub UISUBCLASS_MIDISTREAM () {3;}' unless defined(&UISUBCLASS_MIDISTREAM);
    eval 'sub UICLASS_CDC () {0x2;}' unless defined(&UICLASS_CDC);
    eval 'sub UISUBCLASS_DIRECT_LINE_CONTROL_MODEL () {1;}' unless defined(&UISUBCLASS_DIRECT_LINE_CONTROL_MODEL);
    eval 'sub UISUBCLASS_ABSTRACT_CONTROL_MODEL () {2;}' unless defined(&UISUBCLASS_ABSTRACT_CONTROL_MODEL);
    eval 'sub UISUBCLASS_TELEPHONE_CONTROL_MODEL () {3;}' unless defined(&UISUBCLASS_TELEPHONE_CONTROL_MODEL);
    eval 'sub UISUBCLASS_MULTICHANNEL_CONTROL_MODEL () {4;}' unless defined(&UISUBCLASS_MULTICHANNEL_CONTROL_MODEL);
    eval 'sub UISUBCLASS_CAPI_CONTROLMODEL () {5;}' unless defined(&UISUBCLASS_CAPI_CONTROLMODEL);
    eval 'sub UISUBCLASS_ETHERNET_NETWORKING_CONTROL_MODEL () {6;}' unless defined(&UISUBCLASS_ETHERNET_NETWORKING_CONTROL_MODEL);
    eval 'sub UISUBCLASS_ATM_NETWORKING_CONTROL_MODEL () {7;}' unless defined(&UISUBCLASS_ATM_NETWORKING_CONTROL_MODEL);
    eval 'sub UISUBCLASS_WIRELESS_HANDSET_CM () {8;}' unless defined(&UISUBCLASS_WIRELESS_HANDSET_CM);
    eval 'sub UISUBCLASS_DEVICE_MGMT () {9;}' unless defined(&UISUBCLASS_DEVICE_MGMT);
    eval 'sub UISUBCLASS_MOBILE_DIRECT_LINE_MODEL () {10;}' unless defined(&UISUBCLASS_MOBILE_DIRECT_LINE_MODEL);
    eval 'sub UISUBCLASS_OBEX () {11;}' unless defined(&UISUBCLASS_OBEX);
    eval 'sub UISUBCLASS_ETHERNET_EMULATION_MODEL () {12;}' unless defined(&UISUBCLASS_ETHERNET_EMULATION_MODEL);
    eval 'sub UISUBCLASS_NETWORK_CONTROL_MODEL () {13;}' unless defined(&UISUBCLASS_NETWORK_CONTROL_MODEL);
    eval 'sub UIPROTO_CDC_NONE () {0;}' unless defined(&UIPROTO_CDC_NONE);
    eval 'sub UIPROTO_CDC_AT () {1;}' unless defined(&UIPROTO_CDC_AT);
    eval 'sub UICLASS_HID () {0x3;}' unless defined(&UICLASS_HID);
    eval 'sub UISUBCLASS_BOOT () {1;}' unless defined(&UISUBCLASS_BOOT);
    eval 'sub UIPROTO_BOOT_KEYBOARD () {1;}' unless defined(&UIPROTO_BOOT_KEYBOARD);
    eval 'sub UIPROTO_MOUSE () {2;}' unless defined(&UIPROTO_MOUSE);
    eval 'sub UICLASS_PHYSICAL () {0x5;}' unless defined(&UICLASS_PHYSICAL);
    eval 'sub UICLASS_IMAGE () {0x6;}' unless defined(&UICLASS_IMAGE);
    eval 'sub UISUBCLASS_SIC () {1;}' unless defined(&UISUBCLASS_SIC);
    eval 'sub UICLASS_PRINTER () {0x7;}' unless defined(&UICLASS_PRINTER);
    eval 'sub UISUBCLASS_PRINTER () {1;}' unless defined(&UISUBCLASS_PRINTER);
    eval 'sub UIPROTO_PRINTER_UNI () {1;}' unless defined(&UIPROTO_PRINTER_UNI);
    eval 'sub UIPROTO_PRINTER_BI () {2;}' unless defined(&UIPROTO_PRINTER_BI);
    eval 'sub UIPROTO_PRINTER_1284 () {3;}' unless defined(&UIPROTO_PRINTER_1284);
    eval 'sub UICLASS_MASS () {0x8;}' unless defined(&UICLASS_MASS);
    eval 'sub UISUBCLASS_RBC () {1;}' unless defined(&UISUBCLASS_RBC);
    eval 'sub UISUBCLASS_SFF8020I () {2;}' unless defined(&UISUBCLASS_SFF8020I);
    eval 'sub UISUBCLASS_QIC157 () {3;}' unless defined(&UISUBCLASS_QIC157);
    eval 'sub UISUBCLASS_UFI () {4;}' unless defined(&UISUBCLASS_UFI);
    eval 'sub UISUBCLASS_SFF8070I () {5;}' unless defined(&UISUBCLASS_SFF8070I);
    eval 'sub UISUBCLASS_SCSI () {6;}' unless defined(&UISUBCLASS_SCSI);
    eval 'sub UIPROTO_MASS_CBI_I () {0;}' unless defined(&UIPROTO_MASS_CBI_I);
    eval 'sub UIPROTO_MASS_CBI () {1;}' unless defined(&UIPROTO_MASS_CBI);
    eval 'sub UIPROTO_MASS_BBB_OLD () {2;}' unless defined(&UIPROTO_MASS_BBB_OLD);
    eval 'sub UIPROTO_MASS_BBB () {80;}' unless defined(&UIPROTO_MASS_BBB);
    eval 'sub UICLASS_HUB () {0x9;}' unless defined(&UICLASS_HUB);
    eval 'sub UISUBCLASS_HUB () {0;}' unless defined(&UISUBCLASS_HUB);
    eval 'sub UIPROTO_FSHUB () {0;}' unless defined(&UIPROTO_FSHUB);
    eval 'sub UIPROTO_HSHUBSTT () {0;}' unless defined(&UIPROTO_HSHUBSTT);
    eval 'sub UIPROTO_HSHUBMTT () {1;}' unless defined(&UIPROTO_HSHUBMTT);
    eval 'sub UICLASS_CDC_DATA () {0xa;}' unless defined(&UICLASS_CDC_DATA);
    eval 'sub UISUBCLASS_DATA () {0x;}' unless defined(&UISUBCLASS_DATA);
    eval 'sub UIPROTO_DATA_ISDNBRI () {0x30;}' unless defined(&UIPROTO_DATA_ISDNBRI);
    eval 'sub UIPROTO_DATA_HDLC () {0x31;}' unless defined(&UIPROTO_DATA_HDLC);
    eval 'sub UIPROTO_DATA_TRANSPARENT () {0x32;}' unless defined(&UIPROTO_DATA_TRANSPARENT);
    eval 'sub UIPROTO_DATA_Q921M () {0x50;}' unless defined(&UIPROTO_DATA_Q921M);
    eval 'sub UIPROTO_DATA_Q921 () {0x51;}' unless defined(&UIPROTO_DATA_Q921);
    eval 'sub UIPROTO_DATA_Q921TM () {0x52;}' unless defined(&UIPROTO_DATA_Q921TM);
    eval 'sub UIPROTO_DATA_V42BIS () {0x90;}' unless defined(&UIPROTO_DATA_V42BIS);
    eval 'sub UIPROTO_DATA_Q931 () {0x91;}' unless defined(&UIPROTO_DATA_Q931);
    eval 'sub UIPROTO_DATA_V120 () {0x92;}' unless defined(&UIPROTO_DATA_V120);
    eval 'sub UIPROTO_DATA_CAPI () {0x93;}' unless defined(&UIPROTO_DATA_CAPI);
    eval 'sub UIPROTO_DATA_HOST_BASED () {0xfd;}' unless defined(&UIPROTO_DATA_HOST_BASED);
    eval 'sub UIPROTO_DATA_PUF () {0xfe;}' unless defined(&UIPROTO_DATA_PUF);
    eval 'sub UIPROTO_DATA_VENDOR () {0xff;}' unless defined(&UIPROTO_DATA_VENDOR);
    eval 'sub UIPROTO_DATA_NCM () {0x1;}' unless defined(&UIPROTO_DATA_NCM);
    eval 'sub UICLASS_SMARTCARD () {0xb;}' unless defined(&UICLASS_SMARTCARD);
    eval 'sub UICLASS_FIRM_UPD () {0xc;}' unless defined(&UICLASS_FIRM_UPD);
    eval 'sub UICLASS_SECURITY () {0xd;}' unless defined(&UICLASS_SECURITY);
    eval 'sub UICLASS_DIAGNOSTIC () {0xdc;}' unless defined(&UICLASS_DIAGNOSTIC);
    eval 'sub UICLASS_WIRELESS () {0xe0;}' unless defined(&UICLASS_WIRELESS);
    eval 'sub UISUBCLASS_RF () {0x1;}' unless defined(&UISUBCLASS_RF);
    eval 'sub UIPROTO_BLUETOOTH () {0x1;}' unless defined(&UIPROTO_BLUETOOTH);
    eval 'sub UIPROTO_RNDIS () {0x3;}' unless defined(&UIPROTO_RNDIS);
    eval 'sub UICLASS_IAD () {0xef;}' unless defined(&UICLASS_IAD);
    eval 'sub UISUBCLASS_SYNC () {0x1;}' unless defined(&UISUBCLASS_SYNC);
    eval 'sub UIPROTO_ACTIVESYNC () {0x1;}' unless defined(&UIPROTO_ACTIVESYNC);
    eval 'sub UICLASS_APPL_SPEC () {0xfe;}' unless defined(&UICLASS_APPL_SPEC);
    eval 'sub UISUBCLASS_FIRMWARE_DOWNLOAD () {1;}' unless defined(&UISUBCLASS_FIRMWARE_DOWNLOAD);
    eval 'sub UISUBCLASS_IRDA () {2;}' unless defined(&UISUBCLASS_IRDA);
    eval 'sub UIPROTO_IRDA () {0;}' unless defined(&UIPROTO_IRDA);
    eval 'sub UICLASS_VENDOR () {0xff;}' unless defined(&UICLASS_VENDOR);
    eval 'sub UISUBCLASS_XBOX360_CONTROLLER () {0x5d;}' unless defined(&UISUBCLASS_XBOX360_CONTROLLER);
    eval 'sub UIPROTO_XBOX360_GAMEPAD () {0x1;}' unless defined(&UIPROTO_XBOX360_GAMEPAD);
    eval 'sub UE_GET_DIR {
        my($a) = @_;
	    eval q((($a) & 0x80));
    }' unless defined(&UE_GET_DIR);
    eval 'sub UE_SET_DIR {
        my($a,$d) = @_;
	    eval q((($a) | ((($d)&1) << 7)));
    }' unless defined(&UE_SET_DIR);
    eval 'sub UE_DIR_IN () {0x80;}' unless defined(&UE_DIR_IN);
    eval 'sub UE_DIR_OUT () {0x;}' unless defined(&UE_DIR_OUT);
    eval 'sub UE_DIR_RX () {0xfd;}' unless defined(&UE_DIR_RX);
    eval 'sub UE_DIR_TX () {0xfe;}' unless defined(&UE_DIR_TX);
    eval 'sub UE_DIR_ANY () {0xff;}' unless defined(&UE_DIR_ANY);
    eval 'sub UE_ADDR () {0xf;}' unless defined(&UE_ADDR);
    eval 'sub UE_ADDR_ANY () {0xff;}' unless defined(&UE_ADDR_ANY);
    eval 'sub UE_GET_ADDR {
        my($a) = @_;
	    eval q((($a) &  &UE_ADDR));
    }' unless defined(&UE_GET_ADDR);
    eval 'sub UE_XFERTYPE () {0x3;}' unless defined(&UE_XFERTYPE);
    eval 'sub UE_CONTROL () {0x;}' unless defined(&UE_CONTROL);
    eval 'sub UE_ISOCHRONOUS () {0x1;}' unless defined(&UE_ISOCHRONOUS);
    eval 'sub UE_BULK () {0x2;}' unless defined(&UE_BULK);
    eval 'sub UE_INTERRUPT () {0x3;}' unless defined(&UE_INTERRUPT);
    eval 'sub UE_BULK_INTR () {0xfe;}' unless defined(&UE_BULK_INTR);
    eval 'sub UE_TYPE_ANY () {0xff;}' unless defined(&UE_TYPE_ANY);
    eval 'sub UE_GET_XFERTYPE {
        my($a) = @_;
	    eval q((($a) &  &UE_XFERTYPE));
    }' unless defined(&UE_GET_XFERTYPE);
    eval 'sub UE_ISO_TYPE () {0xc;}' unless defined(&UE_ISO_TYPE);
    eval 'sub UE_ISO_ASYNC () {0x4;}' unless defined(&UE_ISO_ASYNC);
    eval 'sub UE_ISO_ADAPT () {0x8;}' unless defined(&UE_ISO_ADAPT);
    eval 'sub UE_ISO_SYNC () {0xc;}' unless defined(&UE_ISO_SYNC);
    eval 'sub UE_GET_ISO_TYPE {
        my($a) = @_;
	    eval q((($a) &  &UE_ISO_TYPE));
    }' unless defined(&UE_GET_ISO_TYPE);
    eval 'sub UE_ISO_USAGE () {0x30;}' unless defined(&UE_ISO_USAGE);
    eval 'sub UE_ISO_USAGE_DATA () {0x;}' unless defined(&UE_ISO_USAGE_DATA);
    eval 'sub UE_ISO_USAGE_FEEDBACK () {0x10;}' unless defined(&UE_ISO_USAGE_FEEDBACK);
    eval 'sub UE_ISO_USAGE_IMPLICT_FB () {0x20;}' unless defined(&UE_ISO_USAGE_IMPLICT_FB);
    eval 'sub UE_GET_ISO_USAGE {
        my($a) = @_;
	    eval q((($a) &  &UE_ISO_USAGE));
    }' unless defined(&UE_GET_ISO_USAGE);
    eval 'sub UE_ZERO_MPS () {0xffff;}' unless defined(&UE_ZERO_MPS);
    eval 'sub UE_GET_BULK_STREAMS {
        my($x) = @_;
	    eval q((($x) & 0xf));
    }' unless defined(&UE_GET_BULK_STREAMS);
    eval 'sub UE_GET_SS_ISO_MULT {
        my($x) = @_;
	    eval q((($x) & 0x3));
    }' unless defined(&UE_GET_SS_ISO_MULT);
    eval 'sub USB_MAKE_STRING_DESC {
        my($m,$name) = @_;
	    eval q( &static  &const \'struct struct\' {  &uByte  &bLength;  &uByte  &bDescriptorType;  &uByte  $bData[$sizeof{( &uint8_t []){$m}}]; }  &__packed $name = { . &bLength = $sizeof{$name}, . &bDescriptorType =  &UDESC_STRING, . &bData = { $m }, });
    }' unless defined(&USB_MAKE_STRING_DESC);
    eval 'sub UHD_PWR () {0x3;}' unless defined(&UHD_PWR);
    eval 'sub UHD_PWR_GANGED () {0x;}' unless defined(&UHD_PWR_GANGED);
    eval 'sub UHD_PWR_INDIVIDUAL () {0x1;}' unless defined(&UHD_PWR_INDIVIDUAL);
    eval 'sub UHD_PWR_NO_SWITCH () {0x2;}' unless defined(&UHD_PWR_NO_SWITCH);
    eval 'sub UHD_COMPOUND () {0x4;}' unless defined(&UHD_COMPOUND);
    eval 'sub UHD_OC () {0x18;}' unless defined(&UHD_OC);
    eval 'sub UHD_OC_GLOBAL () {0x;}' unless defined(&UHD_OC_GLOBAL);
    eval 'sub UHD_OC_INDIVIDUAL () {0x8;}' unless defined(&UHD_OC_INDIVIDUAL);
    eval 'sub UHD_OC_NONE () {0x10;}' unless defined(&UHD_OC_NONE);
    eval 'sub UHD_TT_THINK () {0x60;}' unless defined(&UHD_TT_THINK);
    eval 'sub UHD_TT_THINK_8 () {0x;}' unless defined(&UHD_TT_THINK_8);
    eval 'sub UHD_TT_THINK_16 () {0x20;}' unless defined(&UHD_TT_THINK_16);
    eval 'sub UHD_TT_THINK_24 () {0x40;}' unless defined(&UHD_TT_THINK_24);
    eval 'sub UHD_TT_THINK_32 () {0x60;}' unless defined(&UHD_TT_THINK_32);
    eval 'sub UHD_PORT_IND () {0x80;}' unless defined(&UHD_PORT_IND);
    eval 'sub UHD_PWRON_FACTOR () {2;}' unless defined(&UHD_PWRON_FACTOR);
    eval 'sub UHD_NOT_REMOV {
        my($desc, $i) = @_;
	    eval q(((($desc)-> $DeviceRemovable[($i)/8] >> (($i) % 8)) & 1));
    }' unless defined(&UHD_NOT_REMOV);
    eval 'sub UOTG_SRP () {0x1;}' unless defined(&UOTG_SRP);
    eval 'sub UOTG_HNP () {0x2;}' unless defined(&UOTG_HNP);
    eval 'sub UOTG_B_HNP_ENABLE () {3;}' unless defined(&UOTG_B_HNP_ENABLE);
    eval 'sub UOTG_A_HNP_SUPPORT () {4;}' unless defined(&UOTG_A_HNP_SUPPORT);
    eval 'sub UOTG_A_ALT_HNP_SUPPORT () {5;}' unless defined(&UOTG_A_ALT_HNP_SUPPORT);
    eval 'sub UDS_SELF_POWERED () {0x1;}' unless defined(&UDS_SELF_POWERED);
    eval 'sub UDS_REMOTE_WAKEUP () {0x2;}' unless defined(&UDS_REMOTE_WAKEUP);
    eval 'sub UES_HALT () {0x1;}' unless defined(&UES_HALT);
    eval 'sub UHS_LOCAL_POWER () {0x1;}' unless defined(&UHS_LOCAL_POWER);
    eval 'sub UHS_OVER_CURRENT () {0x2;}' unless defined(&UHS_OVER_CURRENT);
    eval 'sub UPS_CURRENT_CONNECT_STATUS () {0x1;}' unless defined(&UPS_CURRENT_CONNECT_STATUS);
    eval 'sub UPS_PORT_ENABLED () {0x2;}' unless defined(&UPS_PORT_ENABLED);
    eval 'sub UPS_SUSPEND () {0x4;}' unless defined(&UPS_SUSPEND);
    eval 'sub UPS_OVERCURRENT_INDICATOR () {0x8;}' unless defined(&UPS_OVERCURRENT_INDICATOR);
    eval 'sub UPS_RESET () {0x10;}' unless defined(&UPS_RESET);
    eval 'sub UPS_PORT_L1 () {0x20;}' unless defined(&UPS_PORT_L1);
    eval 'sub UPS_PORT_LINK_STATE_GET {
        my($x) = @_;
	    eval q(((($x) >> 5) & 0xf));
    }' unless defined(&UPS_PORT_LINK_STATE_GET);
    eval 'sub UPS_PORT_LINK_STATE_SET {
        my($x) = @_;
	    eval q(((($x) & 0xf) << 5));
    }' unless defined(&UPS_PORT_LINK_STATE_SET);
    eval 'sub UPS_PORT_LS_U0 () {0x;}' unless defined(&UPS_PORT_LS_U0);
    eval 'sub UPS_PORT_LS_U1 () {0x1;}' unless defined(&UPS_PORT_LS_U1);
    eval 'sub UPS_PORT_LS_U2 () {0x2;}' unless defined(&UPS_PORT_LS_U2);
    eval 'sub UPS_PORT_LS_U3 () {0x3;}' unless defined(&UPS_PORT_LS_U3);
    eval 'sub UPS_PORT_LS_SS_DIS () {0x4;}' unless defined(&UPS_PORT_LS_SS_DIS);
    eval 'sub UPS_PORT_LS_RX_DET () {0x5;}' unless defined(&UPS_PORT_LS_RX_DET);
    eval 'sub UPS_PORT_LS_SS_INA () {0x6;}' unless defined(&UPS_PORT_LS_SS_INA);
    eval 'sub UPS_PORT_LS_POLL () {0x7;}' unless defined(&UPS_PORT_LS_POLL);
    eval 'sub UPS_PORT_LS_RECOVER () {0x8;}' unless defined(&UPS_PORT_LS_RECOVER);
    eval 'sub UPS_PORT_LS_HOT_RST () {0x9;}' unless defined(&UPS_PORT_LS_HOT_RST);
    eval 'sub UPS_PORT_LS_COMP_MODE () {0xa;}' unless defined(&UPS_PORT_LS_COMP_MODE);
    eval 'sub UPS_PORT_LS_LOOPBACK () {0xb;}' unless defined(&UPS_PORT_LS_LOOPBACK);
    eval 'sub UPS_PORT_LS_RESUME () {0xf;}' unless defined(&UPS_PORT_LS_RESUME);
    eval 'sub UPS_PORT_POWER () {0x100;}' unless defined(&UPS_PORT_POWER);
    eval 'sub UPS_PORT_POWER_SS () {0x200;}' unless defined(&UPS_PORT_POWER_SS);
    eval 'sub UPS_LOW_SPEED () {0x200;}' unless defined(&UPS_LOW_SPEED);
    eval 'sub UPS_HIGH_SPEED () {0x400;}' unless defined(&UPS_HIGH_SPEED);
    eval 'sub UPS_OTHER_SPEED () {0x600;}' unless defined(&UPS_OTHER_SPEED);
    eval 'sub UPS_PORT_TEST () {0x800;}' unless defined(&UPS_PORT_TEST);
    eval 'sub UPS_PORT_INDICATOR () {0x1000;}' unless defined(&UPS_PORT_INDICATOR);
    eval 'sub UPS_PORT_MODE_DEVICE () {0x8000;}' unless defined(&UPS_PORT_MODE_DEVICE);
    eval 'sub UPS_C_CONNECT_STATUS () {0x1;}' unless defined(&UPS_C_CONNECT_STATUS);
    eval 'sub UPS_C_PORT_ENABLED () {0x2;}' unless defined(&UPS_C_PORT_ENABLED);
    eval 'sub UPS_C_SUSPEND () {0x4;}' unless defined(&UPS_C_SUSPEND);
    eval 'sub UPS_C_OVERCURRENT_INDICATOR () {0x8;}' unless defined(&UPS_C_OVERCURRENT_INDICATOR);
    eval 'sub UPS_C_PORT_RESET () {0x10;}' unless defined(&UPS_C_PORT_RESET);
    eval 'sub UPS_C_PORT_L1 () {0x20;}' unless defined(&UPS_C_PORT_L1);
    eval 'sub UPS_C_BH_PORT_RESET () {0x20;}' unless defined(&UPS_C_BH_PORT_RESET);
    eval 'sub UPS_C_PORT_LINK_STATE () {0x40;}' unless defined(&UPS_C_PORT_LINK_STATE);
    eval 'sub UPS_C_PORT_CONFIG_ERROR () {0x80;}' unless defined(&UPS_C_PORT_CONFIG_ERROR);
    eval("sub USB_SPEED_VARIABLE () { 0; }") unless defined(&USB_SPEED_VARIABLE);
    eval("sub USB_SPEED_LOW () { 1; }") unless defined(&USB_SPEED_LOW);
    eval("sub USB_SPEED_FULL () { 2; }") unless defined(&USB_SPEED_FULL);
    eval("sub USB_SPEED_HIGH () { 3; }") unless defined(&USB_SPEED_HIGH);
    eval("sub USB_SPEED_SUPER () { 4; }") unless defined(&USB_SPEED_SUPER);
    eval 'sub USB_SPEED_MAX () {( &USB_SPEED_SUPER+1);}' unless defined(&USB_SPEED_MAX);
    eval("sub USB_REV_UNKNOWN () { 0; }") unless defined(&USB_REV_UNKNOWN);
    eval("sub USB_REV_PRE_1_0 () { 1; }") unless defined(&USB_REV_PRE_1_0);
    eval("sub USB_REV_1_0 () { 2; }") unless defined(&USB_REV_1_0);
    eval("sub USB_REV_1_1 () { 3; }") unless defined(&USB_REV_1_1);
    eval("sub USB_REV_2_0 () { 4; }") unless defined(&USB_REV_2_0);
    eval("sub USB_REV_2_5 () { 5; }") unless defined(&USB_REV_2_5);
    eval("sub USB_REV_3_0 () { 6; }") unless defined(&USB_REV_3_0);
    eval 'sub USB_REV_MAX () {( &USB_REV_3_0+1);}' unless defined(&USB_REV_MAX);
    eval("sub USB_MODE_HOST () { 0; }") unless defined(&USB_MODE_HOST);
    eval("sub USB_MODE_DEVICE () { 1; }") unless defined(&USB_MODE_DEVICE);
    eval("sub USB_MODE_DUAL () { 2; }") unless defined(&USB_MODE_DUAL);
    eval 'sub USB_MODE_MAX () {( &USB_MODE_DUAL+1);}' unless defined(&USB_MODE_MAX);
    eval("sub USB_STATE_DETACHED () { 0; }") unless defined(&USB_STATE_DETACHED);
    eval("sub USB_STATE_ATTACHED () { 1; }") unless defined(&USB_STATE_ATTACHED);
    eval("sub USB_STATE_POWERED () { 2; }") unless defined(&USB_STATE_POWERED);
    eval("sub USB_STATE_ADDRESSED () { 3; }") unless defined(&USB_STATE_ADDRESSED);
    eval("sub USB_STATE_CONFIGURED () { 4; }") unless defined(&USB_STATE_CONFIGURED);
    eval 'sub USB_STATE_MAX () {( &USB_STATE_CONFIGURED+1);}' unless defined(&USB_STATE_MAX);
    eval("sub USB_EP_MODE_DEFAULT () { 0; }") unless defined(&USB_EP_MODE_DEFAULT);
    eval("sub USB_EP_MODE_STREAMS () { 1; }") unless defined(&USB_EP_MODE_STREAMS);
    eval("sub USB_EP_MODE_HW_MASS_STORAGE () { 2; }") unless defined(&USB_EP_MODE_HW_MASS_STORAGE);
    eval("sub USB_EP_MODE_HW_SERIAL () { 3; }") unless defined(&USB_EP_MODE_HW_SERIAL);
    eval("sub USB_EP_MODE_HW_ETHERNET_CDC () { 4; }") unless defined(&USB_EP_MODE_HW_ETHERNET_CDC);
    eval("sub USB_EP_MODE_HW_ETHERNET_NCM () { 5; }") unless defined(&USB_EP_MODE_HW_ETHERNET_NCM);
    eval("sub USB_EP_MODE_MAX () { 6; }") unless defined(&USB_EP_MODE_MAX);
}
1;
