require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_USB_ENDIAN_H_)) {
    eval 'sub _USB_ENDIAN_H_ () {1;}' unless defined(&_USB_ENDIAN_H_);
    unless(defined(&USB_GLOBAL_INCLUDE_FILE)) {
	require 'sys/stdint.ph';
	require 'sys/endian.ph';
    }
    eval 'sub UGETB {
        my($w) = @_;
	    eval q((($w)[0]));
    }' unless defined(&UGETB);
    eval 'sub UGETW {
        my($w) = @_;
	    eval q((($w)[0] | ((( &uint16_t)(($w)[1])) << 8)));
    }' unless defined(&UGETW);
    eval 'sub UGETDW {
        my($w) = @_;
	    eval q((($w)[0] | ((( &uint16_t)(($w)[1])) << 8) | ((( &uint32_t)(($w)[2])) << 16) | ((( &uint32_t)(($w)[3])) << 24)));
    }' unless defined(&UGETDW);
    eval 'sub UGETQW {
        my($w) = @_;
	    eval q((($w)[0] | ((( &uint16_t)(($w)[1])) << 8) | ((( &uint32_t)(($w)[2])) << 16) | ((( &uint32_t)(($w)[3])) << 24) | ((( &uint64_t)(($w)[4])) << 32) | ((( &uint64_t)(($w)[5])) << 40) | ((( &uint64_t)(($w)[6])) << 48) | ((( &uint64_t)(($w)[7])) << 56)));
    }' unless defined(&UGETQW);
    eval 'sub USETB {
        my($w,$v) = @_;
	    eval q( &do { ($w)[0] = ( &uint8_t)($v); }  &while (0));
    }' unless defined(&USETB);
    eval 'sub USETW {
        my($w,$v) = @_;
	    eval q( &do { ($w)[0] = ( &uint8_t)($v); ($w)[1] = ( &uint8_t)(($v) >> 8); }  &while (0));
    }' unless defined(&USETW);
    eval 'sub USETDW {
        my($w,$v) = @_;
	    eval q( &do { ($w)[0] = ( &uint8_t)($v); ($w)[1] = ( &uint8_t)(($v) >> 8); ($w)[2] = ( &uint8_t)(($v) >> 16); ($w)[3] = ( &uint8_t)(($v) >> 24); }  &while (0));
    }' unless defined(&USETDW);
    eval 'sub USETQW {
        my($w,$v) = @_;
	    eval q( &do { ($w)[0] = ( &uint8_t)($v); ($w)[1] = ( &uint8_t)(($v) >> 8); ($w)[2] = ( &uint8_t)(($v) >> 16); ($w)[3] = ( &uint8_t)(($v) >> 24); ($w)[4] = ( &uint8_t)(($v) >> 32); ($w)[5] = ( &uint8_t)(($v) >> 40); ($w)[6] = ( &uint8_t)(($v) >> 48); ($w)[7] = ( &uint8_t)(($v) >> 56); }  &while (0));
    }' unless defined(&USETQW);
    eval 'sub USETW2 {
        my($w,$b1,$b0) = @_;
	    eval q( &do { ($w)[0] = ( &uint8_t)($b0); ($w)[1] = ( &uint8_t)($b1); }  &while (0));
    }' unless defined(&USETW2);
    eval 'sub USETW4 {
        my($w,$b3,$b2,$b1,$b0) = @_;
	    eval q( &do { ($w)[0] = ( &uint8_t)($b0); ($w)[1] = ( &uint8_t)($b1); ($w)[2] = ( &uint8_t)($b2); ($w)[3] = ( &uint8_t)($b3); }  &while (0));
    }' unless defined(&USETW4);
    eval 'sub USETW8 {
        my($w,$b7,$b6,$b5,$b4,$b3,$b2,$b1,$b0) = @_;
	    eval q( &do { ($w)[0] = ( &uint8_t)($b0); ($w)[1] = ( &uint8_t)($b1); ($w)[2] = ( &uint8_t)($b2); ($w)[3] = ( &uint8_t)($b3); ($w)[4] = ( &uint8_t)($b4); ($w)[5] = ( &uint8_t)($b5); ($w)[6] = ( &uint8_t)($b6); ($w)[7] = ( &uint8_t)($b7); }  &while (0));
    }' unless defined(&USETW8);
}
1;
