require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_FS_NANDFS_NANDFS_H_)) {
    eval 'sub _FS_NANDFS_NANDFS_H_ () {1;}' unless defined(&_FS_NANDFS_NANDFS_H_);
    require 'sys/param.ph';
    require 'sys/proc.ph';
    require 'sys/condvar.ph';
    require 'sys/lock.ph';
    require 'sys/mutex.ph';
    require 'sys/queue.ph';
    require 'sys/uio.ph';
    require 'sys/mutex.ph';
    require 'sys/disk.ph';
    require 'sys/kthread.ph';
    require './fs/nandfs/nandfs_fs.ph';
    eval 'sub NANDFS_DEBUG_VOLUMES () {0x1;}' unless defined(&NANDFS_DEBUG_VOLUMES);
    eval 'sub NANDFS_DEBUG_BLOCK () {0x4;}' unless defined(&NANDFS_DEBUG_BLOCK);
    eval 'sub NANDFS_DEBUG_LOCKING () {0x8;}' unless defined(&NANDFS_DEBUG_LOCKING);
    eval 'sub NANDFS_DEBUG_NODE () {0x10;}' unless defined(&NANDFS_DEBUG_NODE);
    eval 'sub NANDFS_DEBUG_LOOKUP () {0x20;}' unless defined(&NANDFS_DEBUG_LOOKUP);
    eval 'sub NANDFS_DEBUG_READDIR () {0x40;}' unless defined(&NANDFS_DEBUG_READDIR);
    eval 'sub NANDFS_DEBUG_TRANSLATE () {0x80;}' unless defined(&NANDFS_DEBUG_TRANSLATE);
    eval 'sub NANDFS_DEBUG_STRATEGY () {0x100;}' unless defined(&NANDFS_DEBUG_STRATEGY);
    eval 'sub NANDFS_DEBUG_READ () {0x200;}' unless defined(&NANDFS_DEBUG_READ);
    eval 'sub NANDFS_DEBUG_WRITE () {0x400;}' unless defined(&NANDFS_DEBUG_WRITE);
    eval 'sub NANDFS_DEBUG_IFILE () {0x800;}' unless defined(&NANDFS_DEBUG_IFILE);
    eval 'sub NANDFS_DEBUG_ATTR () {0x1000;}' unless defined(&NANDFS_DEBUG_ATTR);
    eval 'sub NANDFS_DEBUG_EXTATTR () {0x2000;}' unless defined(&NANDFS_DEBUG_EXTATTR);
    eval 'sub NANDFS_DEBUG_ALLOC () {0x4000;}' unless defined(&NANDFS_DEBUG_ALLOC);
    eval 'sub NANDFS_DEBUG_CPFILE () {0x8000;}' unless defined(&NANDFS_DEBUG_CPFILE);
    eval 'sub NANDFS_DEBUG_DIRHASH () {0x10000;}' unless defined(&NANDFS_DEBUG_DIRHASH);
    eval 'sub NANDFS_DEBUG_NOTIMPL () {0x20000;}' unless defined(&NANDFS_DEBUG_NOTIMPL);
    eval 'sub NANDFS_DEBUG_SHEDULE () {0x40000;}' unless defined(&NANDFS_DEBUG_SHEDULE);
    eval 'sub NANDFS_DEBUG_SEG () {0x80000;}' unless defined(&NANDFS_DEBUG_SEG);
    eval 'sub NANDFS_DEBUG_SYNC () {0x100000;}' unless defined(&NANDFS_DEBUG_SYNC);
    eval 'sub NANDFS_DEBUG_PARANOIA () {0x200000;}' unless defined(&NANDFS_DEBUG_PARANOIA);
    eval 'sub NANDFS_DEBUG_VNCALL () {0x400000;}' unless defined(&NANDFS_DEBUG_VNCALL);
    eval 'sub NANDFS_DEBUG_BUF () {0x1000000;}' unless defined(&NANDFS_DEBUG_BUF);
    eval 'sub NANDFS_DEBUG_BMAP () {0x2000000;}' unless defined(&NANDFS_DEBUG_BMAP);
    eval 'sub NANDFS_DEBUG_DAT () {0x4000000;}' unless defined(&NANDFS_DEBUG_DAT);
    eval 'sub NANDFS_DEBUG_GENERIC () {0x8000000;}' unless defined(&NANDFS_DEBUG_GENERIC);
    eval 'sub NANDFS_DEBUG_CLEAN () {0x10000000;}' unless defined(&NANDFS_DEBUG_CLEAN);
    eval 'sub DPRINTF {
        my($name, $arg) = @_;
	    eval q({  &if ( &nandfs_verbose &  &NANDFS_DEBUG_$name) {  &printf $arg; }; });
    }' unless defined(&DPRINTF);
    eval 'sub DPRINTFIF {
        my($name, $cond, $arg) = @_;
	    eval q({  &if ( &nandfs_verbose &  &NANDFS_DEBUG_$name) {  &if ($cond)  &printf $arg; }; });
    }' unless defined(&DPRINTFIF);
    eval 'sub VFSTONANDFS {
        my($mp) = @_;
	    eval q(((($mp)-> &mnt_data)));
    }' unless defined(&VFSTONANDFS);
    eval 'sub VTON {
        my($vp) = @_;
	    eval q((($vp)-> &v_data));
    }' unless defined(&VTON);
    eval 'sub NTOV {
        my($xp) = @_;
	    eval q((($xp)-> &nn_vnode));
    }' unless defined(&NTOV);
    eval 'sub NANDFS_FSSTOR_FAILED () {1;}' unless defined(&NANDFS_FSSTOR_FAILED);
    eval 'sub NANDFS_FORCE_SYNCER () {0x1;}' unless defined(&NANDFS_FORCE_SYNCER);
    eval 'sub NANDFS_UMOUNT () {0x2;}' unless defined(&NANDFS_UMOUNT);
    eval 'sub SYNCER_UMOUNT () {0x;}' unless defined(&SYNCER_UMOUNT);
    eval 'sub SYNCER_VFS_SYNC () {0x1;}' unless defined(&SYNCER_VFS_SYNC);
    eval 'sub SYNCER_BDFLUSH () {0x2;}' unless defined(&SYNCER_BDFLUSH);
    eval 'sub SYNCER_FFORCE () {0x3;}' unless defined(&SYNCER_FFORCE);
    eval 'sub SYNCER_FSYNC () {0x4;}' unless defined(&SYNCER_FSYNC);
    eval 'sub SYNCER_ROUPD () {0x5;}' unless defined(&SYNCER_ROUPD);
    eval 'sub nandfs_writelockflags {
        my($fsdev,$flags) = @_;
	    eval q({ \'int\'  &error = 0;  &if ( &lockstatus( ($fsdev->{nd_seg_const})) !=  &LK_EXCLUSIVE)  &error =  &lockmgr( ($fsdev->{nd_seg_const}), $flags |  &LK_SHARED,  &NULL); ( &error); });
    }' unless defined(&nandfs_writelockflags);
    eval 'sub nandfs_writeunlock {
        my($fsdev) = @_;
	    eval q({  &if ( &lockstatus( ($fsdev->{nd_seg_const})) !=  &LK_EXCLUSIVE)  &lockmgr(($fsdev)-> &nd_seg_const,  &LK_RELEASE,  &NULL); });
    }' unless defined(&nandfs_writeunlock);
    eval 'sub NANDFS_WRITELOCKFLAGS {
        my($fsdev, $flags) = @_;
	    eval q( &nandfs_writelockflags($fsdev, $flags));
    }' unless defined(&NANDFS_WRITELOCKFLAGS);
    eval 'sub NANDFS_WRITELOCK {
        my($fsdev) = @_;
	    eval q( &NANDFS_WRITELOCKFLAGS($fsdev, 0));
    }' unless defined(&NANDFS_WRITELOCK);
    eval 'sub NANDFS_WRITEUNLOCK {
        my($fsdev) = @_;
	    eval q( &nandfs_writeunlock($fsdev));
    }' unless defined(&NANDFS_WRITEUNLOCK);
    eval 'sub NANDFS_WRITEASSERT {
        my($fsdev) = @_;
	    eval q( &lockmgr_assert(($fsdev)-> &nd_seg_const,  &KA_LOCKED));
    }' unless defined(&NANDFS_WRITEASSERT);
    eval 'sub IN_ACCESS () {0x1;}' unless defined(&IN_ACCESS);
    eval 'sub IN_CHANGE () {0x2;}' unless defined(&IN_CHANGE);
    eval 'sub IN_UPDATE () {0x4;}' unless defined(&IN_UPDATE);
    eval 'sub IN_MODIFIED () {0x8;}' unless defined(&IN_MODIFIED);
    eval 'sub IN_RENAME () {0x10;}' unless defined(&IN_RENAME);
    eval 'sub IEXEC () {0000100;}' unless defined(&IEXEC);
    eval 'sub IWRITE () {0000200;}' unless defined(&IWRITE);
    eval 'sub IREAD () {0000400;}' unless defined(&IREAD);
    eval 'sub ISVTX () {0001000;}' unless defined(&ISVTX);
    eval 'sub ISGID () {0002000;}' unless defined(&ISGID);
    eval 'sub ISUID () {0004000;}' unless defined(&ISUID);
    eval 'sub PRINT_NODE_FLAGS () {"\\10\\1IN_ACCESS\\2IN_CHANGE\\3IN_UPDATE\\4IN_MODIFIED\\5IN_RENAME";}' unless defined(&PRINT_NODE_FLAGS);
    eval 'sub NANDFS_GATHER {
        my($x) = @_;
	    eval q((($x)-> &b_flags |=  &B_FS_FLAG1));
    }' unless defined(&NANDFS_GATHER);
    eval 'sub NANDFS_UNGATHER {
        my($x) = @_;
	    eval q((($x)-> &b_flags &= ~ &B_FS_FLAG1));
    }' unless defined(&NANDFS_UNGATHER);
    eval 'sub NANDFS_ISGATHERED {
        my($x) = @_;
	    eval q((($x)-> &b_flags &  &B_FS_FLAG1));
    }' unless defined(&NANDFS_ISGATHERED);
}
1;
