require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NANDFS_FS_H)) {
    eval 'sub _NANDFS_FS_H () {1;}' unless defined(&_NANDFS_FS_H);
    require 'sys/uuid.ph';
    eval 'sub MNINDIR {
        my($fsdev) = @_;
	    eval q((($fsdev)-> &nd_blocksize / $sizeof{ &nandfs_daddr_t}));
    }' unless defined(&MNINDIR);
    eval 'sub NANDFS_WHT_INO () {1;}' unless defined(&NANDFS_WHT_INO);
    eval 'sub NANDFS_ROOT_INO () {2;}' unless defined(&NANDFS_ROOT_INO);
    eval 'sub NANDFS_DAT_INO () {3;}' unless defined(&NANDFS_DAT_INO);
    eval 'sub NANDFS_CPFILE_INO () {4;}' unless defined(&NANDFS_CPFILE_INO);
    eval 'sub NANDFS_SUFILE_INO () {5;}' unless defined(&NANDFS_SUFILE_INO);
    eval 'sub NANDFS_IFILE_INO () {6;}' unless defined(&NANDFS_IFILE_INO);
    eval 'sub NANDFS_GC_INO () {7;}' unless defined(&NANDFS_GC_INO);
    eval 'sub NANDFS_ATIME_INO () {8;}' unless defined(&NANDFS_ATIME_INO);
    eval 'sub NANDFS_XATTR_INO () {9;}' unless defined(&NANDFS_XATTR_INO);
    eval 'sub NANDFS_SKETCH_INO () {10;}' unless defined(&NANDFS_SKETCH_INO);
    eval 'sub NANDFS_USER_INO () {11;}' unless defined(&NANDFS_USER_INO);
    eval 'sub NANDFS_SYS_NODE {
        my($ino) = @_;
	    eval q(((($ino) >=  &NANDFS_DAT_INO)  && (($ino) <=  &NANDFS_GC_INO)));
    }' unless defined(&NANDFS_SYS_NODE);
    eval 'sub NDADDR () {12;}' unless defined(&NDADDR);
    eval 'sub NIADDR () {3;}' unless defined(&NIADDR);
    if(defined(&_KERNEL)) {
    }
    eval 'sub NANDFS_SR_MDT_OFFSET {
        my($inode_size, $i) = @_;
	    eval q((( &uint32_t)(0)-> &sr_dat + ($inode_size) * ($i)));
    }' unless defined(&NANDFS_SR_MDT_OFFSET);
    eval 'sub NANDFS_SR_DAT_OFFSET {
        my($inode_size) = @_;
	    eval q( &NANDFS_SR_MDT_OFFSET($inode_size, 0));
    }' unless defined(&NANDFS_SR_DAT_OFFSET);
    eval 'sub NANDFS_SR_CPFILE_OFFSET {
        my($inode_size) = @_;
	    eval q( &NANDFS_SR_MDT_OFFSET($inode_size, 1));
    }' unless defined(&NANDFS_SR_CPFILE_OFFSET);
    eval 'sub NANDFS_SR_SUFILE_OFFSET {
        my($inode_size) = @_;
	    eval q( &NANDFS_SR_MDT_OFFSET($inode_size, 2));
    }' unless defined(&NANDFS_SR_SUFILE_OFFSET);
    eval 'sub NANDFS_SR_BYTES () {($sizeof{\'struct nandfs_super_root\'});}' unless defined(&NANDFS_SR_BYTES);
    eval 'sub NANDFS_VALID_FS () {0x1;}' unless defined(&NANDFS_VALID_FS);
    eval 'sub NANDFS_ERROR_FS () {0x2;}' unless defined(&NANDFS_ERROR_FS);
    eval 'sub NANDFS_RESIZE_FS () {0x4;}' unless defined(&NANDFS_RESIZE_FS);
    eval 'sub NANDFS_MOUNT_STATE_BITS () {"\\20\\1VALID_FS\\2ERROR_FS\\3RESIZE_FS";}' unless defined(&NANDFS_MOUNT_STATE_BITS);
    if(defined(&_KERNEL)) {
    }
    if(defined(&_KERNEL)) {
    }
    eval 'sub NANDFS_FSDATA_MAGIC () {0xf8da;}' unless defined(&NANDFS_FSDATA_MAGIC);
    eval 'sub NANDFS_SUPER_MAGIC () {0x8008;}' unless defined(&NANDFS_SUPER_MAGIC);
    eval 'sub NANDFS_NFSAREAS () {4;}' unless defined(&NANDFS_NFSAREAS);
    eval 'sub NANDFS_DATA_OFFSET_BYTES {
        my($esize) = @_;
	    eval q(( &NANDFS_NFSAREAS * ($esize)));
    }' unless defined(&NANDFS_DATA_OFFSET_BYTES);
    eval 'sub NANDFS_SBLOCK_OFFSET_BYTES () {($sizeof{\'struct nandfs_fsdata\'});}' unless defined(&NANDFS_SBLOCK_OFFSET_BYTES);
    eval 'sub NANDFS_DEF_BLOCKSIZE () {4096;}' unless defined(&NANDFS_DEF_BLOCKSIZE);
    eval 'sub NANDFS_MIN_BLOCKSIZE () {512;}' unless defined(&NANDFS_MIN_BLOCKSIZE);
    eval 'sub NANDFS_DEF_ERASESIZE () {(2<< 16);}' unless defined(&NANDFS_DEF_ERASESIZE);
    eval 'sub NANDFS_MIN_SEGSIZE () { &NANDFS_DEF_ERASESIZE;}' unless defined(&NANDFS_MIN_SEGSIZE);
    eval 'sub NANDFS_CURRENT_REV () {9;}' unless defined(&NANDFS_CURRENT_REV);
    eval 'sub NANDFS_FSDATA_CRC_BYTES () { &offsetof(\'struct nandfs_fsdata\',  &f_pad);}' unless defined(&NANDFS_FSDATA_CRC_BYTES);
    eval 'sub NANDFS_SB_BYTES () { &offsetof(\'struct nandfs_super_block\',  &s_reserved);}' unless defined(&NANDFS_SB_BYTES);
    eval 'sub NANDFS_LINK_MAX () {32000;}' unless defined(&NANDFS_LINK_MAX);
    eval 'sub NANDFS_NAME_LEN () {255;}' unless defined(&NANDFS_NAME_LEN);
    eval 'sub NANDFS_DIR_PAD () {8;}' unless defined(&NANDFS_DIR_PAD);
    eval 'sub NANDFS_DIR_ROUND () {( &NANDFS_DIR_PAD - 1);}' unless defined(&NANDFS_DIR_ROUND);
    eval 'sub NANDFS_DIR_NAME_OFFSET () {( &offsetof(\'struct nandfs_dir_entry\',  &name));}' unless defined(&NANDFS_DIR_NAME_OFFSET);
    eval 'sub NANDFS_DIR_REC_LEN {
        my($name_len) = @_;
	    eval q(((($name_len) +  &NANDFS_DIR_NAME_OFFSET +  &NANDFS_DIR_ROUND) & ~ &NANDFS_DIR_ROUND));
    }' unless defined(&NANDFS_DIR_REC_LEN);
    eval 'sub NANDFS_DIR_NAME_LEN {
        my($name_len) = @_;
	    eval q(( &NANDFS_DIR_REC_LEN($name_len) -  &NANDFS_DIR_NAME_OFFSET));
    }' unless defined(&NANDFS_DIR_NAME_LEN);
    if(defined(&_KERNEL)) {
    }
    eval 'sub NANDFS_SEGSUM_MAGIC () {0x8e680011;}' unless defined(&NANDFS_SEGSUM_MAGIC);
    eval 'sub NANDFS_SS_LOGBGN () {0x1;}' unless defined(&NANDFS_SS_LOGBGN);
    eval 'sub NANDFS_SS_LOGEND () {0x2;}' unless defined(&NANDFS_SS_LOGEND);
    eval 'sub NANDFS_SS_SR () {0x4;}' unless defined(&NANDFS_SS_SR);
    eval 'sub NANDFS_SS_SYNDT () {0x8;}' unless defined(&NANDFS_SS_SYNDT);
    eval 'sub NANDFS_SS_GC () {0x10;}' unless defined(&NANDFS_SS_GC);
    eval 'sub NANDFS_SS_FLAG_BITS () {"\\20\\1LOGBGN\\2LOGEND\\3SR\\4SYNDT\\5GC";}' unless defined(&NANDFS_SS_FLAG_BITS);
    eval 'sub NANDFS_SEG_MIN_BLOCKS () {16;}' unless defined(&NANDFS_SEG_MIN_BLOCKS);
    eval 'sub NANDFS_PSEG_MIN_BLOCKS () {2;}' unless defined(&NANDFS_PSEG_MIN_BLOCKS);
    eval 'sub NANDFS_MIN_NRSVSEGS () {8;}' unless defined(&NANDFS_MIN_NRSVSEGS);
    eval 'sub NANDFS_CHECKPOINT_SNAPSHOT () {1;}' unless defined(&NANDFS_CHECKPOINT_SNAPSHOT);
    eval 'sub NANDFS_CHECKPOINT_INVALID () {2;}' unless defined(&NANDFS_CHECKPOINT_INVALID);
    eval 'sub NANDFS_CHECKPOINT_SKETCH () {4;}' unless defined(&NANDFS_CHECKPOINT_SKETCH);
    eval 'sub NANDFS_CHECKPOINT_MINOR () {8;}' unless defined(&NANDFS_CHECKPOINT_MINOR);
    eval 'sub NANDFS_CHECKPOINT_BITS () {"\\20\\1SNAPSHOT\\2INVALID\\3SKETCH\\4MINOR";}' unless defined(&NANDFS_CHECKPOINT_BITS);
    eval 'sub NANDFS_CPFILE_FIRST_CHECKPOINT_OFFSET () {(($sizeof{\'struct nandfs_cpfile_header\'} + $sizeof{\'struct nandfs_checkpoint\'} - 1) / $sizeof{\'struct nandfs_checkpoint\'});}' unless defined(&NANDFS_CPFILE_FIRST_CHECKPOINT_OFFSET);
    eval 'sub NANDFS_NOSEGMENT () {0xffffffff;}' unless defined(&NANDFS_NOSEGMENT);
    eval 'sub NANDFS_SEGMENT_USAGE_ACTIVE () {1;}' unless defined(&NANDFS_SEGMENT_USAGE_ACTIVE);
    eval 'sub NANDFS_SEGMENT_USAGE_DIRTY () {2;}' unless defined(&NANDFS_SEGMENT_USAGE_DIRTY);
    eval 'sub NANDFS_SEGMENT_USAGE_ERROR () {4;}' unless defined(&NANDFS_SEGMENT_USAGE_ERROR);
    eval 'sub NANDFS_SEGMENT_USAGE_GC () {8;}' unless defined(&NANDFS_SEGMENT_USAGE_GC);
    eval 'sub NANDFS_SEGMENT_USAGE_BITS () {"\\20\\1ACTIVE\\2DIRTY\\3ERROR";}' unless defined(&NANDFS_SEGMENT_USAGE_BITS);
    eval 'sub NANDFS_SUFILE_FIRST_SEGMENT_USAGE_OFFSET () {(($sizeof{\'struct nandfs_sufile_header\'} + $sizeof{\'struct nandfs_segment_usage\'} - 1) / $sizeof{\'struct nandfs_segment_usage\'});}' unless defined(&NANDFS_SUFILE_FIRST_SEGMENT_USAGE_OFFSET);
    eval("sub NANDFS_CHECKPOINT () { 0; }") unless defined(&NANDFS_CHECKPOINT);
    eval("sub NANDFS_SNAPSHOT () { 1; }") unless defined(&NANDFS_SNAPSHOT);
    eval 'sub NANDFS_CPINFO_MAX () {512;}' unless defined(&NANDFS_CPINFO_MAX);
    eval 'sub NANDFS_SEGMENTS_MAX () {512;}' unless defined(&NANDFS_SEGMENTS_MAX);
    eval 'sub NANDFS_VINFO_MAX () {512;}' unless defined(&NANDFS_VINFO_MAX);
    unless(defined(&_KERNEL)) {
	unless(defined(&MNAMELEN)) {
	    eval 'sub MNAMELEN () {88;}' unless defined(&MNAMELEN);
	}
    }
    eval 'sub NANDFS_MAX_MOUNTS () {65535;}' unless defined(&NANDFS_MAX_MOUNTS);
    eval 'sub NANDFS_IOCTL_GET_SUSTAT () { &_IOR(ord(\'N\'), 100, \'struct nandfs_seg_stat\');}' unless defined(&NANDFS_IOCTL_GET_SUSTAT);
    eval 'sub NANDFS_IOCTL_CHANGE_CPMODE () { &_IOWR(ord(\'N\'), 101, \'struct nandfs_cpmode\');}' unless defined(&NANDFS_IOCTL_CHANGE_CPMODE);
    eval 'sub NANDFS_IOCTL_GET_CPINFO () { &_IOWR(ord(\'N\'), 102, \'struct nandfs_argv\');}' unless defined(&NANDFS_IOCTL_GET_CPINFO);
    eval 'sub NANDFS_IOCTL_DELETE_CP () { &_IOWR(ord(\'N\'), 103,  $uint64_t[2]);}' unless defined(&NANDFS_IOCTL_DELETE_CP);
    eval 'sub NANDFS_IOCTL_GET_CPSTAT () { &_IOR(ord(\'N\'), 104, \'struct nandfs_cpstat\');}' unless defined(&NANDFS_IOCTL_GET_CPSTAT);
    eval 'sub NANDFS_IOCTL_GET_SUINFO () { &_IOWR(ord(\'N\'), 105, \'struct nandfs_argv\');}' unless defined(&NANDFS_IOCTL_GET_SUINFO);
    eval 'sub NANDFS_IOCTL_GET_VINFO () { &_IOWR(ord(\'N\'), 106, \'struct nandfs_argv\');}' unless defined(&NANDFS_IOCTL_GET_VINFO);
    eval 'sub NANDFS_IOCTL_GET_BDESCS () { &_IOWR(ord(\'N\'), 107, \'struct nandfs_argv\');}' unless defined(&NANDFS_IOCTL_GET_BDESCS);
    eval 'sub NANDFS_IOCTL_GET_FSINFO () { &_IOR(ord(\'N\'), 108, \'struct nandfs_fsinfo\');}' unless defined(&NANDFS_IOCTL_GET_FSINFO);
    eval 'sub NANDFS_IOCTL_MAKE_SNAP () { &_IOWR(ord(\'N\'), 109,  &uint64_t);}' unless defined(&NANDFS_IOCTL_MAKE_SNAP);
    eval 'sub NANDFS_IOCTL_DELETE_SNAP () { &_IOWR(ord(\'N\'), 110,  &uint64_t);}' unless defined(&NANDFS_IOCTL_DELETE_SNAP);
    eval 'sub NANDFS_IOCTL_SYNC () { &_IOWR(ord(\'N\'), 111,  &uint64_t);}' unless defined(&NANDFS_IOCTL_SYNC);
}
1;
