require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&NFSVNO_ATTRINIT)) {
    sub NFSVNO_ATTRINIT {
	my($n) = @_;
	eval q(( &VATTR_NULL((($n)-> &na_vattr))));
    }
}
unless(defined(&NFSVNO_SETATTRVAL)) {
    sub NFSVNO_SETATTRVAL {
	my($n, $f, $v) = @_;
	eval q((($n)-> &na_$f = ($v)));
    }
}
unless(defined(&NFSVNO_SETACTIVE)) {
    sub NFSVNO_SETACTIVE {
	my($n, $f) = @_;
	eval q();
    }
}
unless(defined(&NFSVNO_UNSET)) {
    sub NFSVNO_UNSET {
	my($n, $f) = @_;
	eval q((($n)-> &na_$f =  &VNOVAL));
    }
}
unless(defined(&NFSVNO_NOTSETMODE)) {
    sub NFSVNO_NOTSETMODE {
	my($n) = @_;
	eval q((($n)-> &na_mode == (( &mode_t) &VNOVAL)));
    }
}
unless(defined(&NFSVNO_ISSETMODE)) {
    sub NFSVNO_ISSETMODE {
	my($n) = @_;
	eval q((($n)-> &na_mode != (( &mode_t) &VNOVAL)));
    }
}
unless(defined(&NFSVNO_NOTSETUID)) {
    sub NFSVNO_NOTSETUID {
	my($n) = @_;
	eval q((($n)-> &na_uid == (( &uid_t) &VNOVAL)));
    }
}
unless(defined(&NFSVNO_ISSETUID)) {
    sub NFSVNO_ISSETUID {
	my($n) = @_;
	eval q((($n)-> &na_uid != (( &uid_t) &VNOVAL)));
    }
}
unless(defined(&NFSVNO_NOTSETGID)) {
    sub NFSVNO_NOTSETGID {
	my($n) = @_;
	eval q((($n)-> &na_gid == (( &gid_t) &VNOVAL)));
    }
}
unless(defined(&NFSVNO_ISSETGID)) {
    sub NFSVNO_ISSETGID {
	my($n) = @_;
	eval q((($n)-> &na_gid != (( &gid_t) &VNOVAL)));
    }
}
unless(defined(&NFSVNO_NOTSETSIZE)) {
    sub NFSVNO_NOTSETSIZE {
	my($n) = @_;
	eval q((($n)-> &na_size ==  &VNOVAL));
    }
}
unless(defined(&NFSVNO_ISSETSIZE)) {
    sub NFSVNO_ISSETSIZE {
	my($n) = @_;
	eval q((($n)-> &na_size !=  &VNOVAL));
    }
}
unless(defined(&NFSVNO_NOTSETATIME)) {
    sub NFSVNO_NOTSETATIME {
	my($n) = @_;
	eval q((($n)-> ($na_atime->{tv_sec}) ==  &VNOVAL));
    }
}
unless(defined(&NFSVNO_ISSETATIME)) {
    sub NFSVNO_ISSETATIME {
	my($n) = @_;
	eval q((($n)-> ($na_atime->{tv_sec}) !=  &VNOVAL));
    }
}
unless(defined(&NFSVNO_NOTSETMTIME)) {
    sub NFSVNO_NOTSETMTIME {
	my($n) = @_;
	eval q((($n)-> ($na_mtime->{tv_sec}) ==  &VNOVAL));
    }
}
unless(defined(&NFSVNO_ISSETMTIME)) {
    sub NFSVNO_ISSETMTIME {
	my($n) = @_;
	eval q((($n)-> ($na_mtime->{tv_sec}) !=  &VNOVAL));
    }
}
unless(defined(&NFSEXITCODE)) {
    sub NFSEXITCODE {
	my($error) = @_;
	eval q();
    }
}
unless(defined(&NFSEXITCODE2)) {
    sub NFSEXITCODE2 {
	my($error, $nd) = @_;
	eval q();
    }
}
unless(defined(&NFSVNO_EXINIT)) {
    sub NFSVNO_EXINIT {
	my($e) = @_;
	eval q((($e)-> &nes_exflag = 0));
    }
}
unless(defined(&NFSVNO_EXPORTED)) {
    sub NFSVNO_EXPORTED {
	my($e) = @_;
	eval q((($e)-> &nes_exflag &  &MNT_EXPORTED));
    }
}
unless(defined(&NFSVNO_EXRDONLY)) {
    sub NFSVNO_EXRDONLY {
	my($e) = @_;
	eval q((($e)-> &nes_exflag &  &MNT_EXRDONLY));
    }
}
unless(defined(&NFSVNO_EXPORTANON)) {
    sub NFSVNO_EXPORTANON {
	my($e) = @_;
	eval q((($e)-> &nes_exflag &  &MNT_EXPORTANON));
    }
}
unless(defined(&NFSVNO_EXSTRICTACCESS)) {
    sub NFSVNO_EXSTRICTACCESS {
	my($e) = @_;
	eval q((($e)-> &nes_exflag &  &MNT_EXSTRICTACCESS));
    }
}
unless(defined(&NFSVNO_EXV4ONLY)) {
    sub NFSVNO_EXV4ONLY {
	my($e) = @_;
	eval q((($e)-> &nes_exflag &  &MNT_EXV4ONLY));
    }
}
unless(defined(&NFSVNO_SETEXRDONLY)) {
    sub NFSVNO_SETEXRDONLY {
	my($e) = @_;
	eval q((($e)-> &nes_exflag = ( &MNT_EXPORTED| &MNT_EXRDONLY)));
    }
}
unless(defined(&NFSVNO_CMPFH)) {
    sub NFSVNO_CMPFH {
	my($f1, $f2) = @_;
	eval q((($f1)-> ($fh_fsid->{val[0]}) == ($f2)-> ($fh_fsid->{val[0]})  && ($f1)-> ($fh_fsid->{val[1]}) == ($f2)-> ($fh_fsid->{val[1]})  &&  &bcmp(($f1)-> &fh_fid, ($f2)-> &fh_fid, $sizeof{'struct fid'}) == 0));
    }
}
unless(defined(&NFSLOCKHASH)) {
    sub NFSLOCKHASH {
	my($f) = @_;
	eval q(( $nfslockhash[ &nfsrv_hashfh($f) %  &nfsrv_lockhashsize]));
    }
}
unless(defined(&NFSFPVNODE)) {
    sub NFSFPVNODE {
	my($f) = @_;
	eval q(((($f)-> &f_data)));
    }
}
unless(defined(&NFSFPCRED)) {
    sub NFSFPCRED {
	my($f) = @_;
	eval q((($f)-> &f_cred));
    }
}
unless(defined(&NFSFPFLAG)) {
    sub NFSFPFLAG {
	my($f) = @_;
	eval q((($f)-> &f_flag));
    }
}
unless(defined(&NFSNAMEICNDSET)) {
    sub NFSNAMEICNDSET {
	my($n, $c, $o, $f) = @_;
	eval q( &do { ($n)-> &cn_cred = ($c); ($n)-> &cn_nameiop = ($o); ($n)-> &cn_flags = ($f); }  &while (0));
    }
}
unless(defined(&vnode_mount)) {
    sub vnode_mount {
	my($v) = @_;
	eval q((($v)-> &v_mount));
    }
}
unless(defined(&vfs_statfs)) {
    sub vfs_statfs {
	my($m) = @_;
	eval q(((($m)-> &mnt_stat)));
    }
}
eval 'sub NFSPATHLEN_T () {\'size_t\';}' unless defined(&NFSPATHLEN_T);
eval 'sub NFSRV_MINFH () {($sizeof{ &fhandle_t});}' unless defined(&NFSRV_MINFH);
eval 'sub NFSRV_MAXFH () {($sizeof{ &fhandle_t});}' unless defined(&NFSRV_MAXFH);
eval 'sub NFSD_DEBUG () {( &level, ...)  &do {  &if ( &nfsd_debuglevel >= ( &level))  &printf( &__VA_ARGS__); }  &while (0);}' unless defined(&NFSD_DEBUG);
1;
