require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_G_CACHE_H_)) {
    eval 'sub _G_CACHE_H_ () {1;}' unless defined(&_G_CACHE_H_);
    require 'sys/endian.ph';
    eval 'sub G_CACHE_CLASS_NAME () {"CACHE";}' unless defined(&G_CACHE_CLASS_NAME);
    eval 'sub G_CACHE_MAGIC () {"GEOM::CACHE";}' unless defined(&G_CACHE_MAGIC);
    eval 'sub G_CACHE_VERSION () {1;}' unless defined(&G_CACHE_VERSION);
    if(defined(&_KERNEL)) {
	eval 'sub G_CACHE_TYPE_MANUAL () {0;}' unless defined(&G_CACHE_TYPE_MANUAL);
	eval 'sub G_CACHE_TYPE_AUTOMATIC () {1;}' unless defined(&G_CACHE_TYPE_AUTOMATIC);
	eval 'sub G_CACHE_DEBUG () {( &lvl, ...)  &do {  &if ( &g_cache_debug >= ( &lvl)) {  &printf("GEOM_CACHE");  &if ( &g_cache_debug > 0)  &printf("[%u]",  &lvl);  &printf(": ");  &printf( &__VA_ARGS__);  &printf("\\n"); } }  &while (0);}' unless defined(&G_CACHE_DEBUG);
	eval 'sub G_CACHE_LOGREQ () {( &bp, ...)  &do {  &if ( &g_cache_debug >= 2) {  &printf("GEOM_CACHE[2]: ");  &printf( &__VA_ARGS__);  &printf(" ");  &g_print_bio( &bp);  &printf("\\n"); } }  &while (0);}' unless defined(&G_CACHE_LOGREQ);
	eval 'sub G_CACHE_BUCKETS () {(1<< 3);}' unless defined(&G_CACHE_BUCKETS);
	eval 'sub G_CACHE_BUCKET {
	    my($bno) = @_;
    	    eval q((($bno) & ( &G_CACHE_BUCKETS - 1)));
	}' unless defined(&G_CACHE_BUCKET);
	eval 'sub sc_name () { ($sc_geom->{name});}' unless defined(&sc_name);
	eval 'sub D_FLAG_USED () {(1<< 0);}' unless defined(&D_FLAG_USED);
	eval 'sub D_FLAG_INVALID () {(1<< 1);}' unless defined(&D_FLAG_INVALID);
	eval 'sub G_CACHE_NEXT_BIO1 {
	    my($bp) = @_;
    	    eval q(($bp)-> &bio_driver1);
	}' unless defined(&G_CACHE_NEXT_BIO1);
	eval 'sub G_CACHE_NEXT_BIO2 {
	    my($bp) = @_;
    	    eval q(($bp)-> &bio_driver2);
	}' unless defined(&G_CACHE_NEXT_BIO2);
	eval 'sub G_CACHE_DESC1 {
	    my($bp) = @_;
    	    eval q(($bp)-> &bio_caller1);
	}' unless defined(&G_CACHE_DESC1);
	eval 'sub G_CACHE_DESC2 {
	    my($bp) = @_;
    	    eval q(($bp)-> &bio_caller2);
	}' unless defined(&G_CACHE_DESC2);
    }
    eval 'sub cache_metadata_encode {
        my($md,$data) = @_;
	    eval q({  &bcopy( ($md->{md_magic}), $data, $sizeof{ ($md->{md_magic})});  &le32enc($data + 16,  ($md->{md_version}));  &bcopy( ($md->{md_name}), $data + 20, $sizeof{ ($md->{md_name})});  &le32enc($data + 36,  ($md->{md_bsize}));  &le32enc($data + 40,  ($md->{md_size}));  &le64enc($data + 44,  ($md->{md_provsize})); });
    }' unless defined(&cache_metadata_encode);
    eval 'sub cache_metadata_decode {
        my($data,$md) = @_;
	    eval q({  &bcopy($data,  ($md->{md_magic}), $sizeof{ ($md->{md_magic})});  ($md->{md_version}) =  &le32dec($data + 16);  &bcopy($data + 20,  ($md->{md_name}), $sizeof{ ($md->{md_name})});  ($md->{md_bsize}) =  &le32dec($data + 36);  ($md->{md_size}) =  &le32dec($data + 40);  ($md->{md_provsize}) =  &le64dec($data + 44); });
    }' unless defined(&cache_metadata_decode);
}
1;
