require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_G_ELI_H_)) {
    eval 'sub _G_ELI_H_ () {1;}' unless defined(&_G_ELI_H_);
    require 'sys/endian.ph';
    require 'sys/errno.ph';
    require 'sys/malloc.ph';
    require 'crypto/sha2/sha256.ph';
    require 'crypto/sha2/sha512.ph';
    require 'opencrypto/cryptodev.ph';
    if(defined(&_KERNEL)) {
	require 'sys/bio.ph';
	require 'sys/libkern.ph';
	require 'sys/lock.ph';
	require 'sys/mutex.ph';
	require 'geom/geom.ph';
	require 'crypto/intake.ph';
    } else {
	require 'assert.ph';
	require 'stdio.ph';
	require 'string.ph';
	require 'strings.ph';
    }
    require 'sys/queue.ph';
    require 'sys/tree.ph';
    unless(defined(&_OpenSSL_)) {
	require 'sys/md5.ph';
    }
    eval 'sub G_ELI_CLASS_NAME () {"ELI";}' unless defined(&G_ELI_CLASS_NAME);
    eval 'sub G_ELI_MAGIC () {"GEOM::ELI";}' unless defined(&G_ELI_MAGIC);
    eval 'sub G_ELI_SUFFIX () {".eli";}' unless defined(&G_ELI_SUFFIX);
    eval 'sub G_ELI_VERSION_00 () {0;}' unless defined(&G_ELI_VERSION_00);
    eval 'sub G_ELI_VERSION_01 () {1;}' unless defined(&G_ELI_VERSION_01);
    eval 'sub G_ELI_VERSION_02 () {2;}' unless defined(&G_ELI_VERSION_02);
    eval 'sub G_ELI_VERSION_03 () {3;}' unless defined(&G_ELI_VERSION_03);
    eval 'sub G_ELI_VERSION_04 () {4;}' unless defined(&G_ELI_VERSION_04);
    eval 'sub G_ELI_VERSION_05 () {5;}' unless defined(&G_ELI_VERSION_05);
    eval 'sub G_ELI_VERSION_06 () {6;}' unless defined(&G_ELI_VERSION_06);
    eval 'sub G_ELI_VERSION_07 () {7;}' unless defined(&G_ELI_VERSION_07);
    eval 'sub G_ELI_VERSION () { &G_ELI_VERSION_07;}' unless defined(&G_ELI_VERSION);
    eval 'sub G_ELI_FLAG_ONETIME () {0x1;}' unless defined(&G_ELI_FLAG_ONETIME);
    eval 'sub G_ELI_FLAG_BOOT () {0x2;}' unless defined(&G_ELI_FLAG_BOOT);
    eval 'sub G_ELI_FLAG_WO_DETACH () {0x4;}' unless defined(&G_ELI_FLAG_WO_DETACH);
    eval 'sub G_ELI_FLAG_RW_DETACH () {0x8;}' unless defined(&G_ELI_FLAG_RW_DETACH);
    eval 'sub G_ELI_FLAG_AUTH () {0x10;}' unless defined(&G_ELI_FLAG_AUTH);
    eval 'sub G_ELI_FLAG_RO () {0x20;}' unless defined(&G_ELI_FLAG_RO);
    eval 'sub G_ELI_FLAG_NODELETE () {0x40;}' unless defined(&G_ELI_FLAG_NODELETE);
    eval 'sub G_ELI_FLAG_GELIBOOT () {0x80;}' unless defined(&G_ELI_FLAG_GELIBOOT);
    eval 'sub G_ELI_FLAG_GELIDISPLAYPASS () {0x100;}' unless defined(&G_ELI_FLAG_GELIDISPLAYPASS);
    eval 'sub G_ELI_FLAG_WOPEN () {0x10000;}' unless defined(&G_ELI_FLAG_WOPEN);
    eval 'sub G_ELI_FLAG_DESTROY () {0x20000;}' unless defined(&G_ELI_FLAG_DESTROY);
    eval 'sub G_ELI_FLAG_NATIVE_BYTE_ORDER () {0x40000;}' unless defined(&G_ELI_FLAG_NATIVE_BYTE_ORDER);
    eval 'sub G_ELI_FLAG_SINGLE_KEY () {0x80000;}' unless defined(&G_ELI_FLAG_SINGLE_KEY);
    eval 'sub G_ELI_FLAG_SUSPEND () {0x100000;}' unless defined(&G_ELI_FLAG_SUSPEND);
    eval 'sub G_ELI_FLAG_FIRST_KEY () {0x200000;}' unless defined(&G_ELI_FLAG_FIRST_KEY);
    eval 'sub G_ELI_FLAG_ENC_IVKEY () {0x400000;}' unless defined(&G_ELI_FLAG_ENC_IVKEY);
    eval 'sub G_ELI_NEW_BIO () {255;}' unless defined(&G_ELI_NEW_BIO);
    eval 'sub SHA512_MDLEN () {64;}' unless defined(&SHA512_MDLEN);
    eval 'sub G_ELI_AUTH_SECKEYLEN () { &SHA256_DIGEST_LENGTH;}' unless defined(&G_ELI_AUTH_SECKEYLEN);
    eval 'sub G_ELI_MAXMKEYS () {2;}' unless defined(&G_ELI_MAXMKEYS);
    eval 'sub G_ELI_MAXKEYLEN () {64;}' unless defined(&G_ELI_MAXKEYLEN);
    eval 'sub G_ELI_USERKEYLEN () { &G_ELI_MAXKEYLEN;}' unless defined(&G_ELI_USERKEYLEN);
    eval 'sub G_ELI_DATAKEYLEN () { &G_ELI_MAXKEYLEN;}' unless defined(&G_ELI_DATAKEYLEN);
    eval 'sub G_ELI_AUTHKEYLEN () { &G_ELI_MAXKEYLEN;}' unless defined(&G_ELI_AUTHKEYLEN);
    eval 'sub G_ELI_IVKEYLEN () { &G_ELI_MAXKEYLEN;}' unless defined(&G_ELI_IVKEYLEN);
    eval 'sub G_ELI_SALTLEN () {64;}' unless defined(&G_ELI_SALTLEN);
    eval 'sub G_ELI_DATAIVKEYLEN () {( &G_ELI_DATAKEYLEN +  &G_ELI_IVKEYLEN);}' unless defined(&G_ELI_DATAIVKEYLEN);
    eval 'sub G_ELI_MKEYLEN () {( &G_ELI_DATAIVKEYLEN +  &SHA512_MDLEN);}' unless defined(&G_ELI_MKEYLEN);
    eval 'sub G_ELI_OVERWRITES () {5;}' unless defined(&G_ELI_OVERWRITES);
    eval 'sub G_ELI_KEY_SHIFT () {20;}' unless defined(&G_ELI_KEY_SHIFT);
    eval 'sub G_ELI_CRYPTO_UNKNOWN () {0;}' unless defined(&G_ELI_CRYPTO_UNKNOWN);
    eval 'sub G_ELI_CRYPTO_HW () {1;}' unless defined(&G_ELI_CRYPTO_HW);
    eval 'sub G_ELI_CRYPTO_SW () {2;}' unless defined(&G_ELI_CRYPTO_SW);
    if(defined(&_KERNEL)) {
	if(((defined(&MAX_KEY_BYTES) ? &MAX_KEY_BYTES : undef) < (defined(&G_ELI_DATAIVKEYLEN) ? &G_ELI_DATAIVKEYLEN : undef))) {
	    die("MAX_KEY_BYTES is less than G_ELI_DATAKEYLEN");
	}
	eval 'sub G_ELI_DEBUG () {( &lvl, ...)  &do {  &if ( &g_eli_debug >= ( &lvl)) {  &printf("GEOM_ELI");  &if ( &g_eli_debug > 0)  &printf("[%u]",  &lvl);  &printf(": ");  &printf( &__VA_ARGS__);  &printf("\\n"); } }  &while (0);}' unless defined(&G_ELI_DEBUG);
	eval 'sub G_ELI_LOGREQ () {( &lvl,  &bp, ...)  &do {  &if ( &g_eli_debug >= ( &lvl)) {  &printf("GEOM_ELI");  &if ( &g_eli_debug > 0)  &printf("[%u]",  &lvl);  &printf(": ");  &printf( &__VA_ARGS__);  &printf(" ");  &g_print_bio( &bp);  &printf("\\n"); } }  &while (0);}' unless defined(&G_ELI_LOGREQ);
    }
    unless(defined(&_KERNEL)) {
    } else {
    }
    eval 'sub sc_name () { ($sc_geom->{name});}' unless defined(&sc_name);
    eval 'sub G_ELI_KEY_MAGIC () {0xe11341c;}' unless defined(&G_ELI_KEY_MAGIC);
    unless(defined(&_OpenSSL_)) {
	eval 'sub eli_metadata_encode_v0 {
	    my($md,$datap) = @_;
    	    eval q({ \'u_char\' * &p;  &p = *$datap;  &le32enc( &p,  ($md->{md_flags}));  &p += $sizeof{ ($md->{md_flags})};  &le16enc( &p,  ($md->{md_ealgo}));  &p += $sizeof{ ($md->{md_ealgo})};  &le16enc( &p,  ($md->{md_keylen}));  &p += $sizeof{ ($md->{md_keylen})};  &le64enc( &p,  ($md->{md_provsize}));  &p += $sizeof{ ($md->{md_provsize})};  &le32enc( &p,  ($md->{md_sectorsize}));  &p += $sizeof{ ($md->{md_sectorsize})}; * &p =  ($md->{md_keys});  &p += $sizeof{ ($md->{md_keys})};  &le32enc( &p,  ($md->{md_iterations}));  &p += $sizeof{ ($md->{md_iterations})};  &bcopy( ($md->{md_salt}),  &p, $sizeof{ ($md->{md_salt})});  &p += $sizeof{ ($md->{md_salt})};  &bcopy( ($md->{md_mkeys}),  &p, $sizeof{ ($md->{md_mkeys})});  &p += $sizeof{ ($md->{md_mkeys})}; *$datap =  &p; });
	}' unless defined(&eli_metadata_encode_v0);
	eval 'sub eli_metadata_encode_v1v2v3v4v5v6v7 {
	    my($md,$datap) = @_;
    	    eval q({ \'u_char\' * &p;  &p = *$datap;  &le32enc( &p,  ($md->{md_flags}));  &p += $sizeof{ ($md->{md_flags})};  &le16enc( &p,  ($md->{md_ealgo}));  &p += $sizeof{ ($md->{md_ealgo})};  &le16enc( &p,  ($md->{md_keylen}));  &p += $sizeof{ ($md->{md_keylen})};  &le16enc( &p,  ($md->{md_aalgo}));  &p += $sizeof{ ($md->{md_aalgo})};  &le64enc( &p,  ($md->{md_provsize}));  &p += $sizeof{ ($md->{md_provsize})};  &le32enc( &p,  ($md->{md_sectorsize}));  &p += $sizeof{ ($md->{md_sectorsize})}; * &p =  ($md->{md_keys});  &p += $sizeof{ ($md->{md_keys})};  &le32enc( &p,  ($md->{md_iterations}));  &p += $sizeof{ ($md->{md_iterations})};  &bcopy( ($md->{md_salt}),  &p, $sizeof{ ($md->{md_salt})});  &p += $sizeof{ ($md->{md_salt})};  &bcopy( ($md->{md_mkeys}),  &p, $sizeof{ ($md->{md_mkeys})});  &p += $sizeof{ ($md->{md_mkeys})}; *$datap =  &p; });
	}' unless defined(&eli_metadata_encode_v1v2v3v4v5v6v7);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub eli_metadata_encode {
	    my($md,$data) = @_;
    	    eval q({  &uint32_t  $hash[4];  &MD5_CTX  &ctx; \'u_char\' * &p;  &p = $data;  &bcopy( ($md->{md_magic}),  &p, $sizeof{ ($md->{md_magic})});  &p += $sizeof{ ($md->{md_magic})};  &le32enc( &p,  ($md->{md_version}));  &p += $sizeof{ ($md->{md_version})};  &switch ( ($md->{md_version})) {  &case  &G_ELI_VERSION_00:  &eli_metadata_encode_v0($md,  &p);  &break;  &case  &G_ELI_VERSION_01:  &case  &G_ELI_VERSION_02:  &case  &G_ELI_VERSION_03:  &case  &G_ELI_VERSION_04:  &case  &G_ELI_VERSION_05:  &case  &G_ELI_VERSION_06:  &case  &G_ELI_VERSION_07:  &eli_metadata_encode_v1v2v3v4v5v6v7($md,  &p);  &break;  &default: }  &MD5Init( &ctx);  &MD5Update( &ctx, $data,  &p - $data);  &MD5Final(( &void *) &hash,  &ctx);  &bcopy( &hash,  ($md->{md_hash}), $sizeof{ ($md->{md_hash})});  &bcopy( ($md->{md_hash}),  &p, $sizeof{ ($md->{md_hash})}); });
	}' unless defined(&eli_metadata_encode);
	eval 'sub eli_metadata_decode_v0 {
	    my($data,$md) = @_;
    	    eval q({  &uint32_t  $hash[4];  &MD5_CTX  &ctx;  &const \'u_char\' * &p;  &p = $data + $sizeof{ ($md->{md_magic})} + $sizeof{ ($md->{md_version})};  ($md->{md_flags}) =  &le32dec( &p);  &p += $sizeof{ ($md->{md_flags})};  ($md->{md_ealgo}) =  &le16dec( &p);  &p += $sizeof{ ($md->{md_ealgo})};  ($md->{md_keylen}) =  &le16dec( &p);  &p += $sizeof{ ($md->{md_keylen})};  ($md->{md_provsize}) =  &le64dec( &p);  &p += $sizeof{ ($md->{md_provsize})};  ($md->{md_sectorsize}) =  &le32dec( &p);  &p += $sizeof{ ($md->{md_sectorsize})};  ($md->{md_keys}) = * &p;  &p += $sizeof{ ($md->{md_keys})};  ($md->{md_iterations}) =  &le32dec( &p);  &p += $sizeof{ ($md->{md_iterations})};  &bcopy( &p,  ($md->{md_salt}), $sizeof{ ($md->{md_salt})});  &p += $sizeof{ ($md->{md_salt})};  &bcopy( &p,  ($md->{md_mkeys}), $sizeof{ ($md->{md_mkeys})});  &p += $sizeof{ ($md->{md_mkeys})};  &MD5Init( &ctx);  &MD5Update( &ctx, $data,  &p - $data);  &MD5Final(( &void *) &hash,  &ctx);  &bcopy( &hash,  ($md->{md_hash}), $sizeof{ ($md->{md_hash})});  &if ( &bcmp( ($md->{md_hash}),  &p, 16) != 0) ( &EINVAL); (0); });
	}' unless defined(&eli_metadata_decode_v0);
	eval 'sub eli_metadata_decode_v1v2v3v4v5v6v7 {
	    my($data,$md) = @_;
    	    eval q({  &uint32_t  $hash[4];  &MD5_CTX  &ctx;  &const \'u_char\' * &p;  &p = $data + $sizeof{ ($md->{md_magic})} + $sizeof{ ($md->{md_version})};  ($md->{md_flags}) =  &le32dec( &p);  &p += $sizeof{ ($md->{md_flags})};  ($md->{md_ealgo}) =  &le16dec( &p);  &p += $sizeof{ ($md->{md_ealgo})};  ($md->{md_keylen}) =  &le16dec( &p);  &p += $sizeof{ ($md->{md_keylen})};  ($md->{md_aalgo}) =  &le16dec( &p);  &p += $sizeof{ ($md->{md_aalgo})};  ($md->{md_provsize}) =  &le64dec( &p);  &p += $sizeof{ ($md->{md_provsize})};  ($md->{md_sectorsize}) =  &le32dec( &p);  &p += $sizeof{ ($md->{md_sectorsize})};  ($md->{md_keys}) = * &p;  &p += $sizeof{ ($md->{md_keys})};  ($md->{md_iterations}) =  &le32dec( &p);  &p += $sizeof{ ($md->{md_iterations})};  &bcopy( &p,  ($md->{md_salt}), $sizeof{ ($md->{md_salt})});  &p += $sizeof{ ($md->{md_salt})};  &bcopy( &p,  ($md->{md_mkeys}), $sizeof{ ($md->{md_mkeys})});  &p += $sizeof{ ($md->{md_mkeys})};  &MD5Init( &ctx);  &MD5Update( &ctx, $data,  &p - $data);  &MD5Final(( &void *) &hash,  &ctx);  &bcopy( &hash,  ($md->{md_hash}), $sizeof{ ($md->{md_hash})});  &if ( &bcmp( ($md->{md_hash}),  &p, 16) != 0) ( &EINVAL); (0); });
	}' unless defined(&eli_metadata_decode_v1v2v3v4v5v6v7);
	eval 'sub eli_metadata_decode {
	    my($data,$md) = @_;
    	    eval q({ \'int\'  &error;  &bcopy($data,  ($md->{md_magic}), $sizeof{ ($md->{md_magic})});  &if ( &strcmp( ($md->{md_magic}),  &G_ELI_MAGIC) != 0) ( &EINVAL);  ($md->{md_version}) =  &le32dec($data + $sizeof{ ($md->{md_magic})});  &switch ( ($md->{md_version})) {  &case  &G_ELI_VERSION_00:  &error =  &eli_metadata_decode_v0($data, $md);  &break;  &case  &G_ELI_VERSION_01:  &case  &G_ELI_VERSION_02:  &case  &G_ELI_VERSION_03:  &case  &G_ELI_VERSION_04:  &case  &G_ELI_VERSION_05:  &case  &G_ELI_VERSION_06:  &case  &G_ELI_VERSION_07:  &error =  &eli_metadata_decode_v1v2v3v4v5v6v7($data, $md);  &break;  &default:  &error =  &EOPNOTSUPP;  &break; } ( &error); });
	}' unless defined(&eli_metadata_decode);
    }
    eval 'sub g_eli_str2ealgo {
        my($name) = @_;
	    eval q({  &if ( &strcasecmp(\\"null\\", $name) == 0) ( &CRYPTO_NULL_CBC);  &else  &if ( &strcasecmp(\\"null-cbc\\", $name) == 0) ( &CRYPTO_NULL_CBC);  &else  &if ( &strcasecmp(\\"aes\\", $name) == 0) ( &CRYPTO_AES_XTS);  &else  &if ( &strcasecmp(\\"aes-cbc\\", $name) == 0) ( &CRYPTO_AES_CBC);  &else  &if ( &strcasecmp(\\"aes-xts\\", $name) == 0) ( &CRYPTO_AES_XTS);  &else  &if ( &strcasecmp(\\"blowfish\\", $name) == 0) ( &CRYPTO_BLF_CBC);  &else  &if ( &strcasecmp(\\"blowfish-cbc\\", $name) == 0) ( &CRYPTO_BLF_CBC);  &else  &if ( &strcasecmp(\\"camellia\\", $name) == 0) ( &CRYPTO_CAMELLIA_CBC);  &else  &if ( &strcasecmp(\\"camellia-cbc\\", $name) == 0) ( &CRYPTO_CAMELLIA_CBC);  &else  &if ( &strcasecmp(\\"3des\\", $name) == 0) ( &CRYPTO_3DES_CBC);  &else  &if ( &strcasecmp(\\"3des-cbc\\", $name) == 0) ( &CRYPTO_3DES_CBC); ( &CRYPTO_ALGORITHM_MIN - 1); });
    }' unless defined(&g_eli_str2ealgo);
    eval 'sub g_eli_str2aalgo {
        my($name) = @_;
	    eval q({  &if ( &strcasecmp(\\"hmac/md5\\", $name) == 0) ( &CRYPTO_MD5_HMAC);  &else  &if ( &strcasecmp(\\"hmac/sha1\\", $name) == 0) ( &CRYPTO_SHA1_HMAC);  &else  &if ( &strcasecmp(\\"hmac/ripemd160\\", $name) == 0) ( &CRYPTO_RIPEMD160_HMAC);  &else  &if ( &strcasecmp(\\"hmac/sha256\\", $name) == 0) ( &CRYPTO_SHA2_256_HMAC);  &else  &if ( &strcasecmp(\\"hmac/sha384\\", $name) == 0) ( &CRYPTO_SHA2_384_HMAC);  &else  &if ( &strcasecmp(\\"hmac/sha512\\", $name) == 0) ( &CRYPTO_SHA2_512_HMAC); ( &CRYPTO_ALGORITHM_MIN - 1); });
    }' unless defined(&g_eli_str2aalgo);
    eval 'sub g_eli_algo2str {
        my($algo) = @_;
	    eval q({  &switch ($algo) {  &case  &CRYPTO_NULL_CBC: (\\"NULL\\");  &case  &CRYPTO_AES_CBC: (\\"AES-CBC\\");  &case  &CRYPTO_AES_XTS: (\\"AES-XTS\\");  &case  &CRYPTO_BLF_CBC: (\\"Blowfish-CBC\\");  &case  &CRYPTO_CAMELLIA_CBC: (\\"CAMELLIA-CBC\\");  &case  &CRYPTO_3DES_CBC: (\\"3DES-CBC\\");  &case  &CRYPTO_MD5_HMAC: (\\"HMAC/MD5\\");  &case  &CRYPTO_SHA1_HMAC: (\\"HMAC/SHA1\\");  &case  &CRYPTO_RIPEMD160_HMAC: (\\"HMAC/RIPEMD160\\");  &case  &CRYPTO_SHA2_256_HMAC: (\\"HMAC/SHA256\\");  &case  &CRYPTO_SHA2_384_HMAC: (\\"HMAC/SHA384\\");  &case  &CRYPTO_SHA2_512_HMAC: (\\"HMAC/SHA512\\"); } (\\"unknown\\"); });
    }' unless defined(&g_eli_algo2str);
    eval 'sub eli_metadata_dump {
        my($md) = @_;
	    eval q({  &const \'char\'  $hex[] = \\"0123456789abcdef\\"; \'char\'  $str[$sizeof{ ($md->{md_mkeys})} * 2+ 1]; \'u_int\'  &i;  &printf(\\"     magic: %s\\\\n\\",  ($md->{md_magic}));  &printf(\\"   version: %u\\\\n\\",  ($md->{md_version}));  &printf(\\"     flags: 0x%x\\\\n\\",  ($md->{md_flags}));  &printf(\\"     ealgo: %s\\\\n\\",  &g_eli_algo2str( ($md->{md_ealgo})));  &printf(\\"    keylen: %u\\\\n\\",  ($md->{md_keylen}));  &if ( ($md->{md_flags}) &  &G_ELI_FLAG_AUTH)  &printf(\\"     aalgo: %s\\\\n\\",  &g_eli_algo2str( ($md->{md_aalgo})));  &printf(\\"  provsize: %ju\\\\n\\", ( &uintmax_t) ($md->{md_provsize}));  &printf(\\"sectorsize: %u\\\\n\\",  ($md->{md_sectorsize}));  &printf(\\"      keys: 0x%02x\\\\n\\",  ($md->{md_keys}));  &printf(\\"iterations: %d\\\\n\\",  ($md->{md_iterations}));  &bzero( &str, $sizeof{ &str});  &for ( &i = 0;  &i < $sizeof{ ($md->{md_salt})};  &i++) {  $str[ &i * 2] =  $hex[ ($md->{md_salt[&i]}) >> 4];  $str[ &i * 2+ 1] =  $hex[ ($md->{md_salt[&i]}) & 0xf]; }  &printf(\\"      Salt: %s\\\\n\\",  &str);  &bzero( &str, $sizeof{ &str});  &for ( &i = 0;  &i < $sizeof{ ($md->{md_mkeys})};  &i++) {  $str[ &i * 2] =  $hex[ ($md->{md_mkeys[&i]}) >> 4];  $str[ &i * 2+ 1] =  $hex[ ($md->{md_mkeys[&i]}) & 0xf]; }  &printf(\\"Master Key: %s\\\\n\\",  &str);  &bzero( &str, $sizeof{ &str});  &for ( &i = 0;  &i < 16;  &i++) {  $str[ &i * 2] =  $hex[ ($md->{md_hash[&i]}) >> 4];  $str[ &i * 2+ 1] =  $hex[ ($md->{md_hash[&i]}) & 0xf]; }  &printf(\\"  MD5 hash: %s\\\\n\\",  &str); });
    }' unless defined(&eli_metadata_dump);
    eval 'sub g_eli_keylen {
        my($algo,$keylen) = @_;
	    eval q({  &switch ($algo) {  &case  &CRYPTO_NULL_CBC:  &if ($keylen == 0) $keylen = 64* 8;  &else {  &if ($keylen > 64* 8) $keylen = 0; } ($keylen);  &case  &CRYPTO_AES_CBC:  &case  &CRYPTO_CAMELLIA_CBC:  &switch ($keylen) {  &case 0: (128);  &case 128:  &case 192:  &case 256: ($keylen);  &default: (0); }  &case  &CRYPTO_AES_XTS:  &switch ($keylen) {  &case 0: (128);  &case 128:  &case 256: ($keylen);  &default: (0); }  &case  &CRYPTO_BLF_CBC:  &if ($keylen == 0) (128);  &if ($keylen < 128|| $keylen > 448) (0);  &if (($keylen % 32) != 0) (0); ($keylen);  &case  &CRYPTO_3DES_CBC:  &if ($keylen == 0|| $keylen == 192) (192); (0);  &default: (0); } });
    }' unless defined(&g_eli_keylen);
    eval 'sub g_eli_hashlen {
        my($algo) = @_;
	    eval q({  &switch ($algo) {  &case  &CRYPTO_MD5_HMAC: (16);  &case  &CRYPTO_SHA1_HMAC: (20);  &case  &CRYPTO_RIPEMD160_HMAC: (20);  &case  &CRYPTO_SHA2_256_HMAC: (32);  &case  &CRYPTO_SHA2_384_HMAC: (48);  &case  &CRYPTO_SHA2_512_HMAC: (64); } (0); });
    }' unless defined(&g_eli_hashlen);
    eval 'sub eli_metadata_softc {
        my($sc,$md,$sectorsize,$mediasize) = @_;
	    eval q({  ($sc->{sc_version}) =  ($md->{md_version});  ($sc->{sc_inflight}) = 0;  ($sc->{sc_crypto}) =  &G_ELI_CRYPTO_UNKNOWN;  ($sc->{sc_flags}) =  ($md->{md_flags});  &if ( ($md->{md_version}) <  &G_ELI_VERSION_04)  ($sc->{sc_flags}) |=  &G_ELI_FLAG_NATIVE_BYTE_ORDER;  &if ( ($md->{md_version}) <  &G_ELI_VERSION_05)  ($sc->{sc_flags}) |=  &G_ELI_FLAG_SINGLE_KEY;  &if ( ($md->{md_version}) <  &G_ELI_VERSION_06  && ( ($sc->{sc_flags}) &  &G_ELI_FLAG_AUTH) != 0) {  ($sc->{sc_flags}) |=  &G_ELI_FLAG_FIRST_KEY; }  &if ( ($md->{md_version}) <  &G_ELI_VERSION_07)  ($sc->{sc_flags}) |=  &G_ELI_FLAG_ENC_IVKEY;  ($sc->{sc_ealgo}) =  ($md->{md_ealgo});  &if ( ($sc->{sc_flags}) &  &G_ELI_FLAG_AUTH) {  ($sc->{sc_akeylen}) = $sizeof{ ($sc->{sc_akey})} * 8;  ($sc->{sc_aalgo}) =  ($md->{md_aalgo});  ($sc->{sc_alen}) =  &g_eli_hashlen( ($sc->{sc_aalgo}));  ($sc->{sc_data_per_sector}) = $sectorsize -  ($sc->{sc_alen});  ($sc->{sc_data_per_sector}) -=  ($sc->{sc_data_per_sector}) % 16;  ($sc->{sc_bytes_per_sector}) = ( ($md->{md_sectorsize}) - 1) /  ($sc->{sc_data_per_sector}) + 1;  ($sc->{sc_bytes_per_sector}) *= $sectorsize; }  ($sc->{sc_sectorsize}) =  ($md->{md_sectorsize});  ($sc->{sc_mediasize}) = $mediasize;  &if (!( ($sc->{sc_flags}) &  &G_ELI_FLAG_ONETIME))  ($sc->{sc_mediasize}) -= $sectorsize;  &if (!( ($sc->{sc_flags}) &  &G_ELI_FLAG_AUTH))  ($sc->{sc_mediasize}) -= ( ($sc->{sc_mediasize}) %  ($sc->{sc_sectorsize}));  &else {  ($sc->{sc_mediasize}) /=  ($sc->{sc_bytes_per_sector});  ($sc->{sc_mediasize}) *=  ($sc->{sc_sectorsize}); }  ($sc->{sc_ekeylen}) =  ($md->{md_keylen}); });
    }' unless defined(&eli_metadata_softc);
    if(defined(&_KERNEL)) {
    }
    if(defined(&_KERNEL)) {
    }
    if(defined(&_KERNEL)) {
    }
}
1;
