require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_GEOM_GEOM_H_)) {
    eval 'sub _GEOM_GEOM_H_ () {1;}' unless defined(&_GEOM_GEOM_H_);
    require 'sys/lock.ph';
    require 'sys/mutex.ph';
    require 'sys/sx.ph';
    require 'sys/queue.ph';
    require 'sys/ioccom.ph';
    require 'sys/conf.ph';
    require 'sys/module.ph';
    eval 'sub G_TF_NORMAL () {0;}' unless defined(&G_TF_NORMAL);
    eval 'sub G_TF_INSIST () {1;}' unless defined(&G_TF_INSIST);
    eval 'sub G_TF_TRANSPARENT () {2;}' unless defined(&G_TF_TRANSPARENT);
    eval 'sub G_VERSION_00 () {0x19950323;}' unless defined(&G_VERSION_00);
    eval 'sub G_VERSION_01 () {0x20041207;}' unless defined(&G_VERSION_01);
    eval 'sub G_VERSION () { &G_VERSION_01;}' unless defined(&G_VERSION);
    eval 'sub G_GEOM_WITHER () {0x1;}' unless defined(&G_GEOM_WITHER);
    eval 'sub G_GEOM_VOLATILE_BIO () {0x2;}' unless defined(&G_GEOM_VOLATILE_BIO);
    eval 'sub G_GEOM_IN_ACCESS () {0x4;}' unless defined(&G_GEOM_IN_ACCESS);
    eval 'sub G_GEOM_ACCESS_WAIT () {0x8;}' unless defined(&G_GEOM_ACCESS_WAIT);
    eval 'sub G_CF_SPOILED () {0x1;}' unless defined(&G_CF_SPOILED);
    eval 'sub G_CF_ORPHAN () {0x4;}' unless defined(&G_CF_ORPHAN);
    eval 'sub G_CF_DIRECT_SEND () {0x10;}' unless defined(&G_CF_DIRECT_SEND);
    eval 'sub G_CF_DIRECT_RECEIVE () {0x20;}' unless defined(&G_CF_DIRECT_RECEIVE);
    eval 'sub G_PF_WITHER () {0x2;}' unless defined(&G_PF_WITHER);
    eval 'sub G_PF_ORPHAN () {0x4;}' unless defined(&G_PF_ORPHAN);
    eval 'sub G_PF_ACCEPT_UNMAPPED () {0x8;}' unless defined(&G_PF_ACCEPT_UNMAPPED);
    eval 'sub G_PF_DIRECT_SEND () {0x10;}' unless defined(&G_PF_DIRECT_SEND);
    eval 'sub G_PF_DIRECT_RECEIVE () {0x20;}' unless defined(&G_PF_DIRECT_RECEIVE);
    eval 'sub G_STATE_FAILED () {0;}' unless defined(&G_STATE_FAILED);
    eval 'sub G_STATE_REBUILD () {1;}' unless defined(&G_STATE_REBUILD);
    eval 'sub G_STATE_RESYNC () {2;}' unless defined(&G_STATE_RESYNC);
    eval 'sub G_STATE_ACTIVE () {3;}' unless defined(&G_STATE_ACTIVE);
    eval 'sub G_T_TOPOLOGY () {1;}' unless defined(&G_T_TOPOLOGY);
    eval 'sub G_T_BIO () {2;}' unless defined(&G_T_BIO);
    eval 'sub G_T_ACCESS () {4;}' unless defined(&G_T_ACCESS);
    eval 'sub EV_CANCEL () {1;}' unless defined(&EV_CANCEL);
    eval 'sub g_getattr {
        my($a, $c, $v) = @_;
	    eval q( &g_getattr__(($a), ($c), ($v),  &sizeof *($v)));
    }' unless defined(&g_getattr);
    if(defined(&DIAGNOSTIC) || defined(&DDB)) {
    }
    if(defined(&DIAGNOSTIC)) {
	eval 'sub G_VALID_CLASS {
	    my($foo) = @_;
    	    eval q( &KASSERT( &g_valid_obj($foo) == 1, (\\"%p is not a g_class\\", $foo)));
	}' unless defined(&G_VALID_CLASS);
	eval 'sub G_VALID_GEOM {
	    my($foo) = @_;
    	    eval q( &KASSERT( &g_valid_obj($foo) == 2, (\\"%p is not a g_geom\\", $foo)));
	}' unless defined(&G_VALID_GEOM);
	eval 'sub G_VALID_CONSUMER {
	    my($foo) = @_;
    	    eval q( &KASSERT( &g_valid_obj($foo) == 3, (\\"%p is not a g_consumer\\", $foo)));
	}' unless defined(&G_VALID_CONSUMER);
	eval 'sub G_VALID_PROVIDER {
	    my($foo) = @_;
    	    eval q( &KASSERT( &g_valid_obj($foo) == 4, (\\"%p is not a g_provider\\", $foo)));
	}' unless defined(&G_VALID_PROVIDER);
    } else {
	eval 'sub G_VALID_CLASS {
	    my($foo) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&G_VALID_CLASS);
	eval 'sub G_VALID_GEOM {
	    my($foo) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&G_VALID_GEOM);
	eval 'sub G_VALID_CONSUMER {
	    my($foo) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&G_VALID_CONSUMER);
	eval 'sub G_VALID_PROVIDER {
	    my($foo) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&G_VALID_PROVIDER);
    }
    if(defined(&_KERNEL)) {
	eval 'sub g_malloc {
	    my($size,$flags) = @_;
    	    eval q({  &void * &p;  &p =  &malloc($size,  &M_GEOM, $flags); ( &p); });
	}' unless defined(&g_malloc);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub g_free {
	    my($ptr) = @_;
    	    eval q({  &free($ptr,  &M_GEOM); });
	}' unless defined(&g_free);
	eval 'sub g_topology_lock () {
	    eval q( &do {  &sx_xlock( &topology_lock); }  &while (0));
	}' unless defined(&g_topology_lock);
	eval 'sub g_topology_try_lock () {
	    eval q( &sx_try_xlock( &topology_lock));
	}' unless defined(&g_topology_try_lock);
	eval 'sub g_topology_unlock () {
	    eval q( &do {  &sx_xunlock( &topology_lock); }  &while (0));
	}' unless defined(&g_topology_unlock);
	eval 'sub g_topology_assert () {
	    eval q( &do {  &sx_assert( &topology_lock,  &SX_XLOCKED); }  &while (0));
	}' unless defined(&g_topology_assert);
	eval 'sub g_topology_assert_not () {
	    eval q( &do {  &sx_assert( &topology_lock,  &SX_UNLOCKED); }  &while (0));
	}' unless defined(&g_topology_assert_not);
	eval 'sub g_topology_sleep {
	    my($chan, $timo) = @_;
    	    eval q( &sx_sleep($chan,  &topology_lock, 0, \\"gtopol\\", $timo));
	}' unless defined(&g_topology_sleep);
	eval 'sub DECLARE_GEOM_CLASS {
	    my($class, $name) = @_;
    	    eval q( &static  &moduledata_t $name &_mod = { $name,  &g_modevent, $class };  &DECLARE_MODULE($name, $name &_mod,  &SI_SUB_DRIVERS,  &SI_ORDER_FIRST););
	}' unless defined(&DECLARE_GEOM_CLASS);
    }
}
1;
