require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_G_MIRROR_H_)) {
    eval 'sub _G_MIRROR_H_ () {1;}' unless defined(&_G_MIRROR_H_);
    require 'sys/endian.ph';
    require 'sys/md5.ph';
    eval 'sub G_MIRROR_CLASS_NAME () {"MIRROR";}' unless defined(&G_MIRROR_CLASS_NAME);
    eval 'sub G_MIRROR_MAGIC () {"GEOM::MIRROR";}' unless defined(&G_MIRROR_MAGIC);
    eval 'sub G_MIRROR_VERSION () {4;}' unless defined(&G_MIRROR_VERSION);
    eval 'sub G_MIRROR_BALANCE_NONE () {0;}' unless defined(&G_MIRROR_BALANCE_NONE);
    eval 'sub G_MIRROR_BALANCE_ROUND_ROBIN () {1;}' unless defined(&G_MIRROR_BALANCE_ROUND_ROBIN);
    eval 'sub G_MIRROR_BALANCE_LOAD () {2;}' unless defined(&G_MIRROR_BALANCE_LOAD);
    eval 'sub G_MIRROR_BALANCE_SPLIT () {3;}' unless defined(&G_MIRROR_BALANCE_SPLIT);
    eval 'sub G_MIRROR_BALANCE_PREFER () {4;}' unless defined(&G_MIRROR_BALANCE_PREFER);
    eval 'sub G_MIRROR_BALANCE_MIN () { &G_MIRROR_BALANCE_NONE;}' unless defined(&G_MIRROR_BALANCE_MIN);
    eval 'sub G_MIRROR_BALANCE_MAX () { &G_MIRROR_BALANCE_PREFER;}' unless defined(&G_MIRROR_BALANCE_MAX);
    eval 'sub G_MIRROR_DISK_FLAG_DIRTY () {0x1;}' unless defined(&G_MIRROR_DISK_FLAG_DIRTY);
    eval 'sub G_MIRROR_DISK_FLAG_SYNCHRONIZING () {0x2;}' unless defined(&G_MIRROR_DISK_FLAG_SYNCHRONIZING);
    eval 'sub G_MIRROR_DISK_FLAG_FORCE_SYNC () {0x4;}' unless defined(&G_MIRROR_DISK_FLAG_FORCE_SYNC);
    eval 'sub G_MIRROR_DISK_FLAG_INACTIVE () {0x8;}' unless defined(&G_MIRROR_DISK_FLAG_INACTIVE);
    eval 'sub G_MIRROR_DISK_FLAG_HARDCODED () {0x10;}' unless defined(&G_MIRROR_DISK_FLAG_HARDCODED);
    eval 'sub G_MIRROR_DISK_FLAG_BROKEN () {0x20;}' unless defined(&G_MIRROR_DISK_FLAG_BROKEN);
    eval 'sub G_MIRROR_DISK_FLAG_CANDELETE () {0x40;}' unless defined(&G_MIRROR_DISK_FLAG_CANDELETE);
    eval 'sub G_MIRROR_DISK_FLAG_MASK () {( &G_MIRROR_DISK_FLAG_DIRTY |  &G_MIRROR_DISK_FLAG_SYNCHRONIZING |  &G_MIRROR_DISK_FLAG_FORCE_SYNC |  &G_MIRROR_DISK_FLAG_INACTIVE |  &G_MIRROR_DISK_FLAG_CANDELETE);}' unless defined(&G_MIRROR_DISK_FLAG_MASK);
    eval 'sub G_MIRROR_DEVICE_FLAG_NOAUTOSYNC () {0x1;}' unless defined(&G_MIRROR_DEVICE_FLAG_NOAUTOSYNC);
    eval 'sub G_MIRROR_DEVICE_FLAG_NOFAILSYNC () {0x2;}' unless defined(&G_MIRROR_DEVICE_FLAG_NOFAILSYNC);
    eval 'sub G_MIRROR_DEVICE_FLAG_MASK () {( &G_MIRROR_DEVICE_FLAG_NOAUTOSYNC |  &G_MIRROR_DEVICE_FLAG_NOFAILSYNC);}' unless defined(&G_MIRROR_DEVICE_FLAG_MASK);
    if(defined(&_KERNEL)) {
	eval 'sub G_MIRROR_DEBUG () {( &lvl, ...)  &do {  &if ( &g_mirror_debug >= ( &lvl)) {  &printf("GEOM_MIRROR");  &if ( &g_mirror_debug > 0)  &printf("[%u]",  &lvl);  &printf(": ");  &printf( &__VA_ARGS__);  &printf("\\n"); } }  &while (0);}' unless defined(&G_MIRROR_DEBUG);
	eval 'sub G_MIRROR_LOGREQ () {( &lvl,  &bp, ...)  &do {  &if ( &g_mirror_debug >= ( &lvl)) {  &printf("GEOM_MIRROR");  &if ( &g_mirror_debug > 0)  &printf("[%u]",  &lvl);  &printf(": ");  &printf( &__VA_ARGS__);  &printf(" ");  &g_print_bio( &bp);  &printf("\\n"); } }  &while (0);}' unless defined(&G_MIRROR_LOGREQ);
	eval 'sub G_MIRROR_BIO_FLAG_REGULAR () {0x1;}' unless defined(&G_MIRROR_BIO_FLAG_REGULAR);
	eval 'sub G_MIRROR_BIO_FLAG_SYNC () {0x2;}' unless defined(&G_MIRROR_BIO_FLAG_SYNC);
	eval 'sub G_MIRROR_DISK_STATE_NONE () {0;}' unless defined(&G_MIRROR_DISK_STATE_NONE);
	eval 'sub G_MIRROR_DISK_STATE_NEW () {1;}' unless defined(&G_MIRROR_DISK_STATE_NEW);
	eval 'sub G_MIRROR_DISK_STATE_ACTIVE () {2;}' unless defined(&G_MIRROR_DISK_STATE_ACTIVE);
	eval 'sub G_MIRROR_DISK_STATE_STALE () {3;}' unless defined(&G_MIRROR_DISK_STATE_STALE);
	eval 'sub G_MIRROR_DISK_STATE_SYNCHRONIZING () {4;}' unless defined(&G_MIRROR_DISK_STATE_SYNCHRONIZING);
	eval 'sub G_MIRROR_DISK_STATE_DISCONNECTED () {5;}' unless defined(&G_MIRROR_DISK_STATE_DISCONNECTED);
	eval 'sub G_MIRROR_DISK_STATE_DESTROY () {6;}' unless defined(&G_MIRROR_DISK_STATE_DESTROY);
	eval 'sub d_name () { ($d_consumer->{provider}->{name});}' unless defined(&d_name);
	eval 'sub G_MIRROR_EVENT_DONTWAIT () {0x1;}' unless defined(&G_MIRROR_EVENT_DONTWAIT);
	eval 'sub G_MIRROR_EVENT_WAIT () {0x2;}' unless defined(&G_MIRROR_EVENT_WAIT);
	eval 'sub G_MIRROR_EVENT_DEVICE () {0x4;}' unless defined(&G_MIRROR_EVENT_DEVICE);
	eval 'sub G_MIRROR_EVENT_DONE () {0x8;}' unless defined(&G_MIRROR_EVENT_DONE);
	eval 'sub G_MIRROR_DEVICE_FLAG_DESTROY () {0x100000000000000;}' unless defined(&G_MIRROR_DEVICE_FLAG_DESTROY);
	eval 'sub G_MIRROR_DEVICE_FLAG_DRAIN () {0x200000000000000;}' unless defined(&G_MIRROR_DEVICE_FLAG_DRAIN);
	eval 'sub G_MIRROR_DEVICE_FLAG_CLOSEWAIT () {0x400000000000000;}' unless defined(&G_MIRROR_DEVICE_FLAG_CLOSEWAIT);
	eval 'sub G_MIRROR_DEVICE_FLAG_TASTING () {0x800000000000000;}' unless defined(&G_MIRROR_DEVICE_FLAG_TASTING);
	eval 'sub G_MIRROR_DEVICE_FLAG_WIPE () {0x1000000000000000;}' unless defined(&G_MIRROR_DEVICE_FLAG_WIPE);
	eval 'sub G_MIRROR_DEVICE_STATE_STARTING () {0;}' unless defined(&G_MIRROR_DEVICE_STATE_STARTING);
	eval 'sub G_MIRROR_DEVICE_STATE_RUNNING () {1;}' unless defined(&G_MIRROR_DEVICE_STATE_RUNNING);
	eval 'sub G_MIRROR_TYPE_MANUAL () {0;}' unless defined(&G_MIRROR_TYPE_MANUAL);
	eval 'sub G_MIRROR_TYPE_AUTOMATIC () {1;}' unless defined(&G_MIRROR_TYPE_AUTOMATIC);
	eval 'sub G_MIRROR_BUMP_SYNCID () {0x1;}' unless defined(&G_MIRROR_BUMP_SYNCID);
	eval 'sub G_MIRROR_BUMP_GENID () {0x2;}' unless defined(&G_MIRROR_BUMP_GENID);
	eval 'sub G_MIRROR_BUMP_SYNCID_NOW () {0x4;}' unless defined(&G_MIRROR_BUMP_SYNCID_NOW);
	eval 'sub sc_name () { ($sc_geom->{name});}' unless defined(&sc_name);
	eval 'sub G_MIRROR_DESTROY_SOFT () {0;}' unless defined(&G_MIRROR_DESTROY_SOFT);
	eval 'sub G_MIRROR_DESTROY_DELAYED () {1;}' unless defined(&G_MIRROR_DESTROY_DELAYED);
	eval 'sub G_MIRROR_DESTROY_HARD () {2;}' unless defined(&G_MIRROR_DESTROY_HARD);
    }
    eval 'sub mirror_metadata_encode {
        my($md,$data) = @_;
	    eval q({  &MD5_CTX  &ctx;  &bcopy( ($md->{md_magic}), $data, 16);  &le32enc($data + 16,  ($md->{md_version}));  &bcopy( ($md->{md_name}), $data + 20, 16);  &le32enc($data + 36,  ($md->{md_mid}));  &le32enc($data + 40,  ($md->{md_did})); *($data + 44) =  ($md->{md_all});  &le32enc($data + 45,  ($md->{md_genid}));  &le32enc($data + 49,  ($md->{md_syncid})); *($data + 53) =  ($md->{md_priority});  &le32enc($data + 54,  ($md->{md_slice})); *($data + 58) =  ($md->{md_balance});  &le64enc($data + 59,  ($md->{md_mediasize}));  &le32enc($data + 67,  ($md->{md_sectorsize}));  &le64enc($data + 71,  ($md->{md_sync_offset}));  &le64enc($data + 79,  ($md->{md_mflags}));  &le64enc($data + 87,  ($md->{md_dflags}));  &bcopy( ($md->{md_provider}), $data + 95, 16);  &le64enc($data + 111,  ($md->{md_provsize}));  &MD5Init( &ctx);  &MD5Update( &ctx, $data, 119);  &MD5Final( ($md->{md_hash}),  &ctx);  &bcopy( ($md->{md_hash}), $data + 119, 16); });
    }' unless defined(&mirror_metadata_encode);
    eval 'sub mirror_metadata_decode_v0v1 {
        my($data,$md) = @_;
	    eval q({  &MD5_CTX  &ctx;  &bcopy($data + 20,  ($md->{md_name}), 16);  ($md->{md_mid}) =  &le32dec($data + 36);  ($md->{md_did}) =  &le32dec($data + 40);  ($md->{md_all}) = *($data + 44);  ($md->{md_syncid}) =  &le32dec($data + 45);  ($md->{md_priority}) = *($data + 49);  ($md->{md_slice}) =  &le32dec($data + 50);  ($md->{md_balance}) = *($data + 54);  ($md->{md_mediasize}) =  &le64dec($data + 55);  ($md->{md_sectorsize}) =  &le32dec($data + 63);  ($md->{md_sync_offset}) =  &le64dec($data + 67);  ($md->{md_mflags}) =  &le64dec($data + 75);  ($md->{md_dflags}) =  &le64dec($data + 83);  &bcopy($data + 91,  ($md->{md_provider}), 16);  &bcopy($data + 107,  ($md->{md_hash}), 16);  &MD5Init( &ctx);  &MD5Update( &ctx, $data, 107);  &MD5Final( ($md->{md_hash}),  &ctx);  &if ( &bcmp( ($md->{md_hash}), $data + 107, 16) != 0) ( &EINVAL);  ($md->{md_genid}) = 0;  ($md->{md_provsize}) = 0; (0); });
    }' unless defined(&mirror_metadata_decode_v0v1);
    eval 'sub mirror_metadata_decode_v2 {
        my($data,$md) = @_;
	    eval q({  &MD5_CTX  &ctx;  &bcopy($data + 20,  ($md->{md_name}), 16);  ($md->{md_mid}) =  &le32dec($data + 36);  ($md->{md_did}) =  &le32dec($data + 40);  ($md->{md_all}) = *($data + 44);  ($md->{md_genid}) =  &le32dec($data + 45);  ($md->{md_syncid}) =  &le32dec($data + 49);  ($md->{md_priority}) = *($data + 53);  ($md->{md_slice}) =  &le32dec($data + 54);  ($md->{md_balance}) = *($data + 58);  ($md->{md_mediasize}) =  &le64dec($data + 59);  ($md->{md_sectorsize}) =  &le32dec($data + 67);  ($md->{md_sync_offset}) =  &le64dec($data + 71);  ($md->{md_mflags}) =  &le64dec($data + 79);  ($md->{md_dflags}) =  &le64dec($data + 87);  &bcopy($data + 95,  ($md->{md_provider}), 16);  &bcopy($data + 111,  ($md->{md_hash}), 16);  &MD5Init( &ctx);  &MD5Update( &ctx, $data, 111);  &MD5Final( ($md->{md_hash}),  &ctx);  &if ( &bcmp( ($md->{md_hash}), $data + 111, 16) != 0) ( &EINVAL);  ($md->{md_provsize}) = 0; (0); });
    }' unless defined(&mirror_metadata_decode_v2);
    eval 'sub mirror_metadata_decode_v3v4 {
        my($data,$md) = @_;
	    eval q({  &MD5_CTX  &ctx;  &bcopy($data + 20,  ($md->{md_name}), 16);  ($md->{md_mid}) =  &le32dec($data + 36);  ($md->{md_did}) =  &le32dec($data + 40);  ($md->{md_all}) = *($data + 44);  ($md->{md_genid}) =  &le32dec($data + 45);  ($md->{md_syncid}) =  &le32dec($data + 49);  ($md->{md_priority}) = *($data + 53);  ($md->{md_slice}) =  &le32dec($data + 54);  ($md->{md_balance}) = *($data + 58);  ($md->{md_mediasize}) =  &le64dec($data + 59);  ($md->{md_sectorsize}) =  &le32dec($data + 67);  ($md->{md_sync_offset}) =  &le64dec($data + 71);  ($md->{md_mflags}) =  &le64dec($data + 79);  ($md->{md_dflags}) =  &le64dec($data + 87);  &bcopy($data + 95,  ($md->{md_provider}), 16);  ($md->{md_provsize}) =  &le64dec($data + 111);  &bcopy($data + 119,  ($md->{md_hash}), 16);  &MD5Init( &ctx);  &MD5Update( &ctx, $data, 119);  &MD5Final( ($md->{md_hash}),  &ctx);  &if ( &bcmp( ($md->{md_hash}), $data + 119, 16) != 0) ( &EINVAL); (0); });
    }' unless defined(&mirror_metadata_decode_v3v4);
    eval 'sub mirror_metadata_decode {
        my($data,$md) = @_;
	    eval q({ \'int\'  &error;  &bcopy($data,  ($md->{md_magic}), 16);  ($md->{md_version}) =  &le32dec($data + 16);  &switch ( ($md->{md_version})) {  &case 0:  &case 1:  &error =  &mirror_metadata_decode_v0v1($data, $md);  &break;  &case 2:  &error =  &mirror_metadata_decode_v2($data, $md);  &break;  &case 3:  &case 4:  &error =  &mirror_metadata_decode_v3v4($data, $md);  &break;  &default:  &error =  &EINVAL;  &break; } ( &error); });
    }' unless defined(&mirror_metadata_decode);
    eval 'sub balance_name {
        my($balance) = @_;
	    eval q({  &const \'char\' * $algorithms[] = { [ &G_MIRROR_BALANCE_NONE] = \\"none\\", [ &G_MIRROR_BALANCE_ROUND_ROBIN] = \\"round-robin\\", [ &G_MIRROR_BALANCE_LOAD] = \\"load\\", [ &G_MIRROR_BALANCE_SPLIT] = \\"split\\", [ &G_MIRROR_BALANCE_PREFER] = \\"prefer\\", [ &G_MIRROR_BALANCE_MAX + 1] = \\"unknown\\" };  &if ($balance >  &G_MIRROR_BALANCE_MAX) $balance =  &G_MIRROR_BALANCE_MAX + 1; ( $algorithms[$balance]); });
    }' unless defined(&balance_name);
    eval 'sub balance_id {
        my($name) = @_;
	    eval q({  &const \'char\' * $algorithms[] = { [ &G_MIRROR_BALANCE_NONE] = \\"none\\", [ &G_MIRROR_BALANCE_ROUND_ROBIN] = \\"round-robin\\", [ &G_MIRROR_BALANCE_LOAD] = \\"load\\", [ &G_MIRROR_BALANCE_SPLIT] = \\"split\\", [ &G_MIRROR_BALANCE_PREFER] = \\"prefer\\" }; \'int\'  &n;  &for ( &n =  &G_MIRROR_BALANCE_MIN;  &n <=  &G_MIRROR_BALANCE_MAX;  &n++) {  &if ( &strcmp($name,  $algorithms[ &n]) == 0) ( &n); } (-1); });
    }' unless defined(&balance_id);
    eval 'sub mirror_metadata_dump {
        my($md) = @_;
	    eval q({  &const \'char\'  $hex[] = \\"0123456789abcdef\\"; \'char\'  $hash[16* 2+ 1]; \'u_int\'  &i;  &printf(\\"     magic: %s\\\\n\\",  ($md->{md_magic}));  &printf(\\"   version: %u\\\\n\\",  ($md->{md_version}));  &printf(\\"      name: %s\\\\n\\",  ($md->{md_name}));  &printf(\\"       mid: %u\\\\n\\",  ($md->{md_mid}));  &printf(\\"       did: %u\\\\n\\",  ($md->{md_did}));  &printf(\\"       all: %u\\\\n\\",  ($md->{md_all}));  &printf(\\"     genid: %u\\\\n\\",  ($md->{md_genid}));  &printf(\\"    syncid: %u\\\\n\\",  ($md->{md_syncid}));  &printf(\\"  priority: %u\\\\n\\",  ($md->{md_priority}));  &printf(\\"     slice: %u\\\\n\\",  ($md->{md_slice}));  &printf(\\"   balance: %s\\\\n\\",  &balance_name( ($md->{md_balance})));  &printf(\\" mediasize: %jd\\\\n\\", ( &intmax_t) ($md->{md_mediasize}));  &printf(\\"sectorsize: %u\\\\n\\",  ($md->{md_sectorsize}));  &printf(\\"syncoffset: %jd\\\\n\\", ( &intmax_t) ($md->{md_sync_offset}));  &printf(\\"    mflags:\\");  &if ( ($md->{md_mflags}) == 0)  &printf(\\" NONE\\");  &else {  &if (( ($md->{md_mflags}) &  &G_MIRROR_DEVICE_FLAG_NOFAILSYNC) != 0)  &printf(\\" NOFAILSYNC\\");  &if (( ($md->{md_mflags}) &  &G_MIRROR_DEVICE_FLAG_NOAUTOSYNC) != 0)  &printf(\\" NOAUTOSYNC\\"); }  &printf(\\"\\\\n\\");  &printf(\\"    dflags:\\");  &if ( ($md->{md_dflags}) == 0)  &printf(\\" NONE\\");  &else {  &if (( ($md->{md_dflags}) &  &G_MIRROR_DISK_FLAG_DIRTY) != 0)  &printf(\\" DIRTY\\");  &if (( ($md->{md_dflags}) &  &G_MIRROR_DISK_FLAG_SYNCHRONIZING) != 0)  &printf(\\" SYNCHRONIZING\\");  &if (( ($md->{md_dflags}) &  &G_MIRROR_DISK_FLAG_FORCE_SYNC) != 0)  &printf(\\" FORCE_SYNC\\");  &if (( ($md->{md_dflags}) &  &G_MIRROR_DISK_FLAG_INACTIVE) != 0)  &printf(\\" INACTIVE\\"); }  &printf(\\"\\\\n\\");  &printf(\\"hcprovider: %s\\\\n\\",  ($md->{md_provider}));  &printf(\\"  provsize: %ju\\\\n\\", ( &uintmax_t) ($md->{md_provsize}));  &bzero( &hash, $sizeof{ &hash});  &for ( &i = 0;  &i < 16;  &i++) {  $hash[ &i * 2] =  $hex[ ($md->{md_hash[&i]}) >> 4];  $hash[ &i * 2+ 1] =  $hex[ ($md->{md_hash[&i]}) & 0xf]; }  &printf(\\"  MD5 hash: %s\\\\n\\",  &hash); });
    }' unless defined(&mirror_metadata_dump);
}
1;
