require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_G_RAID3_H_)) {
    eval 'sub _G_RAID3_H_ () {1;}' unless defined(&_G_RAID3_H_);
    require 'sys/endian.ph';
    require 'sys/md5.ph';
    eval 'sub G_RAID3_CLASS_NAME () {"RAID3";}' unless defined(&G_RAID3_CLASS_NAME);
    eval 'sub G_RAID3_MAGIC () {"GEOM::RAID3";}' unless defined(&G_RAID3_MAGIC);
    eval 'sub G_RAID3_VERSION () {5;}' unless defined(&G_RAID3_VERSION);
    eval 'sub G_RAID3_DISK_FLAG_DIRTY () {0x1;}' unless defined(&G_RAID3_DISK_FLAG_DIRTY);
    eval 'sub G_RAID3_DISK_FLAG_SYNCHRONIZING () {0x2;}' unless defined(&G_RAID3_DISK_FLAG_SYNCHRONIZING);
    eval 'sub G_RAID3_DISK_FLAG_FORCE_SYNC () {0x4;}' unless defined(&G_RAID3_DISK_FLAG_FORCE_SYNC);
    eval 'sub G_RAID3_DISK_FLAG_HARDCODED () {0x8;}' unless defined(&G_RAID3_DISK_FLAG_HARDCODED);
    eval 'sub G_RAID3_DISK_FLAG_BROKEN () {0x10;}' unless defined(&G_RAID3_DISK_FLAG_BROKEN);
    eval 'sub G_RAID3_DISK_FLAG_MASK () {( &G_RAID3_DISK_FLAG_DIRTY |  &G_RAID3_DISK_FLAG_SYNCHRONIZING |  &G_RAID3_DISK_FLAG_FORCE_SYNC);}' unless defined(&G_RAID3_DISK_FLAG_MASK);
    eval 'sub G_RAID3_DEVICE_FLAG_NOAUTOSYNC () {0x1;}' unless defined(&G_RAID3_DEVICE_FLAG_NOAUTOSYNC);
    eval 'sub G_RAID3_DEVICE_FLAG_ROUND_ROBIN () {0x2;}' unless defined(&G_RAID3_DEVICE_FLAG_ROUND_ROBIN);
    eval 'sub G_RAID3_DEVICE_FLAG_VERIFY () {0x4;}' unless defined(&G_RAID3_DEVICE_FLAG_VERIFY);
    eval 'sub G_RAID3_DEVICE_FLAG_NOFAILSYNC () {0x8;}' unless defined(&G_RAID3_DEVICE_FLAG_NOFAILSYNC);
    eval 'sub G_RAID3_DEVICE_FLAG_MASK () {( &G_RAID3_DEVICE_FLAG_NOAUTOSYNC |  &G_RAID3_DEVICE_FLAG_ROUND_ROBIN |  &G_RAID3_DEVICE_FLAG_VERIFY |  &G_RAID3_DEVICE_FLAG_NOFAILSYNC);}' unless defined(&G_RAID3_DEVICE_FLAG_MASK);
    if(defined(&_KERNEL)) {
	eval 'sub G_RAID3_DEBUG () {( &lvl, ...)  &do {  &if ( &g_raid3_debug >= ( &lvl)) {  &printf("GEOM_RAID3");  &if ( &g_raid3_debug > 0)  &printf("[%u]",  &lvl);  &printf(": ");  &printf( &__VA_ARGS__);  &printf("\\n"); } }  &while (0);}' unless defined(&G_RAID3_DEBUG);
	eval 'sub G_RAID3_LOGREQ () {( &lvl,  &bp, ...)  &do {  &if ( &g_raid3_debug >= ( &lvl)) {  &printf("GEOM_RAID3");  &if ( &g_raid3_debug > 0)  &printf("[%u]",  &lvl);  &printf(": ");  &printf( &__VA_ARGS__);  &printf(" ");  &g_print_bio( &bp);  &printf("\\n"); } }  &while (0);}' unless defined(&G_RAID3_LOGREQ);
	eval 'sub G_RAID3_BIO_CFLAG_REGULAR () {0x1;}' unless defined(&G_RAID3_BIO_CFLAG_REGULAR);
	eval 'sub G_RAID3_BIO_CFLAG_SYNC () {0x2;}' unless defined(&G_RAID3_BIO_CFLAG_SYNC);
	eval 'sub G_RAID3_BIO_CFLAG_PARITY () {0x4;}' unless defined(&G_RAID3_BIO_CFLAG_PARITY);
	eval 'sub G_RAID3_BIO_CFLAG_NODISK () {0x8;}' unless defined(&G_RAID3_BIO_CFLAG_NODISK);
	eval 'sub G_RAID3_BIO_CFLAG_REGSYNC () {0x10;}' unless defined(&G_RAID3_BIO_CFLAG_REGSYNC);
	eval 'sub G_RAID3_BIO_CFLAG_MASK () {( &G_RAID3_BIO_CFLAG_REGULAR |  &G_RAID3_BIO_CFLAG_SYNC |  &G_RAID3_BIO_CFLAG_PARITY |  &G_RAID3_BIO_CFLAG_NODISK |  &G_RAID3_BIO_CFLAG_REGSYNC);}' unless defined(&G_RAID3_BIO_CFLAG_MASK);
	eval 'sub G_RAID3_BIO_PFLAG_DEGRADED () {0x1;}' unless defined(&G_RAID3_BIO_PFLAG_DEGRADED);
	eval 'sub G_RAID3_BIO_PFLAG_NOPARITY () {0x2;}' unless defined(&G_RAID3_BIO_PFLAG_NOPARITY);
	eval 'sub G_RAID3_BIO_PFLAG_VERIFY () {0x4;}' unless defined(&G_RAID3_BIO_PFLAG_VERIFY);
	eval 'sub G_RAID3_BIO_PFLAG_MASK () {( &G_RAID3_BIO_PFLAG_DEGRADED |  &G_RAID3_BIO_PFLAG_NOPARITY |  &G_RAID3_BIO_PFLAG_VERIFY);}' unless defined(&G_RAID3_BIO_PFLAG_MASK);
	eval 'sub G_RAID3_DISK_STATE_NODISK () {0;}' unless defined(&G_RAID3_DISK_STATE_NODISK);
	eval 'sub G_RAID3_DISK_STATE_NONE () {1;}' unless defined(&G_RAID3_DISK_STATE_NONE);
	eval 'sub G_RAID3_DISK_STATE_NEW () {2;}' unless defined(&G_RAID3_DISK_STATE_NEW);
	eval 'sub G_RAID3_DISK_STATE_ACTIVE () {3;}' unless defined(&G_RAID3_DISK_STATE_ACTIVE);
	eval 'sub G_RAID3_DISK_STATE_STALE () {4;}' unless defined(&G_RAID3_DISK_STATE_STALE);
	eval 'sub G_RAID3_DISK_STATE_SYNCHRONIZING () {5;}' unless defined(&G_RAID3_DISK_STATE_SYNCHRONIZING);
	eval 'sub G_RAID3_DISK_STATE_DISCONNECTED () {6;}' unless defined(&G_RAID3_DISK_STATE_DISCONNECTED);
	eval 'sub G_RAID3_DISK_STATE_DESTROY () {7;}' unless defined(&G_RAID3_DISK_STATE_DESTROY);
	eval 'sub d_name () { ($d_consumer->{provider}->{name});}' unless defined(&d_name);
	eval 'sub G_RAID3_EVENT_DONTWAIT () {0x1;}' unless defined(&G_RAID3_EVENT_DONTWAIT);
	eval 'sub G_RAID3_EVENT_WAIT () {0x2;}' unless defined(&G_RAID3_EVENT_WAIT);
	eval 'sub G_RAID3_EVENT_DEVICE () {0x4;}' unless defined(&G_RAID3_EVENT_DEVICE);
	eval 'sub G_RAID3_EVENT_DONE () {0x8;}' unless defined(&G_RAID3_EVENT_DONE);
	eval 'sub G_RAID3_DEVICE_FLAG_DESTROY () {0x100000000000000;}' unless defined(&G_RAID3_DEVICE_FLAG_DESTROY);
	eval 'sub G_RAID3_DEVICE_FLAG_WAIT () {0x200000000000000;}' unless defined(&G_RAID3_DEVICE_FLAG_WAIT);
	eval 'sub G_RAID3_DEVICE_FLAG_DESTROYING () {0x400000000000000;}' unless defined(&G_RAID3_DEVICE_FLAG_DESTROYING);
	eval 'sub G_RAID3_DEVICE_STATE_STARTING () {0;}' unless defined(&G_RAID3_DEVICE_STATE_STARTING);
	eval 'sub G_RAID3_DEVICE_STATE_DEGRADED () {1;}' unless defined(&G_RAID3_DEVICE_STATE_DEGRADED);
	eval 'sub G_RAID3_DEVICE_STATE_COMPLETE () {2;}' unless defined(&G_RAID3_DEVICE_STATE_COMPLETE);
	eval 'sub G_RAID3_BUMP_SYNCID () {0x1;}' unless defined(&G_RAID3_BUMP_SYNCID);
	eval 'sub G_RAID3_BUMP_GENID () {0x2;}' unless defined(&G_RAID3_BUMP_GENID);
	eval("sub G_RAID3_ZONE_64K () { 0; }") unless defined(&G_RAID3_ZONE_64K);
	eval("sub G_RAID3_ZONE_16K () { 1; }") unless defined(&G_RAID3_ZONE_16K);
	eval("sub G_RAID3_ZONE_4K () { 2; }") unless defined(&G_RAID3_ZONE_4K);
	eval("sub G_RAID3_NUM_ZONES () { 3; }") unless defined(&G_RAID3_NUM_ZONES);
	eval 'sub g_raid3_zone {
	    my($nbytes) = @_;
    	    eval q({  &if ($nbytes > 65536) ( &G_RAID3_NUM_ZONES);  &else  &if ($nbytes > 16384) ( &G_RAID3_ZONE_64K);  &else  &if ($nbytes > 4096) ( &G_RAID3_ZONE_16K);  &else ( &G_RAID3_ZONE_4K); };);
	}' unless defined(&g_raid3_zone);
	eval 'sub sc_name () { ($sc_geom->{name});}' unless defined(&sc_name);
	eval 'sub G_RAID3_DESTROY_SOFT () {0;}' unless defined(&G_RAID3_DESTROY_SOFT);
	eval 'sub G_RAID3_DESTROY_DELAYED () {1;}' unless defined(&G_RAID3_DESTROY_DELAYED);
	eval 'sub G_RAID3_DESTROY_HARD () {2;}' unless defined(&G_RAID3_DESTROY_HARD);
    }
    eval 'sub raid3_metadata_encode {
        my($md,$data) = @_;
	    eval q({  &MD5_CTX  &ctx;  &bcopy( ($md->{md_magic}), $data, 16);  &le32enc($data + 16,  ($md->{md_version}));  &bcopy( ($md->{md_name}), $data + 20, 16);  &le32enc($data + 36,  ($md->{md_id}));  &le16enc($data + 40,  ($md->{md_no}));  &le16enc($data + 42,  ($md->{md_all}));  &le32enc($data + 44,  ($md->{md_genid}));  &le32enc($data + 48,  ($md->{md_syncid}));  &le64enc($data + 52,  ($md->{md_mediasize}));  &le32enc($data + 60,  ($md->{md_sectorsize}));  &le64enc($data + 64,  ($md->{md_sync_offset}));  &le64enc($data + 72,  ($md->{md_mflags}));  &le64enc($data + 80,  ($md->{md_dflags}));  &bcopy( ($md->{md_provider}), $data + 88, 16);  &le64enc($data + 104,  ($md->{md_provsize}));  &MD5Init( &ctx);  &MD5Update( &ctx, $data, 112);  &MD5Final( ($md->{md_hash}),  &ctx);  &bcopy( ($md->{md_hash}), $data + 112, 16); });
    }' unless defined(&raid3_metadata_encode);
    eval 'sub raid3_metadata_decode_v0v1v2 {
        my($data,$md) = @_;
	    eval q({  &MD5_CTX  &ctx;  &bcopy($data + 20,  ($md->{md_name}), 16);  ($md->{md_id}) =  &le32dec($data + 36);  ($md->{md_no}) =  &le16dec($data + 40);  ($md->{md_all}) =  &le16dec($data + 42);  ($md->{md_syncid}) =  &le32dec($data + 44);  ($md->{md_mediasize}) =  &le64dec($data + 48);  ($md->{md_sectorsize}) =  &le32dec($data + 56);  ($md->{md_sync_offset}) =  &le64dec($data + 60);  ($md->{md_mflags}) =  &le64dec($data + 68);  ($md->{md_dflags}) =  &le64dec($data + 76);  &bcopy($data + 84,  ($md->{md_provider}), 16);  &bcopy($data + 100,  ($md->{md_hash}), 16);  &MD5Init( &ctx);  &MD5Update( &ctx, $data, 100);  &MD5Final( ($md->{md_hash}),  &ctx);  &if ( &bcmp( ($md->{md_hash}), $data + 100, 16) != 0) ( &EINVAL);  ($md->{md_genid}) = 0;  ($md->{md_provsize}) = 0; (0); });
    }' unless defined(&raid3_metadata_decode_v0v1v2);
    eval 'sub raid3_metadata_decode_v3 {
        my($data,$md) = @_;
	    eval q({  &MD5_CTX  &ctx;  &bcopy($data + 20,  ($md->{md_name}), 16);  ($md->{md_id}) =  &le32dec($data + 36);  ($md->{md_no}) =  &le16dec($data + 40);  ($md->{md_all}) =  &le16dec($data + 42);  ($md->{md_genid}) =  &le32dec($data + 44);  ($md->{md_syncid}) =  &le32dec($data + 48);  ($md->{md_mediasize}) =  &le64dec($data + 52);  ($md->{md_sectorsize}) =  &le32dec($data + 60);  ($md->{md_sync_offset}) =  &le64dec($data + 64);  ($md->{md_mflags}) =  &le64dec($data + 72);  ($md->{md_dflags}) =  &le64dec($data + 80);  &bcopy($data + 88,  ($md->{md_provider}), 16);  &bcopy($data + 104,  ($md->{md_hash}), 16);  &MD5Init( &ctx);  &MD5Update( &ctx, $data, 104);  &MD5Final( ($md->{md_hash}),  &ctx);  &if ( &bcmp( ($md->{md_hash}), $data + 104, 16) != 0) ( &EINVAL);  ($md->{md_provsize}) = 0; (0); });
    }' unless defined(&raid3_metadata_decode_v3);
    eval 'sub raid3_metadata_decode_v4v5 {
        my($data,$md) = @_;
	    eval q({  &MD5_CTX  &ctx;  &bcopy($data + 20,  ($md->{md_name}), 16);  ($md->{md_id}) =  &le32dec($data + 36);  ($md->{md_no}) =  &le16dec($data + 40);  ($md->{md_all}) =  &le16dec($data + 42);  ($md->{md_genid}) =  &le32dec($data + 44);  ($md->{md_syncid}) =  &le32dec($data + 48);  ($md->{md_mediasize}) =  &le64dec($data + 52);  ($md->{md_sectorsize}) =  &le32dec($data + 60);  ($md->{md_sync_offset}) =  &le64dec($data + 64);  ($md->{md_mflags}) =  &le64dec($data + 72);  ($md->{md_dflags}) =  &le64dec($data + 80);  &bcopy($data + 88,  ($md->{md_provider}), 16);  ($md->{md_provsize}) =  &le64dec($data + 104);  &bcopy($data + 112,  ($md->{md_hash}), 16);  &MD5Init( &ctx);  &MD5Update( &ctx, $data, 112);  &MD5Final( ($md->{md_hash}),  &ctx);  &if ( &bcmp( ($md->{md_hash}), $data + 112, 16) != 0) ( &EINVAL); (0); });
    }' unless defined(&raid3_metadata_decode_v4v5);
    eval 'sub raid3_metadata_decode {
        my($data,$md) = @_;
	    eval q({ \'int\'  &error;  &bcopy($data,  ($md->{md_magic}), 16);  ($md->{md_version}) =  &le32dec($data + 16);  &switch ( ($md->{md_version})) {  &case 0:  &case 1:  &case 2:  &error =  &raid3_metadata_decode_v0v1v2($data, $md);  &break;  &case 3:  &error =  &raid3_metadata_decode_v3($data, $md);  &break;  &case 4:  &case 5:  &error =  &raid3_metadata_decode_v4v5($data, $md);  &break;  &default:  &error =  &EINVAL;  &break; } ( &error); });
    }' unless defined(&raid3_metadata_decode);
    eval 'sub raid3_metadata_dump {
        my($md) = @_;
	    eval q({  &const \'char\'  $hex[] = \\"0123456789abcdef\\"; \'char\'  $hash[16* 2+ 1]; \'u_int\'  &i;  &printf(\\"     magic: %s\\\\n\\",  ($md->{md_magic}));  &printf(\\"   version: %u\\\\n\\",  ($md->{md_version}));  &printf(\\"      name: %s\\\\n\\",  ($md->{md_name}));  &printf(\\"	id: %u\\\\n\\",  ($md->{md_id}));  &printf(\\"	no: %u\\\\n\\",  ($md->{md_no}));  &printf(\\"       all: %u\\\\n\\",  ($md->{md_all}));  &printf(\\"     genid: %u\\\\n\\",  ($md->{md_genid}));  &printf(\\"    syncid: %u\\\\n\\",  ($md->{md_syncid}));  &printf(\\" mediasize: %jd\\\\n\\", ( &intmax_t) ($md->{md_mediasize}));  &printf(\\"sectorsize: %u\\\\n\\",  ($md->{md_sectorsize}));  &printf(\\"syncoffset: %jd\\\\n\\", ( &intmax_t) ($md->{md_sync_offset}));  &printf(\\"    mflags:\\");  &if ( ($md->{md_mflags}) == 0)  &printf(\\" NONE\\");  &else {  &if (( ($md->{md_mflags}) &  &G_RAID3_DEVICE_FLAG_NOAUTOSYNC) != 0)  &printf(\\" NOAUTOSYNC\\");  &if (( ($md->{md_mflags}) &  &G_RAID3_DEVICE_FLAG_ROUND_ROBIN) != 0)  &printf(\\" ROUND-ROBIN\\");  &if (( ($md->{md_mflags}) &  &G_RAID3_DEVICE_FLAG_VERIFY) != 0)  &printf(\\" VERIFY\\");  &if (( ($md->{md_mflags}) &  &G_RAID3_DEVICE_FLAG_NOFAILSYNC) != 0)  &printf(\\" NOFAILSYNC\\"); }  &printf(\\"\\\\n\\");  &printf(\\"    dflags:\\");  &if ( ($md->{md_dflags}) == 0)  &printf(\\" NONE\\");  &else {  &if (( ($md->{md_dflags}) &  &G_RAID3_DISK_FLAG_DIRTY) != 0)  &printf(\\" DIRTY\\");  &if (( ($md->{md_dflags}) &  &G_RAID3_DISK_FLAG_SYNCHRONIZING) != 0)  &printf(\\" SYNCHRONIZING\\");  &if (( ($md->{md_dflags}) &  &G_RAID3_DISK_FLAG_FORCE_SYNC) != 0)  &printf(\\" FORCE_SYNC\\"); }  &printf(\\"\\\\n\\");  &printf(\\"hcprovider: %s\\\\n\\",  ($md->{md_provider}));  &printf(\\"  provsize: %ju\\\\n\\", ( &uintmax_t) ($md->{md_provsize}));  &bzero( &hash, $sizeof{ &hash});  &for ( &i = 0;  &i < 16;  &i++) {  $hash[ &i * 2] =  $hex[ ($md->{md_hash[&i]}) >> 4];  $hash[ &i * 2+ 1] =  $hex[ ($md->{md_hash[&i]}) & 0xf]; }  &printf(\\"  MD5 hash: %s\\\\n\\",  &hash); });
    }' unless defined(&raid3_metadata_dump);
}
1;
