require '_h2ph_pre.ph';

no warnings qw(redefine misc);

require 'sys/cdefs.ph';
unless(defined(&_NET_IF_LLATBL_H_)) {
    eval 'sub _NET_IF_LLATBL_H_ () {1;}' unless defined(&_NET_IF_LLATBL_H_);
    require 'sys/_rwlock.ph';
    require 'netinet/in.ph';
    eval 'sub LLTABLE_RLOCK () {
        eval q( &rw_rlock( &lltable_rwlock));
    }' unless defined(&LLTABLE_RLOCK);
    eval 'sub LLTABLE_RUNLOCK () {
        eval q( &rw_runlock( &lltable_rwlock));
    }' unless defined(&LLTABLE_RUNLOCK);
    eval 'sub LLTABLE_WLOCK () {
        eval q( &rw_wlock( &lltable_rwlock));
    }' unless defined(&LLTABLE_WLOCK);
    eval 'sub LLTABLE_WUNLOCK () {
        eval q( &rw_wunlock( &lltable_rwlock));
    }' unless defined(&LLTABLE_WUNLOCK);
    eval 'sub LLTABLE_LOCK_ASSERT () {
        eval q( &rw_assert( &lltable_rwlock,  &RA_LOCKED));
    }' unless defined(&LLTABLE_LOCK_ASSERT);
    eval 'sub LLE_MAX_LINKHDR () {24;}' unless defined(&LLE_MAX_LINKHDR);
    eval 'sub LLE_WLOCK {
        my($lle) = @_;
	    eval q( &rw_wlock(($lle)-> &lle_lock));
    }' unless defined(&LLE_WLOCK);
    eval 'sub LLE_RLOCK {
        my($lle) = @_;
	    eval q( &rw_rlock(($lle)-> &lle_lock));
    }' unless defined(&LLE_RLOCK);
    eval 'sub LLE_WUNLOCK {
        my($lle) = @_;
	    eval q( &rw_wunlock(($lle)-> &lle_lock));
    }' unless defined(&LLE_WUNLOCK);
    eval 'sub LLE_RUNLOCK {
        my($lle) = @_;
	    eval q( &rw_runlock(($lle)-> &lle_lock));
    }' unless defined(&LLE_RUNLOCK);
    eval 'sub LLE_DOWNGRADE {
        my($lle) = @_;
	    eval q( &rw_downgrade(($lle)-> &lle_lock));
    }' unless defined(&LLE_DOWNGRADE);
    eval 'sub LLE_TRY_UPGRADE {
        my($lle) = @_;
	    eval q( &rw_try_upgrade(($lle)-> &lle_lock));
    }' unless defined(&LLE_TRY_UPGRADE);
    eval 'sub LLE_LOCK_INIT {
        my($lle) = @_;
	    eval q( &rw_init_flags(($lle)-> &lle_lock, \\"lle\\",  &RW_DUPOK));
    }' unless defined(&LLE_LOCK_INIT);
    eval 'sub LLE_LOCK_DESTROY {
        my($lle) = @_;
	    eval q( &rw_destroy(($lle)-> &lle_lock));
    }' unless defined(&LLE_LOCK_DESTROY);
    eval 'sub LLE_WLOCK_ASSERT {
        my($lle) = @_;
	    eval q( &rw_assert(($lle)-> &lle_lock,  &RA_WLOCKED));
    }' unless defined(&LLE_WLOCK_ASSERT);
    eval 'sub LLE_REQ_INIT {
        my($lle) = @_;
	    eval q( &mtx_init(($lle)-> &req_mtx, \\"lle req\\",  &NULL,  &MTX_DEF));
    }' unless defined(&LLE_REQ_INIT);
    eval 'sub LLE_REQ_DESTROY {
        my($lle) = @_;
	    eval q( &mtx_destroy(($lle)-> &req_mtx));
    }' unless defined(&LLE_REQ_DESTROY);
    eval 'sub LLE_REQ_LOCK {
        my($lle) = @_;
	    eval q( &mtx_lock(($lle)-> &req_mtx));
    }' unless defined(&LLE_REQ_LOCK);
    eval 'sub LLE_REQ_UNLOCK {
        my($lle) = @_;
	    eval q( &mtx_unlock(($lle)-> &req_mtx));
    }' unless defined(&LLE_REQ_UNLOCK);
    eval 'sub LLE_IS_VALID {
        my($lle) = @_;
	    eval q(((($lle) !=  &NULL)  && (($lle) != ( &void *)-1)));
    }' unless defined(&LLE_IS_VALID);
    eval 'sub LLE_ADDREF {
        my($lle) = @_;
	    eval q( &do {  &LLE_WLOCK_ASSERT($lle);  &KASSERT(($lle)-> &lle_refcnt >= 0, (\\"negative refcnt %d on lle %p\\", ($lle)-> &lle_refcnt, ($lle))); ($lle)-> &lle_refcnt++; }  &while (0));
    }' unless defined(&LLE_ADDREF);
    eval 'sub LLE_REMREF {
        my($lle) = @_;
	    eval q( &do {  &LLE_WLOCK_ASSERT($lle);  &KASSERT(($lle)-> &lle_refcnt > 0, (\\"bogus refcnt %d on lle %p\\", ($lle)-> &lle_refcnt, ($lle))); ($lle)-> &lle_refcnt--; }  &while (0));
    }' unless defined(&LLE_REMREF);
    eval 'sub LLE_FREE_LOCKED {
        my($lle) = @_;
	    eval q( &do {  &if (($lle)-> &lle_refcnt == 1) ($lle)-> &lle_free($lle);  &else {  &LLE_REMREF($lle);  &LLE_WUNLOCK($lle); } ($lle) =  &NULL; }  &while (0));
    }' unless defined(&LLE_FREE_LOCKED);
    eval 'sub LLE_FREE {
        my($lle) = @_;
	    eval q( &do {  &LLE_WLOCK($lle);  &LLE_FREE_LOCKED($lle); }  &while (0));
    }' unless defined(&LLE_FREE);
    eval 'sub LLE_DELETED () {0x1;}' unless defined(&LLE_DELETED);
    eval 'sub LLE_STATIC () {0x2;}' unless defined(&LLE_STATIC);
    eval 'sub LLE_IFADDR () {0x4;}' unless defined(&LLE_IFADDR);
    eval 'sub LLE_VALID () {0x8;}' unless defined(&LLE_VALID);
    eval 'sub LLE_REDIRECT () {0x10;}' unless defined(&LLE_REDIRECT);
    eval 'sub LLE_PUB () {0x20;}' unless defined(&LLE_PUB);
    eval 'sub LLE_LINKED () {0x40;}' unless defined(&LLE_LINKED);
    eval 'sub LLE_EXCLUSIVE () {0x2000;}' unless defined(&LLE_EXCLUSIVE);
    eval 'sub LLE_UNLOCKED () {0x4000;}' unless defined(&LLE_UNLOCKED);
    eval 'sub LLE_ADDRONLY () {0x4000;}' unless defined(&LLE_ADDRONLY);
    eval 'sub LLE_CREATE () {0x8000;}' unless defined(&LLE_CREATE);
    eval 'sub RLLE_VALID () {0x1;}' unless defined(&RLLE_VALID);
    eval 'sub RLLE_IFADDR () { &LLE_IFADDR;}' unless defined(&RLLE_IFADDR);
    eval 'sub LLATBL_HASH {
        my($key, $mask) = @_;
	    eval q(((((((($key >> 8) ^ $key) >> 8) ^ $key) >> 8) ^ $key) & $mask));
    }' unless defined(&LLATBL_HASH);
    if(0) {
    }
    require 'sys/eventhandler.ph';
    eval("sub LLENTRY_RESOLVED () { 0; }") unless defined(&LLENTRY_RESOLVED);
    eval("sub LLENTRY_TIMEDOUT () { 1; }") unless defined(&LLENTRY_TIMEDOUT);
    eval("sub LLENTRY_DELETED () { 2; }") unless defined(&LLENTRY_DELETED);
    eval("sub LLENTRY_EXPIRED () { 3; }") unless defined(&LLENTRY_EXPIRED);
}
1;
