require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NET_IF_VAR_H_)) {
    eval 'sub _NET_IF_VAR_H_ () {1;}' unless defined(&_NET_IF_VAR_H_);
    if(defined(&_KERNEL)) {
	require 'sys/mbuf.ph';
	require 'sys/buf_ring.ph';
	require 'net/vnet.ph';
    }
    require 'sys/counter.ph';
    require 'sys/lock.ph';
    require 'sys/mutex.ph';
    require 'sys/rwlock.ph';
    require 'sys/sx.ph';
    require 'sys/_task.ph';
    eval 'sub IF_DUNIT_NONE () {-1;}' unless defined(&IF_DUNIT_NONE);
    require 'net/altq/if_altq.ph';
    if(defined(&_KERNEL)) {
	eval 'sub V_link_pfil_hook () { &VNET( &link_pfil_hook);}' unless defined(&V_link_pfil_hook);
	eval 'sub HHOOK_IPSEC_INET () {0;}' unless defined(&HHOOK_IPSEC_INET);
	eval 'sub HHOOK_IPSEC_INET6 () {1;}' unless defined(&HHOOK_IPSEC_INET6);
	eval 'sub HHOOK_IPSEC_COUNT () {2;}' unless defined(&HHOOK_IPSEC_COUNT);
	eval 'sub V_ipsec_hhh_in () { &VNET( &ipsec_hhh_in);}' unless defined(&V_ipsec_hhh_in);
	eval 'sub V_ipsec_hhh_out () { &VNET( &ipsec_hhh_out);}' unless defined(&V_ipsec_hhh_out);
    }
    eval("sub IFCOUNTER_IPACKETS () { 0; }") unless defined(&IFCOUNTER_IPACKETS);
    eval("sub IFCOUNTER_IERRORS () { 1; }") unless defined(&IFCOUNTER_IERRORS);
    eval("sub IFCOUNTER_OPACKETS () { 2; }") unless defined(&IFCOUNTER_OPACKETS);
    eval("sub IFCOUNTER_OERRORS () { 3; }") unless defined(&IFCOUNTER_OERRORS);
    eval("sub IFCOUNTER_COLLISIONS () { 4; }") unless defined(&IFCOUNTER_COLLISIONS);
    eval("sub IFCOUNTER_IBYTES () { 5; }") unless defined(&IFCOUNTER_IBYTES);
    eval("sub IFCOUNTER_OBYTES () { 6; }") unless defined(&IFCOUNTER_OBYTES);
    eval("sub IFCOUNTER_IMCASTS () { 7; }") unless defined(&IFCOUNTER_IMCASTS);
    eval("sub IFCOUNTER_OMCASTS () { 8; }") unless defined(&IFCOUNTER_OMCASTS);
    eval("sub IFCOUNTER_IQDROPS () { 9; }") unless defined(&IFCOUNTER_IQDROPS);
    eval("sub IFCOUNTER_OQDROPS () { 10; }") unless defined(&IFCOUNTER_OQDROPS);
    eval("sub IFCOUNTER_NOPROTO () { 11; }") unless defined(&IFCOUNTER_NOPROTO);
    eval("sub IFCOUNTERS () { 12; }") unless defined(&IFCOUNTERS);
    eval("sub IFENCAP_LL () { 1; }") unless defined(&IFENCAP_LL);
    eval 'sub IFENCAP_FLAG_BROADCAST () {0x2;}' unless defined(&IFENCAP_FLAG_BROADCAST);
    eval 'sub if_addrlist () { &if_addrhead;}' unless defined(&if_addrlist);
    eval 'sub if_list () { &if_link;}' unless defined(&if_list);
    eval 'sub if_name {
        my($ifp) = @_;
	    eval q((($ifp)-> &if_xname));
    }' unless defined(&if_name);
    eval 'sub IF_ADDR_LOCK_INIT {
        my($if) = @_;
	    eval q( &rw_init(($if)-> &if_addr_lock, \\"if_addr_lock\\"));
    }' unless defined(&IF_ADDR_LOCK_INIT);
    eval 'sub IF_ADDR_LOCK_DESTROY {
        my($if) = @_;
	    eval q( &rw_destroy(($if)-> &if_addr_lock));
    }' unless defined(&IF_ADDR_LOCK_DESTROY);
    eval 'sub IF_ADDR_WLOCK {
        my($if) = @_;
	    eval q( &rw_wlock(($if)-> &if_addr_lock));
    }' unless defined(&IF_ADDR_WLOCK);
    eval 'sub IF_ADDR_WUNLOCK {
        my($if) = @_;
	    eval q( &rw_wunlock(($if)-> &if_addr_lock));
    }' unless defined(&IF_ADDR_WUNLOCK);
    eval 'sub IF_ADDR_RLOCK {
        my($if) = @_;
	    eval q( &rw_rlock(($if)-> &if_addr_lock));
    }' unless defined(&IF_ADDR_RLOCK);
    eval 'sub IF_ADDR_RUNLOCK {
        my($if) = @_;
	    eval q( &rw_runlock(($if)-> &if_addr_lock));
    }' unless defined(&IF_ADDR_RUNLOCK);
    eval 'sub IF_ADDR_LOCK_ASSERT {
        my($if) = @_;
	    eval q( &rw_assert(($if)-> &if_addr_lock,  &RA_LOCKED));
    }' unless defined(&IF_ADDR_LOCK_ASSERT);
    eval 'sub IF_ADDR_WLOCK_ASSERT {
        my($if) = @_;
	    eval q( &rw_assert(($if)-> &if_addr_lock,  &RA_WLOCKED));
    }' unless defined(&IF_ADDR_WLOCK_ASSERT);
    if(defined(&_KERNEL)) {
	if(defined(&_SYS_EVENTHANDLER_H_)) {
	    eval 'sub IFNET_EVENT_UP () {0;}' unless defined(&IFNET_EVENT_UP);
	    eval 'sub IFNET_EVENT_DOWN () {1;}' unless defined(&IFNET_EVENT_DOWN);
	    eval 'sub IFNET_EVENT_PCP () {2;}' unless defined(&IFNET_EVENT_PCP);
	}
	if(defined(&_SYS_EVENTHANDLER_H_)) {
	}
	eval 'sub IF_AFDATA_LOCK_INIT {
	    my($ifp) = @_;
    	    eval q( &rw_init(($ifp)-> &if_afdata_lock, \\"if_afdata\\"));
	}' unless defined(&IF_AFDATA_LOCK_INIT);
	eval 'sub IF_AFDATA_WLOCK {
	    my($ifp) = @_;
    	    eval q( &rw_wlock(($ifp)-> &if_afdata_lock));
	}' unless defined(&IF_AFDATA_WLOCK);
	eval 'sub IF_AFDATA_RLOCK {
	    my($ifp) = @_;
    	    eval q( &rw_rlock(($ifp)-> &if_afdata_lock));
	}' unless defined(&IF_AFDATA_RLOCK);
	eval 'sub IF_AFDATA_WUNLOCK {
	    my($ifp) = @_;
    	    eval q( &rw_wunlock(($ifp)-> &if_afdata_lock));
	}' unless defined(&IF_AFDATA_WUNLOCK);
	eval 'sub IF_AFDATA_RUNLOCK {
	    my($ifp) = @_;
    	    eval q( &rw_runlock(($ifp)-> &if_afdata_lock));
	}' unless defined(&IF_AFDATA_RUNLOCK);
	eval 'sub IF_AFDATA_LOCK {
	    my($ifp) = @_;
    	    eval q( &IF_AFDATA_WLOCK($ifp));
	}' unless defined(&IF_AFDATA_LOCK);
	eval 'sub IF_AFDATA_UNLOCK {
	    my($ifp) = @_;
    	    eval q( &IF_AFDATA_WUNLOCK($ifp));
	}' unless defined(&IF_AFDATA_UNLOCK);
	eval 'sub IF_AFDATA_TRYLOCK {
	    my($ifp) = @_;
    	    eval q( &rw_try_wlock(($ifp)-> &if_afdata_lock));
	}' unless defined(&IF_AFDATA_TRYLOCK);
	eval 'sub IF_AFDATA_DESTROY {
	    my($ifp) = @_;
    	    eval q( &rw_destroy(($ifp)-> &if_afdata_lock));
	}' unless defined(&IF_AFDATA_DESTROY);
	eval 'sub IF_AFDATA_LOCK_ASSERT {
	    my($ifp) = @_;
    	    eval q( &rw_assert(($ifp)-> &if_afdata_lock,  &RA_LOCKED));
	}' unless defined(&IF_AFDATA_LOCK_ASSERT);
	eval 'sub IF_AFDATA_RLOCK_ASSERT {
	    my($ifp) = @_;
    	    eval q( &rw_assert(($ifp)-> &if_afdata_lock,  &RA_RLOCKED));
	}' unless defined(&IF_AFDATA_RLOCK_ASSERT);
	eval 'sub IF_AFDATA_WLOCK_ASSERT {
	    my($ifp) = @_;
    	    eval q( &rw_assert(($ifp)-> &if_afdata_lock,  &RA_WLOCKED));
	}' unless defined(&IF_AFDATA_WLOCK_ASSERT);
	eval 'sub IF_AFDATA_UNLOCK_ASSERT {
	    my($ifp) = @_;
    	    eval q( &rw_assert(($ifp)-> &if_afdata_lock,  &RA_UNLOCKED));
	}' unless defined(&IF_AFDATA_UNLOCK_ASSERT);
	eval 'sub IF_MINMTU () {72;}' unless defined(&IF_MINMTU);
	eval 'sub IF_MAXMTU () {65535;}' unless defined(&IF_MAXMTU);
	eval 'sub TOEDEV {
	    my($ifp) = @_;
    	    eval q((($ifp)-> &if_llsoftc));
	}' unless defined(&TOEDEV);
	eval 'sub ifa_broadaddr () { &ifa_dstaddr;}' unless defined(&ifa_broadaddr);
	eval 'sub IFA_ROUTE () { &RTF_UP;}' unless defined(&IFA_ROUTE);
	eval 'sub IFA_RTSELF () { &RTF_HOST;}' unless defined(&IFA_RTSELF);
	eval 'sub ifa_list () { &ifa_link;}' unless defined(&ifa_list);
	eval 'sub IFNET_WLOCK () {
	    eval q( &do {  &sx_xlock( &ifnet_sxlock);  &rw_wlock( &ifnet_rwlock); }  &while (0));
	}' unless defined(&IFNET_WLOCK);
	eval 'sub IFNET_WUNLOCK () {
	    eval q( &do {  &rw_wunlock( &ifnet_rwlock);  &sx_xunlock( &ifnet_sxlock); }  &while (0));
	}' unless defined(&IFNET_WUNLOCK);
	eval 'sub IFNET_RLOCK_ASSERT () {
	    eval q( &sx_assert( &ifnet_sxlock,  &SA_SLOCKED));
	}' unless defined(&IFNET_RLOCK_ASSERT);
	eval 'sub IFNET_RLOCK_NOSLEEP_ASSERT () {
	    eval q( &rw_assert( &ifnet_rwlock,  &RA_RLOCKED));
	}' unless defined(&IFNET_RLOCK_NOSLEEP_ASSERT);
	eval 'sub IFNET_WLOCK_ASSERT () {
	    eval q( &do {  &sx_assert( &ifnet_sxlock,  &SA_XLOCKED);  &rw_assert( &ifnet_rwlock,  &RA_WLOCKED); }  &while (0));
	}' unless defined(&IFNET_WLOCK_ASSERT);
	eval 'sub IFNET_RLOCK () {
	    eval q( &sx_slock( &ifnet_sxlock));
	}' unless defined(&IFNET_RLOCK);
	eval 'sub IFNET_RLOCK_NOSLEEP () {
	    eval q( &rw_rlock( &ifnet_rwlock));
	}' unless defined(&IFNET_RLOCK_NOSLEEP);
	eval 'sub IFNET_RUNLOCK () {
	    eval q( &sx_sunlock( &ifnet_sxlock));
	}' unless defined(&IFNET_RUNLOCK);
	eval 'sub IFNET_RUNLOCK_NOSLEEP () {
	    eval q( &rw_runlock( &ifnet_rwlock));
	}' unless defined(&IFNET_RUNLOCK_NOSLEEP);
	eval 'sub V_ifnet () { &VNET( &ifnet);}' unless defined(&V_ifnet);
	eval 'sub V_ifg_head () { &VNET( &ifg_head);}' unless defined(&V_ifg_head);
	eval 'sub V_if_index () { &VNET( &if_index);}' unless defined(&V_if_index);
	eval 'sub V_loif () { &VNET( &loif);}' unless defined(&V_loif);
	eval 'sub IF_LLADDR {
	    my($ifp) = @_;
    	    eval q( &LLADDR((($ifp)-> ($if_addr->{ifa_addr}))));
	}' unless defined(&IF_LLADDR);
	if(defined(&DEVICE_POLLING)) {
	    eval("sub POLL_ONLY () { 0; }") unless defined(&POLL_ONLY);
	    eval("sub POLL_AND_CHECK_STATUS () { 1; }") unless defined(&POLL_AND_CHECK_STATUS);
	}
    }
    require 'net/ifq.ph';
}
1;
