require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NET_IFQ_H_)) {
    eval 'sub _NET_IFQ_H_ () {1;}' unless defined(&_NET_IFQ_H_);
    if(defined(&_KERNEL)) {
	require 'sys/mbuf.ph';
	require 'sys/buf_ring.ph';
	require 'net/vnet.ph';
    }
    require 'sys/lock.ph';
    require 'sys/mutex.ph';
    eval 'sub IF_DUNIT_NONE () {-1;}' unless defined(&IF_DUNIT_NONE);
    require 'net/altq/if_altq.ph';
    if(defined(&_KERNEL)) {
	eval 'sub IF_LOCK {
	    my($ifq) = @_;
    	    eval q( &mtx_lock(($ifq)-> &ifq_mtx));
	}' unless defined(&IF_LOCK);
	eval 'sub IF_UNLOCK {
	    my($ifq) = @_;
    	    eval q( &mtx_unlock(($ifq)-> &ifq_mtx));
	}' unless defined(&IF_UNLOCK);
	eval 'sub IF_LOCK_ASSERT {
	    my($ifq) = @_;
    	    eval q( &mtx_assert(($ifq)-> &ifq_mtx,  &MA_OWNED));
	}' unless defined(&IF_LOCK_ASSERT);
	eval 'sub _IF_QFULL {
	    my($ifq) = @_;
    	    eval q((($ifq)-> &ifq_len >= ($ifq)-> &ifq_maxlen));
	}' unless defined(&_IF_QFULL);
	eval 'sub _IF_QLEN {
	    my($ifq) = @_;
    	    eval q((($ifq)-> &ifq_len));
	}' unless defined(&_IF_QLEN);
	eval 'sub _IF_ENQUEUE {
	    my($ifq, $m) = @_;
    	    eval q( &do { ($m)-> &m_nextpkt =  &NULL;  &if (($ifq)-> &ifq_tail ==  &NULL) ($ifq)-> &ifq_head = $m;  &else ($ifq)-> ($ifq_tail->{m_nextpkt}) = $m; ($ifq)-> &ifq_tail = $m; ($ifq)-> &ifq_len++; }  &while (0));
	}' unless defined(&_IF_ENQUEUE);
	eval 'sub IF_ENQUEUE {
	    my($ifq, $m) = @_;
    	    eval q( &do {  &IF_LOCK($ifq);  &_IF_ENQUEUE($ifq, $m);  &IF_UNLOCK($ifq); }  &while (0));
	}' unless defined(&IF_ENQUEUE);
	eval 'sub _IF_PREPEND {
	    my($ifq, $m) = @_;
    	    eval q( &do { ($m)-> &m_nextpkt = ($ifq)-> &ifq_head;  &if (($ifq)-> &ifq_tail ==  &NULL) ($ifq)-> &ifq_tail = ($m); ($ifq)-> &ifq_head = ($m); ($ifq)-> &ifq_len++; }  &while (0));
	}' unless defined(&_IF_PREPEND);
	eval 'sub IF_PREPEND {
	    my($ifq, $m) = @_;
    	    eval q( &do {  &IF_LOCK($ifq);  &_IF_PREPEND($ifq, $m);  &IF_UNLOCK($ifq); }  &while (0));
	}' unless defined(&IF_PREPEND);
	eval 'sub _IF_DEQUEUE {
	    my($ifq, $m) = @_;
    	    eval q( &do { ($m) = ($ifq)-> &ifq_head;  &if ($m) {  &if ((($ifq)-> &ifq_head = ($m)-> &m_nextpkt) ==  &NULL) ($ifq)-> &ifq_tail =  &NULL; ($m)-> &m_nextpkt =  &NULL; ($ifq)-> &ifq_len--; } }  &while (0));
	}' unless defined(&_IF_DEQUEUE);
	eval 'sub IF_DEQUEUE {
	    my($ifq, $m) = @_;
    	    eval q( &do {  &IF_LOCK($ifq);  &_IF_DEQUEUE($ifq, $m);  &IF_UNLOCK($ifq); }  &while (0));
	}' unless defined(&IF_DEQUEUE);
	eval 'sub _IF_DEQUEUE_ALL {
	    my($ifq, $m) = @_;
    	    eval q( &do { ($m) = ($ifq)-> &ifq_head; ($ifq)-> &ifq_head = ($ifq)-> &ifq_tail =  &NULL; ($ifq)-> &ifq_len = 0; }  &while (0));
	}' unless defined(&_IF_DEQUEUE_ALL);
	eval 'sub IF_DEQUEUE_ALL {
	    my($ifq, $m) = @_;
    	    eval q( &do {  &IF_LOCK($ifq);  &_IF_DEQUEUE_ALL($ifq, $m);  &IF_UNLOCK($ifq); }  &while (0));
	}' unless defined(&IF_DEQUEUE_ALL);
	eval 'sub _IF_POLL {
	    my($ifq, $m) = @_;
    	    eval q((($m) = ($ifq)-> &ifq_head));
	}' unless defined(&_IF_POLL);
	eval 'sub IF_POLL {
	    my($ifq, $m) = @_;
    	    eval q( &_IF_POLL($ifq, $m));
	}' unless defined(&IF_POLL);
	eval 'sub _IF_DRAIN {
	    my($ifq) = @_;
    	    eval q( &do { \'struct mbuf\' * &m;  &for (;;) {  &_IF_DEQUEUE($ifq,  &m);  &if ( &m ==  &NULL)  &break;  &m_freem( &m); } }  &while (0));
	}' unless defined(&_IF_DRAIN);
	eval 'sub IF_DRAIN {
	    my($ifq) = @_;
    	    eval q( &do {  &IF_LOCK($ifq);  &_IF_DRAIN($ifq);  &IF_UNLOCK($ifq); }  &while(0));
	}' unless defined(&IF_DRAIN);
	eval 'sub IF_HANDOFF {
	    my($ifq, $m, $ifp) = @_;
    	    eval q( &if_handoff($ifq, $m, $ifp, 0));
	}' unless defined(&IF_HANDOFF);
	eval 'sub IF_HANDOFF_ADJ {
	    my($ifq, $m, $ifp, $adj) = @_;
    	    eval q( &if_handoff($ifq, $m, $ifp, $adj));
	}' unless defined(&IF_HANDOFF_ADJ);
	eval 'sub IFQ_ENQUEUE {
	    my($ifq, $m, $err) = @_;
    	    eval q( &do {  &IF_LOCK($ifq);  &if ( &ALTQ_IS_ENABLED($ifq))  &ALTQ_ENQUEUE($ifq, $m,  &NULL, $err);  &else {  &if ( &_IF_QFULL($ifq)) {  &m_freem($m); ($err) =  &ENOBUFS; }  &else {  &_IF_ENQUEUE($ifq, $m); ($err) = 0; } }  &IF_UNLOCK($ifq); }  &while (0));
	}' unless defined(&IFQ_ENQUEUE);
	eval 'sub IFQ_DEQUEUE_NOLOCK {
	    my($ifq, $m) = @_;
    	    eval q( &do {  &if ( &TBR_IS_ENABLED($ifq)) ($m) =  &tbr_dequeue_ptr($ifq,  &ALTDQ_REMOVE);  &else  &if ( &ALTQ_IS_ENABLED($ifq))  &ALTQ_DEQUEUE($ifq, $m);  &else  &_IF_DEQUEUE($ifq, $m); }  &while (0));
	}' unless defined(&IFQ_DEQUEUE_NOLOCK);
	eval 'sub IFQ_DEQUEUE {
	    my($ifq, $m) = @_;
    	    eval q( &do {  &IF_LOCK($ifq);  &IFQ_DEQUEUE_NOLOCK($ifq, $m);  &IF_UNLOCK($ifq); }  &while (0));
	}' unless defined(&IFQ_DEQUEUE);
	eval 'sub IFQ_POLL_NOLOCK {
	    my($ifq, $m) = @_;
    	    eval q( &do {  &if ( &TBR_IS_ENABLED($ifq)) ($m) =  &tbr_dequeue_ptr($ifq,  &ALTDQ_POLL);  &else  &if ( &ALTQ_IS_ENABLED($ifq))  &ALTQ_POLL($ifq, $m);  &else  &_IF_POLL($ifq, $m); }  &while (0));
	}' unless defined(&IFQ_POLL_NOLOCK);
	eval 'sub IFQ_POLL {
	    my($ifq, $m) = @_;
    	    eval q( &do {  &IF_LOCK($ifq);  &IFQ_POLL_NOLOCK($ifq, $m);  &IF_UNLOCK($ifq); }  &while (0));
	}' unless defined(&IFQ_POLL);
	eval 'sub IFQ_PURGE_NOLOCK {
	    my($ifq) = @_;
    	    eval q( &do {  &if ( &ALTQ_IS_ENABLED($ifq)) {  &ALTQ_PURGE($ifq); }  &else  &_IF_DRAIN($ifq); }  &while (0));
	}' unless defined(&IFQ_PURGE_NOLOCK);
	eval 'sub IFQ_PURGE {
	    my($ifq) = @_;
    	    eval q( &do {  &IF_LOCK($ifq);  &IFQ_PURGE_NOLOCK($ifq);  &IF_UNLOCK($ifq); }  &while (0));
	}' unless defined(&IFQ_PURGE);
	eval 'sub IFQ_SET_READY {
	    my($ifq) = @_;
    	    eval q( &do { (($ifq)-> &altq_flags |=  &ALTQF_READY); }  &while (0));
	}' unless defined(&IFQ_SET_READY);
	eval 'sub IFQ_LOCK {
	    my($ifq) = @_;
    	    eval q( &IF_LOCK($ifq));
	}' unless defined(&IFQ_LOCK);
	eval 'sub IFQ_UNLOCK {
	    my($ifq) = @_;
    	    eval q( &IF_UNLOCK($ifq));
	}' unless defined(&IFQ_UNLOCK);
	eval 'sub IFQ_LOCK_ASSERT {
	    my($ifq) = @_;
    	    eval q( &IF_LOCK_ASSERT($ifq));
	}' unless defined(&IFQ_LOCK_ASSERT);
	eval 'sub IFQ_IS_EMPTY {
	    my($ifq) = @_;
    	    eval q((($ifq)-> &ifq_len == 0));
	}' unless defined(&IFQ_IS_EMPTY);
	eval 'sub IFQ_INC_LEN {
	    my($ifq) = @_;
    	    eval q((($ifq)-> &ifq_len++));
	}' unless defined(&IFQ_INC_LEN);
	eval 'sub IFQ_DEC_LEN {
	    my($ifq) = @_;
    	    eval q((--($ifq)-> &ifq_len));
	}' unless defined(&IFQ_DEC_LEN);
	eval 'sub IFQ_SET_MAXLEN {
	    my($ifq, $len) = @_;
    	    eval q((($ifq)-> &ifq_maxlen = ($len)));
	}' unless defined(&IFQ_SET_MAXLEN);
	eval 'sub IFQ_HANDOFF_ADJ {
	    my($ifp, $m, $adj, $err) = @_;
    	    eval q( &do { \'int\'  &len; \'short mflags\';  &len = ($m)-> ($m_pkthdr->{len});  &mflags = ($m)-> &m_flags;  &IFQ_ENQUEUE(($ifp)-> &if_snd, $m, $err);  &if (($err) == 0) {  &if_inc_counter(($ifp),  &IFCOUNTER_OBYTES,  &len + ($adj));  &if ( &mflags &  &M_MCAST)  &if_inc_counter(($ifp),  &IFCOUNTER_OMCASTS, 1);  &if ((($ifp)-> &if_drv_flags &  &IFF_DRV_OACTIVE) == 0)  &if_start($ifp); }  &else  &if_inc_counter(($ifp),  &IFCOUNTER_OQDROPS, 1); }  &while (0));
	}' unless defined(&IFQ_HANDOFF_ADJ);
	eval 'sub IFQ_HANDOFF {
	    my($ifp, $m, $err) = @_;
    	    eval q( &IFQ_HANDOFF_ADJ($ifp, $m, 0, $err));
	}' unless defined(&IFQ_HANDOFF);
	eval 'sub IFQ_DRV_DEQUEUE {
	    my($ifq, $m) = @_;
    	    eval q( &do { ($m) = ($ifq)-> &ifq_drv_head;  &if ($m) {  &if ((($ifq)-> &ifq_drv_head = ($m)-> &m_nextpkt) ==  &NULL) ($ifq)-> &ifq_drv_tail =  &NULL; ($m)-> &m_nextpkt =  &NULL; ($ifq)-> &ifq_drv_len--; }  &else {  &IFQ_LOCK($ifq);  &IFQ_DEQUEUE_NOLOCK($ifq, $m);  &while (($ifq)-> &ifq_drv_len < ($ifq)-> &ifq_drv_maxlen) { \'struct mbuf\' * &m0;  &IFQ_DEQUEUE_NOLOCK($ifq,  &m0);  &if ( &m0 ==  &NULL)  &break;  ($m0->{m_nextpkt}) =  &NULL;  &if (($ifq)-> &ifq_drv_tail ==  &NULL) ($ifq)-> &ifq_drv_head =  &m0;  &else ($ifq)-> ($ifq_drv_tail->{m_nextpkt}) =  &m0; ($ifq)-> &ifq_drv_tail =  &m0; ($ifq)-> &ifq_drv_len++; }  &IFQ_UNLOCK($ifq); } }  &while (0));
	}' unless defined(&IFQ_DRV_DEQUEUE);
	eval 'sub IFQ_DRV_PREPEND {
	    my($ifq, $m) = @_;
    	    eval q( &do { ($m)-> &m_nextpkt = ($ifq)-> &ifq_drv_head;  &if (($ifq)-> &ifq_drv_tail ==  &NULL) ($ifq)-> &ifq_drv_tail = ($m); ($ifq)-> &ifq_drv_head = ($m); ($ifq)-> &ifq_drv_len++; }  &while (0));
	}' unless defined(&IFQ_DRV_PREPEND);
	eval 'sub IFQ_DRV_IS_EMPTY {
	    my($ifq) = @_;
    	    eval q(((($ifq)-> &ifq_drv_len == 0)  && (($ifq)-> &ifq_len == 0)));
	}' unless defined(&IFQ_DRV_IS_EMPTY);
	eval 'sub IFQ_DRV_PURGE {
	    my($ifq) = @_;
    	    eval q( &do { \'struct mbuf\' * &m, * &n = ($ifq)-> &ifq_drv_head;  &while(( &m =  &n) !=  &NULL) {  &n =  ($m->{m_nextpkt});  &m_freem( &m); } ($ifq)-> &ifq_drv_head = ($ifq)-> &ifq_drv_tail =  &NULL; ($ifq)-> &ifq_drv_len = 0;  &IFQ_PURGE($ifq); }  &while (0));
	}' unless defined(&IFQ_DRV_PURGE);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub drbr_enqueue {
	    my($ifp,$br,$m) = @_;
    	    eval q({ \'int\'  &error = 0;  &error =  &buf_ring_enqueue($br, $m);  &if ( &error)  &m_freem($m); ( &error); });
	}' unless defined(&drbr_enqueue);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub drbr_putback {
	    my($ifp,$br,$new) = @_;
    	    eval q({  &buf_ring_putback_sc($br, $new); });
	}' unless defined(&drbr_putback);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub drbr_peek {
	    my($ifp,$br) = @_;
    	    eval q({ ( &buf_ring_peek_clear_sc($br)); });
	}' unless defined(&drbr_peek);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub drbr_flush {
	    my($ifp,$br) = @_;
    	    eval q({ \'struct mbuf\' * &m;  &while (( &m =  &buf_ring_dequeue_sc($br)) !=  &NULL)  &m_freem( &m); });
	}' unless defined(&drbr_flush);
	eval 'sub drbr_free {
	    my($br,$type) = @_;
    	    eval q({  &drbr_flush( &NULL, $br);  &buf_ring_free($br, $type); });
	}' unless defined(&drbr_free);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub drbr_dequeue {
	    my($ifp,$br) = @_;
    	    eval q({ ( &buf_ring_dequeue_sc($br)); });
	}' unless defined(&drbr_dequeue);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub drbr_advance {
	    my($ifp,$br) = @_;
    	    eval q({ ( &buf_ring_advance_sc($br)); });
	}' unless defined(&drbr_advance);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub drbr_dequeue_cond () {
	    eval q((\'struct ifnet\' * &ifp, \'struct buf_ring\' * &br,  &int (* &func) (\'struct mbuf\' *,  &void *),  &void * &arg) { \'struct mbuf\' * &m;  &m =  &buf_ring_peek( &br);  &if ( &m ==  &NULL ||  &func( &m,  &arg) == 0) ( &NULL); ( &buf_ring_dequeue_sc( &br)); });
	}' unless defined(&drbr_dequeue_cond);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub drbr_empty {
	    my($ifp,$br) = @_;
    	    eval q({ ( &buf_ring_empty($br)); });
	}' unless defined(&drbr_empty);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub drbr_needs_enqueue {
	    my($ifp,$br) = @_;
    	    eval q({ (! &buf_ring_empty($br)); });
	}' unless defined(&drbr_needs_enqueue);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub drbr_inuse {
	    my($ifp,$br) = @_;
    	    eval q({ ( &buf_ring_count($br)); });
	}' unless defined(&drbr_inuse);
    }
}
1;
