require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NET_PFVAR_H_)) {
    eval 'sub _NET_PFVAR_H_ () {1;}' unless defined(&_NET_PFVAR_H_);
    require 'sys/param.ph';
    require 'sys/queue.ph';
    require 'sys/counter.ph';
    require 'sys/malloc.ph';
    require 'sys/refcount.ph';
    require 'sys/tree.ph';
    require 'vm/uma.ph';
    require 'net/radix.ph';
    require 'netinet/in.ph';
    require 'netpfil/pf/pf.ph';
    require 'netpfil/pf/pf_altq.ph';
    require 'netpfil/pf/pf_mtag.ph';
    eval 'sub v4 () { ($pfa->{v4});}' unless defined(&v4);
    eval 'sub v6 () { ($pfa->{v6});}' unless defined(&v6);
    eval 'sub addr8 () { ($pfa->{addr8});}' unless defined(&addr8);
    eval 'sub addr16 () { ($pfa->{addr16});}' unless defined(&addr16);
    eval 'sub addr32 () { ($pfa->{addr32});}' unless defined(&addr32);
    eval 'sub PFI_AFLAG_NETWORK () {0x1;}' unless defined(&PFI_AFLAG_NETWORK);
    eval 'sub PFI_AFLAG_BROADCAST () {0x2;}' unless defined(&PFI_AFLAG_BROADCAST);
    eval 'sub PFI_AFLAG_PEER () {0x4;}' unless defined(&PFI_AFLAG_PEER);
    eval 'sub PFI_AFLAG_MODEMASK () {0x7;}' unless defined(&PFI_AFLAG_MODEMASK);
    eval 'sub PFI_AFLAG_NOALIAS () {0x8;}' unless defined(&PFI_AFLAG_NOALIAS);
    if(defined(&_KERNEL)) {
	eval 'sub HTONL {
	    my($x) = @_;
    	    eval q(($x) =  &htonl(( &__uint32_t)($x)));
	}' unless defined(&HTONL);
	eval 'sub HTONS {
	    my($x) = @_;
    	    eval q(($x) =  &htons(( &__uint16_t)($x)));
	}' unless defined(&HTONS);
	eval 'sub NTOHL {
	    my($x) = @_;
    	    eval q(($x) =  &ntohl(( &__uint32_t)($x)));
	}' unless defined(&NTOHL);
	eval 'sub NTOHS {
	    my($x) = @_;
    	    eval q(($x) =  &ntohs(( &__uint16_t)($x)));
	}' unless defined(&NTOHS);
	eval 'sub PF_NAME () {"pf";}' unless defined(&PF_NAME);
	eval 'sub PF_HASHROW_ASSERT {
	    my($h) = @_;
    	    eval q( &mtx_assert(($h)-> &lock,  &MA_OWNED));
	}' unless defined(&PF_HASHROW_ASSERT);
	eval 'sub PF_HASHROW_LOCK {
	    my($h) = @_;
    	    eval q( &mtx_lock(($h)-> &lock));
	}' unless defined(&PF_HASHROW_LOCK);
	eval 'sub PF_HASHROW_UNLOCK {
	    my($h) = @_;
    	    eval q( &mtx_unlock(($h)-> &lock));
	}' unless defined(&PF_HASHROW_UNLOCK);
	eval 'sub PF_STATE_LOCK {
	    my($s) = @_;
    	    eval q( &do { \'struct pf_idhash\' * &_ih =  $V_pf_idhash[ &PF_IDHASH($s)];  &PF_HASHROW_LOCK( &_ih); }  &while (0));
	}' unless defined(&PF_STATE_LOCK);
	eval 'sub PF_STATE_UNLOCK {
	    my($s) = @_;
    	    eval q( &do { \'struct pf_idhash\' * &_ih =  $V_pf_idhash[ &PF_IDHASH(($s))];  &PF_HASHROW_UNLOCK( &_ih); }  &while (0));
	}' unless defined(&PF_STATE_UNLOCK);
	if(defined(&INVARIANTS)) {
	    eval 'sub PF_STATE_LOCK_ASSERT {
	        my($s) = @_;
    		eval q( &do { \'struct pf_idhash\' * &_ih =  $V_pf_idhash[ &PF_IDHASH($s)];  &PF_HASHROW_ASSERT( &_ih); }  &while (0));
	    }' unless defined(&PF_STATE_LOCK_ASSERT);
	} else {
	    eval 'sub PF_STATE_LOCK_ASSERT {
	        my($s) = @_;
    		eval q( &do {}  &while (0));
	    }' unless defined(&PF_STATE_LOCK_ASSERT);
	}
	eval 'sub PF_UNLNKDRULES_LOCK () {
	    eval q( &mtx_lock( &pf_unlnkdrules_mtx));
	}' unless defined(&PF_UNLNKDRULES_LOCK);
	eval 'sub PF_UNLNKDRULES_UNLOCK () {
	    eval q( &mtx_unlock( &pf_unlnkdrules_mtx));
	}' unless defined(&PF_UNLNKDRULES_UNLOCK);
	eval 'sub PF_RULES_RLOCK () {
	    eval q( &rw_rlock( &pf_rules_lock));
	}' unless defined(&PF_RULES_RLOCK);
	eval 'sub PF_RULES_RUNLOCK () {
	    eval q( &rw_runlock( &pf_rules_lock));
	}' unless defined(&PF_RULES_RUNLOCK);
	eval 'sub PF_RULES_WLOCK () {
	    eval q( &rw_wlock( &pf_rules_lock));
	}' unless defined(&PF_RULES_WLOCK);
	eval 'sub PF_RULES_WUNLOCK () {
	    eval q( &rw_wunlock( &pf_rules_lock));
	}' unless defined(&PF_RULES_WUNLOCK);
	eval 'sub PF_RULES_ASSERT () {
	    eval q( &rw_assert( &pf_rules_lock,  &RA_LOCKED));
	}' unless defined(&PF_RULES_ASSERT);
	eval 'sub PF_RULES_RASSERT () {
	    eval q( &rw_assert( &pf_rules_lock,  &RA_RLOCKED));
	}' unless defined(&PF_RULES_RASSERT);
	eval 'sub PF_RULES_WASSERT () {
	    eval q( &rw_assert( &pf_rules_lock,  &RA_WLOCKED));
	}' unless defined(&PF_RULES_WASSERT);
	eval 'sub PF_MODVER () {1;}' unless defined(&PF_MODVER);
	eval 'sub PFLOG_MODVER () {1;}' unless defined(&PFLOG_MODVER);
	eval 'sub PFSYNC_MODVER () {1;}' unless defined(&PFSYNC_MODVER);
	eval 'sub PFLOG_MINVER () {1;}' unless defined(&PFLOG_MINVER);
	eval 'sub PFLOG_PREFVER () { &PFLOG_MODVER;}' unless defined(&PFLOG_PREFVER);
	eval 'sub PFLOG_MAXVER () {1;}' unless defined(&PFLOG_MAXVER);
	eval 'sub PFSYNC_MINVER () {1;}' unless defined(&PFSYNC_MINVER);
	eval 'sub PFSYNC_PREFVER () { &PFSYNC_MODVER;}' unless defined(&PFSYNC_PREFVER);
	eval 'sub PFSYNC_MAXVER () {1;}' unless defined(&PFSYNC_MAXVER);
	if(defined(&INET)) {
	    unless(defined(&INET6)) {
		eval 'sub PF_INET_ONLY () {1;}' unless defined(&PF_INET_ONLY);
	    }
	}
	if(defined(&INET6)) {
	    unless(defined(&INET)) {
		eval 'sub PF_INET6_ONLY () {1;}' unless defined(&PF_INET6_ONLY);
	    }
	}
	if(defined(&INET)) {
	    if(defined(&INET6)) {
		eval 'sub PF_INET_INET6 () {1;}' unless defined(&PF_INET_INET6);
	    }
	}
    } else {
	eval 'sub PF_INET_INET6 () {1;}' unless defined(&PF_INET_INET6);
    }
    if(defined(&PF_INET_INET6)) {
	eval 'sub PF_AEQ {
	    my($a, $b, $c) = @_;
    	    eval q((($c ==  &AF_INET  && ($a)-> $addr32[0] == ($b)-> $addr32[0]) || ($c ==  &AF_INET6  && ($a)-> $addr32[3] == ($b)-> $addr32[3]  && ($a)-> $addr32[2] == ($b)-> $addr32[2]  && ($a)-> $addr32[1] == ($b)-> $addr32[1]  && ($a)-> $addr32[0] == ($b)-> $addr32[0])));
	}' unless defined(&PF_AEQ);
	eval 'sub PF_ANEQ {
	    my($a, $b, $c) = @_;
    	    eval q((($c ==  &AF_INET  && ($a)-> $addr32[0] != ($b)-> $addr32[0]) || ($c ==  &AF_INET6  && (($a)-> $addr32[0] != ($b)-> $addr32[0] || ($a)-> $addr32[1] != ($b)-> $addr32[1] || ($a)-> $addr32[2] != ($b)-> $addr32[2] || ($a)-> $addr32[3] != ($b)-> $addr32[3]))));
	}' unless defined(&PF_ANEQ);
	eval 'sub PF_AZERO {
	    my($a, $c) = @_;
    	    eval q((($c ==  &AF_INET  && !($a)-> $addr32[0]) || ($c ==  &AF_INET6  && !($a)-> $addr32[0]  && !($a)-> $addr32[1]  && !($a)-> $addr32[2]  && !($a)-> $addr32[3] )));
	}' unless defined(&PF_AZERO);
	eval 'sub PF_MATCHA {
	    my($n, $a, $m, $b, $f) = @_;
    	    eval q( &pf_match_addr($n, $a, $m, $b, $f));
	}' unless defined(&PF_MATCHA);
	eval 'sub PF_ACPY {
	    my($a, $b, $f) = @_;
    	    eval q( &pf_addrcpy($a, $b, $f));
	}' unless defined(&PF_ACPY);
	eval 'sub PF_AINC {
	    my($a, $f) = @_;
    	    eval q( &pf_addr_inc($a, $f));
	}' unless defined(&PF_AINC);
	eval 'sub PF_POOLMASK {
	    my($a, $b, $c, $d, $f) = @_;
    	    eval q( &pf_poolmask($a, $b, $c, $d, $f));
	}' unless defined(&PF_POOLMASK);
    } else {
	if(defined(&PF_INET6_ONLY)) {
	    eval 'sub PF_AEQ {
	        my($a, $b, $c) = @_;
    		eval q((($a)-> $addr32[3] == ($b)-> $addr32[3]  && ($a)-> $addr32[2] == ($b)-> $addr32[2]  && ($a)-> $addr32[1] == ($b)-> $addr32[1]  && ($a)-> $addr32[0] == ($b)-> $addr32[0]));
	    }' unless defined(&PF_AEQ);
	    eval 'sub PF_ANEQ {
	        my($a, $b, $c) = @_;
    		eval q((($a)-> $addr32[3] != ($b)-> $addr32[3] || ($a)-> $addr32[2] != ($b)-> $addr32[2] || ($a)-> $addr32[1] != ($b)-> $addr32[1] || ($a)-> $addr32[0] != ($b)-> $addr32[0]));
	    }' unless defined(&PF_ANEQ);
	    eval 'sub PF_AZERO {
	        my($a, $c) = @_;
    		eval q((!($a)-> $addr32[0]  && !($a)-> $addr32[1]  && !($a)-> $addr32[2]  && !($a)-> $addr32[3] ));
	    }' unless defined(&PF_AZERO);
	    eval 'sub PF_MATCHA {
	        my($n, $a, $m, $b, $f) = @_;
    		eval q( &pf_match_addr($n, $a, $m, $b, $f));
	    }' unless defined(&PF_MATCHA);
	    eval 'sub PF_ACPY {
	        my($a, $b, $f) = @_;
    		eval q( &pf_addrcpy($a, $b, $f));
	    }' unless defined(&PF_ACPY);
	    eval 'sub PF_AINC {
	        my($a, $f) = @_;
    		eval q( &pf_addr_inc($a, $f));
	    }' unless defined(&PF_AINC);
	    eval 'sub PF_POOLMASK {
	        my($a, $b, $c, $d, $f) = @_;
    		eval q( &pf_poolmask($a, $b, $c, $d, $f));
	    }' unless defined(&PF_POOLMASK);
	} else {
	    if(defined(&PF_INET_ONLY)) {
		eval 'sub PF_AEQ {
		    my($a, $b, $c) = @_;
    		    eval q((($a)-> $addr32[0] == ($b)-> $addr32[0]));
		}' unless defined(&PF_AEQ);
		eval 'sub PF_ANEQ {
		    my($a, $b, $c) = @_;
    		    eval q((($a)-> $addr32[0] != ($b)-> $addr32[0]));
		}' unless defined(&PF_ANEQ);
		eval 'sub PF_AZERO {
		    my($a, $c) = @_;
    		    eval q((!($a)-> $addr32[0]));
		}' unless defined(&PF_AZERO);
		eval 'sub PF_MATCHA {
		    my($n, $a, $m, $b, $f) = @_;
    		    eval q( &pf_match_addr($n, $a, $m, $b, $f));
		}' unless defined(&PF_MATCHA);
		eval 'sub PF_ACPY {
		    my($a, $b, $f) = @_;
    		    eval q(($a)-> ($v4->{s_addr}) = ($b)-> ($v4->{s_addr}));
		}' unless defined(&PF_ACPY);
		eval 'sub PF_AINC {
		    my($a, $f) = @_;
    		    eval q( &do { ($a)-> $addr32[0] =  &htonl( &ntohl(($a)-> $addr32[0]) + 1); }  &while (0));
		}' unless defined(&PF_AINC);
		eval 'sub PF_POOLMASK {
		    my($a, $b, $c, $d, $f) = @_;
    		    eval q( &do { ($a)-> $addr32[0] = (($b)-> $addr32[0] & ($c)-> $addr32[0]) | ((($c)-> $addr32[0] ^ 0xffffffff ) & ($d)-> $addr32[0]); }  &while (0));
		}' unless defined(&PF_POOLMASK);
	    }
	}
    }
    eval 'sub PF_MISMATCHAW {
        my($aw, $x, $af, $neg, $ifp, $rtid) = @_;
	    eval q(( ((($aw)-> &type ==  &PF_ADDR_NOROUTE  &&  &pf_routable(($x), ($af),  &NULL, ($rtid))) || ((($aw)-> &type ==  &PF_ADDR_URPFFAILED  && ($ifp) !=  &NULL  &&  &pf_routable(($x), ($af), ($ifp), ($rtid))) || (($aw)-> &type ==  &PF_ADDR_TABLE  && ! &pfr_match_addr(($aw)-> ($p->{tbl}), ($x), ($af))) || (($aw)-> &type ==  &PF_ADDR_DYNIFTL  && ! &pfi_match_addr(($aw)-> ($p->{dyn}), ($x), ($af))) || (($aw)-> &type ==  &PF_ADDR_RANGE  && ! &pf_match_addr_range(($aw)-> ($v->{a}->{addr}), ($aw)-> ($v->{a}->{mask}), ($x), ($af))) || (($aw)-> &type ==  &PF_ADDR_ADDRMASK  && ! &PF_AZERO(($aw)-> ($v->{a}->{mask}), ($af))  && ! &PF_MATCHA(0, ($aw)-> ($v->{a}->{addr}), ($aw)-> ($v->{a}->{mask}), ($x), ($af))))) != ($neg) ));
    }' unless defined(&PF_MISMATCHAW);
    eval 'sub key8 () { ($pfk->{key8});}' unless defined(&key8);
    eval 'sub key16 () { ($pfk->{key16});}' unless defined(&key16);
    eval 'sub key32 () { ($pfk->{key32});}' unless defined(&key32);
    eval 'sub PF_OSFP_ANY () {(( &pf_osfp_t)0);}' unless defined(&PF_OSFP_ANY);
    eval 'sub PF_OSFP_UNKNOWN () {(( &pf_osfp_t)-1);}' unless defined(&PF_OSFP_UNKNOWN);
    eval 'sub PF_OSFP_NOMATCH () {(( &pf_osfp_t)-2);}' unless defined(&PF_OSFP_NOMATCH);
    eval 'sub PF_OSFP_EXPANDED () {0x1;}' unless defined(&PF_OSFP_EXPANDED);
    eval 'sub PF_OSFP_GENERIC () {0x2;}' unless defined(&PF_OSFP_GENERIC);
    eval 'sub PF_OSFP_NODETAIL () {0x4;}' unless defined(&PF_OSFP_NODETAIL);
    eval 'sub PF_OSFP_LEN () {32;}' unless defined(&PF_OSFP_LEN);
    eval 'sub PF_OSFP_ENTRY_EQ {
        my($a, $b) = @_;
	    eval q((($a)-> &fp_os == ($b)-> &fp_os  &&  &memcmp(($a)-> &fp_class_nm, ($b)-> &fp_class_nm,  &PF_OSFP_LEN) == 0 &&  &memcmp(($a)-> &fp_version_nm, ($b)-> &fp_version_nm,  &PF_OSFP_LEN) == 0 &&  &memcmp(($a)-> &fp_subtype_nm, ($b)-> &fp_subtype_nm,  &PF_OSFP_LEN) == 0));
    }' unless defined(&PF_OSFP_ENTRY_EQ);
    eval 'sub _FP_RESERVED_BIT () {1;}' unless defined(&_FP_RESERVED_BIT);
    eval 'sub _FP_UNUSED_BITS () {1;}' unless defined(&_FP_UNUSED_BITS);
    eval 'sub _FP_CLASS_BITS () {10;}' unless defined(&_FP_CLASS_BITS);
    eval 'sub _FP_VERSION_BITS () {10;}' unless defined(&_FP_VERSION_BITS);
    eval 'sub _FP_SUBTYPE_BITS () {10;}' unless defined(&_FP_SUBTYPE_BITS);
    eval 'sub PF_OSFP_UNPACK {
        my($osfp, $class, $version, $subtype) = @_;
	    eval q( &do { ($class) = (($osfp) >> ( &_FP_VERSION_BITS+ &_FP_SUBTYPE_BITS)) & ((1<<  &_FP_CLASS_BITS) - 1); ($version) = (($osfp) >>  &_FP_SUBTYPE_BITS) & ((1<<  &_FP_VERSION_BITS) - 1); ($subtype) = ($osfp) & ((1<<  &_FP_SUBTYPE_BITS) - 1); }  &while(0));
    }' unless defined(&PF_OSFP_UNPACK);
    eval 'sub PF_OSFP_PACK {
        my($osfp, $class, $version, $subtype) = @_;
	    eval q( &do { ($osfp) = (($class) & ((1<<  &_FP_CLASS_BITS) - 1)) << ( &_FP_VERSION_BITS +  &_FP_SUBTYPE_BITS); ($osfp) |= (($version) & ((1<<  &_FP_VERSION_BITS) - 1)) <<  &_FP_SUBTYPE_BITS; ($osfp) |= ($subtype) & ((1<<  &_FP_SUBTYPE_BITS) - 1); }  &while(0));
    }' unless defined(&PF_OSFP_PACK);
    eval 'sub PF_OSFP_WSIZE_MOD () {0x1;}' unless defined(&PF_OSFP_WSIZE_MOD);
    eval 'sub PF_OSFP_WSIZE_DC () {0x2;}' unless defined(&PF_OSFP_WSIZE_DC);
    eval 'sub PF_OSFP_WSIZE_MSS () {0x4;}' unless defined(&PF_OSFP_WSIZE_MSS);
    eval 'sub PF_OSFP_WSIZE_MTU () {0x8;}' unless defined(&PF_OSFP_WSIZE_MTU);
    eval 'sub PF_OSFP_PSIZE_MOD () {0x10;}' unless defined(&PF_OSFP_PSIZE_MOD);
    eval 'sub PF_OSFP_PSIZE_DC () {0x20;}' unless defined(&PF_OSFP_PSIZE_DC);
    eval 'sub PF_OSFP_WSCALE () {0x40;}' unless defined(&PF_OSFP_WSCALE);
    eval 'sub PF_OSFP_WSCALE_MOD () {0x80;}' unless defined(&PF_OSFP_WSCALE_MOD);
    eval 'sub PF_OSFP_WSCALE_DC () {0x100;}' unless defined(&PF_OSFP_WSCALE_DC);
    eval 'sub PF_OSFP_MSS () {0x200;}' unless defined(&PF_OSFP_MSS);
    eval 'sub PF_OSFP_MSS_MOD () {0x400;}' unless defined(&PF_OSFP_MSS_MOD);
    eval 'sub PF_OSFP_MSS_DC () {0x800;}' unless defined(&PF_OSFP_MSS_DC);
    eval 'sub PF_OSFP_DF () {0x1000;}' unless defined(&PF_OSFP_DF);
    eval 'sub PF_OSFP_TS0 () {0x2000;}' unless defined(&PF_OSFP_TS0);
    eval 'sub PF_OSFP_INET6 () {0x4000;}' unless defined(&PF_OSFP_INET6);
    eval 'sub PF_OSFP_MAXTTL_OFFSET () {40;}' unless defined(&PF_OSFP_MAXTTL_OFFSET);
    eval 'sub PF_OSFP_TCPOPT_NOP () {0x;}' unless defined(&PF_OSFP_TCPOPT_NOP);
    eval 'sub PF_OSFP_TCPOPT_WSCALE () {0x1;}' unless defined(&PF_OSFP_TCPOPT_WSCALE);
    eval 'sub PF_OSFP_TCPOPT_MSS () {0x2;}' unless defined(&PF_OSFP_TCPOPT_MSS);
    eval 'sub PF_OSFP_TCPOPT_SACK () {0x3;}' unless defined(&PF_OSFP_TCPOPT_SACK);
    eval 'sub PF_OSFP_TCPOPT_TS () {0x4;}' unless defined(&PF_OSFP_TCPOPT_TS);
    eval 'sub PF_OSFP_TCPOPT_BITS () {3;}' unless defined(&PF_OSFP_TCPOPT_BITS);
    eval 'sub PF_OSFP_MAX_OPTS () {($sizeof{(0)-> &fp_tcpopts} * 8) /  &PF_OSFP_TCPOPT_BITS;}' unless defined(&PF_OSFP_MAX_OPTS);
    eval 'sub PF_ANCHOR_NAME_SIZE () {64;}' unless defined(&PF_ANCHOR_NAME_SIZE);
    eval 'sub PF_SKIP_IFP () {0;}' unless defined(&PF_SKIP_IFP);
    eval 'sub PF_SKIP_DIR () {1;}' unless defined(&PF_SKIP_DIR);
    eval 'sub PF_SKIP_AF () {2;}' unless defined(&PF_SKIP_AF);
    eval 'sub PF_SKIP_PROTO () {3;}' unless defined(&PF_SKIP_PROTO);
    eval 'sub PF_SKIP_SRC_ADDR () {4;}' unless defined(&PF_SKIP_SRC_ADDR);
    eval 'sub PF_SKIP_SRC_PORT () {5;}' unless defined(&PF_SKIP_SRC_PORT);
    eval 'sub PF_SKIP_DST_ADDR () {6;}' unless defined(&PF_SKIP_DST_ADDR);
    eval 'sub PF_SKIP_DST_PORT () {7;}' unless defined(&PF_SKIP_DST_PORT);
    eval 'sub PF_SKIP_COUNT () {8;}' unless defined(&PF_SKIP_COUNT);
    eval 'sub PF_RULE_LABEL_SIZE () {64;}' unless defined(&PF_RULE_LABEL_SIZE);
    eval 'sub PF_TAG_NAME_SIZE () {64;}' unless defined(&PF_TAG_NAME_SIZE);
    eval 'sub PF_STATE_NORMAL () {0x1;}' unless defined(&PF_STATE_NORMAL);
    eval 'sub PF_STATE_MODULATE () {0x2;}' unless defined(&PF_STATE_MODULATE);
    eval 'sub PF_STATE_SYNPROXY () {0x3;}' unless defined(&PF_STATE_SYNPROXY);
    eval 'sub PF_FLUSH () {0x1;}' unless defined(&PF_FLUSH);
    eval 'sub PF_FLUSH_GLOBAL () {0x2;}' unless defined(&PF_FLUSH_GLOBAL);
    eval 'sub PF_PRIO_ZERO () {0xff;}' unless defined(&PF_PRIO_ZERO);
    eval 'sub PF_PRIO_MAX () {7;}' unless defined(&PF_PRIO_MAX);
    eval 'sub PFRULE_DROP () {0x;}' unless defined(&PFRULE_DROP);
    eval 'sub PFRULE_RETURNRST () {0x1;}' unless defined(&PFRULE_RETURNRST);
    eval 'sub PFRULE_FRAGMENT () {0x2;}' unless defined(&PFRULE_FRAGMENT);
    eval 'sub PFRULE_RETURNICMP () {0x4;}' unless defined(&PFRULE_RETURNICMP);
    eval 'sub PFRULE_RETURN () {0x8;}' unless defined(&PFRULE_RETURN);
    eval 'sub PFRULE_NOSYNC () {0x10;}' unless defined(&PFRULE_NOSYNC);
    eval 'sub PFRULE_SRCTRACK () {0x20;}' unless defined(&PFRULE_SRCTRACK);
    eval 'sub PFRULE_RULESRCTRACK () {0x40;}' unless defined(&PFRULE_RULESRCTRACK);
    eval 'sub PFRULE_REFS () {0x80;}' unless defined(&PFRULE_REFS);
    eval 'sub PFRULE_NODF () {0x100;}' unless defined(&PFRULE_NODF);
    eval 'sub PFRULE_RANDOMID () {0x800;}' unless defined(&PFRULE_RANDOMID);
    eval 'sub PFRULE_REASSEMBLE_TCP () {0x1000;}' unless defined(&PFRULE_REASSEMBLE_TCP);
    eval 'sub PFRULE_SET_TOS () {0x2000;}' unless defined(&PFRULE_SET_TOS);
    eval 'sub PFRULE_IFBOUND () {0x10000;}' unless defined(&PFRULE_IFBOUND);
    eval 'sub PFRULE_STATESLOPPY () {0x20000;}' unless defined(&PFRULE_STATESLOPPY);
    eval 'sub PFSTATE_HIWAT () {10000;}' unless defined(&PFSTATE_HIWAT);
    eval 'sub PFSTATE_ADAPT_START () {6000;}' unless defined(&PFSTATE_ADAPT_START);
    eval 'sub PFSTATE_ADAPT_END () {12000;}' unless defined(&PFSTATE_ADAPT_END);
    eval 'sub PF_THRESHOLD_MULT () {1000;}' unless defined(&PF_THRESHOLD_MULT);
    eval 'sub PF_THRESHOLD_MAX () {0xffffffff /  &PF_THRESHOLD_MULT;}' unless defined(&PF_THRESHOLD_MAX);
    eval 'sub PFSNODE_HIWAT () {10000;}' unless defined(&PFSNODE_HIWAT);
    eval 'sub PFSS_TIMESTAMP () {0x1;}' unless defined(&PFSS_TIMESTAMP);
    eval 'sub PFSS_PAWS () {0x10;}' unless defined(&PFSS_PAWS);
    eval 'sub PFSS_PAWS_IDLED () {0x20;}' unless defined(&PFSS_PAWS_IDLED);
    eval 'sub PFSS_DATA_TS () {0x40;}' unless defined(&PFSS_DATA_TS);
    eval 'sub PFSS_DATA_NOTS () {0x80;}' unless defined(&PFSS_DATA_NOTS);
    eval 'sub PFSTATE_ALLOWOPTS () {0x1;}' unless defined(&PFSTATE_ALLOWOPTS);
    eval 'sub PFSTATE_SLOPPY () {0x2;}' unless defined(&PFSTATE_SLOPPY);
    eval 'sub PFSTATE_NOSYNC () {0x8;}' unless defined(&PFSTATE_NOSYNC);
    eval 'sub PFSTATE_ACK () {0x10;}' unless defined(&PFSTATE_ACK);
    eval 'sub PFSTATE_SETPRIO () {0x200;}' unless defined(&PFSTATE_SETPRIO);
    eval 'sub PFSTATE_SETMASK () {( &PFSTATE_SETPRIO);}' unless defined(&PFSTATE_SETMASK);
    eval 'sub PFSYNC_SCRUB_FLAG_VALID () {0x1;}' unless defined(&PFSYNC_SCRUB_FLAG_VALID);
    if(defined(&_KERNEL)) {
    }
    eval 'sub PFSYNC_FLAG_SRCNODE () {0x4;}' unless defined(&PFSYNC_FLAG_SRCNODE);
    eval 'sub PFSYNC_FLAG_NATSRCNODE () {0x8;}' unless defined(&PFSYNC_FLAG_NATSRCNODE);
    eval 'sub pf_state_peer_hton {
        my($s,$d) = @_;
	    eval q( &do { ($d)-> &seqlo =  &htonl(($s)-> &seqlo); ($d)-> &seqhi =  &htonl(($s)-> &seqhi); ($d)-> &seqdiff =  &htonl(($s)-> &seqdiff); ($d)-> &max_win =  &htons(($s)-> &max_win); ($d)-> &mss =  &htons(($s)-> &mss); ($d)-> &state = ($s)-> &state; ($d)-> &wscale = ($s)-> &wscale;  &if (($s)-> &scrub) { ($d)-> ($scrub->{pfss_flags}) =  &htons(($s)-> ($scrub->{pfss_flags}) &  &PFSS_TIMESTAMP); ($d)-> ($scrub->{pfss_ttl}) = ($s)-> ($scrub->{pfss_ttl}); ($d)-> ($scrub->{pfss_ts_mod}) =  &htonl(($s)-> ($scrub->{pfss_ts_mod})); ($d)-> ($scrub->{scrub_flag}) =  &PFSYNC_SCRUB_FLAG_VALID; } }  &while (0));
    }' unless defined(&pf_state_peer_hton);
    eval 'sub pf_state_peer_ntoh {
        my($s,$d) = @_;
	    eval q( &do { ($d)-> &seqlo =  &ntohl(($s)-> &seqlo); ($d)-> &seqhi =  &ntohl(($s)-> &seqhi); ($d)-> &seqdiff =  &ntohl(($s)-> &seqdiff); ($d)-> &max_win =  &ntohs(($s)-> &max_win); ($d)-> &mss =  &ntohs(($s)-> &mss); ($d)-> &state = ($s)-> &state; ($d)-> &wscale = ($s)-> &wscale;  &if (($s)-> ($scrub->{scrub_flag}) ==  &PFSYNC_SCRUB_FLAG_VALID  && ($d)-> &scrub !=  &NULL) { ($d)-> ($scrub->{pfss_flags}) =  &ntohs(($s)-> ($scrub->{pfss_flags})) &  &PFSS_TIMESTAMP; ($d)-> ($scrub->{pfss_ttl}) = ($s)-> ($scrub->{pfss_ttl}); ($d)-> ($scrub->{pfss_ts_mod}) =  &ntohl(($s)-> ($scrub->{pfss_ts_mod})); } }  &while (0));
    }' unless defined(&pf_state_peer_ntoh);
    eval 'sub pf_state_counter_hton {
        my($s,$d) = @_;
	    eval q( &do { $d->[0] =  &htonl(($s>>32)&0xffffffff); $d->[1] =  &htonl($s&0xffffffff); }  &while (0));
    }' unless defined(&pf_state_counter_hton);
    eval 'sub pf_state_counter_from_pfsync {
        my($s) = @_;
	    eval q(((( &u_int64_t)($s->[0])<<32) | ( &u_int64_t)($s->[1])));
    }' unless defined(&pf_state_counter_from_pfsync);
    eval 'sub pf_state_counter_ntoh {
        my($s,$d) = @_;
	    eval q( &do { $d =  &ntohl($s->[0]); $d = $d<<32; $d +=  &ntohl($s->[1]); }  &while (0));
    }' unless defined(&pf_state_counter_ntoh);
    eval 'sub PF_RESERVED_ANCHOR () {"_pf";}' unless defined(&PF_RESERVED_ANCHOR);
    eval 'sub PFR_TFLAG_PERSIST () {0x1;}' unless defined(&PFR_TFLAG_PERSIST);
    eval 'sub PFR_TFLAG_CONST () {0x2;}' unless defined(&PFR_TFLAG_CONST);
    eval 'sub PFR_TFLAG_ACTIVE () {0x4;}' unless defined(&PFR_TFLAG_ACTIVE);
    eval 'sub PFR_TFLAG_INACTIVE () {0x8;}' unless defined(&PFR_TFLAG_INACTIVE);
    eval 'sub PFR_TFLAG_REFERENCED () {0x10;}' unless defined(&PFR_TFLAG_REFERENCED);
    eval 'sub PFR_TFLAG_REFDANCHOR () {0x20;}' unless defined(&PFR_TFLAG_REFDANCHOR);
    eval 'sub PFR_TFLAG_COUNTERS () {0x40;}' unless defined(&PFR_TFLAG_COUNTERS);
    eval 'sub PFR_TFLAG_USRMASK () {( &PFR_TFLAG_PERSIST |  &PFR_TFLAG_CONST |  &PFR_TFLAG_COUNTERS);}' unless defined(&PFR_TFLAG_USRMASK);
    eval 'sub PFR_TFLAG_SETMASK () {( &PFR_TFLAG_ACTIVE |  &PFR_TFLAG_INACTIVE |  &PFR_TFLAG_REFERENCED |  &PFR_TFLAG_REFDANCHOR);}' unless defined(&PFR_TFLAG_SETMASK);
    eval 'sub PFR_TFLAG_ALLMASK () {( &PFR_TFLAG_PERSIST |  &PFR_TFLAG_CONST |  &PFR_TFLAG_ACTIVE |  &PFR_TFLAG_INACTIVE |  &PFR_TFLAG_REFERENCED |  &PFR_TFLAG_REFDANCHOR |  &PFR_TFLAG_COUNTERS);}' unless defined(&PFR_TFLAG_ALLMASK);
    eval("sub PFR_FB_NONE () { 0; }") unless defined(&PFR_FB_NONE);
    eval("sub PFR_FB_MATCH () { 1; }") unless defined(&PFR_FB_MATCH);
    eval("sub PFR_FB_ADDED () { 2; }") unless defined(&PFR_FB_ADDED);
    eval("sub PFR_FB_DELETED () { 3; }") unless defined(&PFR_FB_DELETED);
    eval("sub PFR_FB_CHANGED () { 4; }") unless defined(&PFR_FB_CHANGED);
    eval("sub PFR_FB_CLEARED () { 5; }") unless defined(&PFR_FB_CLEARED);
    eval("sub PFR_FB_DUPLICATE () { 6; }") unless defined(&PFR_FB_DUPLICATE);
    eval("sub PFR_FB_NOTMATCH () { 7; }") unless defined(&PFR_FB_NOTMATCH);
    eval("sub PFR_FB_CONFLICT () { 8; }") unless defined(&PFR_FB_CONFLICT);
    eval("sub PFR_FB_NOCOUNT () { 9; }") unless defined(&PFR_FB_NOCOUNT);
    eval("sub PFR_FB_MAX () { 10; }") unless defined(&PFR_FB_MAX);
    eval 'sub pfra_ip4addr () { ($pfra_u->{_pfra_ip4addr});}' unless defined(&pfra_ip4addr);
    eval 'sub pfra_ip6addr () { ($pfra_u->{_pfra_ip6addr});}' unless defined(&pfra_ip6addr);
    eval("sub PFR_DIR_IN () { 0; }") unless defined(&PFR_DIR_IN);
    eval("sub PFR_DIR_OUT () { 1; }") unless defined(&PFR_DIR_OUT);
    eval("sub PFR_DIR_MAX () { 2; }") unless defined(&PFR_DIR_MAX);
    eval("sub PFR_OP_BLOCK () { 0; }") unless defined(&PFR_OP_BLOCK);
    eval("sub PFR_OP_PASS () { 1; }") unless defined(&PFR_OP_PASS);
    eval("sub PFR_OP_ADDR_MAX () { 2; }") unless defined(&PFR_OP_ADDR_MAX);
    eval("sub PFR_OP_TABLE_MAX () { 3; }") unless defined(&PFR_OP_TABLE_MAX);
    eval 'sub PFR_OP_XPASS () { &PFR_OP_ADDR_MAX;}' unless defined(&PFR_OP_XPASS);
    eval("sub PFR_REFCNT_RULE () { 0; }") unless defined(&PFR_REFCNT_RULE);
    eval("sub PFR_REFCNT_ANCHOR () { 1; }") unless defined(&PFR_REFCNT_ANCHOR);
    eval("sub PFR_REFCNT_MAX () { 2; }") unless defined(&PFR_REFCNT_MAX);
    eval 'sub pfrts_name () { ($pfrts_t->{pfrt_name});}' unless defined(&pfrts_name);
    eval 'sub pfrts_flags () { ($pfrts_t->{pfrt_flags});}' unless defined(&pfrts_flags);
    unless(defined(&_SOCKADDR_UNION_DEFINED)) {
	eval 'sub _SOCKADDR_UNION_DEFINED () {1;}' unless defined(&_SOCKADDR_UNION_DEFINED);
    }
    eval 'sub pfrkt_t () { ($pfrkt_ts->{pfrts_t});}' unless defined(&pfrkt_t);
    eval 'sub pfrkt_name () { ($pfrkt_t->{pfrt_name});}' unless defined(&pfrkt_name);
    eval 'sub pfrkt_anchor () { ($pfrkt_t->{pfrt_anchor});}' unless defined(&pfrkt_anchor);
    eval 'sub pfrkt_ruleset () { ($pfrkt_t->{pfrt_ruleset});}' unless defined(&pfrkt_ruleset);
    eval 'sub pfrkt_flags () { ($pfrkt_t->{pfrt_flags});}' unless defined(&pfrkt_flags);
    eval 'sub pfrkt_cnt () { ($pfrkt_ts->{pfrts_cnt});}' unless defined(&pfrkt_cnt);
    eval 'sub pfrkt_refcnt () { ($pfrkt_ts->{pfrts_refcnt});}' unless defined(&pfrkt_refcnt);
    eval 'sub pfrkt_packets () { ($pfrkt_ts->{pfrts_packets});}' unless defined(&pfrkt_packets);
    eval 'sub pfrkt_bytes () { ($pfrkt_ts->{pfrts_bytes});}' unless defined(&pfrkt_bytes);
    eval 'sub pfrkt_match () { ($pfrkt_ts->{pfrts_match});}' unless defined(&pfrkt_match);
    eval 'sub pfrkt_nomatch () { ($pfrkt_ts->{pfrts_nomatch});}' unless defined(&pfrkt_nomatch);
    eval 'sub pfrkt_tzero () { ($pfrkt_ts->{pfrts_tzero});}' unless defined(&pfrkt_tzero);
    eval 'sub pfik_tree () { ($_pfik_glue->{_pfik_tree});}' unless defined(&pfik_tree);
    eval 'sub pfik_list () { ($_pfik_glue->{_pfik_list});}' unless defined(&pfik_list);
    eval 'sub PFI_IFLAG_REFS () {0x1;}' unless defined(&PFI_IFLAG_REFS);
    eval 'sub PFI_IFLAG_SKIP () {0x100;}' unless defined(&PFI_IFLAG_SKIP);
    if(defined(&INET6)) {
    }
    eval 'sub PFDESC_TCP_NORM () {0x1;}' unless defined(&PFDESC_TCP_NORM);
    eval 'sub PFDESC_IP_REAS () {0x2;}' unless defined(&PFDESC_IP_REAS);
    eval 'sub PF_DPORT_RANGE () {0x1;}' unless defined(&PF_DPORT_RANGE);
    eval 'sub PF_RPORT_RANGE () {0x2;}' unless defined(&PF_RPORT_RANGE);
    eval 'sub PFUDPS_NO_TRAFFIC () {0;}' unless defined(&PFUDPS_NO_TRAFFIC);
    eval 'sub PFUDPS_SINGLE () {1;}' unless defined(&PFUDPS_SINGLE);
    eval 'sub PFUDPS_MULTIPLE () {2;}' unless defined(&PFUDPS_MULTIPLE);
    eval 'sub PFUDPS_NSTATES () {3;}' unless defined(&PFUDPS_NSTATES);
    eval 'sub PFUDPS_NAMES () {{ "NO_TRAFFIC", "SINGLE", "MULTIPLE",  &NULL };}' unless defined(&PFUDPS_NAMES);
    eval 'sub PFOTHERS_NO_TRAFFIC () {0;}' unless defined(&PFOTHERS_NO_TRAFFIC);
    eval 'sub PFOTHERS_SINGLE () {1;}' unless defined(&PFOTHERS_SINGLE);
    eval 'sub PFOTHERS_MULTIPLE () {2;}' unless defined(&PFOTHERS_MULTIPLE);
    eval 'sub PFOTHERS_NSTATES () {3;}' unless defined(&PFOTHERS_NSTATES);
    eval 'sub PFOTHERS_NAMES () {{ "NO_TRAFFIC", "SINGLE", "MULTIPLE",  &NULL };}' unless defined(&PFOTHERS_NAMES);
    eval 'sub ACTION_SET {
        my($a, $x) = @_;
	    eval q( &do {  &if (($a) !=  &NULL) *($a) = ($x); }  &while (0));
    }' unless defined(&ACTION_SET);
    eval 'sub REASON_SET {
        my($a, $x) = @_;
	    eval q( &do {  &if (($a) !=  &NULL) *($a) = ($x);  &if ($x <  &PFRES_MAX)  &counter_u64_add( ($V_pf_status->{counters[$x]}), 1); }  &while (0));
    }' unless defined(&REASON_SET);
    eval 'sub PFFRAG_FRENT_HIWAT () {5000;}' unless defined(&PFFRAG_FRENT_HIWAT);
    eval 'sub PFR_KENTRY_HIWAT () {200000;}' unless defined(&PFR_KENTRY_HIWAT);
    eval 'sub ps_buf () { ($ps_u->{psu_buf});}' unless defined(&ps_buf);
    eval 'sub ps_states () { ($ps_u->{psu_states});}' unless defined(&ps_states);
    eval 'sub psn_buf () { ($psn_u->{psu_buf});}' unless defined(&psn_buf);
    eval 'sub psn_src_nodes () { ($psn_u->{psu_src_nodes});}' unless defined(&psn_src_nodes);
    eval 'sub PF_RULESET_ALTQ () {( &PF_RULESET_MAX);}' unless defined(&PF_RULESET_ALTQ);
    eval 'sub PF_RULESET_TABLE () {( &PF_RULESET_MAX+1);}' unless defined(&PF_RULESET_TABLE);
    eval 'sub PFR_FLAG_ATOMIC () {0x1;}' unless defined(&PFR_FLAG_ATOMIC);
    eval 'sub PFR_FLAG_DUMMY () {0x2;}' unless defined(&PFR_FLAG_DUMMY);
    eval 'sub PFR_FLAG_FEEDBACK () {0x4;}' unless defined(&PFR_FLAG_FEEDBACK);
    eval 'sub PFR_FLAG_CLSTATS () {0x8;}' unless defined(&PFR_FLAG_CLSTATS);
    eval 'sub PFR_FLAG_ADDRSTOO () {0x10;}' unless defined(&PFR_FLAG_ADDRSTOO);
    eval 'sub PFR_FLAG_REPLACE () {0x20;}' unless defined(&PFR_FLAG_REPLACE);
    eval 'sub PFR_FLAG_ALLRSETS () {0x40;}' unless defined(&PFR_FLAG_ALLRSETS);
    eval 'sub PFR_FLAG_ALLMASK () {0x7f;}' unless defined(&PFR_FLAG_ALLMASK);
    if(defined(&_KERNEL)) {
	eval 'sub PFR_FLAG_USERIOCTL () {0x10000000;}' unless defined(&PFR_FLAG_USERIOCTL);
    }
    eval 'sub pfrio_exists () { &pfrio_nadd;}' unless defined(&pfrio_exists);
    eval 'sub pfrio_nzero () { &pfrio_nadd;}' unless defined(&pfrio_nzero);
    eval 'sub pfrio_nmatch () { &pfrio_nadd;}' unless defined(&pfrio_nmatch);
    eval 'sub pfrio_naddr () { &pfrio_size2;}' unless defined(&pfrio_naddr);
    eval 'sub pfrio_setflag () { &pfrio_size2;}' unless defined(&pfrio_setflag);
    eval 'sub pfrio_clrflag () { &pfrio_nadd;}' unless defined(&pfrio_clrflag);
    eval 'sub DIOCSTART () { &_IO (ord(\'D\'), 1);}' unless defined(&DIOCSTART);
    eval 'sub DIOCSTOP () { &_IO (ord(\'D\'), 2);}' unless defined(&DIOCSTOP);
    eval 'sub DIOCADDRULE () { &_IOWR(ord(\'D\'), 4, \'struct pfioc_rule\');}' unless defined(&DIOCADDRULE);
    eval 'sub DIOCGETRULES () { &_IOWR(ord(\'D\'), 6, \'struct pfioc_rule\');}' unless defined(&DIOCGETRULES);
    eval 'sub DIOCGETRULE () { &_IOWR(ord(\'D\'), 7, \'struct pfioc_rule\');}' unless defined(&DIOCGETRULE);
    eval 'sub DIOCCLRSTATES () { &_IOWR(ord(\'D\'), 18, \'struct pfioc_state_kill\');}' unless defined(&DIOCCLRSTATES);
    eval 'sub DIOCGETSTATE () { &_IOWR(ord(\'D\'), 19, \'struct pfioc_state\');}' unless defined(&DIOCGETSTATE);
    eval 'sub DIOCSETSTATUSIF () { &_IOWR(ord(\'D\'), 20, \'struct pfioc_if\');}' unless defined(&DIOCSETSTATUSIF);
    eval 'sub DIOCGETSTATUS () { &_IOWR(ord(\'D\'), 21, \'struct pf_status\');}' unless defined(&DIOCGETSTATUS);
    eval 'sub DIOCCLRSTATUS () { &_IO (ord(\'D\'), 22);}' unless defined(&DIOCCLRSTATUS);
    eval 'sub DIOCNATLOOK () { &_IOWR(ord(\'D\'), 23, \'struct pfioc_natlook\');}' unless defined(&DIOCNATLOOK);
    eval 'sub DIOCSETDEBUG () { &_IOWR(ord(\'D\'), 24,  &u_int32_t);}' unless defined(&DIOCSETDEBUG);
    eval 'sub DIOCGETSTATES () { &_IOWR(ord(\'D\'), 25, \'struct pfioc_states\');}' unless defined(&DIOCGETSTATES);
    eval 'sub DIOCCHANGERULE () { &_IOWR(ord(\'D\'), 26, \'struct pfioc_rule\');}' unless defined(&DIOCCHANGERULE);
    eval 'sub DIOCSETTIMEOUT () { &_IOWR(ord(\'D\'), 29, \'struct pfioc_tm\');}' unless defined(&DIOCSETTIMEOUT);
    eval 'sub DIOCGETTIMEOUT () { &_IOWR(ord(\'D\'), 30, \'struct pfioc_tm\');}' unless defined(&DIOCGETTIMEOUT);
    eval 'sub DIOCADDSTATE () { &_IOWR(ord(\'D\'), 37, \'struct pfioc_state\');}' unless defined(&DIOCADDSTATE);
    eval 'sub DIOCCLRRULECTRS () { &_IO (ord(\'D\'), 38);}' unless defined(&DIOCCLRRULECTRS);
    eval 'sub DIOCGETLIMIT () { &_IOWR(ord(\'D\'), 39, \'struct pfioc_limit\');}' unless defined(&DIOCGETLIMIT);
    eval 'sub DIOCSETLIMIT () { &_IOWR(ord(\'D\'), 40, \'struct pfioc_limit\');}' unless defined(&DIOCSETLIMIT);
    eval 'sub DIOCKILLSTATES () { &_IOWR(ord(\'D\'), 41, \'struct pfioc_state_kill\');}' unless defined(&DIOCKILLSTATES);
    eval 'sub DIOCSTARTALTQ () { &_IO (ord(\'D\'), 42);}' unless defined(&DIOCSTARTALTQ);
    eval 'sub DIOCSTOPALTQ () { &_IO (ord(\'D\'), 43);}' unless defined(&DIOCSTOPALTQ);
    eval 'sub DIOCADDALTQ () { &_IOWR(ord(\'D\'), 45, \'struct pfioc_altq\');}' unless defined(&DIOCADDALTQ);
    eval 'sub DIOCGETALTQS () { &_IOWR(ord(\'D\'), 47, \'struct pfioc_altq\');}' unless defined(&DIOCGETALTQS);
    eval 'sub DIOCGETALTQ () { &_IOWR(ord(\'D\'), 48, \'struct pfioc_altq\');}' unless defined(&DIOCGETALTQ);
    eval 'sub DIOCCHANGEALTQ () { &_IOWR(ord(\'D\'), 49, \'struct pfioc_altq\');}' unless defined(&DIOCCHANGEALTQ);
    eval 'sub DIOCGETQSTATS () { &_IOWR(ord(\'D\'), 50, \'struct pfioc_qstats\');}' unless defined(&DIOCGETQSTATS);
    eval 'sub DIOCBEGINADDRS () { &_IOWR(ord(\'D\'), 51, \'struct pfioc_pooladdr\');}' unless defined(&DIOCBEGINADDRS);
    eval 'sub DIOCADDADDR () { &_IOWR(ord(\'D\'), 52, \'struct pfioc_pooladdr\');}' unless defined(&DIOCADDADDR);
    eval 'sub DIOCGETADDRS () { &_IOWR(ord(\'D\'), 53, \'struct pfioc_pooladdr\');}' unless defined(&DIOCGETADDRS);
    eval 'sub DIOCGETADDR () { &_IOWR(ord(\'D\'), 54, \'struct pfioc_pooladdr\');}' unless defined(&DIOCGETADDR);
    eval 'sub DIOCCHANGEADDR () { &_IOWR(ord(\'D\'), 55, \'struct pfioc_pooladdr\');}' unless defined(&DIOCCHANGEADDR);
    eval 'sub DIOCGETRULESETS () { &_IOWR(ord(\'D\'), 58, \'struct pfioc_ruleset\');}' unless defined(&DIOCGETRULESETS);
    eval 'sub DIOCGETRULESET () { &_IOWR(ord(\'D\'), 59, \'struct pfioc_ruleset\');}' unless defined(&DIOCGETRULESET);
    eval 'sub DIOCRCLRTABLES () { &_IOWR(ord(\'D\'), 60, \'struct pfioc_table\');}' unless defined(&DIOCRCLRTABLES);
    eval 'sub DIOCRADDTABLES () { &_IOWR(ord(\'D\'), 61, \'struct pfioc_table\');}' unless defined(&DIOCRADDTABLES);
    eval 'sub DIOCRDELTABLES () { &_IOWR(ord(\'D\'), 62, \'struct pfioc_table\');}' unless defined(&DIOCRDELTABLES);
    eval 'sub DIOCRGETTABLES () { &_IOWR(ord(\'D\'), 63, \'struct pfioc_table\');}' unless defined(&DIOCRGETTABLES);
    eval 'sub DIOCRGETTSTATS () { &_IOWR(ord(\'D\'), 64, \'struct pfioc_table\');}' unless defined(&DIOCRGETTSTATS);
    eval 'sub DIOCRCLRTSTATS () { &_IOWR(ord(\'D\'), 65, \'struct pfioc_table\');}' unless defined(&DIOCRCLRTSTATS);
    eval 'sub DIOCRCLRADDRS () { &_IOWR(ord(\'D\'), 66, \'struct pfioc_table\');}' unless defined(&DIOCRCLRADDRS);
    eval 'sub DIOCRADDADDRS () { &_IOWR(ord(\'D\'), 67, \'struct pfioc_table\');}' unless defined(&DIOCRADDADDRS);
    eval 'sub DIOCRDELADDRS () { &_IOWR(ord(\'D\'), 68, \'struct pfioc_table\');}' unless defined(&DIOCRDELADDRS);
    eval 'sub DIOCRSETADDRS () { &_IOWR(ord(\'D\'), 69, \'struct pfioc_table\');}' unless defined(&DIOCRSETADDRS);
    eval 'sub DIOCRGETADDRS () { &_IOWR(ord(\'D\'), 70, \'struct pfioc_table\');}' unless defined(&DIOCRGETADDRS);
    eval 'sub DIOCRGETASTATS () { &_IOWR(ord(\'D\'), 71, \'struct pfioc_table\');}' unless defined(&DIOCRGETASTATS);
    eval 'sub DIOCRCLRASTATS () { &_IOWR(ord(\'D\'), 72, \'struct pfioc_table\');}' unless defined(&DIOCRCLRASTATS);
    eval 'sub DIOCRTSTADDRS () { &_IOWR(ord(\'D\'), 73, \'struct pfioc_table\');}' unless defined(&DIOCRTSTADDRS);
    eval 'sub DIOCRSETTFLAGS () { &_IOWR(ord(\'D\'), 74, \'struct pfioc_table\');}' unless defined(&DIOCRSETTFLAGS);
    eval 'sub DIOCRINADEFINE () { &_IOWR(ord(\'D\'), 77, \'struct pfioc_table\');}' unless defined(&DIOCRINADEFINE);
    eval 'sub DIOCOSFPFLUSH () { &_IO(ord(\'D\'), 78);}' unless defined(&DIOCOSFPFLUSH);
    eval 'sub DIOCOSFPADD () { &_IOWR(ord(\'D\'), 79, \'struct pf_osfp_ioctl\');}' unless defined(&DIOCOSFPADD);
    eval 'sub DIOCOSFPGET () { &_IOWR(ord(\'D\'), 80, \'struct pf_osfp_ioctl\');}' unless defined(&DIOCOSFPGET);
    eval 'sub DIOCXBEGIN () { &_IOWR(ord(\'D\'), 81, \'struct pfioc_trans\');}' unless defined(&DIOCXBEGIN);
    eval 'sub DIOCXCOMMIT () { &_IOWR(ord(\'D\'), 82, \'struct pfioc_trans\');}' unless defined(&DIOCXCOMMIT);
    eval 'sub DIOCXROLLBACK () { &_IOWR(ord(\'D\'), 83, \'struct pfioc_trans\');}' unless defined(&DIOCXROLLBACK);
    eval 'sub DIOCGETSRCNODES () { &_IOWR(ord(\'D\'), 84, \'struct pfioc_src_nodes\');}' unless defined(&DIOCGETSRCNODES);
    eval 'sub DIOCCLRSRCNODES () { &_IO(ord(\'D\'), 85);}' unless defined(&DIOCCLRSRCNODES);
    eval 'sub DIOCSETHOSTID () { &_IOWR(ord(\'D\'), 86,  &u_int32_t);}' unless defined(&DIOCSETHOSTID);
    eval 'sub DIOCIGETIFACES () { &_IOWR(ord(\'D\'), 87, \'struct pfioc_iface\');}' unless defined(&DIOCIGETIFACES);
    eval 'sub DIOCSETIFFLAG () { &_IOWR(ord(\'D\'), 89, \'struct pfioc_iface\');}' unless defined(&DIOCSETIFFLAG);
    eval 'sub DIOCCLRIFFLAG () { &_IOWR(ord(\'D\'), 90, \'struct pfioc_iface\');}' unless defined(&DIOCCLRIFFLAG);
    eval 'sub DIOCKILLSRCNODES () { &_IOWR(ord(\'D\'), 91, \'struct pfioc_src_node_kill\');}' unless defined(&DIOCKILLSRCNODES);
    eval 'sub DIOCGIFSPEED () { &_IOWR(ord(\'D\'), 92, \'struct pf_ifspeed\');}' unless defined(&DIOCGIFSPEED);
    if(defined(&_KERNEL)) {
	eval 'sub PF_HASHSIZ () {(32768);}' unless defined(&PF_HASHSIZ);
	eval 'sub PF_SRCHASHSIZ () {( &PF_HASHSIZ/4);}' unless defined(&PF_SRCHASHSIZ);
	eval 'sub V_pf_keyhash () { &VNET( &pf_keyhash);}' unless defined(&V_pf_keyhash);
	eval 'sub V_pf_idhash () { &VNET( &pf_idhash);}' unless defined(&V_pf_idhash);
	eval 'sub V_pf_srchash () { &VNET( &pf_srchash);}' unless defined(&V_pf_srchash);
	eval 'sub PF_IDHASH {
	    my($s) = @_;
    	    eval q(( &be64toh(($s)-> &id) % ( &pf_hashmask + 1)));
	}' unless defined(&PF_IDHASH);
	eval 'sub V_pf_swi_cookie () { &VNET( &pf_swi_cookie);}' unless defined(&V_pf_swi_cookie);
	eval 'sub V_pf_stateid () { &VNET( &pf_stateid);}' unless defined(&V_pf_stateid);
	eval 'sub V_pf_altqs () { &VNET( &pf_altqs);}' unless defined(&V_pf_altqs);
	eval 'sub V_pf_pabuf () { &VNET( &pf_pabuf);}' unless defined(&V_pf_pabuf);
	eval 'sub V_ticket_altqs_active () { &VNET( &ticket_altqs_active);}' unless defined(&V_ticket_altqs_active);
	eval 'sub V_ticket_altqs_inactive () { &VNET( &ticket_altqs_inactive);}' unless defined(&V_ticket_altqs_inactive);
	eval 'sub V_altqs_inactive_open () { &VNET( &altqs_inactive_open);}' unless defined(&V_altqs_inactive_open);
	eval 'sub V_ticket_pabuf () { &VNET( &ticket_pabuf);}' unless defined(&V_ticket_pabuf);
	eval 'sub V_pf_altqs_active () { &VNET( &pf_altqs_active);}' unless defined(&V_pf_altqs_active);
	eval 'sub V_pf_altqs_inactive () { &VNET( &pf_altqs_inactive);}' unless defined(&V_pf_altqs_inactive);
	eval 'sub V_pf_unlinked_rules () { &VNET( &pf_unlinked_rules);}' unless defined(&V_pf_unlinked_rules);
	if(defined(&ALTQ)) {
	}
	eval 'sub V_pf_state_z () { &VNET( &pf_state_z);}' unless defined(&V_pf_state_z);
	eval 'sub V_pf_state_key_z () { &VNET( &pf_state_key_z);}' unless defined(&V_pf_state_key_z);
	eval 'sub V_pf_state_scrub_z () { &VNET( &pf_state_scrub_z);}' unless defined(&V_pf_state_scrub_z);
	eval 'sub PF_ENTER_LOCKED () {0x1;}' unless defined(&PF_ENTER_LOCKED);
	eval 'sub PF_RETURN_LOCKED () {0x2;}' unless defined(&PF_RETURN_LOCKED);
	eval 'sub pf_ref_state {
	    my($s) = @_;
    	    eval q({  &refcount_acquire( ($s->{refs})); });
	}' unless defined(&pf_ref_state);
	eval 'sub pf_release_state {
	    my($s) = @_;
    	    eval q({  &if ( &refcount_release( ($s->{refs}))) {  &pf_free_state($s); (1); }  &else (0); });
	}' unless defined(&pf_release_state);
	eval 'sub V_sync_ifp () { &VNET( &sync_ifp);;}' unless defined(&V_sync_ifp);
	eval 'sub V_pf_default_rule () { &VNET( &pf_default_rule);}' unless defined(&V_pf_default_rule);
	if(defined(&INET)) {
	}
	if(defined(&INET6)) {
	}
	eval 'sub V_pfi_all () { &VNET( &pfi_all);}' unless defined(&V_pfi_all);
	eval 'sub V_pf_status () { &VNET( &pf_status);}' unless defined(&V_pf_status);
	eval 'sub V_pf_limits () { &VNET( &pf_limits);}' unless defined(&V_pf_limits);
    }
    if(defined(&_KERNEL)) {
	eval 'sub V_pf_anchors () { &VNET( &pf_anchors);}' unless defined(&V_pf_anchors);
	eval 'sub V_pf_main_anchor () { &VNET( &pf_main_anchor);}' unless defined(&V_pf_main_anchor);
	eval 'sub pf_main_ruleset () { ($V_pf_main_anchor->{ruleset});}' unless defined(&pf_main_ruleset);
    }
    if(defined(&_KERNEL)) {
    }
    if(defined(&_KERNEL)) {
    }
}
1;
