require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NET_ROUTE_H_)) {
    eval 'sub _NET_ROUTE_H_ () {1;}' unless defined(&_NET_ROUTE_H_);
    require 'sys/counter.ph';
    require 'net/vnet.ph';
    eval 'sub RT_L2_ME_BIT () {2;}' unless defined(&RT_L2_ME_BIT);
    eval 'sub RT_MAY_LOOP_BIT () {3;}' unless defined(&RT_MAY_LOOP_BIT);
    eval 'sub RT_HAS_HEADER_BIT () {4;}' unless defined(&RT_HAS_HEADER_BIT);
    eval 'sub RT_CACHING_CONTEXT () {0x1;}' unless defined(&RT_CACHING_CONTEXT);
    eval 'sub RT_NORTREF () {0x2;}' unless defined(&RT_NORTREF);
    eval 'sub RT_L2_ME () {(1<<  &RT_L2_ME_BIT);}' unless defined(&RT_L2_ME);
    eval 'sub RT_MAY_LOOP () {(1<<  &RT_MAY_LOOP_BIT);}' unless defined(&RT_MAY_LOOP);
    eval 'sub RT_HAS_HEADER () {(1<<  &RT_HAS_HEADER_BIT);}' unless defined(&RT_HAS_HEADER);
    eval 'sub RT_REJECT () {0x20;}' unless defined(&RT_REJECT);
    eval 'sub RT_BLACKHOLE () {0x40;}' unless defined(&RT_BLACKHOLE);
    eval 'sub RT_HAS_GW () {0x80;}' unless defined(&RT_HAS_GW);
    eval 'sub RT_LLE_CACHE () {0x100;}' unless defined(&RT_LLE_CACHE);
    eval 'sub RTM_RTTUNIT () {1000000;}' unless defined(&RTM_RTTUNIT);
    eval 'sub RTTTOPRHZ {
        my($r) = @_;
	    eval q((($r) / ( &RTM_RTTUNIT /  &PR_SLOWHZ)));
    }' unless defined(&RTTTOPRHZ);
    eval 'sub rmx_state () { &rmx_weight;}' unless defined(&rmx_state);
    eval 'sub RT_GEN {
        my($fibnum, $af) = @_;
	    eval q( &rt_tables_get_gen($fibnum, $af));
    }' unless defined(&RT_GEN);
    eval 'sub RT_DEFAULT_FIB () {0;}' unless defined(&RT_DEFAULT_FIB);
    eval 'sub RT_ALL_FIBS () {-1;}' unless defined(&RT_ALL_FIBS);
    if(defined(&_KERNEL)) {
	eval 'sub V_rt_add_addr_allfibs () { &VNET( &rt_add_addr_allfibs);}' unless defined(&V_rt_add_addr_allfibs);
    }
    unless(defined(&RNF_NORMAL)) {
	require 'net/radix.ph';
	if(defined(&RADIX_MPATH)) {
	    require 'net/radix_mpath.ph';
	}
    }
    if(defined(&_KERNEL) || defined(&_WANT_RTENTRY)) {
	eval 'sub rt_key {
	    my($r) = @_;
    	    eval q((*((($r)-> ($rt_nodes->{rn_key})))));
	}' unless defined(&rt_key);
	eval 'sub rt_mask {
	    my($r) = @_;
    	    eval q((*((($r)-> ($rt_nodes->{rn_mask})))));
	}' unless defined(&rt_mask);
	eval 'sub rt_endzero () { &rt_pksent;}' unless defined(&rt_endzero);
    }
    eval 'sub RTF_UP () {0x1;}' unless defined(&RTF_UP);
    eval 'sub RTF_GATEWAY () {0x2;}' unless defined(&RTF_GATEWAY);
    eval 'sub RTF_HOST () {0x4;}' unless defined(&RTF_HOST);
    eval 'sub RTF_REJECT () {0x8;}' unless defined(&RTF_REJECT);
    eval 'sub RTF_DYNAMIC () {0x10;}' unless defined(&RTF_DYNAMIC);
    eval 'sub RTF_MODIFIED () {0x20;}' unless defined(&RTF_MODIFIED);
    eval 'sub RTF_DONE () {0x40;}' unless defined(&RTF_DONE);
    eval 'sub RTF_XRESOLVE () {0x200;}' unless defined(&RTF_XRESOLVE);
    eval 'sub RTF_LLINFO () {0x400;}' unless defined(&RTF_LLINFO);
    eval 'sub RTF_LLDATA () {0x400;}' unless defined(&RTF_LLDATA);
    eval 'sub RTF_STATIC () {0x800;}' unless defined(&RTF_STATIC);
    eval 'sub RTF_BLACKHOLE () {0x1000;}' unless defined(&RTF_BLACKHOLE);
    eval 'sub RTF_PROTO2 () {0x4000;}' unless defined(&RTF_PROTO2);
    eval 'sub RTF_PROTO1 () {0x8000;}' unless defined(&RTF_PROTO1);
    eval 'sub RTF_PROTO3 () {0x40000;}' unless defined(&RTF_PROTO3);
    eval 'sub RTF_FIXEDMTU () {0x80000;}' unless defined(&RTF_FIXEDMTU);
    eval 'sub RTF_PINNED () {0x100000;}' unless defined(&RTF_PINNED);
    eval 'sub RTF_LOCAL () {0x200000;}' unless defined(&RTF_LOCAL);
    eval 'sub RTF_BROADCAST () {0x400000;}' unless defined(&RTF_BROADCAST);
    eval 'sub RTF_MULTICAST () {0x800000;}' unless defined(&RTF_MULTICAST);
    eval 'sub RTF_STICKY () {0x10000000;}' unless defined(&RTF_STICKY);
    eval 'sub RTF_RNH_LOCKED () {0x40000000;}' unless defined(&RTF_RNH_LOCKED);
    eval 'sub RTF_GWFLAG_COMPAT () {0x80000000;}' unless defined(&RTF_GWFLAG_COMPAT);
    eval 'sub RTF_FMASK () {( &RTF_PROTO1 |  &RTF_PROTO2 |  &RTF_PROTO3 |  &RTF_BLACKHOLE |  &RTF_REJECT |  &RTF_STATIC |  &RTF_STICKY);}' unless defined(&RTF_FMASK);
    eval 'sub NHF_REJECT () {0x10;}' unless defined(&NHF_REJECT);
    eval 'sub NHF_BLACKHOLE () {0x20;}' unless defined(&NHF_BLACKHOLE);
    eval 'sub NHF_REDIRECT () {0x40;}' unless defined(&NHF_REDIRECT);
    eval 'sub NHF_DEFAULT () {0x80;}' unless defined(&NHF_DEFAULT);
    eval 'sub NHF_BROADCAST () {0x100;}' unless defined(&NHF_BROADCAST);
    eval 'sub NHF_GATEWAY () {0x200;}' unless defined(&NHF_GATEWAY);
    eval 'sub NHR_IFAIF () {0x1;}' unless defined(&NHR_IFAIF);
    eval 'sub NHR_REF () {0x2;}' unless defined(&NHR_REF);
    eval 'sub NHR_COPY () {0x100;}' unless defined(&NHR_COPY);
    if(defined(&_KERNEL)) {
    }
    eval 'sub RTM_VERSION () {5;}' unless defined(&RTM_VERSION);
    eval 'sub RTM_ADD () {0x1;}' unless defined(&RTM_ADD);
    eval 'sub RTM_DELETE () {0x2;}' unless defined(&RTM_DELETE);
    eval 'sub RTM_CHANGE () {0x3;}' unless defined(&RTM_CHANGE);
    eval 'sub RTM_GET () {0x4;}' unless defined(&RTM_GET);
    eval 'sub RTM_LOSING () {0x5;}' unless defined(&RTM_LOSING);
    eval 'sub RTM_REDIRECT () {0x6;}' unless defined(&RTM_REDIRECT);
    eval 'sub RTM_MISS () {0x7;}' unless defined(&RTM_MISS);
    eval 'sub RTM_LOCK () {0x8;}' unless defined(&RTM_LOCK);
    eval 'sub RTM_RESOLVE () {0xb;}' unless defined(&RTM_RESOLVE);
    eval 'sub RTM_NEWADDR () {0xc;}' unless defined(&RTM_NEWADDR);
    eval 'sub RTM_DELADDR () {0xd;}' unless defined(&RTM_DELADDR);
    eval 'sub RTM_IFINFO () {0xe;}' unless defined(&RTM_IFINFO);
    eval 'sub RTM_NEWMADDR () {0xf;}' unless defined(&RTM_NEWMADDR);
    eval 'sub RTM_DELMADDR () {0x10;}' unless defined(&RTM_DELMADDR);
    eval 'sub RTM_IFANNOUNCE () {0x11;}' unless defined(&RTM_IFANNOUNCE);
    eval 'sub RTM_IEEE80211 () {0x12;}' unless defined(&RTM_IEEE80211);
    eval 'sub RTV_MTU () {0x1;}' unless defined(&RTV_MTU);
    eval 'sub RTV_HOPCOUNT () {0x2;}' unless defined(&RTV_HOPCOUNT);
    eval 'sub RTV_EXPIRE () {0x4;}' unless defined(&RTV_EXPIRE);
    eval 'sub RTV_RPIPE () {0x8;}' unless defined(&RTV_RPIPE);
    eval 'sub RTV_SPIPE () {0x10;}' unless defined(&RTV_SPIPE);
    eval 'sub RTV_SSTHRESH () {0x20;}' unless defined(&RTV_SSTHRESH);
    eval 'sub RTV_RTT () {0x40;}' unless defined(&RTV_RTT);
    eval 'sub RTV_RTTVAR () {0x80;}' unless defined(&RTV_RTTVAR);
    eval 'sub RTV_WEIGHT () {0x100;}' unless defined(&RTV_WEIGHT);
    eval 'sub RTA_DST () {0x1;}' unless defined(&RTA_DST);
    eval 'sub RTA_GATEWAY () {0x2;}' unless defined(&RTA_GATEWAY);
    eval 'sub RTA_NETMASK () {0x4;}' unless defined(&RTA_NETMASK);
    eval 'sub RTA_GENMASK () {0x8;}' unless defined(&RTA_GENMASK);
    eval 'sub RTA_IFP () {0x10;}' unless defined(&RTA_IFP);
    eval 'sub RTA_IFA () {0x20;}' unless defined(&RTA_IFA);
    eval 'sub RTA_AUTHOR () {0x40;}' unless defined(&RTA_AUTHOR);
    eval 'sub RTA_BRD () {0x80;}' unless defined(&RTA_BRD);
    eval 'sub RTAX_DST () {0;}' unless defined(&RTAX_DST);
    eval 'sub RTAX_GATEWAY () {1;}' unless defined(&RTAX_GATEWAY);
    eval 'sub RTAX_NETMASK () {2;}' unless defined(&RTAX_NETMASK);
    eval 'sub RTAX_GENMASK () {3;}' unless defined(&RTAX_GENMASK);
    eval 'sub RTAX_IFP () {4;}' unless defined(&RTAX_IFP);
    eval 'sub RTAX_IFA () {5;}' unless defined(&RTAX_IFA);
    eval 'sub RTAX_AUTHOR () {6;}' unless defined(&RTAX_AUTHOR);
    eval 'sub RTAX_BRD () {7;}' unless defined(&RTAX_BRD);
    eval 'sub RTAX_MAX () {8;}' unless defined(&RTAX_MAX);
    eval 'sub SA_SIZE {
        my($sa) = @_;
	    eval q(( (!($sa) || (($sa))-> &sa_len == 0) ? $sizeof{\'long\'} : 1+ ( ((($sa))-> &sa_len - 1) | ($sizeof{\'long\'} - 1) ) ));
    }' unless defined(&SA_SIZE);
    eval 'sub sa_equal {
        my($a, $b) = @_;
	    eval q(( ((( &const \'struct sockaddr\' *)($a))-> &sa_len == (( &const \'struct sockaddr\' *)($b))-> &sa_len)  && ( &bcmp(($a), ($b), (( &const \'struct sockaddr\' *)($b))-> &sa_len) == 0)));
    }' unless defined(&sa_equal);
    if(defined(&_KERNEL)) {
	eval 'sub RT_LINK_IS_UP {
	    my($ifp) = @_;
    	    eval q((!(($ifp)-> &if_capabilities &  &IFCAP_LINKSTATE) || ($ifp)-> &if_link_state ==  &LINK_STATE_UP));
	}' unless defined(&RT_LINK_IS_UP);
	eval 'sub RT_LOCK_INIT {
	    my($_rt) = @_;
    	    eval q( &mtx_init(($_rt)-> &rt_mtx, \\"rtentry\\",  &NULL,  &MTX_DEF |  &MTX_DUPOK));
	}' unless defined(&RT_LOCK_INIT);
	eval 'sub RT_LOCK {
	    my($_rt) = @_;
    	    eval q( &mtx_lock(($_rt)-> &rt_mtx));
	}' unless defined(&RT_LOCK);
	eval 'sub RT_UNLOCK {
	    my($_rt) = @_;
    	    eval q( &mtx_unlock(($_rt)-> &rt_mtx));
	}' unless defined(&RT_UNLOCK);
	eval 'sub RT_LOCK_DESTROY {
	    my($_rt) = @_;
    	    eval q( &mtx_destroy(($_rt)-> &rt_mtx));
	}' unless defined(&RT_LOCK_DESTROY);
	eval 'sub RT_LOCK_ASSERT {
	    my($_rt) = @_;
    	    eval q( &mtx_assert(($_rt)-> &rt_mtx,  &MA_OWNED));
	}' unless defined(&RT_LOCK_ASSERT);
	eval 'sub RT_UNLOCK_COND {
	    my($_rt) = @_;
    	    eval q( &do {  &if ( &mtx_owned(($_rt)-> &rt_mtx))  &mtx_unlock(($_rt)-> &rt_mtx); }  &while (0));
	}' unless defined(&RT_UNLOCK_COND);
	eval 'sub RT_ADDREF {
	    my($_rt) = @_;
    	    eval q( &do {  &RT_LOCK_ASSERT($_rt);  &KASSERT(($_rt)-> &rt_refcnt >= 0, (\\"negative refcnt %d\\", ($_rt)-> &rt_refcnt)); ($_rt)-> &rt_refcnt++; }  &while (0));
	}' unless defined(&RT_ADDREF);
	eval 'sub RT_REMREF {
	    my($_rt) = @_;
    	    eval q( &do {  &RT_LOCK_ASSERT($_rt);  &KASSERT(($_rt)-> &rt_refcnt > 0, (\\"bogus refcnt %d\\", ($_rt)-> &rt_refcnt)); ($_rt)-> &rt_refcnt--; }  &while (0));
	}' unless defined(&RT_REMREF);
	eval 'sub RTFREE_LOCKED {
	    my($_rt) = @_;
    	    eval q( &do {  &if (($_rt)-> &rt_refcnt <= 1)  &rtfree($_rt);  &else {  &RT_REMREF($_rt);  &RT_UNLOCK($_rt); } $_rt = 0; }  &while (0));
	}' unless defined(&RTFREE_LOCKED);
	eval 'sub RTFREE {
	    my($_rt) = @_;
    	    eval q( &do {  &RT_LOCK($_rt);  &RTFREE_LOCKED($_rt); }  &while (0));
	}' unless defined(&RTFREE);
	eval 'sub RO_RTFREE {
	    my($_ro) = @_;
    	    eval q( &do {  &if (($_ro)-> &ro_rt) {  &if (($_ro)-> &ro_flags &  &RT_NORTREF) { ($_ro)-> &ro_flags &= ~ &RT_NORTREF; ($_ro)-> &ro_rt =  &NULL; ($_ro)-> &ro_lle =  &NULL; }  &else {  &RT_LOCK(($_ro)-> &ro_rt);  &RTFREE_LOCKED(($_ro)-> &ro_rt); } } }  &while (0));
	}' unless defined(&RO_RTFREE);
	eval 'sub RT_VALIDATE {
	    my($ro, $cookiep, $fibnum) = @_;
    	    eval q( &do {  &rt_gen_t  &cookie =  &RT_GEN($fibnum, ($ro)-> ($ro_dst->{sa_family}));  &if (*($cookiep) !=  &cookie) {  &if (($ro)-> &ro_rt !=  &NULL) {  &RTFREE(($ro)-> &ro_rt); ($ro)-> &ro_rt =  &NULL; } *($cookiep) =  &cookie; } }  &while (0));
	}' unless defined(&RT_VALIDATE);
    }
}
1;
