require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NET_VNET_H_)) {
    eval 'sub _NET_VNET_H_ () {1;}' unless defined(&_NET_VNET_H_);
    if(defined(&_KERNEL) || defined(&_WANT_VNET)) {
	require 'sys/queue.ph';
	eval 'sub VNET_MAGIC_N () {0x3e0d8f29;}' unless defined(&VNET_MAGIC_N);
	eval 'sub VNET_SETNAME () {"set_vnet";}' unless defined(&VNET_SETNAME);
	eval 'sub VNET_SYMPREFIX () {"vnet_entry_";}' unless defined(&VNET_SYMPREFIX);
    }
    if(defined(&_KERNEL)) {
	eval 'sub VNET_PCPUSTAT_DECLARE {
	    my($type, $name) = @_;
    	    eval q( &VNET_DECLARE( &counter_u64_t, $name->[$sizeof{$type} / $sizeof{ &uint64_t}]));
	}' unless defined(&VNET_PCPUSTAT_DECLARE);
	eval 'sub VNET_PCPUSTAT_DEFINE {
	    my($type, $name) = @_;
    	    eval q( &VNET_DEFINE( &counter_u64_t, $name->[$sizeof{$type} / $sizeof{ &uint64_t}]));
	}' unless defined(&VNET_PCPUSTAT_DEFINE);
	eval 'sub VNET_PCPUSTAT_ALLOC {
	    my($name, $wait) = @_;
    	    eval q( &COUNTER_ARRAY_ALLOC( &VNET($name), $sizeof{ &VNET($name)} / $sizeof{ &counter_u64_t}, ($wait)));
	}' unless defined(&VNET_PCPUSTAT_ALLOC);
	eval 'sub VNET_PCPUSTAT_FREE {
	    my($name) = @_;
    	    eval q( &COUNTER_ARRAY_FREE( &VNET($name), $sizeof{ &VNET($name)} / $sizeof{ &counter_u64_t}));
	}' unless defined(&VNET_PCPUSTAT_FREE);
	eval 'sub VNET_PCPUSTAT_ADD {
	    my($type, $name, $f, $v) = @_;
    	    eval q( &counter_u64_add( &VNET($name)[ &offsetof($type, $f) / $sizeof{ &uint64_t}], ($v)));
	}' unless defined(&VNET_PCPUSTAT_ADD);
	eval 'sub VNET_PCPUSTAT_FETCH {
	    my($type, $name, $f) = @_;
    	    eval q( &counter_u64_fetch( &VNET($name)[ &offsetof($type, $f) / $sizeof{ &uint64_t}]));
	}' unless defined(&VNET_PCPUSTAT_FETCH);
	eval 'sub VNET_PCPUSTAT_SYSINIT {
	    my($name) = @_;
    	    eval q( &static  &void  &vnet_$name &_init( &const  &void * &unused) {  &VNET_PCPUSTAT_ALLOC($name,  &M_WAITOK); }  &VNET_SYSINIT( &vnet_  $name   &_init,  &SI_SUB_INIT_IF,  &SI_ORDER_FIRST,  &vnet_  $name   &_init,  &NULL));
	}' unless defined(&VNET_PCPUSTAT_SYSINIT);
	eval 'sub VNET_PCPUSTAT_SYSUNINIT {
	    my($name) = @_;
    	    eval q( &static  &void  &vnet_$name &_uninit( &const  &void * &unused) {  &VNET_PCPUSTAT_FREE($name); }  &VNET_SYSUNINIT( &vnet_  $name   &_uninit,  &SI_SUB_INIT_IF,  &SI_ORDER_FIRST,  &vnet_  $name   &_uninit,  &NULL));
	}' unless defined(&VNET_PCPUSTAT_SYSUNINIT);
	if(defined(&SYSCTL_OID)) {
	    eval 'sub SYSCTL_VNET_PCPUSTAT {
	        my($parent, $nbr, $name, $type, $array, $desc) = @_;
    		eval q( &static \'int\' $array &_sysctl( &SYSCTL_HANDLER_ARGS) { $type  &s;  &CTASSERT(($sizeof{$type} / $sizeof{ &uint64_t}) == ($sizeof{ &VNET($array)} / $sizeof{ &counter_u64_t}));  &COUNTER_ARRAY_COPY( &VNET($array),  &s, $sizeof{$type} / $sizeof{ &uint64_t});  &if ( ($req->{newptr}))  &COUNTER_ARRAY_ZERO( &VNET($array), $sizeof{$type} / $sizeof{ &uint64_t});  &return ( &SYSCTL_OUT( &req,  &s, $sizeof{$type})); }  &SYSCTL_PROC($parent, $nbr, $name,  &CTLFLAG_VNET |  &CTLTYPE_OPAQUE |  &CTLFLAG_RW,  &NULL, 0, $array   &_sysctl, \\"I\\", $desc));
	    }' unless defined(&SYSCTL_VNET_PCPUSTAT);
	}
	if(defined(&VIMAGE)) {
	    require 'sys/lock.ph';
	    require 'sys/proc.ph';
	    require 'sys/rwlock.ph';
	    require 'sys/sx.ph';
	    eval 'sub VNET_START () {( &uintptr_t)& &__start_set_vnet;}' unless defined(&VNET_START);
	    eval 'sub VNET_STOP () {( &uintptr_t)& &__stop_set_vnet;}' unless defined(&VNET_STOP);
	    eval 'sub curvnet () { ($curthread->{td_vnet});}' unless defined(&curvnet);
	    if(defined(&INVARIANTS) || defined(&VNET_DEBUG)) {
		eval 'sub VNET_ASSERT {
		    my($exp, $msg) = @_;
    		    eval q( &do {  &if (!($exp))  &panic $msg; }  &while (0));
		}' unless defined(&VNET_ASSERT);
	    } else {
		eval 'sub VNET_ASSERT {
		    my($exp, $msg) = @_;
    		    eval q( &do { }  &while (0));
		}' unless defined(&VNET_ASSERT);
	    }
	    if(defined(&VNET_DEBUG)) {
		eval 'sub CURVNET_SET_QUIET {
		    my($arg) = @_;
    		    eval q( &VNET_ASSERT(($arg) !=  &NULL  && ($arg)-> &vnet_magic_n ==  &VNET_MAGIC_N, (\\"CURVNET_SET at %s:%d %s() curvnet=%p vnet=%p\\",  &__FILE__,  &__LINE__,  &__func__,  &curvnet, ($arg))); \'struct vnet\' * &saved_vnet =  &curvnet;  &const \'char\' * &saved_vnet_lpush =  ($curthread->{td_vnet_lpush});  &curvnet = $arg;  ($curthread->{td_vnet_lpush}) =  &__func__;);
		}' unless defined(&CURVNET_SET_QUIET);
		eval 'sub CURVNET_SET_VERBOSE {
		    my($arg) = @_;
    		    eval q( &CURVNET_SET_QUIET($arg)  &if ( &saved_vnet)  &vnet_log_recursion( &saved_vnet,  &saved_vnet_lpush,  &__LINE__););
		}' unless defined(&CURVNET_SET_VERBOSE);
		eval 'sub CURVNET_SET {
		    my($arg) = @_;
    		    eval q( &CURVNET_SET_VERBOSE($arg));
		}' unless defined(&CURVNET_SET);
		eval 'sub CURVNET_RESTORE () {
		    eval q( &VNET_ASSERT( &curvnet !=  &NULL  && ( &saved_vnet ==  &NULL ||  ($saved_vnet->{vnet_magic_n}) ==  &VNET_MAGIC_N), (\\"CURVNET_RESTORE at %s:%d %s() curvnet=%p saved_vnet=%p\\",  &__FILE__,  &__LINE__,  &__func__,  &curvnet,  &saved_vnet));  &curvnet =  &saved_vnet;  ($curthread->{td_vnet_lpush}) =  &saved_vnet_lpush;);
		}' unless defined(&CURVNET_RESTORE);
	    } else {
		eval 'sub CURVNET_SET_QUIET {
		    my($arg) = @_;
    		    eval q( &VNET_ASSERT(($arg) !=  &NULL  && ($arg)-> &vnet_magic_n ==  &VNET_MAGIC_N, (\\"CURVNET_SET at %s:%d %s() curvnet=%p vnet=%p\\",  &__FILE__,  &__LINE__,  &__func__,  &curvnet, ($arg))); \'struct vnet\' * &saved_vnet =  &curvnet;  &curvnet = $arg;);
		}' unless defined(&CURVNET_SET_QUIET);
		eval 'sub CURVNET_SET_VERBOSE {
		    my($arg) = @_;
    		    eval q( &CURVNET_SET_QUIET($arg));
		}' unless defined(&CURVNET_SET_VERBOSE);
		eval 'sub CURVNET_SET {
		    my($arg) = @_;
    		    eval q( &CURVNET_SET_VERBOSE($arg));
		}' unless defined(&CURVNET_SET);
		eval 'sub CURVNET_RESTORE () {
		    eval q( &VNET_ASSERT( &curvnet !=  &NULL  && ( &saved_vnet ==  &NULL ||  ($saved_vnet->{vnet_magic_n}) ==  &VNET_MAGIC_N), (\\"CURVNET_RESTORE at %s:%d %s() curvnet=%p saved_vnet=%p\\",  &__FILE__,  &__LINE__,  &__func__,  &curvnet,  &saved_vnet));  &curvnet =  &saved_vnet;);
		}' unless defined(&CURVNET_RESTORE);
	    }
	    eval 'sub IS_DEFAULT_VNET {
	        my($arg) = @_;
    		eval q((($arg) ==  &vnet0));
	    }' unless defined(&IS_DEFAULT_VNET);
	    eval 'sub CRED_TO_VNET {
	        my($cr) = @_;
    		eval q(($cr)-> ($cr_prison->{pr_vnet}));
	    }' unless defined(&CRED_TO_VNET);
	    eval 'sub TD_TO_VNET {
	        my($td) = @_;
    		eval q( &CRED_TO_VNET(($td)-> &td_ucred));
	    }' unless defined(&TD_TO_VNET);
	    eval 'sub P_TO_VNET {
	        my($p) = @_;
    		eval q( &CRED_TO_VNET(($p)-> &p_ucred));
	    }' unless defined(&P_TO_VNET);
	    eval 'sub VNET_LIST_RLOCK () {
	        eval q( &sx_slock( &vnet_sxlock));
	    }' unless defined(&VNET_LIST_RLOCK);
	    eval 'sub VNET_LIST_RLOCK_NOSLEEP () {
	        eval q( &rw_rlock( &vnet_rwlock));
	    }' unless defined(&VNET_LIST_RLOCK_NOSLEEP);
	    eval 'sub VNET_LIST_RUNLOCK () {
	        eval q( &sx_sunlock( &vnet_sxlock));
	    }' unless defined(&VNET_LIST_RUNLOCK);
	    eval 'sub VNET_LIST_RUNLOCK_NOSLEEP () {
	        eval q( &rw_runlock( &vnet_rwlock));
	    }' unless defined(&VNET_LIST_RUNLOCK_NOSLEEP);
	    eval 'sub VNET_ITERATOR_DECL {
	        my($arg) = @_;
    		eval q(\'struct vnet\' *$arg);
	    }' unless defined(&VNET_ITERATOR_DECL);
	    eval 'sub VNET_FOREACH {
	        my($arg) = @_;
    		eval q( &LIST_FOREACH(($arg),  &vnet_head,  &vnet_le));
	    }' unless defined(&VNET_FOREACH);
	    eval 'sub VNET_NAME {
	        my($n) = @_;
    		eval q( &vnet_entry_$n);
	    }' unless defined(&VNET_NAME);
	    eval 'sub VNET_DECLARE {
	        my($t, $n) = @_;
    		eval q( &extern $t  &VNET_NAME($n));
	    }' unless defined(&VNET_DECLARE);
	    eval 'sub VNET_DEFINE {
	        my($t, $n) = @_;
    		eval q($t  &VNET_NAME($n)  &__section( &VNET_SETNAME)  &__used);
	    }' unless defined(&VNET_DEFINE);
	    eval 'sub _VNET_PTR {
	        my($b, $n) = @_;
    		eval q(( &__typeof( &VNET_NAME($n))*) (($b) + ( &uintptr_t) &VNET_NAME($n)));
	    }' unless defined(&_VNET_PTR);
	    eval 'sub _VNET {
	        my($b, $n) = @_;
    		eval q((* &_VNET_PTR($b, $n)));
	    }' unless defined(&_VNET);
	    eval 'sub VNET_VNET_PTR {
	        my($vnet, $n) = @_;
    		eval q( &_VNET_PTR(($vnet)-> &vnet_data_base, $n));
	    }' unless defined(&VNET_VNET_PTR);
	    eval 'sub VNET_VNET {
	        my($vnet, $n) = @_;
    		eval q((* &VNET_VNET_PTR(($vnet), $n)));
	    }' unless defined(&VNET_VNET);
	    eval 'sub VNET_PTR {
	        my($n) = @_;
    		eval q( &VNET_VNET_PTR( &curvnet, $n));
	    }' unless defined(&VNET_PTR);
	    eval 'sub VNET {
	        my($n) = @_;
    		eval q( &VNET_VNET( &curvnet, $n));
	    }' unless defined(&VNET);
	    require 'sys/kernel.ph';
	    eval 'sub VNET_SYSINIT {
	        my($ident, $subsystem, $order, $func, $arg) = @_;
    		eval q( &static \'struct vnet_sysinit\' $ident   &_vnet_init = { $subsystem, $order, ( &sysinit_cfunc_t)( &sysinit_nfunc_t)$func, ($arg) };  &SYSINIT( &vnet_init_  $ident, $subsystem, $order,  &vnet_register_sysinit, $ident   &_vnet_init);  &SYSUNINIT( &vnet_init_  $ident, $subsystem, $order,  &vnet_deregister_sysinit, $ident   &_vnet_init));
	    }' unless defined(&VNET_SYSINIT);
	    eval 'sub VNET_SYSUNINIT {
	        my($ident, $subsystem, $order, $func, $arg) = @_;
    		eval q( &static \'struct vnet_sysinit\' $ident   &_vnet_uninit = { $subsystem, $order, ( &sysinit_cfunc_t)( &sysinit_nfunc_t)$func, ($arg) };  &SYSINIT( &vnet_uninit_  $ident, $subsystem, $order,  &vnet_register_sysuninit, $ident   &_vnet_uninit);  &SYSUNINIT( &vnet_uninit_  $ident, $subsystem, $order,  &vnet_deregister_sysuninit, $ident   &_vnet_uninit));
	    }' unless defined(&VNET_SYSUNINIT);
	    require 'sys/eventhandler.ph';
	    eval 'sub VNET_GLOBAL_EVENTHANDLER_REGISTER_TAG {
	        my($tag, $name, $func, $arg, $priority) = @_;
    		eval q( &do {  &if ( &IS_DEFAULT_VNET( &curvnet)) { ($tag) =  &vimage_eventhandler_register( &NULL, $name, $func, $arg, $priority,  &vnet_global_eventhandler_iterator_func); } }  &while(0));
	    }' unless defined(&VNET_GLOBAL_EVENTHANDLER_REGISTER_TAG);
	    eval 'sub VNET_GLOBAL_EVENTHANDLER_REGISTER {
	        my($name, $func, $arg, $priority) = @_;
    		eval q( &do {  &if ( &IS_DEFAULT_VNET( &curvnet)) {  &vimage_eventhandler_register( &NULL, $name, $func, $arg, $priority,  &vnet_global_eventhandler_iterator_func); } }  &while(0));
	    }' unless defined(&VNET_GLOBAL_EVENTHANDLER_REGISTER);
	} else {
	    eval 'sub curvnet () { &NULL;}' unless defined(&curvnet);
	    eval 'sub VNET_ASSERT {
	        my($exp, $msg) = @_;
    		eval q();
	    }' unless defined(&VNET_ASSERT);
	    eval 'sub CURVNET_SET {
	        my($arg) = @_;
    		eval q();
	    }' unless defined(&CURVNET_SET);
	    eval 'sub CURVNET_SET_QUIET {
	        my($arg) = @_;
    		eval q();
	    }' unless defined(&CURVNET_SET_QUIET);
	    eval 'sub CURVNET_RESTORE () {
	        eval q();
	    }' unless defined(&CURVNET_RESTORE);
	    eval 'sub VNET_LIST_RLOCK () {
	        eval q();
	    }' unless defined(&VNET_LIST_RLOCK);
	    eval 'sub VNET_LIST_RLOCK_NOSLEEP () {
	        eval q();
	    }' unless defined(&VNET_LIST_RLOCK_NOSLEEP);
	    eval 'sub VNET_LIST_RUNLOCK () {
	        eval q();
	    }' unless defined(&VNET_LIST_RUNLOCK);
	    eval 'sub VNET_LIST_RUNLOCK_NOSLEEP () {
	        eval q();
	    }' unless defined(&VNET_LIST_RUNLOCK_NOSLEEP);
	    eval 'sub VNET_ITERATOR_DECL {
	        my($arg) = @_;
    		eval q();
	    }' unless defined(&VNET_ITERATOR_DECL);
	    eval 'sub VNET_FOREACH {
	        my($arg) = @_;
    		eval q();
	    }' unless defined(&VNET_FOREACH);
	    eval 'sub IS_DEFAULT_VNET {
	        my($arg) = @_;
    		eval q(1);
	    }' unless defined(&IS_DEFAULT_VNET);
	    eval 'sub CRED_TO_VNET {
	        my($cr) = @_;
    		eval q( &NULL);
	    }' unless defined(&CRED_TO_VNET);
	    eval 'sub TD_TO_VNET {
	        my($td) = @_;
    		eval q( &NULL);
	    }' unless defined(&TD_TO_VNET);
	    eval 'sub P_TO_VNET {
	        my($p) = @_;
    		eval q( &NULL);
	    }' unless defined(&P_TO_VNET);
	    eval 'sub VNET_NAME {
	        my($n) = @_;
    		eval q($n);
	    }' unless defined(&VNET_NAME);
	    eval 'sub VNET_DECLARE {
	        my($t, $n) = @_;
    		eval q( &extern $t $n);
	    }' unless defined(&VNET_DECLARE);
	    eval 'sub VNET_DEFINE {
	        my($t, $n) = @_;
    		eval q($t $n);
	    }' unless defined(&VNET_DEFINE);
	    eval 'sub _VNET_PTR {
	        my($b, $n) = @_;
    		eval q( &VNET_NAME($n));
	    }' unless defined(&_VNET_PTR);
	    eval 'sub VNET_VNET_PTR {
	        my($vnet, $n) = @_;
    		eval q((($n)));
	    }' unless defined(&VNET_VNET_PTR);
	    eval 'sub VNET_VNET {
	        my($vnet, $n) = @_;
    		eval q(($n));
	    }' unless defined(&VNET_VNET);
	    eval 'sub VNET_PTR {
	        my($n) = @_;
    		eval q((($n)));
	    }' unless defined(&VNET_PTR);
	    eval 'sub VNET {
	        my($n) = @_;
    		eval q(($n));
	    }' unless defined(&VNET);
	    eval 'sub VNET_SYSINIT {
	        my($ident, $subsystem, $order, $func, $arg) = @_;
    		eval q( &SYSINIT($ident, $subsystem, $order, $func, $arg));
	    }' unless defined(&VNET_SYSINIT);
	    eval 'sub VNET_SYSUNINIT {
	        my($ident, $subsystem, $order, $func, $arg) = @_;
    		eval q( &SYSUNINIT($ident, $subsystem, $order, $func, $arg));
	    }' unless defined(&VNET_SYSUNINIT);
	    eval 'sub VNET_GLOBAL_EVENTHANDLER_REGISTER_TAG {
	        my($tag, $name, $func, $arg, $priority) = @_;
    		eval q(($tag) =  &eventhandler_register( &NULL, $name, $func, $arg, $priority));
	    }' unless defined(&VNET_GLOBAL_EVENTHANDLER_REGISTER_TAG);
	    eval 'sub VNET_GLOBAL_EVENTHANDLER_REGISTER {
	        my($name, $func, $arg, $priority) = @_;
    		eval q( &eventhandler_register( &NULL, $name, $func, $arg, $priority));
	    }' unless defined(&VNET_GLOBAL_EVENTHANDLER_REGISTER);
	}
    }
}
1;
