require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NET80211_IEEE80211_VAR_H_)) {
    eval 'sub _NET80211_IEEE80211_VAR_H_ () {1;}' unless defined(&_NET80211_IEEE80211_VAR_H_);
    if(defined(&__NetBSD__)) {
	require 'net80211/ieee80211_netbsd.ph';
    }
 elsif(defined(&__FreeBSD__)) {
	require 'net80211/ieee80211_freebsd.ph';
    }
 elsif(defined(&__linux__)) {
	require 'net80211/ieee80211_linux.ph';
    } else {
	die("No support for your operating system!");
    }
    require 'net80211/_ieee80211.ph';
    require 'net80211/ieee80211.ph';
    require 'net80211/ieee80211_ageq.ph';
    require 'net80211/ieee80211_crypto.ph';
    require 'net80211/ieee80211_dfs.ph';
    require 'net80211/ieee80211_ioctl.ph';
    require 'net80211/ieee80211_phy.ph';
    require 'net80211/ieee80211_power.ph';
    require 'net80211/ieee80211_node.ph';
    require 'net80211/ieee80211_proto.ph';
    require 'net80211/ieee80211_radiotap.ph';
    require 'net80211/ieee80211_scan.ph';
    eval 'sub IEEE80211_TXPOWER_MAX () {100;}' unless defined(&IEEE80211_TXPOWER_MAX);
    eval 'sub IEEE80211_TXPOWER_MIN () {0;}' unless defined(&IEEE80211_TXPOWER_MIN);
    eval 'sub IEEE80211_DTIM_DEFAULT () {1;}' unless defined(&IEEE80211_DTIM_DEFAULT);
    eval 'sub IEEE80211_BINTVAL_DEFAULT () {100;}' unless defined(&IEEE80211_BINTVAL_DEFAULT);
    eval 'sub IEEE80211_BMISS_MAX () {2;}' unless defined(&IEEE80211_BMISS_MAX);
    eval 'sub IEEE80211_HWBMISS_DEFAULT () {7;}' unless defined(&IEEE80211_HWBMISS_DEFAULT);
    eval 'sub IEEE80211_BGSCAN_INTVAL_MIN () {15;}' unless defined(&IEEE80211_BGSCAN_INTVAL_MIN);
    eval 'sub IEEE80211_BGSCAN_INTVAL_DEFAULT () {(5*60);}' unless defined(&IEEE80211_BGSCAN_INTVAL_DEFAULT);
    eval 'sub IEEE80211_BGSCAN_IDLE_MIN () {100;}' unless defined(&IEEE80211_BGSCAN_IDLE_MIN);
    eval 'sub IEEE80211_BGSCAN_IDLE_DEFAULT () {250;}' unless defined(&IEEE80211_BGSCAN_IDLE_DEFAULT);
    eval 'sub IEEE80211_SCAN_VALID_MIN () {10;}' unless defined(&IEEE80211_SCAN_VALID_MIN);
    eval 'sub IEEE80211_SCAN_VALID_DEFAULT () {60;}' unless defined(&IEEE80211_SCAN_VALID_DEFAULT);
    eval 'sub IEEE80211_PS_SLEEP () {0x1;}' unless defined(&IEEE80211_PS_SLEEP);
    eval 'sub IEEE80211_PS_MAX_QUEUE () {50;}' unless defined(&IEEE80211_PS_MAX_QUEUE);
    eval 'sub IEEE80211_FIXED_RATE_NONE () {0xff;}' unless defined(&IEEE80211_FIXED_RATE_NONE);
    eval 'sub IEEE80211_TXMAX_DEFAULT () {6;}' unless defined(&IEEE80211_TXMAX_DEFAULT);
    eval 'sub IEEE80211_RTS_DEFAULT () { &IEEE80211_RTS_MAX;}' unless defined(&IEEE80211_RTS_DEFAULT);
    eval 'sub IEEE80211_FRAG_DEFAULT () { &IEEE80211_FRAG_MAX;}' unless defined(&IEEE80211_FRAG_DEFAULT);
    eval 'sub IEEE80211_MS_TO_TU {
        my($x) = @_;
	    eval q(((($x) * 1000) / 1024));
    }' unless defined(&IEEE80211_MS_TO_TU);
    eval 'sub IEEE80211_TU_TO_MS {
        my($x) = @_;
	    eval q(((($x) * 1024) / 1000));
    }' unless defined(&IEEE80211_TU_TO_MS);
    eval 'sub IEEE80211_TU_TO_TICKS {
        my($x) = @_;
	    eval q(((( &uint64_t)($x) * 1024*  &hz) / (1000* 1000)));
    }' unless defined(&IEEE80211_TU_TO_TICKS);
    if(0) {
    }
    eval 'sub IEEE80211_ADDR_EQ {
        my($a1,$a2) = @_;
	    eval q(( &memcmp($a1,$a2, &IEEE80211_ADDR_LEN) == 0));
    }' unless defined(&IEEE80211_ADDR_EQ);
    eval 'sub IEEE80211_ADDR_COPY {
        my($dst,$src) = @_;
	    eval q( &memcpy($dst,$src, &IEEE80211_ADDR_LEN));
    }' unless defined(&IEEE80211_ADDR_COPY);
    eval 'sub IEEE80211_F_TURBOP () {0x1;}' unless defined(&IEEE80211_F_TURBOP);
    eval 'sub IEEE80211_F_COMP () {0x2;}' unless defined(&IEEE80211_F_COMP);
    eval 'sub IEEE80211_F_FF () {0x4;}' unless defined(&IEEE80211_F_FF);
    eval 'sub IEEE80211_F_BURST () {0x8;}' unless defined(&IEEE80211_F_BURST);
    eval 'sub IEEE80211_F_PRIVACY () {0x10;}' unless defined(&IEEE80211_F_PRIVACY);
    eval 'sub IEEE80211_F_PUREG () {0x20;}' unless defined(&IEEE80211_F_PUREG);
    eval 'sub IEEE80211_F_SCAN () {0x80;}' unless defined(&IEEE80211_F_SCAN);
    eval 'sub IEEE80211_F_ASCAN () {0x100;}' unless defined(&IEEE80211_F_ASCAN);
    eval 'sub IEEE80211_F_SIBSS () {0x200;}' unless defined(&IEEE80211_F_SIBSS);
    eval 'sub IEEE80211_F_SHSLOT () {0x400;}' unless defined(&IEEE80211_F_SHSLOT);
    eval 'sub IEEE80211_F_PMGTON () {0x800;}' unless defined(&IEEE80211_F_PMGTON);
    eval 'sub IEEE80211_F_DESBSSID () {0x1000;}' unless defined(&IEEE80211_F_DESBSSID);
    eval 'sub IEEE80211_F_WME () {0x2000;}' unless defined(&IEEE80211_F_WME);
    eval 'sub IEEE80211_F_BGSCAN () {0x4000;}' unless defined(&IEEE80211_F_BGSCAN);
    eval 'sub IEEE80211_F_SWRETRY () {0x8000;}' unless defined(&IEEE80211_F_SWRETRY);
    eval 'sub IEEE80211_F_TXPOW_FIXED () {0x10000;}' unless defined(&IEEE80211_F_TXPOW_FIXED);
    eval 'sub IEEE80211_F_IBSSON () {0x20000;}' unless defined(&IEEE80211_F_IBSSON);
    eval 'sub IEEE80211_F_SHPREAMBLE () {0x40000;}' unless defined(&IEEE80211_F_SHPREAMBLE);
    eval 'sub IEEE80211_F_DATAPAD () {0x80000;}' unless defined(&IEEE80211_F_DATAPAD);
    eval 'sub IEEE80211_F_USEPROT () {0x100000;}' unless defined(&IEEE80211_F_USEPROT);
    eval 'sub IEEE80211_F_USEBARKER () {0x200000;}' unless defined(&IEEE80211_F_USEBARKER);
    eval 'sub IEEE80211_F_CSAPENDING () {0x400000;}' unless defined(&IEEE80211_F_CSAPENDING);
    eval 'sub IEEE80211_F_WPA1 () {0x800000;}' unless defined(&IEEE80211_F_WPA1);
    eval 'sub IEEE80211_F_WPA2 () {0x1000000;}' unless defined(&IEEE80211_F_WPA2);
    eval 'sub IEEE80211_F_WPA () {0x1800000;}' unless defined(&IEEE80211_F_WPA);
    eval 'sub IEEE80211_F_DROPUNENC () {0x2000000;}' unless defined(&IEEE80211_F_DROPUNENC);
    eval 'sub IEEE80211_F_COUNTERM () {0x4000000;}' unless defined(&IEEE80211_F_COUNTERM);
    eval 'sub IEEE80211_F_HIDESSID () {0x8000000;}' unless defined(&IEEE80211_F_HIDESSID);
    eval 'sub IEEE80211_F_NOBRIDGE () {0x10000000;}' unless defined(&IEEE80211_F_NOBRIDGE);
    eval 'sub IEEE80211_F_PCF () {0x20000000;}' unless defined(&IEEE80211_F_PCF);
    eval 'sub IEEE80211_F_DOTH () {0x40000000;}' unless defined(&IEEE80211_F_DOTH);
    eval 'sub IEEE80211_F_DWDS () {0x80000000;}' unless defined(&IEEE80211_F_DWDS);
    eval 'sub IEEE80211_F_BITS () {"\\20\\1TURBOP\\2COMP\\3FF\\4BURST\\5PRIVACY\\6PUREG\\10SCAN\\11ASCAN\\12SIBSS" "\\13SHSLOT\\14PMGTON\\15DESBSSID\\16WME\\17BGSCAN\\20SWRETRY\\21TXPOW_FIXED" "\\22IBSSON\\23SHPREAMBLE\\24DATAPAD\\25USEPROT\\26USERBARKER\\27CSAPENDING" "\\30WPA1\\31WPA2\\32DROPUNENC\\33COUNTERM\\34HIDESSID\\35NOBRIDG\\36PCF" "\\37DOTH\\40DWDS";}' unless defined(&IEEE80211_F_BITS);
    eval 'sub IEEE80211_F_ATHEROS () {( &IEEE80211_F_FF |  &IEEE80211_F_COMP |  &IEEE80211_F_TURBOP);}' unless defined(&IEEE80211_F_ATHEROS);
    eval 'sub IEEE80211_ATH_CAP {
        my($vap, $ni, $bit) = @_;
	    eval q((($vap)-> &iv_flags & ($ni)-> &ni_ath_flags & ($bit)));
    }' unless defined(&IEEE80211_ATH_CAP);
    eval 'sub IEEE80211_FEXT_INACT () {0x2;}' unless defined(&IEEE80211_FEXT_INACT);
    eval 'sub IEEE80211_FEXT_SCANWAIT () {0x4;}' unless defined(&IEEE80211_FEXT_SCANWAIT);
    eval 'sub IEEE80211_FEXT_BGSCAN () {0x8;}' unless defined(&IEEE80211_FEXT_BGSCAN);
    eval 'sub IEEE80211_FEXT_WPS () {0x10;}' unless defined(&IEEE80211_FEXT_WPS);
    eval 'sub IEEE80211_FEXT_TSN () {0x20;}' unless defined(&IEEE80211_FEXT_TSN);
    eval 'sub IEEE80211_FEXT_SCANREQ () {0x40;}' unless defined(&IEEE80211_FEXT_SCANREQ);
    eval 'sub IEEE80211_FEXT_RESUME () {0x80;}' unless defined(&IEEE80211_FEXT_RESUME);
    eval 'sub IEEE80211_FEXT_4ADDR () {0x100;}' unless defined(&IEEE80211_FEXT_4ADDR);
    eval 'sub IEEE80211_FEXT_NONERP_PR () {0x200;}' unless defined(&IEEE80211_FEXT_NONERP_PR);
    eval 'sub IEEE80211_FEXT_SWBMISS () {0x400;}' unless defined(&IEEE80211_FEXT_SWBMISS);
    eval 'sub IEEE80211_FEXT_DFS () {0x800;}' unless defined(&IEEE80211_FEXT_DFS);
    eval 'sub IEEE80211_FEXT_DOTD () {0x1000;}' unless defined(&IEEE80211_FEXT_DOTD);
    eval 'sub IEEE80211_FEXT_STATEWAIT () {0x2000;}' unless defined(&IEEE80211_FEXT_STATEWAIT);
    eval 'sub IEEE80211_FEXT_REINIT () {0x4000;}' unless defined(&IEEE80211_FEXT_REINIT);
    eval 'sub IEEE80211_FEXT_BPF () {0x8000;}' unless defined(&IEEE80211_FEXT_BPF);
    eval 'sub IEEE80211_FEXT_WDSLEGACY () {0x10000;}' unless defined(&IEEE80211_FEXT_WDSLEGACY);
    eval 'sub IEEE80211_FEXT_PROBECHAN () {0x20000;}' unless defined(&IEEE80211_FEXT_PROBECHAN);
    eval 'sub IEEE80211_FEXT_UNIQMAC () {0x40000;}' unless defined(&IEEE80211_FEXT_UNIQMAC);
    eval 'sub IEEE80211_FEXT_SCAN_OFFLOAD () {0x80000;}' unless defined(&IEEE80211_FEXT_SCAN_OFFLOAD);
    eval 'sub IEEE80211_FEXT_BITS () {"\\20\\2INACT\\3SCANWAIT\\4BGSCAN\\5WPS\\6TSN\\7SCANREQ\\10RESUME" "\\0114ADDR\\12NONEPR_PR\\13SWBMISS\\14DFS\\15DOTD\\16STATEWAIT\\17REINIT" "\\20BPF\\21WDSLEGACY\\22PROBECHAN\\23UNIQMAC\\24SCAN_OFFLOAD";}' unless defined(&IEEE80211_FEXT_BITS);
    eval 'sub IEEE80211_FHT_NONHT_PR () {0x1;}' unless defined(&IEEE80211_FHT_NONHT_PR);
    eval 'sub IEEE80211_FHT_GF () {0x40000;}' unless defined(&IEEE80211_FHT_GF);
    eval 'sub IEEE80211_FHT_HT () {0x80000;}' unless defined(&IEEE80211_FHT_HT);
    eval 'sub IEEE80211_FHT_AMPDU_TX () {0x100000;}' unless defined(&IEEE80211_FHT_AMPDU_TX);
    eval 'sub IEEE80211_FHT_AMPDU_RX () {0x200000;}' unless defined(&IEEE80211_FHT_AMPDU_RX);
    eval 'sub IEEE80211_FHT_AMSDU_TX () {0x400000;}' unless defined(&IEEE80211_FHT_AMSDU_TX);
    eval 'sub IEEE80211_FHT_AMSDU_RX () {0x800000;}' unless defined(&IEEE80211_FHT_AMSDU_RX);
    eval 'sub IEEE80211_FHT_USEHT40 () {0x1000000;}' unless defined(&IEEE80211_FHT_USEHT40);
    eval 'sub IEEE80211_FHT_PUREN () {0x2000000;}' unless defined(&IEEE80211_FHT_PUREN);
    eval 'sub IEEE80211_FHT_SHORTGI20 () {0x4000000;}' unless defined(&IEEE80211_FHT_SHORTGI20);
    eval 'sub IEEE80211_FHT_SHORTGI40 () {0x8000000;}' unless defined(&IEEE80211_FHT_SHORTGI40);
    eval 'sub IEEE80211_FHT_HTCOMPAT () {0x10000000;}' unless defined(&IEEE80211_FHT_HTCOMPAT);
    eval 'sub IEEE80211_FHT_RIFS () {0x20000000;}' unless defined(&IEEE80211_FHT_RIFS);
    eval 'sub IEEE80211_FHT_STBC_TX () {0x40000000;}' unless defined(&IEEE80211_FHT_STBC_TX);
    eval 'sub IEEE80211_FHT_STBC_RX () {0x80000000;}' unless defined(&IEEE80211_FHT_STBC_RX);
    eval 'sub IEEE80211_FHT_BITS () {"\\20\\1NONHT_PR" "\\23GF\\24HT\\25AMPDU_TX\\26AMPDU_TX" "\\27AMSDU_TX\\30AMSDU_RX\\31USEHT40\\32PUREN\\33SHORTGI20\\34SHORTGI40" "\\35HTCOMPAT\\36RIFS\\37STBC_TX\\40STBC_RX";}' unless defined(&IEEE80211_FHT_BITS);
    eval 'sub IEEE80211_FVEN_BITS () {"\\20";}' unless defined(&IEEE80211_FVEN_BITS);
    eval 'sub IEEE80211_C_STA () {0x1;}' unless defined(&IEEE80211_C_STA);
    eval 'sub IEEE80211_C_8023ENCAP () {0x2;}' unless defined(&IEEE80211_C_8023ENCAP);
    eval 'sub IEEE80211_C_FF () {0x40;}' unless defined(&IEEE80211_C_FF);
    eval 'sub IEEE80211_C_TURBOP () {0x80;}' unless defined(&IEEE80211_C_TURBOP);
    eval 'sub IEEE80211_C_IBSS () {0x100;}' unless defined(&IEEE80211_C_IBSS);
    eval 'sub IEEE80211_C_PMGT () {0x200;}' unless defined(&IEEE80211_C_PMGT);
    eval 'sub IEEE80211_C_HOSTAP () {0x400;}' unless defined(&IEEE80211_C_HOSTAP);
    eval 'sub IEEE80211_C_AHDEMO () {0x800;}' unless defined(&IEEE80211_C_AHDEMO);
    eval 'sub IEEE80211_C_SWRETRY () {0x1000;}' unless defined(&IEEE80211_C_SWRETRY);
    eval 'sub IEEE80211_C_TXPMGT () {0x2000;}' unless defined(&IEEE80211_C_TXPMGT);
    eval 'sub IEEE80211_C_SHSLOT () {0x4000;}' unless defined(&IEEE80211_C_SHSLOT);
    eval 'sub IEEE80211_C_SHPREAMBLE () {0x8000;}' unless defined(&IEEE80211_C_SHPREAMBLE);
    eval 'sub IEEE80211_C_MONITOR () {0x10000;}' unless defined(&IEEE80211_C_MONITOR);
    eval 'sub IEEE80211_C_DFS () {0x20000;}' unless defined(&IEEE80211_C_DFS);
    eval 'sub IEEE80211_C_MBSS () {0x40000;}' unless defined(&IEEE80211_C_MBSS);
    eval 'sub IEEE80211_C_SWSLEEP () {0x80000;}' unless defined(&IEEE80211_C_SWSLEEP);
    eval 'sub IEEE80211_C_SWAMSDUTX () {0x100000;}' unless defined(&IEEE80211_C_SWAMSDUTX);
    eval 'sub IEEE80211_C_WPA1 () {0x800000;}' unless defined(&IEEE80211_C_WPA1);
    eval 'sub IEEE80211_C_WPA2 () {0x1000000;}' unless defined(&IEEE80211_C_WPA2);
    eval 'sub IEEE80211_C_WPA () {0x1800000;}' unless defined(&IEEE80211_C_WPA);
    eval 'sub IEEE80211_C_BURST () {0x2000000;}' unless defined(&IEEE80211_C_BURST);
    eval 'sub IEEE80211_C_WME () {0x4000000;}' unless defined(&IEEE80211_C_WME);
    eval 'sub IEEE80211_C_WDS () {0x8000000;}' unless defined(&IEEE80211_C_WDS);
    eval 'sub IEEE80211_C_BGSCAN () {0x20000000;}' unless defined(&IEEE80211_C_BGSCAN);
    eval 'sub IEEE80211_C_TXFRAG () {0x40000000;}' unless defined(&IEEE80211_C_TXFRAG);
    eval 'sub IEEE80211_C_TDMA () {0x80000000;}' unless defined(&IEEE80211_C_TDMA);
    eval 'sub IEEE80211_C_OPMODE () {( &IEEE80211_C_STA |  &IEEE80211_C_IBSS |  &IEEE80211_C_HOSTAP |  &IEEE80211_C_AHDEMO |  &IEEE80211_C_MONITOR |  &IEEE80211_C_WDS |  &IEEE80211_C_TDMA |  &IEEE80211_C_MBSS);}' unless defined(&IEEE80211_C_OPMODE);
    eval 'sub IEEE80211_C_BITS () {"\\20\\1STA\\002803ENCAP\\7FF\\10TURBOP\\11IBSS\\12PMGT" "\\13HOSTAP\\14AHDEMO\\15SWRETRY\\16TXPMGT\\17SHSLOT\\20SHPREAMBLE" "\\21MONITOR\\22DFS\\23MBSS\\30WPA1\\31WPA2\\32BURST\\33WME\\34WDS\\36BGSCAN" "\\37TXFRAG\\40TDMA";}' unless defined(&IEEE80211_C_BITS);
    eval 'sub IEEE80211_HTC_AMPDU () {0x10000;}' unless defined(&IEEE80211_HTC_AMPDU);
    eval 'sub IEEE80211_HTC_AMSDU () {0x20000;}' unless defined(&IEEE80211_HTC_AMSDU);
    eval 'sub IEEE80211_HTC_HT () {0x40000;}' unless defined(&IEEE80211_HTC_HT);
    eval 'sub IEEE80211_HTC_SMPS () {0x80000;}' unless defined(&IEEE80211_HTC_SMPS);
    eval 'sub IEEE80211_HTC_RIFS () {0x100000;}' unless defined(&IEEE80211_HTC_RIFS);
    eval 'sub IEEE80211_HTC_RXUNEQUAL () {0x200000;}' unless defined(&IEEE80211_HTC_RXUNEQUAL);
    eval 'sub IEEE80211_HTC_RXMCS32 () {0x400000;}' unless defined(&IEEE80211_HTC_RXMCS32);
    eval 'sub IEEE80211_HTC_TXUNEQUAL () {0x800000;}' unless defined(&IEEE80211_HTC_TXUNEQUAL);
    eval 'sub IEEE80211_HTC_TXMCS32 () {0x1000000;}' unless defined(&IEEE80211_HTC_TXMCS32);
    eval 'sub IEEE80211_C_HTCAP_BITS () {"\\20\\1LDPC\\2CHWIDTH40\\5GREENFIELD\\6SHORTGI20\\7SHORTGI40\\10TXSTBC" "\\21AMPDU\\22AMSDU\\23HT\\24SMPS\\25RIFS";}' unless defined(&IEEE80211_C_HTCAP_BITS);
    eval 'sub ieee80211_radiotap_active {
        my($ic) = @_;
	    eval q({ ( ($ic->{ic_flags_ext}) &  &IEEE80211_FEXT_BPF) != 0; });
    }' unless defined(&ieee80211_radiotap_active);
    eval 'sub ieee80211_radiotap_active_vap {
        my($vap) = @_;
	    eval q({ ( ($vap->{iv_flags_ext}) &  &IEEE80211_FEXT_BPF) ||  ($vap->{iv_ic}->{ic_montaps}) != 0; });
    }' unless defined(&ieee80211_radiotap_active_vap);
    eval 'sub ieee80211_key_update_end {
        my($vap) = @_;
	    eval q({  ($vap->{iv_key_update_end})($vap); });
    }' unless defined(&ieee80211_key_update_end);
    eval 'sub IEEE80211_MSG_11N () {0x80000000;}' unless defined(&IEEE80211_MSG_11N);
    eval 'sub IEEE80211_MSG_DEBUG () {0x40000000;}' unless defined(&IEEE80211_MSG_DEBUG);
    eval 'sub IEEE80211_MSG_DUMPPKTS () {0x20000000;}' unless defined(&IEEE80211_MSG_DUMPPKTS);
    eval 'sub IEEE80211_MSG_CRYPTO () {0x10000000;}' unless defined(&IEEE80211_MSG_CRYPTO);
    eval 'sub IEEE80211_MSG_INPUT () {0x8000000;}' unless defined(&IEEE80211_MSG_INPUT);
    eval 'sub IEEE80211_MSG_XRATE () {0x4000000;}' unless defined(&IEEE80211_MSG_XRATE);
    eval 'sub IEEE80211_MSG_ELEMID () {0x2000000;}' unless defined(&IEEE80211_MSG_ELEMID);
    eval 'sub IEEE80211_MSG_NODE () {0x1000000;}' unless defined(&IEEE80211_MSG_NODE);
    eval 'sub IEEE80211_MSG_ASSOC () {0x800000;}' unless defined(&IEEE80211_MSG_ASSOC);
    eval 'sub IEEE80211_MSG_AUTH () {0x400000;}' unless defined(&IEEE80211_MSG_AUTH);
    eval 'sub IEEE80211_MSG_SCAN () {0x200000;}' unless defined(&IEEE80211_MSG_SCAN);
    eval 'sub IEEE80211_MSG_OUTPUT () {0x100000;}' unless defined(&IEEE80211_MSG_OUTPUT);
    eval 'sub IEEE80211_MSG_STATE () {0x80000;}' unless defined(&IEEE80211_MSG_STATE);
    eval 'sub IEEE80211_MSG_POWER () {0x40000;}' unless defined(&IEEE80211_MSG_POWER);
    eval 'sub IEEE80211_MSG_HWMP () {0x20000;}' unless defined(&IEEE80211_MSG_HWMP);
    eval 'sub IEEE80211_MSG_DOT1XSM () {0x10000;}' unless defined(&IEEE80211_MSG_DOT1XSM);
    eval 'sub IEEE80211_MSG_RADIUS () {0x8000;}' unless defined(&IEEE80211_MSG_RADIUS);
    eval 'sub IEEE80211_MSG_RADDUMP () {0x4000;}' unless defined(&IEEE80211_MSG_RADDUMP);
    eval 'sub IEEE80211_MSG_MESH () {0x2000;}' unless defined(&IEEE80211_MSG_MESH);
    eval 'sub IEEE80211_MSG_WPA () {0x1000;}' unless defined(&IEEE80211_MSG_WPA);
    eval 'sub IEEE80211_MSG_ACL () {0x800;}' unless defined(&IEEE80211_MSG_ACL);
    eval 'sub IEEE80211_MSG_WME () {0x400;}' unless defined(&IEEE80211_MSG_WME);
    eval 'sub IEEE80211_MSG_SUPERG () {0x200;}' unless defined(&IEEE80211_MSG_SUPERG);
    eval 'sub IEEE80211_MSG_DOTH () {0x100;}' unless defined(&IEEE80211_MSG_DOTH);
    eval 'sub IEEE80211_MSG_INACT () {0x80;}' unless defined(&IEEE80211_MSG_INACT);
    eval 'sub IEEE80211_MSG_ROAM () {0x40;}' unless defined(&IEEE80211_MSG_ROAM);
    eval 'sub IEEE80211_MSG_RATECTL () {0x20;}' unless defined(&IEEE80211_MSG_RATECTL);
    eval 'sub IEEE80211_MSG_ACTION () {0x10;}' unless defined(&IEEE80211_MSG_ACTION);
    eval 'sub IEEE80211_MSG_WDS () {0x8;}' unless defined(&IEEE80211_MSG_WDS);
    eval 'sub IEEE80211_MSG_IOCTL () {0x4;}' unless defined(&IEEE80211_MSG_IOCTL);
    eval 'sub IEEE80211_MSG_TDMA () {0x2;}' unless defined(&IEEE80211_MSG_TDMA);
    eval 'sub IEEE80211_MSG_ANY () {0xffffffff;}' unless defined(&IEEE80211_MSG_ANY);
    eval 'sub IEEE80211_MSG_BITS () {"\\20\\2TDMA\\3IOCTL\\4WDS\\5ACTION\\6RATECTL\\7ROAM\\10INACT\\11DOTH\\12SUPERG" "\\13WME\\14ACL\\15WPA\\16RADKEYS\\17RADDUMP\\20RADIUS\\21DOT1XSM\\22HWMP" "\\23POWER\\24STATE\\25OUTPUT\\26SCAN\\27AUTH\\30ASSOC\\31NODE\\32ELEMID" "\\33XRATE\\34INPUT\\35CRYPTO\\36DUPMPKTS\\37DEBUG\\04011N";}' unless defined(&IEEE80211_MSG_BITS);
    if(defined(&IEEE80211_DEBUG)) {
	eval 'sub ieee80211_msg {
	    my($_vap, $_m) = @_;
    	    eval q((($_vap)-> &iv_debug & ($_m)));
	}' unless defined(&ieee80211_msg);
	eval 'sub IEEE80211_DPRINTF () {( &_vap,  &_m,  &_fmt, ...)  &do {  &if ( &ieee80211_msg( &_vap,  &_m))  &ieee80211_note( &_vap,  &_fmt,  &__VA_ARGS__); }  &while (0);}' unless defined(&IEEE80211_DPRINTF);
	eval 'sub IEEE80211_NOTE () {( &_vap,  &_m,  &_ni,  &_fmt, ...)  &do {  &if ( &ieee80211_msg( &_vap,  &_m))  &ieee80211_note_mac( &_vap, ( &_ni)-> &ni_macaddr,  &_fmt,  &__VA_ARGS__);}  &while (0);}' unless defined(&IEEE80211_NOTE);
	eval 'sub IEEE80211_NOTE_MAC () {( &_vap,  &_m,  &_mac,  &_fmt, ...)  &do {  &if ( &ieee80211_msg( &_vap,  &_m))  &ieee80211_note_mac( &_vap,  &_mac,  &_fmt,  &__VA_ARGS__); }  &while (0);}' unless defined(&IEEE80211_NOTE_MAC);
	eval 'sub IEEE80211_NOTE_FRAME () {( &_vap,  &_m,  &_wh,  &_fmt, ...)  &do {  &if ( &ieee80211_msg( &_vap,  &_m))  &ieee80211_note_frame( &_vap,  &_wh,  &_fmt,  &__VA_ARGS__); }  &while (0);}' unless defined(&IEEE80211_NOTE_FRAME);
	eval 'sub ieee80211_msg_debug {
	    my($_vap) = @_;
    	    eval q((($_vap)-> &iv_debug &  &IEEE80211_MSG_DEBUG));
	}' unless defined(&ieee80211_msg_debug);
	eval 'sub ieee80211_msg_dumppkts {
	    my($_vap) = @_;
    	    eval q((($_vap)-> &iv_debug &  &IEEE80211_MSG_DUMPPKTS));
	}' unless defined(&ieee80211_msg_dumppkts);
	eval 'sub ieee80211_msg_input {
	    my($_vap) = @_;
    	    eval q((($_vap)-> &iv_debug &  &IEEE80211_MSG_INPUT));
	}' unless defined(&ieee80211_msg_input);
	eval 'sub ieee80211_msg_radius {
	    my($_vap) = @_;
    	    eval q((($_vap)-> &iv_debug &  &IEEE80211_MSG_RADIUS));
	}' unless defined(&ieee80211_msg_radius);
	eval 'sub ieee80211_msg_dumpradius {
	    my($_vap) = @_;
    	    eval q((($_vap)-> &iv_debug &  &IEEE80211_MSG_RADDUMP));
	}' unless defined(&ieee80211_msg_dumpradius);
	eval 'sub ieee80211_msg_dumpradkeys {
	    my($_vap) = @_;
    	    eval q((($_vap)-> &iv_debug &  &IEEE80211_MSG_RADKEYS));
	}' unless defined(&ieee80211_msg_dumpradkeys);
	eval 'sub ieee80211_msg_scan {
	    my($_vap) = @_;
    	    eval q((($_vap)-> &iv_debug &  &IEEE80211_MSG_SCAN));
	}' unless defined(&ieee80211_msg_scan);
	eval 'sub ieee80211_msg_assoc {
	    my($_vap) = @_;
    	    eval q((($_vap)-> &iv_debug &  &IEEE80211_MSG_ASSOC));
	}' unless defined(&ieee80211_msg_assoc);
	eval 'sub IEEE80211_DISCARD () {( &_vap,  &_m,  &_wh,  &_type,  &_fmt, ...)  &do {  &if (( &_vap)-> &iv_debug & ( &_m))  &ieee80211_discard_frame( &_vap,  &_wh,  &_type,  &_fmt,  &__VA_ARGS__);}  &while (0);}' unless defined(&IEEE80211_DISCARD);
	eval 'sub IEEE80211_DISCARD_IE () {( &_vap,  &_m,  &_wh,  &_type,  &_fmt, ...)  &do {  &if (( &_vap)-> &iv_debug & ( &_m))  &ieee80211_discard_ie( &_vap,  &_wh,  &_type,  &_fmt,  &__VA_ARGS__);}  &while (0);}' unless defined(&IEEE80211_DISCARD_IE);
	eval 'sub IEEE80211_DISCARD_MAC () {( &_vap,  &_m,  &_mac,  &_type,  &_fmt, ...)  &do {  &if (( &_vap)-> &iv_debug & ( &_m))  &ieee80211_discard_mac( &_vap,  &_mac,  &_type,  &_fmt,  &__VA_ARGS__);}  &while (0);}' unless defined(&IEEE80211_DISCARD_MAC);
    } else {
	eval 'sub IEEE80211_DPRINTF () {( &_vap,  &_m,  &_fmt, ...);}' unless defined(&IEEE80211_DPRINTF);
	eval 'sub IEEE80211_NOTE () {( &_vap,  &_m,  &_ni,  &_fmt, ...);}' unless defined(&IEEE80211_NOTE);
	eval 'sub IEEE80211_NOTE_FRAME () {( &_vap,  &_m,  &_wh,  &_fmt, ...);}' unless defined(&IEEE80211_NOTE_FRAME);
	eval 'sub IEEE80211_NOTE_MAC () {( &_vap,  &_m,  &_mac,  &_fmt, ...);}' unless defined(&IEEE80211_NOTE_MAC);
	eval 'sub ieee80211_msg_dumppkts {
	    my($_vap) = @_;
    	    eval q(0);
	}' unless defined(&ieee80211_msg_dumppkts);
	eval 'sub ieee80211_msg {
	    my($_vap, $_m) = @_;
    	    eval q(0);
	}' unless defined(&ieee80211_msg);
	eval 'sub IEEE80211_DISCARD () {( &_vap,  &_m,  &_wh,  &_type,  &_fmt, ...);}' unless defined(&IEEE80211_DISCARD);
	eval 'sub IEEE80211_DISCARD_IE () {( &_vap,  &_m,  &_wh,  &_type,  &_fmt, ...);}' unless defined(&IEEE80211_DISCARD_IE);
	eval 'sub IEEE80211_DISCARD_MAC () {( &_vap,  &_m,  &_mac,  &_type,  &_fmt, ...);}' unless defined(&IEEE80211_DISCARD_MAC);
    }
}
1;
