require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NETFLOW_V9_H_)) {
    eval 'sub _NETFLOW_V9_H_ () {1;}' unless defined(&_NETFLOW_V9_H_);
    if(defined(&COUNTERS_64)) {
	eval 'sub CNTR () { &uint64_t;}' unless defined(&CNTR);
	eval 'sub CNTR_MAX () { &UINT64_MAX;}' unless defined(&CNTR_MAX);
    } else {
	eval 'sub CNTR () { &uint32_t;}' unless defined(&CNTR);
	eval 'sub CNTR_MAX () { &UINT_MAX;}' unless defined(&CNTR_MAX);
    }
    eval 'sub BASE_MTU () {1500;}' unless defined(&BASE_MTU);
    eval 'sub MIN_MTU () {$sizeof{\'struct netflow_v5_header\'};}' unless defined(&MIN_MTU);
    eval 'sub MAX_MTU () {16384;}' unless defined(&MAX_MTU);
    eval 'sub NETFLOW_V9_MAX_SIZE () { &_NETFLOW_V9_MAX_SIZE( &BASE_MTU);}' unless defined(&NETFLOW_V9_MAX_SIZE);
    eval 'sub _NETFLOW_V9_MAX_SIZE {
        my($x) = @_;
	    eval q(($x) - $sizeof{\'struct ip6_hdr\'} - $sizeof{\'struct udphdr\'} - 16);
    }' unless defined(&_NETFLOW_V9_MAX_SIZE);
    eval 'sub NETFLOW_V9_MAX_RECORD_SIZE () {$sizeof{\'struct netflow_v9_record_ipv6_tcp\'};}' unless defined(&NETFLOW_V9_MAX_RECORD_SIZE);
    eval 'sub NETFLOW_V9_MAX_PACKETS_TEMPL () {500;}' unless defined(&NETFLOW_V9_MAX_PACKETS_TEMPL);
    eval 'sub NETFLOW_V9_MAX_TIME_TEMPL () {600;}' unless defined(&NETFLOW_V9_MAX_TIME_TEMPL);
    eval 'sub NETFLOW_V9_MAX_TEMPLATES () {16;}' unless defined(&NETFLOW_V9_MAX_TEMPLATES);
    eval 'sub _NETFLOW_V9_TEMPLATE_SIZE {
        my($x) = @_;
	    eval q(($sizeof{$x} / $sizeof{\'struct netflow_v9_template\'}) * 4);
    }' unless defined(&_NETFLOW_V9_TEMPLATE_SIZE);
    eval 'sub NETFLOW_V9_FLOW_V4_L4 () {1;}' unless defined(&NETFLOW_V9_FLOW_V4_L4);
    eval 'sub NETFLOW_V9_FLOW_V4_ICMP () {2;}' unless defined(&NETFLOW_V9_FLOW_V4_ICMP);
    eval 'sub NETFLOW_V9_FLOW_V4_L3 () {3;}' unless defined(&NETFLOW_V9_FLOW_V4_L3);
    eval 'sub NETFLOW_V9_FLOW_V6_L4 () {4;}' unless defined(&NETFLOW_V9_FLOW_V6_L4);
    eval 'sub NETFLOW_V9_FLOW_V6_ICMP () {5;}' unless defined(&NETFLOW_V9_FLOW_V6_ICMP);
    eval 'sub NETFLOW_V9_FLOW_V6_L3 () {6;}' unless defined(&NETFLOW_V9_FLOW_V6_L3);
    eval 'sub NETFLOW_V9_FLOW_FAKE () {65535;}' unless defined(&NETFLOW_V9_FLOW_FAKE);
}
1;
