require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NETGRAPH_NETGRAPH_H_)) {
    eval 'sub _NETGRAPH_NETGRAPH_H_ () {1;}' unless defined(&_NETGRAPH_NETGRAPH_H_);
    unless(defined(&_KERNEL)) {
	die("This file should not be included in user level programs");
    }
    require 'sys/queue.ph';
    require 'sys/lock.ph';
    require 'sys/malloc.ph';
    require 'sys/module.ph';
    require 'sys/mutex.ph';
    require 'sys/refcount.ph';
    if(defined(&HAVE_KERNEL_OPTION_HEADERS)) {
	require './netgraph/opt_netgraph.ph';
	require './netgraph/opt_kdb.ph';
    }
    eval 'sub NG_SEPARATE_MALLOC () {1;}' unless defined(&NG_SEPARATE_MALLOC);
    eval 'sub _NG_ABI_VERSION () {12;}' unless defined(&_NG_ABI_VERSION);
    if(defined(&NETGRAPH_DEBUG)) {
	eval 'sub NG_ABI_VERSION () {( &_NG_ABI_VERSION + 0x10000);}' unless defined(&NG_ABI_VERSION);
    } else {
	eval 'sub NG_ABI_VERSION () { &_NG_ABI_VERSION;}' unless defined(&NG_ABI_VERSION);
    }
    if(defined(&NETGRAPH_DEBUG)) {
	eval 'sub HK_MAGIC () {0x78573011;}' unless defined(&HK_MAGIC);
    }
    eval 'sub HK_INVALID () {0x1;}' unless defined(&HK_INVALID);
    eval 'sub HK_QUEUE () {0x2;}' unless defined(&HK_QUEUE);
    eval 'sub HK_FORCE_WRITER () {0x4;}' unless defined(&HK_FORCE_WRITER);
    eval 'sub HK_DEAD () {0x8;}' unless defined(&HK_DEAD);
    eval 'sub HK_HI_STACK () {0x10;}' unless defined(&HK_HI_STACK);
    eval 'sub HK_TO_INBOUND () {0x20;}' unless defined(&HK_TO_INBOUND);
    eval 'sub _NG_HOOK_REF {
        my($hook) = @_;
	    eval q( &refcount_acquire(($hook)-> &hk_refs));
    }' unless defined(&_NG_HOOK_REF);
    eval 'sub _NG_HOOK_NAME {
        my($hook) = @_;
	    eval q((($hook)-> &hk_name));
    }' unless defined(&_NG_HOOK_NAME);
    eval 'sub _NG_HOOK_UNREF {
        my($hook) = @_;
	    eval q( &ng_unref_hook($hook));
    }' unless defined(&_NG_HOOK_UNREF);
    eval 'sub _NG_HOOK_SET_PRIVATE {
        my($hook, $val) = @_;
	    eval q( &do {($hook)-> &hk_private = $val;}  &while (0));
    }' unless defined(&_NG_HOOK_SET_PRIVATE);
    eval 'sub _NG_HOOK_SET_RCVMSG {
        my($hook, $val) = @_;
	    eval q( &do {($hook)-> &hk_rcvmsg = $val;}  &while (0));
    }' unless defined(&_NG_HOOK_SET_RCVMSG);
    eval 'sub _NG_HOOK_SET_RCVDATA {
        my($hook, $val) = @_;
	    eval q( &do {($hook)-> &hk_rcvdata = $val;}  &while (0));
    }' unless defined(&_NG_HOOK_SET_RCVDATA);
    eval 'sub _NG_HOOK_PRIVATE {
        my($hook) = @_;
	    eval q((($hook)-> &hk_private));
    }' unless defined(&_NG_HOOK_PRIVATE);
    eval 'sub _NG_HOOK_NOT_VALID {
        my($hook) = @_;
	    eval q((($hook)-> &hk_flags &  &HK_INVALID));
    }' unless defined(&_NG_HOOK_NOT_VALID);
    eval 'sub _NG_HOOK_IS_VALID {
        my($hook) = @_;
	    eval q((!(($hook)-> &hk_flags &  &HK_INVALID)));
    }' unless defined(&_NG_HOOK_IS_VALID);
    eval 'sub _NG_HOOK_NODE {
        my($hook) = @_;
	    eval q((($hook)-> &hk_node));
    }' unless defined(&_NG_HOOK_NODE);
    eval 'sub _NG_HOOK_PEER {
        my($hook) = @_;
	    eval q((($hook)-> &hk_peer));
    }' unless defined(&_NG_HOOK_PEER);
    eval 'sub _NG_HOOK_FORCE_WRITER {
        my($hook) = @_;
	    eval q( &do {  ($hook->{hk_flags}) |=  &HK_FORCE_WRITER; }  &while (0));
    }' unless defined(&_NG_HOOK_FORCE_WRITER);
    eval 'sub _NG_HOOK_FORCE_QUEUE {
        my($hook) = @_;
	    eval q( &do {  ($hook->{hk_flags}) |=  &HK_QUEUE; }  &while (0));
    }' unless defined(&_NG_HOOK_FORCE_QUEUE);
    eval 'sub _NG_HOOK_SET_TO_INBOUND {
        my($hook) = @_;
	    eval q( &do {  ($hook->{hk_flags}) |=  &HK_TO_INBOUND; }  &while (0));
    }' unless defined(&_NG_HOOK_SET_TO_INBOUND);
    eval 'sub _NG_HOOK_HI_STACK {
        my($hook) = @_;
	    eval q( &do {  ($hook->{hk_flags}) |=  &HK_HI_STACK; }  &while (0));
    }' unless defined(&_NG_HOOK_HI_STACK);
    eval 'sub NG_PEER_NODE {
        my($hook) = @_;
	    eval q( &NG_HOOK_NODE( &NG_HOOK_PEER($hook)));
    }' unless defined(&NG_PEER_NODE);
    eval 'sub NG_PEER_HOOK_NAME {
        my($hook) = @_;
	    eval q( &NG_HOOK_NAME( &NG_HOOK_PEER($hook)));
    }' unless defined(&NG_PEER_HOOK_NAME);
    eval 'sub NG_PEER_NODE_NAME {
        my($hook) = @_;
	    eval q( &NG_NODE_NAME( &NG_PEER_NODE($hook)));
    }' unless defined(&NG_PEER_NODE_NAME);
    if(defined(&NETGRAPH_DEBUG)) {
	eval 'sub _NN_ () { &__FILE__, &__LINE__;}' unless defined(&_NN_);
	eval 'sub _ng_hook_ref {
	    my($hook,$file,$line) = @_;
    	    eval q({  &_chkhook($hook, $file, $line);  &_NG_HOOK_REF($hook); });
	}' unless defined(&_ng_hook_ref);
	eval 'sub _ng_hook_name {
	    my($hook,$file,$line) = @_;
    	    eval q({  &_chkhook($hook, $file, $line); ( &_NG_HOOK_NAME($hook)); });
	}' unless defined(&_ng_hook_name);
	eval 'sub _ng_hook_unref {
	    my($hook,$file,$line) = @_;
    	    eval q({  &_chkhook($hook, $file, $line);  &_NG_HOOK_UNREF($hook); });
	}' unless defined(&_ng_hook_unref);
	eval 'sub _ng_hook_set_private {
	    my($hook,$val,$file,$line) = @_;
    	    eval q({  &_chkhook($hook, $file, $line);  &_NG_HOOK_SET_PRIVATE($hook, $val); });
	}' unless defined(&_ng_hook_set_private);
	eval 'sub _ng_hook_set_rcvmsg {
	    my($hook,$val,$file,$line) = @_;
    	    eval q({  &_chkhook($hook, $file, $line);  &_NG_HOOK_SET_RCVMSG($hook, $val); });
	}' unless defined(&_ng_hook_set_rcvmsg);
	eval 'sub _ng_hook_set_rcvdata {
	    my($hook,$val,$file,$line) = @_;
    	    eval q({  &_chkhook($hook, $file, $line);  &_NG_HOOK_SET_RCVDATA($hook, $val); });
	}' unless defined(&_ng_hook_set_rcvdata);
	eval 'sub _ng_hook_private {
	    my($hook,$file,$line) = @_;
    	    eval q({  &_chkhook($hook, $file, $line); ( &_NG_HOOK_PRIVATE($hook)); });
	}' unless defined(&_ng_hook_private);
	eval 'sub _ng_hook_not_valid {
	    my($hook,$file,$line) = @_;
    	    eval q({  &_chkhook($hook, $file, $line); ( &_NG_HOOK_NOT_VALID($hook)); });
	}' unless defined(&_ng_hook_not_valid);
	eval 'sub _ng_hook_is_valid {
	    my($hook,$file,$line) = @_;
    	    eval q({  &_chkhook($hook, $file, $line); ( &_NG_HOOK_IS_VALID($hook)); });
	}' unless defined(&_ng_hook_is_valid);
	eval 'sub _ng_hook_node {
	    my($hook,$file,$line) = @_;
    	    eval q({  &_chkhook($hook, $file, $line); ( &_NG_HOOK_NODE($hook)); });
	}' unless defined(&_ng_hook_node);
	eval 'sub _ng_hook_peer {
	    my($hook,$file,$line) = @_;
    	    eval q({  &_chkhook($hook, $file, $line); ( &_NG_HOOK_PEER($hook)); });
	}' unless defined(&_ng_hook_peer);
	eval 'sub _ng_hook_force_writer {
	    my($hook,$file,$line) = @_;
    	    eval q({  &_chkhook($hook, $file, $line);  &_NG_HOOK_FORCE_WRITER($hook); });
	}' unless defined(&_ng_hook_force_writer);
	eval 'sub _ng_hook_force_queue {
	    my($hook,$file,$line) = @_;
    	    eval q({  &_chkhook($hook, $file, $line);  &_NG_HOOK_FORCE_QUEUE($hook); });
	}' unless defined(&_ng_hook_force_queue);
	eval 'sub _ng_hook_set_to_inbound {
	    my($hook,$file,$line) = @_;
    	    eval q({  &_chkhook($hook, $file, $line);  &_NG_HOOK_SET_TO_INBOUND($hook); });
	}' unless defined(&_ng_hook_set_to_inbound);
	eval 'sub _ng_hook_hi_stack {
	    my($hook,$file,$line) = @_;
    	    eval q({  &_chkhook($hook, $file, $line);  &_NG_HOOK_HI_STACK($hook); });
	}' unless defined(&_ng_hook_hi_stack);
	eval 'sub NG_HOOK_REF {
	    my($hook) = @_;
    	    eval q( &_ng_hook_ref($hook,  &_NN_));
	}' unless defined(&NG_HOOK_REF);
	eval 'sub NG_HOOK_NAME {
	    my($hook) = @_;
    	    eval q( &_ng_hook_name($hook,  &_NN_));
	}' unless defined(&NG_HOOK_NAME);
	eval 'sub NG_HOOK_UNREF {
	    my($hook) = @_;
    	    eval q( &_ng_hook_unref($hook,  &_NN_));
	}' unless defined(&NG_HOOK_UNREF);
	eval 'sub NG_HOOK_SET_PRIVATE {
	    my($hook, $val) = @_;
    	    eval q( &_ng_hook_set_private($hook, $val,  &_NN_));
	}' unless defined(&NG_HOOK_SET_PRIVATE);
	eval 'sub NG_HOOK_SET_RCVMSG {
	    my($hook, $val) = @_;
    	    eval q( &_ng_hook_set_rcvmsg($hook, $val,  &_NN_));
	}' unless defined(&NG_HOOK_SET_RCVMSG);
	eval 'sub NG_HOOK_SET_RCVDATA {
	    my($hook, $val) = @_;
    	    eval q( &_ng_hook_set_rcvdata($hook, $val,  &_NN_));
	}' unless defined(&NG_HOOK_SET_RCVDATA);
	eval 'sub NG_HOOK_PRIVATE {
	    my($hook) = @_;
    	    eval q( &_ng_hook_private($hook,  &_NN_));
	}' unless defined(&NG_HOOK_PRIVATE);
	eval 'sub NG_HOOK_NOT_VALID {
	    my($hook) = @_;
    	    eval q( &_ng_hook_not_valid($hook,  &_NN_));
	}' unless defined(&NG_HOOK_NOT_VALID);
	eval 'sub NG_HOOK_IS_VALID {
	    my($hook) = @_;
    	    eval q( &_ng_hook_is_valid($hook,  &_NN_));
	}' unless defined(&NG_HOOK_IS_VALID);
	eval 'sub NG_HOOK_NODE {
	    my($hook) = @_;
    	    eval q( &_ng_hook_node($hook,  &_NN_));
	}' unless defined(&NG_HOOK_NODE);
	eval 'sub NG_HOOK_PEER {
	    my($hook) = @_;
    	    eval q( &_ng_hook_peer($hook,  &_NN_));
	}' unless defined(&NG_HOOK_PEER);
	eval 'sub NG_HOOK_FORCE_WRITER {
	    my($hook) = @_;
    	    eval q( &_ng_hook_force_writer($hook,  &_NN_));
	}' unless defined(&NG_HOOK_FORCE_WRITER);
	eval 'sub NG_HOOK_FORCE_QUEUE {
	    my($hook) = @_;
    	    eval q( &_ng_hook_force_queue($hook,  &_NN_));
	}' unless defined(&NG_HOOK_FORCE_QUEUE);
	eval 'sub NG_HOOK_SET_TO_INBOUND {
	    my($hook) = @_;
    	    eval q( &_ng_hook_set_to_inbound($hook,  &_NN_));
	}' unless defined(&NG_HOOK_SET_TO_INBOUND);
	eval 'sub NG_HOOK_HI_STACK {
	    my($hook) = @_;
    	    eval q( &_ng_hook_hi_stack($hook,  &_NN_));
	}' unless defined(&NG_HOOK_HI_STACK);
    } else {
	eval 'sub NG_HOOK_REF {
	    my($hook) = @_;
    	    eval q( &_NG_HOOK_REF($hook));
	}' unless defined(&NG_HOOK_REF);
	eval 'sub NG_HOOK_NAME {
	    my($hook) = @_;
    	    eval q( &_NG_HOOK_NAME($hook));
	}' unless defined(&NG_HOOK_NAME);
	eval 'sub NG_HOOK_UNREF {
	    my($hook) = @_;
    	    eval q( &_NG_HOOK_UNREF($hook));
	}' unless defined(&NG_HOOK_UNREF);
	eval 'sub NG_HOOK_SET_PRIVATE {
	    my($hook, $val) = @_;
    	    eval q( &_NG_HOOK_SET_PRIVATE($hook, $val));
	}' unless defined(&NG_HOOK_SET_PRIVATE);
	eval 'sub NG_HOOK_SET_RCVMSG {
	    my($hook, $val) = @_;
    	    eval q( &_NG_HOOK_SET_RCVMSG($hook, $val));
	}' unless defined(&NG_HOOK_SET_RCVMSG);
	eval 'sub NG_HOOK_SET_RCVDATA {
	    my($hook, $val) = @_;
    	    eval q( &_NG_HOOK_SET_RCVDATA($hook, $val));
	}' unless defined(&NG_HOOK_SET_RCVDATA);
	eval 'sub NG_HOOK_PRIVATE {
	    my($hook) = @_;
    	    eval q( &_NG_HOOK_PRIVATE($hook));
	}' unless defined(&NG_HOOK_PRIVATE);
	eval 'sub NG_HOOK_NOT_VALID {
	    my($hook) = @_;
    	    eval q( &_NG_HOOK_NOT_VALID($hook));
	}' unless defined(&NG_HOOK_NOT_VALID);
	eval 'sub NG_HOOK_IS_VALID {
	    my($hook) = @_;
    	    eval q( &_NG_HOOK_IS_VALID($hook));
	}' unless defined(&NG_HOOK_IS_VALID);
	eval 'sub NG_HOOK_NODE {
	    my($hook) = @_;
    	    eval q( &_NG_HOOK_NODE($hook));
	}' unless defined(&NG_HOOK_NODE);
	eval 'sub NG_HOOK_PEER {
	    my($hook) = @_;
    	    eval q( &_NG_HOOK_PEER($hook));
	}' unless defined(&NG_HOOK_PEER);
	eval 'sub NG_HOOK_FORCE_WRITER {
	    my($hook) = @_;
    	    eval q( &_NG_HOOK_FORCE_WRITER($hook));
	}' unless defined(&NG_HOOK_FORCE_WRITER);
	eval 'sub NG_HOOK_FORCE_QUEUE {
	    my($hook) = @_;
    	    eval q( &_NG_HOOK_FORCE_QUEUE($hook));
	}' unless defined(&NG_HOOK_FORCE_QUEUE);
	eval 'sub NG_HOOK_SET_TO_INBOUND {
	    my($hook) = @_;
    	    eval q( &_NG_HOOK_SET_TO_INBOUND($hook));
	}' unless defined(&NG_HOOK_SET_TO_INBOUND);
	eval 'sub NG_HOOK_HI_STACK {
	    my($hook) = @_;
    	    eval q( &_NG_HOOK_HI_STACK($hook));
	}' unless defined(&NG_HOOK_HI_STACK);
    }
    if(defined(&NETGRAPH_DEBUG)) {
	eval 'sub ND_MAGIC () {0x59264837;}' unless defined(&ND_MAGIC);
    }
    eval 'sub NGF_INVALID () {0x1;}' unless defined(&NGF_INVALID);
    eval 'sub NG_INVALID () { &NGF_INVALID;}' unless defined(&NG_INVALID);
    eval 'sub NGF_FORCE_WRITER () {0x4;}' unless defined(&NGF_FORCE_WRITER);
    eval 'sub NG_FORCE_WRITER () { &NGF_FORCE_WRITER;}' unless defined(&NG_FORCE_WRITER);
    eval 'sub NGF_CLOSING () {0x8;}' unless defined(&NGF_CLOSING);
    eval 'sub NG_CLOSING () { &NGF_CLOSING;}' unless defined(&NG_CLOSING);
    eval 'sub NGF_REALLY_DIE () {0x10;}' unless defined(&NGF_REALLY_DIE);
    eval 'sub NG_REALLY_DIE () { &NGF_REALLY_DIE;}' unless defined(&NG_REALLY_DIE);
    eval 'sub NGF_HI_STACK () {0x20;}' unless defined(&NGF_HI_STACK);
    eval 'sub NGF_TYPE1 () {0x10000000;}' unless defined(&NGF_TYPE1);
    eval 'sub NGF_TYPE2 () {0x20000000;}' unless defined(&NGF_TYPE2);
    eval 'sub NGF_TYPE3 () {0x40000000;}' unless defined(&NGF_TYPE3);
    eval 'sub NGF_TYPE4 () {0x80000000;}' unless defined(&NGF_TYPE4);
    eval 'sub _NG_NODE_NAME {
        my($node) = @_;
	    eval q((($node)-> &nd_name + 0));
    }' unless defined(&_NG_NODE_NAME);
    eval 'sub _NG_NODE_HAS_NAME {
        my($node) = @_;
	    eval q((($node)-> $nd_name[0] + 0));
    }' unless defined(&_NG_NODE_HAS_NAME);
    eval 'sub _NG_NODE_ID {
        my($node) = @_;
	    eval q((($node)-> &nd_ID + 0));
    }' unless defined(&_NG_NODE_ID);
    eval 'sub _NG_NODE_REF {
        my($node) = @_;
	    eval q( &refcount_acquire(($node)-> &nd_refs));
    }' unless defined(&_NG_NODE_REF);
    eval 'sub _NG_NODE_UNREF {
        my($node) = @_;
	    eval q( &ng_unref_node($node));
    }' unless defined(&_NG_NODE_UNREF);
    eval 'sub _NG_NODE_SET_PRIVATE {
        my($node, $val) = @_;
	    eval q( &do {($node)-> &nd_private = $val;}  &while (0));
    }' unless defined(&_NG_NODE_SET_PRIVATE);
    eval 'sub _NG_NODE_PRIVATE {
        my($node) = @_;
	    eval q((($node)-> &nd_private));
    }' unless defined(&_NG_NODE_PRIVATE);
    eval 'sub _NG_NODE_IS_VALID {
        my($node) = @_;
	    eval q((!(($node)-> &nd_flags &  &NGF_INVALID)));
    }' unless defined(&_NG_NODE_IS_VALID);
    eval 'sub _NG_NODE_NOT_VALID {
        my($node) = @_;
	    eval q((($node)-> &nd_flags &  &NGF_INVALID));
    }' unless defined(&_NG_NODE_NOT_VALID);
    eval 'sub _NG_NODE_NUMHOOKS {
        my($node) = @_;
	    eval q((($node)-> &nd_numhooks + 0));
    }' unless defined(&_NG_NODE_NUMHOOKS);
    eval 'sub _NG_NODE_FORCE_WRITER {
        my($node) = @_;
	    eval q( &do{  ($node->{nd_flags}) |=  &NGF_FORCE_WRITER; } &while (0));
    }' unless defined(&_NG_NODE_FORCE_WRITER);
    eval 'sub _NG_NODE_HI_STACK {
        my($node) = @_;
	    eval q( &do{  ($node->{nd_flags}) |=  &NGF_HI_STACK; } &while (0));
    }' unless defined(&_NG_NODE_HI_STACK);
    eval 'sub _NG_NODE_REALLY_DIE {
        my($node) = @_;
	    eval q( &do{  ($node->{nd_flags}) |= ( &NGF_REALLY_DIE| &NGF_INVALID); } &while (0));
    }' unless defined(&_NG_NODE_REALLY_DIE);
    eval 'sub _NG_NODE_REVIVE {
        my($node) = @_;
	    eval q( &do {  ($node->{nd_flags}) &= ~ &NGF_INVALID; }  &while (0));
    }' unless defined(&_NG_NODE_REVIVE);
    eval 'sub _NG_NODE_FOREACH_HOOK {
        my($node, $fn, $arg, $rethook) = @_;
	    eval q( &do {  &hook_p  &_hook; ($rethook) =  &NULL;  &LIST_FOREACH( &_hook, (($node)-> &nd_hooks),  &hk_hooks) {  &if (($fn)( &_hook, $arg) == 0) { ($rethook) =  &_hook;  &break; } } }  &while (0));
    }' unless defined(&_NG_NODE_FOREACH_HOOK);
    if(defined(&NETGRAPH_DEBUG)) {
	eval 'sub _chknode {
	    my($node,$file,$line) = @_;
    	    eval q({  &if ( ($node->{nd_magic}) !=  &ND_MAGIC) {  &printf(\\"Accessing freed \\");  &dumpnode($node, $file, $line); }  ($node->{lastline}) = $line;  ($node->{lastfile}) = $file; });
	}' unless defined(&_chknode);
	eval 'sub _ng_node_name {
	    my($node,$file,$line) = @_;
    	    eval q({  &_chknode($node, $file, $line); ( &_NG_NODE_NAME($node)); });
	}' unless defined(&_ng_node_name);
	eval 'sub _ng_node_has_name {
	    my($node,$file,$line) = @_;
    	    eval q({  &_chknode($node, $file, $line); ( &_NG_NODE_HAS_NAME($node)); });
	}' unless defined(&_ng_node_has_name);
	eval 'sub _ng_node_id {
	    my($node,$file,$line) = @_;
    	    eval q({  &_chknode($node, $file, $line); ( &_NG_NODE_ID($node)); });
	}' unless defined(&_ng_node_id);
	eval 'sub _ng_node_ref {
	    my($node,$file,$line) = @_;
    	    eval q({  &_chknode($node, $file, $line);  &_NG_NODE_REF($node); });
	}' unless defined(&_ng_node_ref);
	eval 'sub _ng_node_unref {
	    my($node,$file,$line) = @_;
    	    eval q({  &_chknode($node, $file, $line);  &_NG_NODE_UNREF($node); });
	}' unless defined(&_ng_node_unref);
	eval 'sub _ng_node_set_private {
	    my($node,$val,$file,$line) = @_;
    	    eval q({  &_chknode($node, $file, $line);  &_NG_NODE_SET_PRIVATE($node, $val); });
	}' unless defined(&_ng_node_set_private);
	eval 'sub _ng_node_private {
	    my($node,$file,$line) = @_;
    	    eval q({  &_chknode($node, $file, $line); ( &_NG_NODE_PRIVATE($node)); });
	}' unless defined(&_ng_node_private);
	eval 'sub _ng_node_is_valid {
	    my($node,$file,$line) = @_;
    	    eval q({  &_chknode($node, $file, $line); ( &_NG_NODE_IS_VALID($node)); });
	}' unless defined(&_ng_node_is_valid);
	eval 'sub _ng_node_not_valid {
	    my($node,$file,$line) = @_;
    	    eval q({  &_chknode($node, $file, $line); ( &_NG_NODE_NOT_VALID($node)); });
	}' unless defined(&_ng_node_not_valid);
	eval 'sub _ng_node_numhooks {
	    my($node,$file,$line) = @_;
    	    eval q({  &_chknode($node, $file, $line); ( &_NG_NODE_NUMHOOKS($node)); });
	}' unless defined(&_ng_node_numhooks);
	eval 'sub _ng_node_force_writer {
	    my($node,$file,$line) = @_;
    	    eval q({  &_chknode($node, $file, $line);  &_NG_NODE_FORCE_WRITER($node); });
	}' unless defined(&_ng_node_force_writer);
	eval 'sub _ng_node_hi_stack {
	    my($node,$file,$line) = @_;
    	    eval q({  &_chknode($node, $file, $line);  &_NG_NODE_HI_STACK($node); });
	}' unless defined(&_ng_node_hi_stack);
	eval 'sub _ng_node_really_die {
	    my($node,$file,$line) = @_;
    	    eval q({  &_chknode($node, $file, $line);  &_NG_NODE_REALLY_DIE($node); });
	}' unless defined(&_ng_node_really_die);
	eval 'sub _ng_node_revive {
	    my($node,$file,$line) = @_;
    	    eval q({  &_chknode($node, $file, $line);  &_NG_NODE_REVIVE($node); });
	}' unless defined(&_ng_node_revive);
	eval 'sub _ng_node_foreach_hook {
	    my($node,$fn,$arg,$file,$line) = @_;
    	    eval q({  &hook_p  &hook;  &_chknode($node, $file, $line);  &_NG_NODE_FOREACH_HOOK($node, $fn, $arg,  &hook); ( &hook); });
	}' unless defined(&_ng_node_foreach_hook);
	eval 'sub NG_NODE_NAME {
	    my($node) = @_;
    	    eval q( &_ng_node_name($node,  &_NN_));
	}' unless defined(&NG_NODE_NAME);
	eval 'sub NG_NODE_HAS_NAME {
	    my($node) = @_;
    	    eval q( &_ng_node_has_name($node,  &_NN_));
	}' unless defined(&NG_NODE_HAS_NAME);
	eval 'sub NG_NODE_ID {
	    my($node) = @_;
    	    eval q( &_ng_node_id($node,  &_NN_));
	}' unless defined(&NG_NODE_ID);
	eval 'sub NG_NODE_REF {
	    my($node) = @_;
    	    eval q( &_ng_node_ref($node,  &_NN_));
	}' unless defined(&NG_NODE_REF);
	eval 'sub NG_NODE_UNREF {
	    my($node) = @_;
    	    eval q( &_ng_node_unref($node,  &_NN_));
	}' unless defined(&NG_NODE_UNREF);
	eval 'sub NG_NODE_SET_PRIVATE {
	    my($node, $val) = @_;
    	    eval q( &_ng_node_set_private($node, $val,  &_NN_));
	}' unless defined(&NG_NODE_SET_PRIVATE);
	eval 'sub NG_NODE_PRIVATE {
	    my($node) = @_;
    	    eval q( &_ng_node_private($node,  &_NN_));
	}' unless defined(&NG_NODE_PRIVATE);
	eval 'sub NG_NODE_IS_VALID {
	    my($node) = @_;
    	    eval q( &_ng_node_is_valid($node,  &_NN_));
	}' unless defined(&NG_NODE_IS_VALID);
	eval 'sub NG_NODE_NOT_VALID {
	    my($node) = @_;
    	    eval q( &_ng_node_not_valid($node,  &_NN_));
	}' unless defined(&NG_NODE_NOT_VALID);
	eval 'sub NG_NODE_FORCE_WRITER {
	    my($node) = @_;
    	    eval q( &_ng_node_force_writer($node,  &_NN_));
	}' unless defined(&NG_NODE_FORCE_WRITER);
	eval 'sub NG_NODE_HI_STACK {
	    my($node) = @_;
    	    eval q( &_ng_node_hi_stack($node,  &_NN_));
	}' unless defined(&NG_NODE_HI_STACK);
	eval 'sub NG_NODE_REALLY_DIE {
	    my($node) = @_;
    	    eval q( &_ng_node_really_die($node,  &_NN_));
	}' unless defined(&NG_NODE_REALLY_DIE);
	eval 'sub NG_NODE_NUMHOOKS {
	    my($node) = @_;
    	    eval q( &_ng_node_numhooks($node,  &_NN_));
	}' unless defined(&NG_NODE_NUMHOOKS);
	eval 'sub NG_NODE_REVIVE {
	    my($node) = @_;
    	    eval q( &_ng_node_revive($node,  &_NN_));
	}' unless defined(&NG_NODE_REVIVE);
	eval 'sub NG_NODE_FOREACH_HOOK {
	    my($node, $fn, $arg, $rethook) = @_;
    	    eval q( &do { $rethook =  &_ng_node_foreach_hook($node, $fn, ( &void *)$arg,  &_NN_); }  &while (0));
	}' unless defined(&NG_NODE_FOREACH_HOOK);
    } else {
	eval 'sub NG_NODE_NAME {
	    my($node) = @_;
    	    eval q( &_NG_NODE_NAME($node));
	}' unless defined(&NG_NODE_NAME);
	eval 'sub NG_NODE_HAS_NAME {
	    my($node) = @_;
    	    eval q( &_NG_NODE_HAS_NAME($node));
	}' unless defined(&NG_NODE_HAS_NAME);
	eval 'sub NG_NODE_ID {
	    my($node) = @_;
    	    eval q( &_NG_NODE_ID($node));
	}' unless defined(&NG_NODE_ID);
	eval 'sub NG_NODE_REF {
	    my($node) = @_;
    	    eval q( &_NG_NODE_REF($node));
	}' unless defined(&NG_NODE_REF);
	eval 'sub NG_NODE_UNREF {
	    my($node) = @_;
    	    eval q( &_NG_NODE_UNREF($node));
	}' unless defined(&NG_NODE_UNREF);
	eval 'sub NG_NODE_SET_PRIVATE {
	    my($node, $val) = @_;
    	    eval q( &_NG_NODE_SET_PRIVATE($node, $val));
	}' unless defined(&NG_NODE_SET_PRIVATE);
	eval 'sub NG_NODE_PRIVATE {
	    my($node) = @_;
    	    eval q( &_NG_NODE_PRIVATE($node));
	}' unless defined(&NG_NODE_PRIVATE);
	eval 'sub NG_NODE_IS_VALID {
	    my($node) = @_;
    	    eval q( &_NG_NODE_IS_VALID($node));
	}' unless defined(&NG_NODE_IS_VALID);
	eval 'sub NG_NODE_NOT_VALID {
	    my($node) = @_;
    	    eval q( &_NG_NODE_NOT_VALID($node));
	}' unless defined(&NG_NODE_NOT_VALID);
	eval 'sub NG_NODE_FORCE_WRITER {
	    my($node) = @_;
    	    eval q( &_NG_NODE_FORCE_WRITER($node));
	}' unless defined(&NG_NODE_FORCE_WRITER);
	eval 'sub NG_NODE_HI_STACK {
	    my($node) = @_;
    	    eval q( &_NG_NODE_HI_STACK($node));
	}' unless defined(&NG_NODE_HI_STACK);
	eval 'sub NG_NODE_REALLY_DIE {
	    my($node) = @_;
    	    eval q( &_NG_NODE_REALLY_DIE($node));
	}' unless defined(&NG_NODE_REALLY_DIE);
	eval 'sub NG_NODE_NUMHOOKS {
	    my($node) = @_;
    	    eval q( &_NG_NODE_NUMHOOKS($node));
	}' unless defined(&NG_NODE_NUMHOOKS);
	eval 'sub NG_NODE_REVIVE {
	    my($node) = @_;
    	    eval q( &_NG_NODE_REVIVE($node));
	}' unless defined(&NG_NODE_REVIVE);
	eval 'sub NG_NODE_FOREACH_HOOK {
	    my($node, $fn, $arg, $rethook) = @_;
    	    eval q( &_NG_NODE_FOREACH_HOOK($node, $fn, $arg, $rethook));
	}' unless defined(&NG_NODE_FOREACH_HOOK);
    }
    if(defined(&NETGRAPH_DEBUG)) {
    }
    eval 'sub NGQF_TYPE () {0x3;}' unless defined(&NGQF_TYPE);
    eval 'sub NGQF_MESG () {0x;}' unless defined(&NGQF_MESG);
    eval 'sub NGQF_DATA () {0x1;}' unless defined(&NGQF_DATA);
    eval 'sub NGQF_FN () {0x2;}' unless defined(&NGQF_FN);
    eval 'sub NGQF_FN2 () {0x3;}' unless defined(&NGQF_FN2);
    eval 'sub NGQF_RW () {0x4;}' unless defined(&NGQF_RW);
    eval 'sub NGQF_READER () {0x4;}' unless defined(&NGQF_READER);
    eval 'sub NGQF_WRITER () {0x;}' unless defined(&NGQF_WRITER);
    eval 'sub NGQF_QMODE () {0x8;}' unless defined(&NGQF_QMODE);
    eval 'sub NGQF_QREADER () {0x8;}' unless defined(&NGQF_QREADER);
    eval 'sub NGQF_QWRITER () {0x;}' unless defined(&NGQF_QWRITER);
    eval 'sub _NGI_M {
        my($i) = @_;
	    eval q((($i)-> ($body->{da_m})));
    }' unless defined(&_NGI_M);
    eval 'sub _NGI_MSG {
        my($i) = @_;
	    eval q((($i)-> ($body->{msg}->{msg_msg})));
    }' unless defined(&_NGI_MSG);
    eval 'sub _NGI_RETADDR {
        my($i) = @_;
	    eval q((($i)-> ($body->{msg}->{msg_retaddr})));
    }' unless defined(&_NGI_RETADDR);
    eval 'sub _NGI_FN {
        my($i) = @_;
	    eval q((($i)-> ($body->{fn}->{fn_fn}->{fn_fn})));
    }' unless defined(&_NGI_FN);
    eval 'sub _NGI_FN2 {
        my($i) = @_;
	    eval q((($i)-> ($body->{fn}->{fn_fn}->{fn_fn2})));
    }' unless defined(&_NGI_FN2);
    eval 'sub _NGI_ARG1 {
        my($i) = @_;
	    eval q((($i)-> ($body->{fn}->{fn_arg1})));
    }' unless defined(&_NGI_ARG1);
    eval 'sub _NGI_ARG2 {
        my($i) = @_;
	    eval q((($i)-> ($body->{fn}->{fn_arg2})));
    }' unless defined(&_NGI_ARG2);
    eval 'sub _NGI_NODE {
        my($i) = @_;
	    eval q((($i)-> &el_dest));
    }' unless defined(&_NGI_NODE);
    eval 'sub _NGI_HOOK {
        my($i) = @_;
	    eval q((($i)-> &el_hook));
    }' unless defined(&_NGI_HOOK);
    eval 'sub _NGI_SET_HOOK {
        my($i,$h) = @_;
	    eval q( &do {  &_NGI_HOOK($i) = $h; $h =  &NULL;}  &while (0));
    }' unless defined(&_NGI_SET_HOOK);
    eval 'sub _NGI_CLR_HOOK {
        my($i) = @_;
	    eval q( &do {  &hook_p  &_hook =  &_NGI_HOOK($i);  &if ( &_hook) {  &_NG_HOOK_UNREF( &_hook);  &_NGI_HOOK($i) =  &NULL; } }  &while (0));
    }' unless defined(&_NGI_CLR_HOOK);
    eval 'sub _NGI_SET_NODE {
        my($i,$n) = @_;
	    eval q( &do {  &_NGI_NODE($i) = $n; $n =  &NULL;}  &while (0));
    }' unless defined(&_NGI_SET_NODE);
    eval 'sub _NGI_CLR_NODE {
        my($i) = @_;
	    eval q( &do {  &node_p  &_node =  &_NGI_NODE($i);  &if ( &_node) {  &_NG_NODE_UNREF( &_node);  &_NGI_NODE($i) =  &NULL; } }  &while (0));
    }' unless defined(&_NGI_CLR_NODE);
    if(defined(&NETGRAPH_DEBUG)) {
	eval 'sub _ngi_check {
	    my($item,$file,$line) = @_;
    	    eval q({ ($item)-> &lastline = $line; ($item)-> &lastfile = $file; });
	}' unless defined(&_ngi_check);
	eval 'sub _ngi_m {
	    my($item,$file,$line) = @_;
    	    eval q({  &_ngi_check($item, $file, $line); (& &_NGI_M($item)); });
	}' unless defined(&_ngi_m);
	eval 'sub _ngi_msg {
	    my($item,$file,$line) = @_;
    	    eval q({  &_ngi_check($item, $file, $line); (& &_NGI_MSG($item)); });
	}' unless defined(&_ngi_msg);
	eval 'sub _ngi_retaddr {
	    my($item,$file,$line) = @_;
    	    eval q({  &_ngi_check($item, $file, $line); (& &_NGI_RETADDR($item)); });
	}' unless defined(&_ngi_retaddr);
	eval 'sub _ngi_fn {
	    my($item,$file,$line) = @_;
    	    eval q({  &_ngi_check($item, $file, $line); (& &_NGI_FN($item)); });
	}' unless defined(&_ngi_fn);
	eval 'sub _ngi_fn2 {
	    my($item,$file,$line) = @_;
    	    eval q({  &_ngi_check($item, $file, $line); (& &_NGI_FN2($item)); });
	}' unless defined(&_ngi_fn2);
	eval 'sub _ngi_arg1 {
	    my($item,$file,$line) = @_;
    	    eval q({  &_ngi_check($item, $file, $line); (& &_NGI_ARG1($item)); });
	}' unless defined(&_ngi_arg1);
	eval 'sub _ngi_arg2 {
	    my($item,$file,$line) = @_;
    	    eval q({  &_ngi_check($item, $file, $line); (& &_NGI_ARG2($item)); });
	}' unless defined(&_ngi_arg2);
	eval 'sub _ngi_node {
	    my($item,$file,$line) = @_;
    	    eval q({  &_ngi_check($item, $file, $line); ( &_NGI_NODE($item)); });
	}' unless defined(&_ngi_node);
	eval 'sub _ngi_hook {
	    my($item,$file,$line) = @_;
    	    eval q({  &_ngi_check($item, $file, $line); ( &_NGI_HOOK($item)); });
	}' unless defined(&_ngi_hook);
	eval 'sub NGI_M {
	    my($i) = @_;
    	    eval q((* &_ngi_m($i,  &_NN_)));
	}' unless defined(&NGI_M);
	eval 'sub NGI_MSG {
	    my($i) = @_;
    	    eval q((* &_ngi_msg($i,  &_NN_)));
	}' unless defined(&NGI_MSG);
	eval 'sub NGI_RETADDR {
	    my($i) = @_;
    	    eval q((* &_ngi_retaddr($i,  &_NN_)));
	}' unless defined(&NGI_RETADDR);
	eval 'sub NGI_FN {
	    my($i) = @_;
    	    eval q((* &_ngi_fn($i,  &_NN_)));
	}' unless defined(&NGI_FN);
	eval 'sub NGI_FN2 {
	    my($i) = @_;
    	    eval q((* &_ngi_fn2($i,  &_NN_)));
	}' unless defined(&NGI_FN2);
	eval 'sub NGI_ARG1 {
	    my($i) = @_;
    	    eval q((* &_ngi_arg1($i,  &_NN_)));
	}' unless defined(&NGI_ARG1);
	eval 'sub NGI_ARG2 {
	    my($i) = @_;
    	    eval q((* &_ngi_arg2($i,  &_NN_)));
	}' unless defined(&NGI_ARG2);
	eval 'sub NGI_HOOK {
	    my($i) = @_;
    	    eval q( &_ngi_hook($i,  &_NN_));
	}' unless defined(&NGI_HOOK);
	eval 'sub NGI_NODE {
	    my($i) = @_;
    	    eval q( &_ngi_node($i,  &_NN_));
	}' unless defined(&NGI_NODE);
	eval 'sub NGI_SET_HOOK {
	    my($i,$h) = @_;
    	    eval q( &do {  &_ngi_check($i,  &_NN_);  &_NGI_SET_HOOK($i, $h); }  &while (0));
	}' unless defined(&NGI_SET_HOOK);
	eval 'sub NGI_CLR_HOOK {
	    my($i) = @_;
    	    eval q( &do {  &_ngi_check($i,  &_NN_);  &_NGI_CLR_HOOK($i); }  &while (0));
	}' unless defined(&NGI_CLR_HOOK);
	eval 'sub NGI_SET_NODE {
	    my($i,$n) = @_;
    	    eval q( &do {  &_ngi_check($i,  &_NN_);  &_NGI_SET_NODE($i, $n); }  &while (0));
	}' unless defined(&NGI_SET_NODE);
	eval 'sub NGI_CLR_NODE {
	    my($i) = @_;
    	    eval q( &do {  &_ngi_check($i,  &_NN_);  &_NGI_CLR_NODE($i); }  &while (0));
	}' unless defined(&NGI_CLR_NODE);
	eval 'sub NG_FREE_ITEM {
	    my($item) = @_;
    	    eval q( &do {  &_ngi_check($item,  &_NN_);  &ng_free_item(($item)); }  &while (0));
	}' unless defined(&NG_FREE_ITEM);
	eval 'sub SAVE_LINE {
	    my($item) = @_;
    	    eval q( &do { ($item)-> &lastline =  &__LINE__; ($item)-> &lastfile =  &__FILE__; }  &while (0));
	}' unless defined(&SAVE_LINE);
    } else {
	eval 'sub NGI_M {
	    my($i) = @_;
    	    eval q( &_NGI_M($i));
	}' unless defined(&NGI_M);
	eval 'sub NGI_MSG {
	    my($i) = @_;
    	    eval q( &_NGI_MSG($i));
	}' unless defined(&NGI_MSG);
	eval 'sub NGI_RETADDR {
	    my($i) = @_;
    	    eval q( &_NGI_RETADDR($i));
	}' unless defined(&NGI_RETADDR);
	eval 'sub NGI_FN {
	    my($i) = @_;
    	    eval q( &_NGI_FN($i));
	}' unless defined(&NGI_FN);
	eval 'sub NGI_FN2 {
	    my($i) = @_;
    	    eval q( &_NGI_FN2($i));
	}' unless defined(&NGI_FN2);
	eval 'sub NGI_ARG1 {
	    my($i) = @_;
    	    eval q( &_NGI_ARG1($i));
	}' unless defined(&NGI_ARG1);
	eval 'sub NGI_ARG2 {
	    my($i) = @_;
    	    eval q( &_NGI_ARG2($i));
	}' unless defined(&NGI_ARG2);
	eval 'sub NGI_NODE {
	    my($i) = @_;
    	    eval q( &_NGI_NODE($i));
	}' unless defined(&NGI_NODE);
	eval 'sub NGI_HOOK {
	    my($i) = @_;
    	    eval q( &_NGI_HOOK($i));
	}' unless defined(&NGI_HOOK);
	eval 'sub NGI_SET_HOOK {
	    my($i,$h) = @_;
    	    eval q( &_NGI_SET_HOOK($i,$h));
	}' unless defined(&NGI_SET_HOOK);
	eval 'sub NGI_CLR_HOOK {
	    my($i) = @_;
    	    eval q( &_NGI_CLR_HOOK($i));
	}' unless defined(&NGI_CLR_HOOK);
	eval 'sub NGI_SET_NODE {
	    my($i,$n) = @_;
    	    eval q( &_NGI_SET_NODE($i,$n));
	}' unless defined(&NGI_SET_NODE);
	eval 'sub NGI_CLR_NODE {
	    my($i) = @_;
    	    eval q( &_NGI_CLR_NODE($i));
	}' unless defined(&NGI_CLR_NODE);
	eval 'sub NG_FREE_ITEM {
	    my($item) = @_;
    	    eval q( &ng_free_item(($item)));
	}' unless defined(&NG_FREE_ITEM);
	eval 'sub SAVE_LINE {
	    my($item) = @_;
    	    eval q( &do {}  &while (0));
	}' unless defined(&SAVE_LINE);
    }
    eval 'sub NGI_GET_M {
        my($i,$m) = @_;
	    eval q( &do { ($m) =  &NGI_M($i);  &_NGI_M($i) =  &NULL; }  &while (0));
    }' unless defined(&NGI_GET_M);
    eval 'sub NGI_GET_MSG {
        my($i,$m) = @_;
	    eval q( &do { ($m) =  &NGI_MSG($i);  &_NGI_MSG($i) =  &NULL; }  &while (0));
    }' unless defined(&NGI_GET_MSG);
    eval 'sub NGI_GET_NODE {
        my($i,$n) = @_;
	    eval q( &do { ($n) =  &NGI_NODE($i);  &_NGI_NODE($i) =  &NULL; }  &while (0));
    }' unless defined(&NGI_GET_NODE);
    eval 'sub NGI_GET_HOOK {
        my($i,$h) = @_;
	    eval q( &do { ($h) =  &NGI_HOOK($i);  &_NGI_HOOK($i) =  &NULL; }  &while (0));
    }' unless defined(&NGI_GET_HOOK);
    eval 'sub NGI_SET_WRITER {
        my($i) = @_;
	    eval q((($i)-> &el_flags &= ~ &NGQF_QMODE));
    }' unless defined(&NGI_SET_WRITER);
    eval 'sub NGI_SET_READER {
        my($i) = @_;
	    eval q((($i)-> &el_flags |=  &NGQF_QREADER));
    }' unless defined(&NGI_SET_READER);
    eval 'sub NGI_QUEUED_READER {
        my($i) = @_;
	    eval q((($i)-> &el_flags &  &NGQF_QREADER));
    }' unless defined(&NGI_QUEUED_READER);
    eval 'sub NGI_QUEUED_WRITER {
        my($i) = @_;
	    eval q(((($i)-> &el_flags &  &NGQF_QMODE) ==  &NGQF_QWRITER));
    }' unless defined(&NGI_QUEUED_WRITER);
    eval 'sub NG_FWD_ITEM_HOOK_FLAGS {
        my($error, $item, $hook, $flags) = @_;
	    eval q( &do { ($error) =  &ng_address_hook( &NULL, ($item), ($hook),  &NG_NOFLAGS);  &if ($error == 0) {  &SAVE_LINE($item); ($error) =  &ng_snd_item(($item), ($flags)); } ($item) =  &NULL; }  &while (0));
    }' unless defined(&NG_FWD_ITEM_HOOK_FLAGS);
    eval 'sub NG_FWD_ITEM_HOOK {
        my($error, $item, $hook) = @_;
	    eval q( &NG_FWD_ITEM_HOOK_FLAGS($error, $item, $hook,  &NG_NOFLAGS));
    }' unless defined(&NG_FWD_ITEM_HOOK);
    eval 'sub NG_FWD_NEW_DATA_FLAGS {
        my($error, $item, $hook, $m, $flags) = @_;
	    eval q( &do {  &NGI_M($item) = ($m); ($m) =  &NULL;  &NG_FWD_ITEM_HOOK_FLAGS($error, $item, $hook, $flags); }  &while (0));
    }' unless defined(&NG_FWD_NEW_DATA_FLAGS);
    eval 'sub NG_FWD_NEW_DATA {
        my($error, $item, $hook, $m) = @_;
	    eval q( &NG_FWD_NEW_DATA_FLAGS($error, $item, $hook, $m,  &NG_NOFLAGS));
    }' unless defined(&NG_FWD_NEW_DATA);
    eval 'sub NG_SEND_DATA_FLAGS {
        my($error, $hook, $m, $flags) = @_;
	    eval q( &do {  &item_p  &_item;  &if (( &_item =  &ng_package_data(($m), $flags))) {  &NG_FWD_ITEM_HOOK_FLAGS($error,  &_item, $hook, $flags); }  &else { ($error) =  &ENOMEM; } ($m) =  &NULL; }  &while (0));
    }' unless defined(&NG_SEND_DATA_FLAGS);
    eval 'sub NG_SEND_DATA_ONLY {
        my($error, $hook, $m) = @_;
	    eval q( &NG_SEND_DATA_FLAGS($error, $hook, $m,  &NG_NOFLAGS));
    }' unless defined(&NG_SEND_DATA_ONLY);
    eval 'sub NG_SEND_DATA {
        my($error, $hook, $m, $x) = @_;
	    eval q( &NG_SEND_DATA_FLAGS($error, $hook, $m,  &NG_NOFLAGS));
    }' unless defined(&NG_SEND_DATA);
    eval 'sub NG_FREE_MSG {
        my($msg) = @_;
	    eval q( &do {  &if (($msg)) {  &free(($msg),  &M_NETGRAPH_MSG); ($msg) =  &NULL; } }  &while (0));
    }' unless defined(&NG_FREE_MSG);
    eval 'sub NG_FREE_M {
        my($m) = @_;
	    eval q( &do {  &if (($m)) {  &m_freem(($m)); ($m) =  &NULL; } }  &while (0));
    }' unless defined(&NG_FREE_M);
    eval 'sub NG_SEND_MSG_HOOK {
        my($error, $here, $msg, $hook, $retaddr) = @_;
	    eval q( &do {  &item_p  &_item;  &if (( &_item =  &ng_package_msg($msg,  &NG_NOFLAGS)) ==  &NULL) { ($msg) =  &NULL; ($error) =  &ENOMEM;  &break; }  &if ((($error) =  &ng_address_hook(($here), ( &_item), ($hook), ($retaddr))) == 0) {  &SAVE_LINE( &_item); ($error) =  &ng_snd_item(( &_item), 0); } ($msg) =  &NULL; }  &while (0));
    }' unless defined(&NG_SEND_MSG_HOOK);
    eval 'sub NG_SEND_MSG_PATH {
        my($error, $here, $msg, $path, $retaddr) = @_;
	    eval q( &do {  &item_p  &_item;  &if (( &_item =  &ng_package_msg($msg,  &NG_NOFLAGS)) ==  &NULL) { ($msg) =  &NULL; ($error) =  &ENOMEM;  &break; }  &if ((($error) =  &ng_address_path(($here), ( &_item), ($path), ($retaddr))) == 0) {  &SAVE_LINE( &_item); ($error) =  &ng_snd_item(( &_item), 0); } ($msg) =  &NULL; }  &while (0));
    }' unless defined(&NG_SEND_MSG_PATH);
    eval 'sub NG_SEND_MSG_ID {
        my($error, $here, $msg, $ID, $retaddr) = @_;
	    eval q( &do {  &item_p  &_item;  &if (( &_item =  &ng_package_msg($msg,  &NG_NOFLAGS)) ==  &NULL) { ($msg) =  &NULL; ($error) =  &ENOMEM;  &break; }  &if ((($error) =  &ng_address_ID(($here), ( &_item), ($ID), ($retaddr))) == 0) {  &SAVE_LINE( &_item); ($error) =  &ng_snd_item(( &_item), 0); } ($msg) =  &NULL; }  &while (0));
    }' unless defined(&NG_SEND_MSG_ID);
    eval 'sub NG_FWD_MSG_HOOK {
        my($error, $here, $item, $hook, $retaddr) = @_;
	    eval q( &do {  &if ((($error) =  &ng_address_hook(($here), ($item), ($hook), ($retaddr))) == 0) {  &SAVE_LINE($item); ($error) =  &ng_snd_item(($item), 0); } ($item) =  &NULL; }  &while (0));
    }' unless defined(&NG_FWD_MSG_HOOK);
    eval 'sub NG_RESPOND_MSG {
        my($error, $here, $item, $resp) = @_;
	    eval q( &do {  &if ($resp) {  &ng_ID_t  &_dest =  &NGI_RETADDR($item);  &NGI_RETADDR($item) = 0;  &NGI_MSG($item) = $resp;  &if (($error =  &ng_address_ID(($here), ($item),  &_dest, 0)) == 0) {  &SAVE_LINE($item); ($error) =  &ng_snd_item(($item),  &NG_QUEUE); } }  &else  &NG_FREE_ITEM($item); ($item) =  &NULL; }  &while (0));
    }' unless defined(&NG_RESPOND_MSG);
    eval 'sub NETGRAPH_INIT_ORDERED {
        my($typename, $typestructp, $sub, $order) = @_;
	    eval q( &static  &moduledata_t  &ng_$typename &_mod = { \\"ng_\\" $typename,  &ng_mod_event, ($typestructp) };  &DECLARE_MODULE( &ng_$typename,  &ng_$typename &_mod, $sub, $order);  &MODULE_DEPEND( &ng_$typename,  &netgraph,  &NG_ABI_VERSION,  &NG_ABI_VERSION,  &NG_ABI_VERSION));
    }' unless defined(&NETGRAPH_INIT_ORDERED);
    eval 'sub NETGRAPH_INIT {
        my($tn, $tp) = @_;
	    eval q( &NETGRAPH_INIT_ORDERED($tn, $tp,  &SI_SUB_PSEUDO,  &SI_ORDER_MIDDLE));
    }' unless defined(&NETGRAPH_INIT);
    if(defined(&SYSCTL_DECL)) {
    }
    eval 'sub ng_callout_init {
        my($c) = @_;
	    eval q( &callout_init($c, 1));
    }' unless defined(&ng_callout_init);
    eval 'sub NG_NOFLAGS () {0x;}' unless defined(&NG_NOFLAGS);
    eval 'sub NG_QUEUE () {0x1;}' unless defined(&NG_QUEUE);
    eval 'sub NG_WAITOK () {0x2;}' unless defined(&NG_WAITOK);
    eval 'sub NG_PROGRESS () {0x4;}' unless defined(&NG_PROGRESS);
    eval 'sub NG_REUSE_ITEM () {0x8;}' unless defined(&NG_REUSE_ITEM);
    eval 'sub NG_TAG_PRIO () {1;}' unless defined(&NG_TAG_PRIO);
    eval 'sub NG_PRIO_CUTOFF () {32;}' unless defined(&NG_PRIO_CUTOFF);
    eval 'sub NG_PRIO_LINKSTATE () {64;}' unless defined(&NG_PRIO_LINKSTATE);
    eval 'sub _NGI_META {
        my($i) = @_;
	    eval q( &NULL);
    }' unless defined(&_NGI_META);
    eval 'sub NGI_META {
        my($i) = @_;
	    eval q( &NULL);
    }' unless defined(&NGI_META);
    eval 'sub NG_FREE_META {
        my($meta) = @_;
	    eval q();
    }' unless defined(&NG_FREE_META);
    eval 'sub NGI_GET_META {
        my($i,$m) = @_;
	    eval q();
    }' unless defined(&NGI_GET_META);
    eval 'sub ng_copy_meta {
        my($meta) = @_;
	    eval q( &NULL);
    }' unless defined(&ng_copy_meta);
    eval 'sub NG_OUTBOUND_THREAD_REF () {
        eval q( ($curthread->{td_ng_outbound})++);
    }' unless defined(&NG_OUTBOUND_THREAD_REF);
    eval 'sub NG_OUTBOUND_THREAD_UNREF () {
        eval q( &do {  ($curthread->{td_ng_outbound})--;  &KASSERT( ($curthread->{td_ng_outbound}) >= 0, (\\"%s: negative td_ng_outbound\\",  &__func__)); }  &while (0));
    }' unless defined(&NG_OUTBOUND_THREAD_UNREF);
}
1;
