require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NETINET_IGMP_VAR_H_)) {
    eval 'sub _NETINET_IGMP_VAR_H_ () {1;}' unless defined(&_NETINET_IGMP_VAR_H_);
    eval 'sub IGPS_VERSION_3 () {3;}' unless defined(&IGPS_VERSION_3);
    eval 'sub IGPS_VERSION3_LEN () {168;}' unless defined(&IGPS_VERSION3_LEN);
    if(defined(&CTASSERT)) {
    }
    eval 'sub IGMPCTL_STATS () {1;}' unless defined(&IGMPCTL_STATS);
    eval 'sub IGMP_RANDOM_DELAY {
        my($X) = @_;
	    eval q(( &random() % ($X) + 1));
    }' unless defined(&IGMP_RANDOM_DELAY);
    eval 'sub IGMP_MAX_STATE_CHANGES () {24;}' unless defined(&IGMP_MAX_STATE_CHANGES);
    eval 'sub IGMP_NOT_MEMBER () {0;}' unless defined(&IGMP_NOT_MEMBER);
    eval 'sub IGMP_SILENT_MEMBER () {1;}' unless defined(&IGMP_SILENT_MEMBER);
    eval 'sub IGMP_REPORTING_MEMBER () {2;}' unless defined(&IGMP_REPORTING_MEMBER);
    eval 'sub IGMP_IDLE_MEMBER () {3;}' unless defined(&IGMP_IDLE_MEMBER);
    eval 'sub IGMP_LAZY_MEMBER () {4;}' unless defined(&IGMP_LAZY_MEMBER);
    eval 'sub IGMP_SLEEPING_MEMBER () {5;}' unless defined(&IGMP_SLEEPING_MEMBER);
    eval 'sub IGMP_AWAKENING_MEMBER () {6;}' unless defined(&IGMP_AWAKENING_MEMBER);
    eval 'sub IGMP_G_QUERY_PENDING_MEMBER () {7;}' unless defined(&IGMP_G_QUERY_PENDING_MEMBER);
    eval 'sub IGMP_SG_QUERY_PENDING_MEMBER () {8;}' unless defined(&IGMP_SG_QUERY_PENDING_MEMBER);
    eval 'sub IGMP_LEAVING_MEMBER () {9;}' unless defined(&IGMP_LEAVING_MEMBER);
    eval 'sub IGMP_VERSION_NONE () {0;}' unless defined(&IGMP_VERSION_NONE);
    eval 'sub IGMP_VERSION_1 () {1;}' unless defined(&IGMP_VERSION_1);
    eval 'sub IGMP_VERSION_2 () {2;}' unless defined(&IGMP_VERSION_2);
    eval 'sub IGMP_VERSION_3 () {3;}' unless defined(&IGMP_VERSION_3);
    eval 'sub IGMP_RV_INIT () {2;}' unless defined(&IGMP_RV_INIT);
    eval 'sub IGMP_RV_MIN () {1;}' unless defined(&IGMP_RV_MIN);
    eval 'sub IGMP_RV_MAX () {7;}' unless defined(&IGMP_RV_MAX);
    eval 'sub IGMP_QI_INIT () {125;}' unless defined(&IGMP_QI_INIT);
    eval 'sub IGMP_QI_MIN () {1;}' unless defined(&IGMP_QI_MIN);
    eval 'sub IGMP_QI_MAX () {255;}' unless defined(&IGMP_QI_MAX);
    eval 'sub IGMP_QRI_INIT () {10;}' unless defined(&IGMP_QRI_INIT);
    eval 'sub IGMP_QRI_MIN () {1;}' unless defined(&IGMP_QRI_MIN);
    eval 'sub IGMP_QRI_MAX () {255;}' unless defined(&IGMP_QRI_MAX);
    eval 'sub IGMP_URI_INIT () {3;}' unless defined(&IGMP_URI_INIT);
    eval 'sub IGMP_URI_MIN () {0;}' unless defined(&IGMP_URI_MIN);
    eval 'sub IGMP_URI_MAX () {10;}' unless defined(&IGMP_URI_MAX);
    eval 'sub IGMP_MAX_G_GS_PACKETS () {8;}' unless defined(&IGMP_MAX_G_GS_PACKETS);
    eval 'sub IGMP_MAX_STATE_CHANGE_PACKETS () {8;}' unless defined(&IGMP_MAX_STATE_CHANGE_PACKETS);
    eval 'sub IGMP_MAX_RESPONSE_PACKETS () {16;}' unless defined(&IGMP_MAX_RESPONSE_PACKETS);
    eval 'sub IGMP_MAX_RESPONSE_BURST () {4;}' unless defined(&IGMP_MAX_RESPONSE_BURST);
    eval 'sub IGMP_RESPONSE_BURST_INTERVAL () {( &PR_FASTHZ / 2);}' unless defined(&IGMP_RESPONSE_BURST_INTERVAL);
    eval 'sub M_IGMPV2 () { &M_PROTO1;}' unless defined(&M_IGMPV2);
    eval 'sub M_IGMPV3_HDR () { &M_PROTO2;}' unless defined(&M_IGMPV3_HDR);
    eval 'sub M_GROUPREC () { &M_PROTO3;}' unless defined(&M_GROUPREC);
    eval 'sub M_IGMP_LOOP () { &M_PROTO4;}' unless defined(&M_IGMP_LOOP);
    eval 'sub RAOPT_LEN () {4;}' unless defined(&RAOPT_LEN);
    eval 'sub IGMP_LEADINGSPACE () {($sizeof{\'struct ip\'} +  &RAOPT_LEN + $sizeof{\'struct igmp_report\'});}' unless defined(&IGMP_LEADINGSPACE);
    eval 'sub IGIF_SILENT () {0x1;}' unless defined(&IGIF_SILENT);
    eval 'sub IGIF_LOOPBACK () {0x2;}' unless defined(&IGIF_LOOPBACK);
    if(defined(&_KERNEL)) {
	eval 'sub IGMPSTAT_ADD {
	    my($name, $val) = @_;
    	    eval q( ($V_igmpstat->{name}) += ($val));
	}' unless defined(&IGMPSTAT_ADD);
	eval 'sub IGMPSTAT_INC {
	    my($name) = @_;
    	    eval q( &IGMPSTAT_ADD($name, 1));
	}' unless defined(&IGMPSTAT_INC);
	eval 'sub IGMP_LOCK_INIT () {
	    eval q( &mtx_init( &igmp_mtx, \\"igmp_mtx\\",  &NULL,  &MTX_DEF));
	}' unless defined(&IGMP_LOCK_INIT);
	eval 'sub IGMP_LOCK_DESTROY () {
	    eval q( &mtx_destroy( &igmp_mtx));
	}' unless defined(&IGMP_LOCK_DESTROY);
	eval 'sub IGMP_LOCK () {
	    eval q( &mtx_lock( &igmp_mtx));
	}' unless defined(&IGMP_LOCK);
	eval 'sub IGMP_LOCK_ASSERT () {
	    eval q( &mtx_assert( &igmp_mtx,  &MA_OWNED));
	}' unless defined(&IGMP_LOCK_ASSERT);
	eval 'sub IGMP_UNLOCK () {
	    eval q( &mtx_unlock( &igmp_mtx));
	}' unless defined(&IGMP_UNLOCK);
	eval 'sub IGMP_UNLOCK_ASSERT () {
	    eval q( &mtx_assert( &igmp_mtx,  &MA_NOTOWNED));
	}' unless defined(&IGMP_UNLOCK_ASSERT);
    }
}
1;
