require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NETINET_IN_VAR_H_)) {
    eval 'sub _NETINET_IN_VAR_H_ () {1;}' unless defined(&_NETINET_IN_VAR_H_);
    eval 'sub ifra_dstaddr () { &ifra_broadaddr;}' unless defined(&ifra_dstaddr);
    if(defined(&_KERNEL)) {
	require 'sys/queue.ph';
	require 'sys/fnv_hash.ph';
	require 'sys/tree.ph';
	eval 'sub ia_ifp () { ($ia_ifa->{ifa_ifp});}' unless defined(&ia_ifp);
	eval 'sub ia_flags () { ($ia_ifa->{ifa_flags});}' unless defined(&ia_flags);
	eval 'sub ia_broadaddr () { &ia_dstaddr;}' unless defined(&ia_broadaddr);
	eval 'sub IA_SIN {
	    my($ia) = @_;
    	    eval q((((($ia))-> &ia_addr)));
	}' unless defined(&IA_SIN);
	eval 'sub IA_DSTSIN {
	    my($ia) = @_;
    	    eval q((((($ia))-> &ia_dstaddr)));
	}' unless defined(&IA_DSTSIN);
	eval 'sub IA_MASKSIN {
	    my($ia) = @_;
    	    eval q((((($ia))-> &ia_sockmask)));
	}' unless defined(&IA_MASKSIN);
	eval 'sub IN_LNAOF {
	    my($in, $ifa) = @_;
    	    eval q((( &ntohl(($in). &s_addr) & ~(($ifa)-> &ia_subnetmask)));
	}' unless defined(&IN_LNAOF);
	eval 'sub LLTABLE {
	    my($ifp) = @_;
    	    eval q((($ifp)-> $if_afdata[ &AF_INET])-> &ii_llt);
	}' unless defined(&LLTABLE);
	eval 'sub V_in_ifaddrhashtbl () { &VNET( &in_ifaddrhashtbl);}' unless defined(&V_in_ifaddrhashtbl);
	eval 'sub V_in_ifaddrhead () { &VNET( &in_ifaddrhead);}' unless defined(&V_in_ifaddrhead);
	eval 'sub V_in_ifaddrhmask () { &VNET( &in_ifaddrhmask);}' unless defined(&V_in_ifaddrhmask);
	eval 'sub INADDR_NHASH_LOG2 () {9;}' unless defined(&INADDR_NHASH_LOG2);
	eval 'sub INADDR_NHASH () {(1<<  &INADDR_NHASH_LOG2);}' unless defined(&INADDR_NHASH);
	eval 'sub INADDR_HASHVAL {
	    my($x) = @_;
    	    eval q( &fnv_32_buf((($x)), $sizeof{$x},  &FNV1_32_INIT));
	}' unless defined(&INADDR_HASHVAL);
	eval 'sub INADDR_HASH {
	    my($x) = @_;
    	    eval q(( $V_in_ifaddrhashtbl[ &INADDR_HASHVAL($x) &  &V_in_ifaddrhmask]));
	}' unless defined(&INADDR_HASH);
	eval 'sub IN_IFADDR_LOCK_ASSERT () {
	    eval q( &rm_assert( &in_ifaddr_lock,  &RA_LOCKED));
	}' unless defined(&IN_IFADDR_LOCK_ASSERT);
	eval 'sub IN_IFADDR_RLOCK {
	    my($t) = @_;
    	    eval q( &rm_rlock( &in_ifaddr_lock, ($t)));
	}' unless defined(&IN_IFADDR_RLOCK);
	eval 'sub IN_IFADDR_RLOCK_ASSERT () {
	    eval q( &rm_assert( &in_ifaddr_lock,  &RA_RLOCKED));
	}' unless defined(&IN_IFADDR_RLOCK_ASSERT);
	eval 'sub IN_IFADDR_RUNLOCK {
	    my($t) = @_;
    	    eval q( &rm_runlock( &in_ifaddr_lock, ($t)));
	}' unless defined(&IN_IFADDR_RUNLOCK);
	eval 'sub IN_IFADDR_WLOCK () {
	    eval q( &rm_wlock( &in_ifaddr_lock));
	}' unless defined(&IN_IFADDR_WLOCK);
	eval 'sub IN_IFADDR_WLOCK_ASSERT () {
	    eval q( &rm_assert( &in_ifaddr_lock,  &RA_WLOCKED));
	}' unless defined(&IN_IFADDR_WLOCK_ASSERT);
	eval 'sub IN_IFADDR_WUNLOCK () {
	    eval q( &rm_wunlock( &in_ifaddr_lock));
	}' unless defined(&IN_IFADDR_WUNLOCK);
	eval 'sub INADDR_TO_IFADDR {
	    my($addr, $ia) = @_;
    	    eval q( &do {  &LIST_FOREACH($ia,  &INADDR_HASH(($addr). &s_addr),  &ia_hash)  &if ( &IA_SIN($ia)-> ($sin_addr->{s_addr}) == ($addr). &s_addr)  &break; }  &while (0));
	}' unless defined(&INADDR_TO_IFADDR);
	eval 'sub INADDR_TO_IFP {
	    my($addr, $ifp) = @_;
    	    eval q({ \'struct in_ifaddr\' * &ia;  &INADDR_TO_IFADDR($addr,  &ia); ($ifp) = ( &ia ==  &NULL) ?  &NULL :  ($ia->{ia_ifp}); });
	}' unless defined(&INADDR_TO_IFP);
	eval 'sub IFP_TO_IA {
	    my($ifp, $ia, $t) = @_;
    	    eval q( &do {  &IN_IFADDR_RLOCK(($t));  &for (($ia) =  &TAILQ_FIRST( &V_in_ifaddrhead); ($ia) !=  &NULL  && ($ia)-> &ia_ifp != ($ifp); ($ia) =  &TAILQ_NEXT(($ia),  &ia_link))  &continue;  &if (($ia) !=  &NULL)  &ifa_ref(($ia)-> &ia_ifa);  &IN_IFADDR_RUNLOCK(($t)); }  &while (0));
	}' unless defined(&IFP_TO_IA);
	eval 'sub ip_msource_cmp {
	    my($a,$b) = @_;
    	    eval q({  &if ( ($a->{ims_haddr}) <  ($b->{ims_haddr})) (-1);  &if ( ($a->{ims_haddr}) ==  ($b->{ims_haddr})) (0); (1); });
	}' unless defined(&ip_msource_cmp);
	if(defined(&SYSCTL_DECL)) {
	}
	eval 'sub IN_MULTI_LOCK () {
	    eval q( &mtx_lock( &in_multi_mtx));
	}' unless defined(&IN_MULTI_LOCK);
	eval 'sub IN_MULTI_UNLOCK () {
	    eval q( &mtx_unlock( &in_multi_mtx));
	}' unless defined(&IN_MULTI_UNLOCK);
	eval 'sub IN_MULTI_LOCK_ASSERT () {
	    eval q( &mtx_assert( &in_multi_mtx,  &MA_OWNED));
	}' unless defined(&IN_MULTI_LOCK_ASSERT);
	eval 'sub IN_MULTI_UNLOCK_ASSERT () {
	    eval q( &mtx_assert( &in_multi_mtx,  &MA_NOTOWNED));
	}' unless defined(&IN_MULTI_UNLOCK_ASSERT);
	eval 'sub MCAST_PASS () {0;}' unless defined(&MCAST_PASS);
	eval 'sub MCAST_NOTGMEMBER () {1;}' unless defined(&MCAST_NOTGMEMBER);
	eval 'sub MCAST_NOTSMEMBER () {2;}' unless defined(&MCAST_NOTSMEMBER);
	eval 'sub MCAST_MUTED () {3;}' unless defined(&MCAST_MUTED);
    }
    require 'netinet6/in6_var.ph';
}
1;
