require '_h2ph_pre.ph';

no warnings qw(redefine misc);

require 'sys/cdefs.ph';
unless(defined(&_NETINET_SCTP_OS_BSD_H_)) {
    eval 'sub _NETINET_SCTP_OS_BSD_H_ () {1;}' unless defined(&_NETINET_SCTP_OS_BSD_H_);
    require './netinet/opt_compat.ph';
    require './netinet/opt_inet6.ph';
    require './netinet/opt_inet.ph';
    require './netinet/opt_sctp.ph';
    require 'sys/param.ph';
    require 'sys/ktr.ph';
    require 'sys/systm.ph';
    require 'sys/malloc.ph';
    require 'sys/kernel.ph';
    require 'sys/sysctl.ph';
    require 'sys/mbuf.ph';
    require 'sys/protosw.ph';
    require 'sys/socket.ph';
    require 'sys/socketvar.ph';
    require 'sys/jail.ph';
    require 'sys/sysctl.ph';
    require 'sys/resourcevar.ph';
    require 'sys/uio.ph';
    require 'sys/lock.ph';
    require 'sys/rwlock.ph';
    require 'sys/kthread.ph';
    require 'sys/priv.ph';
    require 'sys/random.ph';
    require 'sys/limits.ph';
    require 'sys/queue.ph';
    require 'machine/cpu.ph';
    require 'net/if.ph';
    require 'net/if_types.ph';
    require 'net/if_var.ph';
    require 'net/route.ph';
    require 'net/vnet.ph';
    require 'netinet/in.ph';
    require 'netinet/in_systm.ph';
    require 'netinet/ip.ph';
    require 'netinet/in_pcb.ph';
    require 'netinet/in_var.ph';
    require 'netinet/ip_var.ph';
    require 'netinet/ip_icmp.ph';
    require 'netinet/icmp_var.ph';
    if(defined(&INET6)) {
	require 'sys/domain.ph';
	require 'netinet/ip6.ph';
	require 'netinet6/ip6_var.ph';
	require 'netinet6/in6_pcb.ph';
	require 'netinet6/ip6protosw.ph';
	require 'netinet6/nd6.ph';
	require 'netinet6/scope6_var.ph';
    }
    require 'netinet/ip_options.ph';
    require 'crypto/sha1.ph';
    require 'crypto/sha2/sha256.ph';
    unless(defined(&in6pcb)) {
	eval 'sub in6pcb () { &inpcb;}' unless defined(&in6pcb);
    }
    if(defined(&SCTP_LOCAL_TRACE_BUF)) {
	eval 'sub SCTP_GET_CYCLECOUNT () { &get_cyclecount();}' unless defined(&SCTP_GET_CYCLECOUNT);
	eval 'sub SCTP_CTR6 () { &sctp_log_trace;}' unless defined(&SCTP_CTR6);
    } else {
	eval 'sub SCTP_CTR6 () { &CTR6;}' unless defined(&SCTP_CTR6);
    }
    eval 'sub MODULE_GLOBAL {
        my($__SYMBOL) = @_;
	    eval q( &V_$__SYMBOL);
    }' unless defined(&MODULE_GLOBAL);
    eval 'sub V_system_base_info () { &VNET( &system_base_info);}' unless defined(&V_system_base_info);
    eval 'sub SCTP_BASE_INFO {
        my($__m) = @_;
	    eval q( ($V_system_base_info->{sctppcbinfo}->{__m}));
    }' unless defined(&SCTP_BASE_INFO);
    eval 'sub SCTP_BASE_STATS () { ($V_system_base_info->{sctpstat});}' unless defined(&SCTP_BASE_STATS);
    eval 'sub SCTP_BASE_STAT {
        my($__m) = @_;
	    eval q( ($V_system_base_info->{sctpstat}->{__m}));
    }' unless defined(&SCTP_BASE_STAT);
    eval 'sub SCTP_BASE_SYSCTL {
        my($__m) = @_;
	    eval q( ($V_system_base_info->{sctpsysctl}->{__m}));
    }' unless defined(&SCTP_BASE_SYSCTL);
    eval 'sub SCTP_BASE_VAR {
        my($__m) = @_;
	    eval q( ($V_system_base_info->{__m}));
    }' unless defined(&SCTP_BASE_VAR);
    eval 'sub SCTP_PRINTF () {( &params...)  &printf( &params);}' unless defined(&SCTP_PRINTF);
    if(defined(&SCTP_DEBUG)) {
	eval 'sub SCTPDBG () {( &level,  &params...) {  &do {  &if ( &SCTP_BASE_SYSCTL( &sctp_debug_on) &  &level ) {  &SCTP_PRINTF( &params); } }  &while (0); };}' unless defined(&SCTPDBG);
	eval 'sub SCTPDBG_ADDR {
	    my($level, $addr) = @_;
    	    eval q({  &do {  &if ( &SCTP_BASE_SYSCTL( &sctp_debug_on) & $level ) {  &sctp_print_address($addr); } }  &while (0); });
	}' unless defined(&SCTPDBG_ADDR);
    } else {
	eval 'sub SCTPDBG () {( &level,  &params...);}' unless defined(&SCTPDBG);
	eval 'sub SCTPDBG_ADDR {
	    my($level, $addr) = @_;
    	    eval q();
	}' unless defined(&SCTPDBG_ADDR);
    }
    if(defined(&SCTP_LTRACE_CHUNKS)) {
	eval 'sub SCTP_LTRACE_CHK {
	    my($a, $b, $c, $d) = @_;
    	    eval q( &if( &SCTP_BASE_SYSCTL( &sctp_logging_level) &  &SCTP_LTRACE_CHUNK_ENABLE)  &SCTP_CTR6( &KTR_SUBSYS, \\"SCTP:%d[%d]:%x-%x-%x-%x\\",  &SCTP_LOG_CHUNK_PROC, 0, $a, $b, $c, $d));
	}' unless defined(&SCTP_LTRACE_CHK);
    } else {
	eval 'sub SCTP_LTRACE_CHK {
	    my($a, $b, $c, $d) = @_;
    	    eval q();
	}' unless defined(&SCTP_LTRACE_CHK);
    }
    if(defined(&SCTP_LTRACE_ERRORS)) {
	eval 'sub SCTP_LTRACE_ERR_RET_PKT {
	    my($m, $inp, $stcb, $net, $file, $err) = @_;
    	    eval q( &if ( &SCTP_BASE_SYSCTL( &sctp_logging_level) &  &SCTP_LTRACE_ERROR_ENABLE)  &SCTP_PRINTF(\\"mbuf:%p inp:%p stcb:%p net:%p file:%x line:%d error:%d\\\\n\\", $m, $inp, $stcb, $net, $file,  &__LINE__, $err););
	}' unless defined(&SCTP_LTRACE_ERR_RET_PKT);
	eval 'sub SCTP_LTRACE_ERR_RET {
	    my($inp, $stcb, $net, $file, $err) = @_;
    	    eval q( &if ( &SCTP_BASE_SYSCTL( &sctp_logging_level) &  &SCTP_LTRACE_ERROR_ENABLE)  &SCTP_PRINTF(\\"inp:%p stcb:%p net:%p file:%x line:%d error:%d\\\\n\\", $inp, $stcb, $net, $file,  &__LINE__, $err););
	}' unless defined(&SCTP_LTRACE_ERR_RET);
    } else {
	eval 'sub SCTP_LTRACE_ERR_RET_PKT {
	    my($m, $inp, $stcb, $net, $file, $err) = @_;
    	    eval q();
	}' unless defined(&SCTP_LTRACE_ERR_RET_PKT);
	eval 'sub SCTP_LTRACE_ERR_RET {
	    my($inp, $stcb, $net, $file, $err) = @_;
    	    eval q();
	}' unless defined(&SCTP_LTRACE_ERR_RET);
    }
    eval 'sub SCTP_MAX_VRF_ID () {0;}' unless defined(&SCTP_MAX_VRF_ID);
    eval 'sub SCTP_SIZE_OF_VRF_HASH () {3;}' unless defined(&SCTP_SIZE_OF_VRF_HASH);
    eval 'sub SCTP_IFNAMSIZ () { &IFNAMSIZ;}' unless defined(&SCTP_IFNAMSIZ);
    eval 'sub SCTP_DEFAULT_VRFID () {0;}' unless defined(&SCTP_DEFAULT_VRFID);
    eval 'sub SCTP_VRF_ADDR_HASH_SIZE () {16;}' unless defined(&SCTP_VRF_ADDR_HASH_SIZE);
    eval 'sub SCTP_VRF_IFN_HASH_SIZE () {3;}' unless defined(&SCTP_VRF_IFN_HASH_SIZE);
    eval 'sub SCTP_INIT_VRF_TABLEID {
        my($vrf) = @_;
	    eval q();
    }' unless defined(&SCTP_INIT_VRF_TABLEID);
    eval 'sub SCTP_IFN_IS_IFT_LOOP {
        my($ifn) = @_;
	    eval q((($ifn)-> &ifn_type ==  &IFT_LOOP));
    }' unless defined(&SCTP_IFN_IS_IFT_LOOP);
    eval 'sub SCTP_ROUTE_IS_REAL_LOOP {
        my($ro) = @_;
	    eval q((($ro)-> &ro_rt  && ($ro)-> ($ro_rt->{rt_ifa})  && ($ro)-> ($ro_rt->{rt_ifa}->{ifa_ifp})  && ($ro)-> ($ro_rt->{rt_ifa}->{ifa_ifp}->{if_type}) ==  &IFT_LOOP));
    }' unless defined(&SCTP_ROUTE_IS_REAL_LOOP);
    eval 'sub SCTP_GET_IFN_VOID_FROM_ROUTE {
        my($ro) = @_;
	    eval q(( &void *) ($ro->{ro_rt}->{rt_ifp}));
    }' unless defined(&SCTP_GET_IFN_VOID_FROM_ROUTE);
    eval 'sub SCTP_GET_IF_INDEX_FROM_ROUTE {
        my($ro) = @_;
	    eval q(($ro)-> ($ro_rt->{rt_ifp}->{if_index}));
    }' unless defined(&SCTP_GET_IF_INDEX_FROM_ROUTE);
    eval 'sub SCTP_ROUTE_HAS_VALID_IFN {
        my($ro) = @_;
	    eval q((($ro)-> &ro_rt  && ($ro)-> ($ro_rt->{rt_ifp})));
    }' unless defined(&SCTP_ROUTE_HAS_VALID_IFN);
    eval 'sub SCTP_MALLOC {
        my($var, $type, $size, $name) = @_;
	    eval q( &do { $var = ($type) &malloc($size, $name,  &M_NOWAIT); }  &while (0));
    }' unless defined(&SCTP_MALLOC);
    eval 'sub SCTP_FREE {
        my($var, $type) = @_;
	    eval q( &free($var, $type));
    }' unless defined(&SCTP_FREE);
    eval 'sub SCTP_MALLOC_SONAME {
        my($var, $type, $size) = @_;
	    eval q( &do { $var = ($type) &malloc($size,  &M_SONAME,  &M_WAITOK |  &M_ZERO); }  &while (0));
    }' unless defined(&SCTP_MALLOC_SONAME);
    eval 'sub SCTP_FREE_SONAME {
        my($var) = @_;
	    eval q( &free($var,  &M_SONAME));
    }' unless defined(&SCTP_FREE_SONAME);
    eval 'sub SCTP_PROCESS_STRUCT () {\'struct proc\' *;}' unless defined(&SCTP_PROCESS_STRUCT);
    require 'vm/uma.ph';
    eval 'sub SCTP_ZONE_INIT {
        my($zone, $name, $size, $number) = @_;
	    eval q({ $zone =  &uma_zcreate($name, $size,  &NULL,  &NULL,  &NULL,  &NULL,  &UMA_ALIGN_PTR, 0);  &uma_zone_set_max($zone, $number); });
    }' unless defined(&SCTP_ZONE_INIT);
    eval 'sub SCTP_ZONE_DESTROY {
        my($zone) = @_;
	    eval q( &uma_zdestroy($zone));
    }' unless defined(&SCTP_ZONE_DESTROY);
    eval 'sub SCTP_ZONE_GET {
        my($zone, $type) = @_;
	    eval q(($type *) &uma_zalloc($zone,  &M_NOWAIT););
    }' unless defined(&SCTP_ZONE_GET);
    eval 'sub SCTP_ZONE_FREE {
        my($zone, $element) = @_;
	    eval q( &uma_zfree($zone, $element););
    }' unless defined(&SCTP_ZONE_FREE);
    eval 'sub SCTP_HASH_INIT {
        my($size, $hashmark) = @_;
	    eval q( &hashinit_flags($size,  &M_PCB, $hashmark,  &HASH_NOWAIT));
    }' unless defined(&SCTP_HASH_INIT);
    eval 'sub SCTP_HASH_FREE {
        my($table, $hashmark) = @_;
	    eval q( &hashdestroy($table,  &M_PCB, $hashmark));
    }' unless defined(&SCTP_HASH_FREE);
    eval 'sub SCTP_M_COPYM () { &m_copym;}' unless defined(&SCTP_M_COPYM);
    require 'sys/callout.ph';
    eval 'sub SCTP_OS_TIMER_INIT {
        my($tmr) = @_;
	    eval q( &callout_init($tmr, 1));
    }' unless defined(&SCTP_OS_TIMER_INIT);
    eval 'sub SCTP_OS_TIMER_START () { &callout_reset;}' unless defined(&SCTP_OS_TIMER_START);
    eval 'sub SCTP_OS_TIMER_STOP () { &callout_stop;}' unless defined(&SCTP_OS_TIMER_STOP);
    eval 'sub SCTP_OS_TIMER_STOP_DRAIN () { &callout_drain;}' unless defined(&SCTP_OS_TIMER_STOP_DRAIN);
    eval 'sub SCTP_OS_TIMER_PENDING () { &callout_pending;}' unless defined(&SCTP_OS_TIMER_PENDING);
    eval 'sub SCTP_OS_TIMER_ACTIVE () { &callout_active;}' unless defined(&SCTP_OS_TIMER_ACTIVE);
    eval 'sub SCTP_OS_TIMER_DEACTIVATE () { &callout_deactivate;}' unless defined(&SCTP_OS_TIMER_DEACTIVATE);
    eval 'sub sctp_get_tick_count () {
        eval q(( &ticks));
    }' unless defined(&sctp_get_tick_count);
    eval 'sub SCTP_UNUSED () { &__attribute__(( &unused));}' unless defined(&SCTP_UNUSED);
    eval 'sub SCTP_BUF_LEN {
        my($m) = @_;
	    eval q(( ($m->{m_len})));
    }' unless defined(&SCTP_BUF_LEN);
    eval 'sub SCTP_BUF_NEXT {
        my($m) = @_;
	    eval q(( ($m->{m_next})));
    }' unless defined(&SCTP_BUF_NEXT);
    eval 'sub SCTP_BUF_NEXT_PKT {
        my($m) = @_;
	    eval q(( ($m->{m_nextpkt})));
    }' unless defined(&SCTP_BUF_NEXT_PKT);
    eval 'sub SCTP_BUF_RESV_UF {
        my($m, $size) = @_;
	    eval q( ($m->{m_data}) += $size);
    }' unless defined(&SCTP_BUF_RESV_UF);
    eval 'sub SCTP_BUF_AT {
        my($m, $size) = @_;
	    eval q( ($m->{m_data}) + $size);
    }' unless defined(&SCTP_BUF_AT);
    eval 'sub SCTP_BUF_IS_EXTENDED {
        my($m) = @_;
	    eval q(( ($m->{m_flags}) &  &M_EXT));
    }' unless defined(&SCTP_BUF_IS_EXTENDED);
    eval 'sub SCTP_BUF_SIZE () { &M_SIZE;}' unless defined(&SCTP_BUF_SIZE);
    eval 'sub SCTP_BUF_TYPE {
        my($m) = @_;
	    eval q(( ($m->{m_type})));
    }' unless defined(&SCTP_BUF_TYPE);
    eval 'sub SCTP_BUF_RECVIF {
        my($m) = @_;
	    eval q(( ($m->{m_pkthdr}->{rcvif})));
    }' unless defined(&SCTP_BUF_RECVIF);
    eval 'sub SCTP_BUF_PREPEND () { &M_PREPEND;}' unless defined(&SCTP_BUF_PREPEND);
    eval 'sub SCTP_ALIGN_TO_END {
        my($m, $len) = @_;
	    eval q( &M_ALIGN($m, $len));
    }' unless defined(&SCTP_ALIGN_TO_END);
    eval 'sub SCTP_PKTLOG_WRITERS_NEED_LOCK () {3;}' unless defined(&SCTP_PKTLOG_WRITERS_NEED_LOCK);
    eval 'sub SCTP_GATHER_MTU_FROM_IFN_INFO {
        my($ifn, $ifn_index, $af) = @_;
	    eval q(($ifn)-> &if_mtu);
    }' unless defined(&SCTP_GATHER_MTU_FROM_IFN_INFO);
    eval 'sub SCTP_GATHER_MTU_FROM_ROUTE {
        my($sctp_ifa, $sa, $rt) = @_;
	    eval q((( &uint32_t)(($rt !=  &NULL) ?  ($rt->{rt_mtu}) : 0)));
    }' unless defined(&SCTP_GATHER_MTU_FROM_ROUTE);
    eval 'sub SCTP_GATHER_MTU_FROM_INTFC {
        my($sctp_ifn) = @_;
	    eval q((( ($sctp_ifn->{ifn_p}) !=  &NULL) ? (( ($sctp_ifn->{ifn_p})))-> &if_mtu : 0));
    }' unless defined(&SCTP_GATHER_MTU_FROM_INTFC);
    eval 'sub SCTP_SET_MTU_OF_ROUTE {
        my($sa, $rt, $mtu) = @_;
	    eval q( &do {  &if ($rt !=  &NULL)  ($rt->{rt_mtu}) = $mtu; }  &while(0));
    }' unless defined(&SCTP_SET_MTU_OF_ROUTE);
    eval 'sub SCTP_REGISTER_INTERFACE {
        my($ifhandle, $af) = @_;
	    eval q();
    }' unless defined(&SCTP_REGISTER_INTERFACE);
    eval 'sub SCTP_DEREGISTER_INTERFACE {
        my($ifhandle, $af) = @_;
	    eval q();
    }' unless defined(&SCTP_DEREGISTER_INTERFACE);
    eval 'sub SCTP_BUF_EXTEND_BASE {
        my($m) = @_;
	    eval q(( ($m->{m_ext}->{ext_buf})));
    }' unless defined(&SCTP_BUF_EXTEND_BASE);
    eval 'sub SCTP_BUF_EXTEND_REFCNT {
        my($m) = @_;
	    eval q((* ($m->{m_ext}->{ext_cnt})));
    }' unless defined(&SCTP_BUF_EXTEND_REFCNT);
    eval 'sub SCTP_BUF_GET_FLAGS {
        my($m) = @_;
	    eval q(( ($m->{m_flags})));
    }' unless defined(&SCTP_BUF_GET_FLAGS);
    eval 'sub SCTP_HEADER_TO_CHAIN {
        my($m) = @_;
	    eval q(($m));
    }' unless defined(&SCTP_HEADER_TO_CHAIN);
    eval 'sub SCTP_DETACH_HEADER_FROM_CHAIN {
        my($m) = @_;
	    eval q();
    }' unless defined(&SCTP_DETACH_HEADER_FROM_CHAIN);
    eval 'sub SCTP_HEADER_LEN {
        my($m) = @_;
	    eval q((($m)-> ($m_pkthdr->{len})));
    }' unless defined(&SCTP_HEADER_LEN);
    eval 'sub SCTP_GET_HEADER_FOR_OUTPUT {
        my($o_pak) = @_;
	    eval q(0);
    }' unless defined(&SCTP_GET_HEADER_FOR_OUTPUT);
    eval 'sub SCTP_RELEASE_HEADER {
        my($m) = @_;
	    eval q();
    }' unless defined(&SCTP_RELEASE_HEADER);
    eval 'sub SCTP_RELEASE_PKT {
        my($m) = @_;
	    eval q( &sctp_m_freem($m));
    }' unless defined(&SCTP_RELEASE_PKT);
    eval 'sub SCTP_ENABLE_UDP_CSUM {
        my($m) = @_;
	    eval q( &do {  ($m->{m_pkthdr}->{csum_flags}) =  &CSUM_UDP;  ($m->{m_pkthdr}->{csum_data}) =  &offsetof(\'struct udphdr\',  &uh_sum); }  &while (0));
    }' unless defined(&SCTP_ENABLE_UDP_CSUM);
    eval 'sub SCTP_GET_PKT_VRFID {
        my($m, $vrf_id) = @_;
	    eval q((($vrf_id =  &SCTP_DEFAULT_VRFID) !=  &SCTP_DEFAULT_VRFID));
    }' unless defined(&SCTP_GET_PKT_VRFID);
    eval 'sub SCTP_ATTACH_CHAIN {
        my($pak, $m, $packet_length) = @_;
	    eval q( &do { $pak = $m;  ($pak->{m_pkthdr}->{len}) = $packet_length; }  &while(0));
    }' unless defined(&SCTP_ATTACH_CHAIN);
    eval 'sub SCTP_IS_IT_BROADCAST {
        my($dst, $m) = @_;
	    eval q((( ($m->{m_flags}) &  &M_PKTHDR) ?  &in_broadcast($dst,  ($m->{m_pkthdr}->{rcvif})) : 0));
    }' unless defined(&SCTP_IS_IT_BROADCAST);
    eval 'sub SCTP_IS_IT_LOOPBACK {
        my($m) = @_;
	    eval q((( ($m->{m_flags}) &  &M_PKTHDR)  && (( ($m->{m_pkthdr}->{rcvif}) ==  &NULL) || ( ($m->{m_pkthdr}->{rcvif}->{if_type}) ==  &IFT_LOOP))));
    }' unless defined(&SCTP_IS_IT_LOOPBACK);
    eval 'sub SCTP_GET_HLIM {
        my($inp, $ro) = @_;
	    eval q( &in6_selecthlim( ($inp->{ip_inp}->{inp}), ($ro ? ( ($ro->{ro_rt}) ? ( ($ro->{ro_rt}->{rt_ifp})) : ( &NULL)) : ( &NULL))););
    }' unless defined(&SCTP_GET_HLIM);
    eval 'sub SCTP_IPV6_V6ONLY {
        my($inp) = @_;
	    eval q((($inp)-> &inp_flags &  &IN6P_IPV6_V6ONLY));
    }' unless defined(&SCTP_IPV6_V6ONLY);
    eval 'sub SCTP_SO_IS_NBIO {
        my($so) = @_;
	    eval q((($so)-> &so_state &  &SS_NBIO));
    }' unless defined(&SCTP_SO_IS_NBIO);
    eval 'sub SCTP_SET_SO_NBIO {
        my($so) = @_;
	    eval q((($so)-> &so_state |=  &SS_NBIO));
    }' unless defined(&SCTP_SET_SO_NBIO);
    eval 'sub SCTP_CLEAR_SO_NBIO {
        my($so) = @_;
	    eval q((($so)-> &so_state &= ~ &SS_NBIO));
    }' unless defined(&SCTP_CLEAR_SO_NBIO);
    eval 'sub SCTP_SO_TYPE {
        my($so) = @_;
	    eval q((($so)-> &so_type));
    }' unless defined(&SCTP_SO_TYPE);
    eval 'sub sb_cc () { &sb_acc;}' unless defined(&sb_cc);
    eval 'sub SCTP_SORESERVE {
        my($so, $send, $recv) = @_;
	    eval q( &soreserve($so, $send, $recv));
    }' unless defined(&SCTP_SORESERVE);
    eval 'sub SCTP_SOWAKEUP {
        my($so) = @_;
	    eval q( &wakeup(($so)-> &so_timeo));
    }' unless defined(&SCTP_SOWAKEUP);
    eval 'sub SCTP_SB_CLEAR {
        my($sb) = @_;
	    eval q(($sb). &sb_cc = 0; ($sb). &sb_mb =  &NULL; ($sb). &sb_mbcnt = 0;);
    }' unless defined(&SCTP_SB_CLEAR);
    eval 'sub SCTP_SB_LIMIT_RCV {
        my($so) = @_;
	    eval q( ($so->{so_rcv}->{sb_hiwat}));
    }' unless defined(&SCTP_SB_LIMIT_RCV);
    eval 'sub SCTP_SB_LIMIT_SND {
        my($so) = @_;
	    eval q( ($so->{so_snd}->{sb_hiwat}));
    }' unless defined(&SCTP_SB_LIMIT_SND);
    eval 'sub SCTP_RTALLOC {
        my($ro, $vrf_id, $fibnum) = @_;
	    eval q( &rtalloc_ign_fib($ro, 0, $fibnum));
    }' unless defined(&SCTP_RTALLOC);
    eval 'sub M_NOTIFICATION () { &M_PROTO1;}' unless defined(&M_NOTIFICATION);
    eval 'sub SCTP_IP_OUTPUT {
        my($result, $o_pak, $ro, $stcb, $vrf_id) = @_;
	    eval q({ \'int\'  &o_flgs =  &IP_RAWOUTPUT; \'struct sctp_tcb\' * &local_stcb = $stcb;  &if ( &local_stcb  &&  ($local_stcb->{sctp_ep})  &&  ($local_stcb->{sctp_ep}->{sctp_socket}))  &o_flgs |=  ($local_stcb->{sctp_ep}->{sctp_socket}->{so_options}) &  &SO_DONTROUTE;  &m_clrprotoflags($o_pak); $result =  &ip_output($o_pak,  &NULL, $ro,  &o_flgs, 0,  &NULL); });
    }' unless defined(&SCTP_IP_OUTPUT);
    eval 'sub SCTP_IP6_OUTPUT {
        my($result, $o_pak, $ro, $ifp, $stcb, $vrf_id) = @_;
	    eval q({ \'struct sctp_tcb\' * &local_stcb = $stcb;  &m_clrprotoflags($o_pak);  &if ( &local_stcb  &&  ($local_stcb->{sctp_ep})) $result =  &ip6_output($o_pak, (( ($local_stcb->{sctp_ep})))-> &in6p_outputopts, ($ro), 0, 0, $ifp,  &NULL);  &else $result =  &ip6_output($o_pak,  &NULL, ($ro), 0, 0, $ifp,  &NULL); });
    }' unless defined(&SCTP_IP6_OUTPUT);
    eval 'sub SCTP_READ_RANDOM {
        my($buf, $len) = @_;
	    eval q( &read_random($buf, $len));
    }' unless defined(&SCTP_READ_RANDOM);
    eval 'sub SCTP_SHA1_CTX () { &SHA1_CTX;}' unless defined(&SCTP_SHA1_CTX);
    eval 'sub SCTP_SHA1_INIT () { &SHA1Init;}' unless defined(&SCTP_SHA1_INIT);
    eval 'sub SCTP_SHA1_UPDATE () { &SHA1Update;}' unless defined(&SCTP_SHA1_UPDATE);
    eval 'sub SCTP_SHA1_FINAL {
        my($x,$y) = @_;
	    eval q( &SHA1Final($x, $y));
    }' unless defined(&SCTP_SHA1_FINAL);
    eval 'sub SCTP_SHA256_CTX () { &SHA256_CTX;}' unless defined(&SCTP_SHA256_CTX);
    eval 'sub SCTP_SHA256_INIT () { &SHA256_Init;}' unless defined(&SCTP_SHA256_INIT);
    eval 'sub SCTP_SHA256_UPDATE () { &SHA256_Update;}' unless defined(&SCTP_SHA256_UPDATE);
    eval 'sub SCTP_SHA256_FINAL {
        my($x,$y) = @_;
	    eval q( &SHA256_Final($x, $y));
    }' unless defined(&SCTP_SHA256_FINAL);
}
unless(defined(&SCTP_DECREMENT_AND_CHECK_REFCOUNT)) {
    sub SCTP_DECREMENT_AND_CHECK_REFCOUNT {
	my($addr) = @_;
	eval q(( &atomic_fetchadd_int($addr, -1) == 1));
    }
}
if(defined(&INVARIANTS)) {
    eval 'sub SCTP_SAVE_ATOMIC_DECREMENT {
        my($addr, $val) = @_;
	    eval q({  &int32_t  &oldval;  &oldval =  &atomic_fetchadd_int($addr, -$val);  &if ( &oldval < $val) {  &panic(\\"Counter goes negative\\"); } });
    }' unless defined(&SCTP_SAVE_ATOMIC_DECREMENT);
} else {
    eval 'sub SCTP_SAVE_ATOMIC_DECREMENT {
        my($addr, $val) = @_;
	    eval q({  &int32_t  &oldval;  &oldval =  &atomic_fetchadd_int($addr, -$val);  &if ( &oldval < $val) { *$addr = 0; } });
    }' unless defined(&SCTP_SAVE_ATOMIC_DECREMENT);
}
1;
