require '_h2ph_pre.ph';

no warnings qw(redefine misc);

require 'sys/cdefs.ph';
unless(defined(&_NETINET_SCTP_VAR_H_)) {
    eval 'sub _NETINET_SCTP_VAR_H_ () {1;}' unless defined(&_NETINET_SCTP_VAR_H_);
    require 'netinet/sctp_uio.ph';
    if(defined(&_KERNEL) || defined(&__Userspace__)) {
	eval 'sub sctp_feature_on {
	    my($inp, $feature) = @_;
    	    eval q(( ($inp->{sctp_features}) |= $feature));
	}' unless defined(&sctp_feature_on);
	eval 'sub sctp_feature_off {
	    my($inp, $feature) = @_;
    	    eval q(( ($inp->{sctp_features}) &= ~$feature));
	}' unless defined(&sctp_feature_off);
	eval 'sub sctp_is_feature_on {
	    my($inp, $feature) = @_;
    	    eval q((( ($inp->{sctp_features}) & $feature) == $feature));
	}' unless defined(&sctp_is_feature_on);
	eval 'sub sctp_is_feature_off {
	    my($inp, $feature) = @_;
    	    eval q((( ($inp->{sctp_features}) & $feature) == 0));
	}' unless defined(&sctp_is_feature_off);
	eval 'sub sctp_stcb_feature_on {
	    my($inp, $stcb, $feature) = @_;
    	    eval q({  &if ($stcb) {  ($stcb->{asoc}->{sctp_features}) |= $feature; }  &else  &if ($inp) {  ($inp->{sctp_features}) |= $feature; } });
	}' unless defined(&sctp_stcb_feature_on);
	eval 'sub sctp_stcb_feature_off {
	    my($inp, $stcb, $feature) = @_;
    	    eval q({  &if ($stcb) {  ($stcb->{asoc}->{sctp_features}) &= ~$feature; }  &else  &if ($inp) {  ($inp->{sctp_features}) &= ~$feature; } });
	}' unless defined(&sctp_stcb_feature_off);
	eval 'sub sctp_stcb_is_feature_on {
	    my($inp, $stcb, $feature) = @_;
    	    eval q(((($stcb !=  &NULL)  && (( ($stcb->{asoc}->{sctp_features}) & $feature) == $feature)) || (($stcb ==  &NULL)  && ($inp !=  &NULL)  && (( ($inp->{sctp_features}) & $feature) == $feature))));
	}' unless defined(&sctp_stcb_is_feature_on);
	eval 'sub sctp_stcb_is_feature_off {
	    my($inp, $stcb, $feature) = @_;
    	    eval q(((($stcb !=  &NULL)  && (( ($stcb->{asoc}->{sctp_features}) & $feature) == 0)) || (($stcb ==  &NULL)  && ($inp !=  &NULL)  && (( ($inp->{sctp_features}) & $feature) == 0)) || (($stcb ==  &NULL)  && ($inp ==  &NULL))));
	}' unless defined(&sctp_stcb_is_feature_off);
	eval 'sub sctp_mobility_feature_on {
	    my($inp, $feature) = @_;
    	    eval q(( ($inp->{sctp_mobility_features}) |= $feature));
	}' unless defined(&sctp_mobility_feature_on);
	eval 'sub sctp_mobility_feature_off {
	    my($inp, $feature) = @_;
    	    eval q(( ($inp->{sctp_mobility_features}) &= ~$feature));
	}' unless defined(&sctp_mobility_feature_off);
	eval 'sub sctp_is_mobility_feature_on {
	    my($inp, $feature) = @_;
    	    eval q(( ($inp->{sctp_mobility_features}) & $feature));
	}' unless defined(&sctp_is_mobility_feature_on);
	eval 'sub sctp_is_mobility_feature_off {
	    my($inp, $feature) = @_;
    	    eval q((( ($inp->{sctp_mobility_features}) & $feature) == 0));
	}' unless defined(&sctp_is_mobility_feature_off);
	eval 'sub sctp_maxspace {
	    my($sb) = @_;
    	    eval q(( &max(($sb)-> &sb_hiwat, &SCTP_MINIMAL_RWND)));
	}' unless defined(&sctp_maxspace);
	eval 'sub sctp_sbspace {
	    my($asoc, $sb) = @_;
    	    eval q(( (( &sctp_maxspace($sb) > ($asoc)-> &sb_cc) ? ( &sctp_maxspace($sb) - ($asoc)-> &sb_cc) : 0)));
	}' unless defined(&sctp_sbspace);
	eval 'sub sctp_sbspace_failedmsgs {
	    my($sb) = @_;
    	    eval q(( (( &sctp_maxspace($sb) > ($sb)-> &sb_cc) ? ( &sctp_maxspace($sb) - ($sb)-> &sb_cc) : 0)));
	}' unless defined(&sctp_sbspace_failedmsgs);
	eval 'sub sctp_sbspace_sub {
	    my($a,$b) = @_;
    	    eval q(((($a) > ($b)) ? (($a) - ($b)) : 0));
	}' unless defined(&sctp_sbspace_sub);
	if(defined(&INVARIANTS)) {
	    eval 'sub sctp_free_a_readq {
	        my($_stcb, $_readq) = @_;
    		eval q({  &if (($_readq)-> &on_strm_q)  &panic(\\"On strm q stcb:%p readq:%p\\", ($_stcb), ($_readq));  &SCTP_ZONE_FREE( &SCTP_BASE_INFO( &ipi_zone_readq), ($_readq));  &SCTP_DECR_READQ_COUNT(); });
	    }' unless defined(&sctp_free_a_readq);
	} else {
	    eval 'sub sctp_free_a_readq {
	        my($_stcb, $_readq) = @_;
    		eval q({  &SCTP_ZONE_FREE( &SCTP_BASE_INFO( &ipi_zone_readq), ($_readq));  &SCTP_DECR_READQ_COUNT(); });
	    }' unless defined(&sctp_free_a_readq);
	}
	eval 'sub sctp_alloc_a_readq {
	    my($_stcb, $_readq) = @_;
    	    eval q({ ($_readq) =  &SCTP_ZONE_GET( &SCTP_BASE_INFO( &ipi_zone_readq), \'struct sctp_queued_to_read\');  &if (($_readq)) {  &SCTP_INCR_READQ_COUNT(); } });
	}' unless defined(&sctp_alloc_a_readq);
	eval 'sub sctp_free_a_strmoq {
	    my($_stcb, $_strmoq, $_so_locked) = @_;
    	    eval q({  &if (($_strmoq)-> &holds_key_ref) {  &sctp_auth_key_release( &stcb,  ($sp->{auth_keyid}), $_so_locked); ($_strmoq)-> &holds_key_ref = 0; }  &SCTP_ZONE_FREE( &SCTP_BASE_INFO( &ipi_zone_strmoq), ($_strmoq));  &SCTP_DECR_STRMOQ_COUNT(); });
	}' unless defined(&sctp_free_a_strmoq);
	eval 'sub sctp_alloc_a_strmoq {
	    my($_stcb, $_strmoq) = @_;
    	    eval q({ ($_strmoq) =  &SCTP_ZONE_GET( &SCTP_BASE_INFO( &ipi_zone_strmoq), \'struct sctp_stream_queue_pending\');  &if (($_strmoq)) {  &memset($_strmoq, 0, $sizeof{\'struct sctp_stream_queue_pending\'});  &SCTP_INCR_STRMOQ_COUNT(); ($_strmoq)-> &holds_key_ref = 0; } });
	}' unless defined(&sctp_alloc_a_strmoq);
	eval 'sub sctp_free_a_chunk {
	    my($_stcb, $_chk, $_so_locked) = @_;
    	    eval q({  &if (($_chk)-> &holds_key_ref) {  &sctp_auth_key_release(($_stcb), ($_chk)-> &auth_keyid, $_so_locked); ($_chk)-> &holds_key_ref = 0; }  &if ($_stcb) {  &SCTP_TCB_LOCK_ASSERT(($_stcb));  &if (($_chk)-> &whoTo) {  &sctp_free_remote_addr(($_chk)-> &whoTo); ($_chk)-> &whoTo =  &NULL; }  &if ((($_stcb)-> ($asoc->{free_chunk_cnt}) >  &SCTP_BASE_SYSCTL( &sctp_asoc_free_resc_limit)) || ( &SCTP_BASE_INFO( &ipi_free_chunks) >  &SCTP_BASE_SYSCTL( &sctp_system_free_resc_limit))) {  &SCTP_ZONE_FREE( &SCTP_BASE_INFO( &ipi_zone_chunk), ($_chk));  &SCTP_DECR_CHK_COUNT(); }  &else {  &TAILQ_INSERT_TAIL(($_stcb)-> ($asoc->{free_chunks}), ($_chk),  &sctp_next); ($_stcb)-> ($asoc->{free_chunk_cnt})++;  &atomic_add_int( &SCTP_BASE_INFO( &ipi_free_chunks), 1); } }  &else {  &SCTP_ZONE_FREE( &SCTP_BASE_INFO( &ipi_zone_chunk), ($_chk));  &SCTP_DECR_CHK_COUNT(); } });
	}' unless defined(&sctp_free_a_chunk);
	eval 'sub sctp_alloc_a_chunk {
	    my($_stcb, $_chk) = @_;
    	    eval q({  &if ( &TAILQ_EMPTY(($_stcb)-> ($asoc->{free_chunks}))) { ($_chk) =  &SCTP_ZONE_GET( &SCTP_BASE_INFO( &ipi_zone_chunk), \'struct sctp_tmit_chunk\');  &if (($_chk)) {  &SCTP_INCR_CHK_COUNT(); ($_chk)-> &whoTo =  &NULL; ($_chk)-> &holds_key_ref = 0; } }  &else { ($_chk) =  &TAILQ_FIRST(($_stcb)-> ($asoc->{free_chunks}));  &TAILQ_REMOVE(($_stcb)-> ($asoc->{free_chunks}), ($_chk),  &sctp_next);  &atomic_subtract_int( &SCTP_BASE_INFO( &ipi_free_chunks), 1); ($_chk)-> &holds_key_ref = 0;  &SCTP_STAT_INCR( &sctps_cached_chk); ($_stcb)-> ($asoc->{free_chunk_cnt})--; } });
	}' unless defined(&sctp_alloc_a_chunk);
	eval 'sub sctp_free_remote_addr {
	    my($__net) = @_;
    	    eval q({  &if (($__net)) {  &if ( &SCTP_DECREMENT_AND_CHECK_REFCOUNT(($__net)-> &ref_count)) { ( &void) &SCTP_OS_TIMER_STOP(($__net)-> ($rxt_timer->{timer})); ( &void) &SCTP_OS_TIMER_STOP(($__net)-> ($pmtu_timer->{timer})); ( &void) &SCTP_OS_TIMER_STOP(($__net)-> ($hb_timer->{timer}));  &if (($__net)-> ($ro->{ro_rt})) {  &RTFREE(($__net)-> ($ro->{ro_rt})); ($__net)-> ($ro->{ro_rt}) =  &NULL; }  &if (($__net)-> &src_addr_selected) {  &sctp_free_ifa(($__net)-> ($ro->{_s_addr})); ($__net)-> ($ro->{_s_addr}) =  &NULL; } ($__net)-> &src_addr_selected = 0; ($__net)-> &dest_state &= ~ &SCTP_ADDR_REACHABLE;  &SCTP_ZONE_FREE( &SCTP_BASE_INFO( &ipi_zone_net), ($__net));  &SCTP_DECR_RADDR_COUNT(); } } });
	}' unless defined(&sctp_free_remote_addr);
	eval 'sub sctp_sbfree {
	    my($ctl, $stcb, $sb, $m) = @_;
    	    eval q({  &SCTP_SAVE_ATOMIC_DECREMENT(($sb)-> &sb_cc,  &SCTP_BUF_LEN(($m)));  &SCTP_SAVE_ATOMIC_DECREMENT(($sb)-> &sb_mbcnt,  &MSIZE);  &if ((($ctl)-> &do_not_ref_stcb == 0)  && $stcb) {  &SCTP_SAVE_ATOMIC_DECREMENT(($stcb)-> ($asoc->{sb_cc}),  &SCTP_BUF_LEN(($m)));  &SCTP_SAVE_ATOMIC_DECREMENT(($stcb)-> ($asoc->{my_rwnd_control_len}),  &MSIZE); }  &if ( &SCTP_BUF_TYPE($m) !=  &MT_DATA  &&  &SCTP_BUF_TYPE($m) !=  &MT_HEADER  &&  &SCTP_BUF_TYPE($m) !=  &MT_OOBDATA)  &atomic_subtract_int(($sb)-> &sb_ctl, &SCTP_BUF_LEN(($m))); });
	}' unless defined(&sctp_sbfree);
	eval 'sub sctp_sballoc {
	    my($stcb, $sb, $m) = @_;
    	    eval q({  &atomic_add_int(($sb)-> &sb_cc, &SCTP_BUF_LEN(($m)));  &atomic_add_int(($sb)-> &sb_mbcnt,  &MSIZE);  &if ($stcb) {  &atomic_add_int(($stcb)-> ($asoc->{sb_cc}),  &SCTP_BUF_LEN(($m)));  &atomic_add_int(($stcb)-> ($asoc->{my_rwnd_control_len}),  &MSIZE); }  &if ( &SCTP_BUF_TYPE($m) !=  &MT_DATA  &&  &SCTP_BUF_TYPE($m) !=  &MT_HEADER  &&  &SCTP_BUF_TYPE($m) !=  &MT_OOBDATA)  &atomic_add_int(($sb)-> &sb_ctl, &SCTP_BUF_LEN(($m))); });
	}' unless defined(&sctp_sballoc);
	eval 'sub sctp_ucount_incr {
	    my($val) = @_;
    	    eval q({ $val++; });
	}' unless defined(&sctp_ucount_incr);
	eval 'sub sctp_ucount_decr {
	    my($val) = @_;
    	    eval q({  &if ($val > 0) { $val--; }  &else { $val = 0; } });
	}' unless defined(&sctp_ucount_decr);
	eval 'sub sctp_mbuf_crush {
	    my($data) = @_;
    	    eval q( &do { \'struct mbuf\' * &_m;  &_m = ($data);  &while ( &_m  && ( &SCTP_BUF_LEN( &_m) == 0)) { ($data) =  &SCTP_BUF_NEXT( &_m);  &SCTP_BUF_NEXT( &_m) =  &NULL;  &sctp_m_free( &_m);  &_m = ($data); } }  &while (0));
	}' unless defined(&sctp_mbuf_crush);
	eval 'sub sctp_flight_size_decrease {
	    my($tp1) = @_;
    	    eval q( &do {  &if ( ($tp1->{whoTo}->{flight_size}) >=  ($tp1->{book_size}))  ($tp1->{whoTo}->{flight_size}) -=  ($tp1->{book_size});  &else  ($tp1->{whoTo}->{flight_size}) = 0; }  &while (0));
	}' unless defined(&sctp_flight_size_decrease);
	eval 'sub sctp_flight_size_increase {
	    my($tp1) = @_;
    	    eval q( &do { ($tp1)-> ($whoTo->{flight_size}) += ($tp1)-> &book_size; }  &while (0));
	}' unless defined(&sctp_flight_size_increase);
	if(defined(&SCTP_FS_SPEC_LOG)) {
	    eval 'sub sctp_total_flight_decrease {
	        my($stcb, $tp1) = @_;
    		eval q( &do {  &if ( ($stcb->{asoc}->{fs_index}) >  &SCTP_FS_SPEC_LOG_SIZE)  ($stcb->{asoc}->{fs_index}) = 0;  ($stcb->{asoc}->{fslog[$stcb}->{asoc}->{fs_index]}->{total_flight}) =  ($stcb->{asoc}->{total_flight});  ($stcb->{asoc}->{fslog[$stcb}->{asoc}->{fs_index]}->{tsn}) =  ($tp1->{rec}->{data}->{tsn});  ($stcb->{asoc}->{fslog[$stcb}->{asoc}->{fs_index]}->{book}) =  ($tp1->{book_size});  ($stcb->{asoc}->{fslog[$stcb}->{asoc}->{fs_index]}->{sent}) =  ($tp1->{sent});  ($stcb->{asoc}->{fslog[$stcb}->{asoc}->{fs_index]}->{incr}) = 0;  ($stcb->{asoc}->{fslog[$stcb}->{asoc}->{fs_index]}->{decr}) = 1;  ($stcb->{asoc}->{fs_index})++;  ($tp1->{window_probe}) = 0;  &if ( ($stcb->{asoc}->{total_flight}) >=  ($tp1->{book_size})) {  ($stcb->{asoc}->{total_flight}) -=  ($tp1->{book_size});  &if ( ($stcb->{asoc}->{total_flight_count}) > 0)  ($stcb->{asoc}->{total_flight_count})--; }  &else {  ($stcb->{asoc}->{total_flight}) = 0;  ($stcb->{asoc}->{total_flight_count}) = 0; } }  &while (0));
	    }' unless defined(&sctp_total_flight_decrease);
	    eval 'sub sctp_total_flight_increase {
	        my($stcb, $tp1) = @_;
    		eval q( &do {  &if ( ($stcb->{asoc}->{fs_index}) >  &SCTP_FS_SPEC_LOG_SIZE)  ($stcb->{asoc}->{fs_index}) = 0;  ($stcb->{asoc}->{fslog[$stcb}->{asoc}->{fs_index]}->{total_flight}) =  ($stcb->{asoc}->{total_flight});  ($stcb->{asoc}->{fslog[$stcb}->{asoc}->{fs_index]}->{tsn}) =  ($tp1->{rec}->{data}->{tsn});  ($stcb->{asoc}->{fslog[$stcb}->{asoc}->{fs_index]}->{book}) =  ($tp1->{book_size});  ($stcb->{asoc}->{fslog[$stcb}->{asoc}->{fs_index]}->{sent}) =  ($tp1->{sent});  ($stcb->{asoc}->{fslog[$stcb}->{asoc}->{fs_index]}->{incr}) = 1;  ($stcb->{asoc}->{fslog[$stcb}->{asoc}->{fs_index]}->{decr}) = 0;  ($stcb->{asoc}->{fs_index})++; ($stcb)-> ($asoc->{total_flight_count})++; ($stcb)-> ($asoc->{total_flight}) += ($tp1)-> &book_size; }  &while (0));
	    }' unless defined(&sctp_total_flight_increase);
	} else {
	    eval 'sub sctp_total_flight_decrease {
	        my($stcb, $tp1) = @_;
    		eval q( &do {  ($tp1->{window_probe}) = 0;  &if ( ($stcb->{asoc}->{total_flight}) >=  ($tp1->{book_size})) {  ($stcb->{asoc}->{total_flight}) -=  ($tp1->{book_size});  &if ( ($stcb->{asoc}->{total_flight_count}) > 0)  ($stcb->{asoc}->{total_flight_count})--; }  &else {  ($stcb->{asoc}->{total_flight}) = 0;  ($stcb->{asoc}->{total_flight_count}) = 0; } }  &while (0));
	    }' unless defined(&sctp_total_flight_decrease);
	    eval 'sub sctp_total_flight_increase {
	        my($stcb, $tp1) = @_;
    		eval q( &do { ($stcb)-> ($asoc->{total_flight_count})++; ($stcb)-> ($asoc->{total_flight}) += ($tp1)-> &book_size; }  &while (0));
	    }' unless defined(&sctp_total_flight_increase);
	}
	eval 'sub SCTP_PF_ENABLED {
	    my($_net) = @_;
    	    eval q(( ($_net->{pf_threshold}) <  ($_net->{failure_threshold})));
	}' unless defined(&SCTP_PF_ENABLED);
	eval 'sub SCTP_NET_IS_PF {
	    my($_net) = @_;
    	    eval q(( ($_net->{pf_threshold}) <  ($_net->{error_count})));
	}' unless defined(&SCTP_NET_IS_PF);
	if(defined(&INET)) {
	}
    }
}
1;
