require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NETIPSEC_IPSEC_H_)) {
    eval 'sub _NETIPSEC_IPSEC_H_ () {1;}' unless defined(&_NETIPSEC_IPSEC_H_);
    if(defined(&_KERNEL)  && !defined(&_LKM)  && !defined(&KLD_MODULE)) {
	require './netipsec/opt_inet.ph';
	require './netipsec/opt_ipsec.ph';
    }
    require 'net/pfkeyv2.ph';
    require 'netipsec/keydb.ph';
    if(defined(&_KERNEL)) {
	require 'sys/_lock.ph';
	require 'sys/_mutex.ph';
	require 'sys/_rwlock.ph';
	eval 'sub IPSEC_ASSERT {
	    my($_c,$_m) = @_;
    	    eval q( &KASSERT($_c, $_m));
	}' unless defined(&IPSEC_ASSERT);
	eval 'sub IPSEC_MAXREQ () {4;}' unless defined(&IPSEC_MAXREQ);
	eval 'sub IPSEC_SPSTATE_DEAD () {0;}' unless defined(&IPSEC_SPSTATE_DEAD);
	eval 'sub IPSEC_SPSTATE_LARVAL () {1;}' unless defined(&IPSEC_SPSTATE_LARVAL);
	eval 'sub IPSEC_SPSTATE_ALIVE () {2;}' unless defined(&IPSEC_SPSTATE_ALIVE);
	eval 'sub IPSEC_SPSTATE_PCB () {3;}' unless defined(&IPSEC_SPSTATE_PCB);
	eval 'sub IPSEC_SPSTATE_IFNET () {4;}' unless defined(&IPSEC_SPSTATE_IFNET);
	eval 'sub INP_INBOUND_POLICY () {0x1;}' unless defined(&INP_INBOUND_POLICY);
	eval 'sub INP_OUTBOUND_POLICY () {0x2;}' unless defined(&INP_OUTBOUND_POLICY);
    }
    eval 'sub IPSEC_ADDRSTRLEN () {( &INET6_ADDRSTRLEN + 11);}' unless defined(&IPSEC_ADDRSTRLEN);
    eval 'sub IPSEC_PORT_ANY () {0;}' unless defined(&IPSEC_PORT_ANY);
    eval 'sub IPSEC_ULPROTO_ANY () {255;}' unless defined(&IPSEC_ULPROTO_ANY);
    eval 'sub IPSEC_PROTO_ANY () {255;}' unless defined(&IPSEC_PROTO_ANY);
    eval 'sub IPSEC_MODE_ANY () {0;}' unless defined(&IPSEC_MODE_ANY);
    eval 'sub IPSEC_MODE_TRANSPORT () {1;}' unless defined(&IPSEC_MODE_TRANSPORT);
    eval 'sub IPSEC_MODE_TUNNEL () {2;}' unless defined(&IPSEC_MODE_TUNNEL);
    eval 'sub IPSEC_MODE_TCPMD5 () {3;}' unless defined(&IPSEC_MODE_TCPMD5);
    eval 'sub IPSEC_DIR_ANY () {0;}' unless defined(&IPSEC_DIR_ANY);
    eval 'sub IPSEC_DIR_INBOUND () {1;}' unless defined(&IPSEC_DIR_INBOUND);
    eval 'sub IPSEC_DIR_OUTBOUND () {2;}' unless defined(&IPSEC_DIR_OUTBOUND);
    eval 'sub IPSEC_DIR_MAX () {3;}' unless defined(&IPSEC_DIR_MAX);
    eval 'sub IPSEC_DIR_INVALID () {4;}' unless defined(&IPSEC_DIR_INVALID);
    eval 'sub IPSEC_POLICY_DISCARD () {0;}' unless defined(&IPSEC_POLICY_DISCARD);
    eval 'sub IPSEC_POLICY_NONE () {1;}' unless defined(&IPSEC_POLICY_NONE);
    eval 'sub IPSEC_POLICY_IPSEC () {2;}' unless defined(&IPSEC_POLICY_IPSEC);
    eval 'sub IPSEC_POLICY_ENTRUST () {3;}' unless defined(&IPSEC_POLICY_ENTRUST);
    eval 'sub IPSEC_POLICY_BYPASS () {4;}' unless defined(&IPSEC_POLICY_BYPASS);
    eval 'sub IPSEC_POLICYSCOPE_ANY () {0x;}' unless defined(&IPSEC_POLICYSCOPE_ANY);
    eval 'sub IPSEC_POLICYSCOPE_GLOBAL () {0x1;}' unless defined(&IPSEC_POLICYSCOPE_GLOBAL);
    eval 'sub IPSEC_POLICYSCOPE_IFNET () {0x2;}' unless defined(&IPSEC_POLICYSCOPE_IFNET);
    eval 'sub IPSEC_POLICYSCOPE_PCB () {0x4;}' unless defined(&IPSEC_POLICYSCOPE_PCB);
    eval 'sub IPSEC_LEVEL_DEFAULT () {0;}' unless defined(&IPSEC_LEVEL_DEFAULT);
    eval 'sub IPSEC_LEVEL_USE () {1;}' unless defined(&IPSEC_LEVEL_USE);
    eval 'sub IPSEC_LEVEL_REQUIRE () {2;}' unless defined(&IPSEC_LEVEL_REQUIRE);
    eval 'sub IPSEC_LEVEL_UNIQUE () {3;}' unless defined(&IPSEC_LEVEL_UNIQUE);
    eval 'sub IPSEC_MANUAL_REQID_MAX () {0x3fff;}' unless defined(&IPSEC_MANUAL_REQID_MAX);
    eval 'sub IPSEC_REPLAYWSIZE () {32;}' unless defined(&IPSEC_REPLAYWSIZE);
    eval 'sub IPSECCTL_STATS () {1;}' unless defined(&IPSECCTL_STATS);
    eval 'sub IPSECCTL_DEF_POLICY () {2;}' unless defined(&IPSECCTL_DEF_POLICY);
    eval 'sub IPSECCTL_DEF_ESP_TRANSLEV () {3;}' unless defined(&IPSECCTL_DEF_ESP_TRANSLEV);
    eval 'sub IPSECCTL_DEF_ESP_NETLEV () {4;}' unless defined(&IPSECCTL_DEF_ESP_NETLEV);
    eval 'sub IPSECCTL_DEF_AH_TRANSLEV () {5;}' unless defined(&IPSECCTL_DEF_AH_TRANSLEV);
    eval 'sub IPSECCTL_DEF_AH_NETLEV () {6;}' unless defined(&IPSECCTL_DEF_AH_NETLEV);
    if(0) {
	eval 'sub IPSECCTL_INBOUND_CALL_IKE () {7;}' unless defined(&IPSECCTL_INBOUND_CALL_IKE);
    }
    eval 'sub IPSECCTL_AH_CLEARTOS () {8;}' unless defined(&IPSECCTL_AH_CLEARTOS);
    eval 'sub IPSECCTL_AH_OFFSETMASK () {9;}' unless defined(&IPSECCTL_AH_OFFSETMASK);
    eval 'sub IPSECCTL_DFBIT () {10;}' unless defined(&IPSECCTL_DFBIT);
    eval 'sub IPSECCTL_ECN () {11;}' unless defined(&IPSECCTL_ECN);
    eval 'sub IPSECCTL_DEBUG () {12;}' unless defined(&IPSECCTL_DEBUG);
    eval 'sub IPSECCTL_ESP_RANDPAD () {13;}' unless defined(&IPSECCTL_ESP_RANDPAD);
    if(defined(&_KERNEL)) {
	require 'sys/counter.ph';
	eval 'sub IPSEC_INIT_CTX {
	    my($_ctx, $_mp, $_inp, $_sav, $_af, $_enc) = @_;
    	    eval q( &do { ($_ctx)-> &mp = ($_mp); ($_ctx)-> &inp = ($_inp); ($_ctx)-> &sav = ($_sav); ($_ctx)-> &af = ($_af); ($_ctx)-> &enc = ($_enc); }  &while(0));
	}' unless defined(&IPSEC_INIT_CTX);
	eval 'sub V_ipsec_debug () { &VNET( &ipsec_debug);}' unless defined(&V_ipsec_debug);
	if(defined(&REGRESSION)) {
	    eval 'sub V_ipsec_replay () { &VNET( &ipsec_replay);}' unless defined(&V_ipsec_replay);
	    eval 'sub V_ipsec_integrity () { &VNET( &ipsec_integrity);}' unless defined(&V_ipsec_integrity);
	}
	eval 'sub IPSECSTAT_INC {
	    my($name) = @_;
    	    eval q( &VNET_PCPUSTAT_ADD(\'struct ipsecstat\',  &ipsec4stat, $name, 1));
	}' unless defined(&IPSECSTAT_INC);
	eval 'sub V_ip4_esp_trans_deflev () { &VNET( &ip4_esp_trans_deflev);}' unless defined(&V_ip4_esp_trans_deflev);
	eval 'sub V_ip4_esp_net_deflev () { &VNET( &ip4_esp_net_deflev);}' unless defined(&V_ip4_esp_net_deflev);
	eval 'sub V_ip4_ah_trans_deflev () { &VNET( &ip4_ah_trans_deflev);}' unless defined(&V_ip4_ah_trans_deflev);
	eval 'sub V_ip4_ah_net_deflev () { &VNET( &ip4_ah_net_deflev);}' unless defined(&V_ip4_ah_net_deflev);
	eval 'sub V_ip4_ipsec_dfbit () { &VNET( &ip4_ipsec_dfbit);}' unless defined(&V_ip4_ipsec_dfbit);
	eval 'sub V_ip4_ipsec_ecn () { &VNET( &ip4_ipsec_ecn);}' unless defined(&V_ip4_ipsec_ecn);
	eval 'sub V_crypto_support () { &VNET( &crypto_support);}' unless defined(&V_crypto_support);
	eval 'sub V_natt_cksum_policy () { &VNET( &natt_cksum_policy);}' unless defined(&V_natt_cksum_policy);
	eval 'sub ipseclog {
	    my($x) = @_;
    	    eval q( &do {  &if ( &V_ipsec_debug)  &log $x; }  &while (0));
	}' unless defined(&ipseclog);
	if(defined(&IPSEC_DEBUG)) {
	    eval 'sub IPSEC_DEBUG_DECLARE {
	        my($x) = @_;
    		eval q($x);
	    }' unless defined(&IPSEC_DEBUG_DECLARE);
	    eval 'sub DPRINTF {
	        my($x) = @_;
    		eval q( &do {  &if ( &V_ipsec_debug)  &printf $x; }  &while (0));
	    }' unless defined(&DPRINTF);
	} else {
	    eval 'sub IPSEC_DEBUG_DECLARE {
	        my($x) = @_;
    		eval q();
	    }' unless defined(&IPSEC_DEBUG_DECLARE);
	    eval 'sub DPRINTF {
	        my($x) = @_;
    		eval q();
	    }' unless defined(&DPRINTF);
	}
    }
    unless(defined(&_KERNEL)) {
    }
}
1;
