require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NETIPSEC_IPSEC_SUPPORT_H_)) {
    eval 'sub _NETIPSEC_IPSEC_SUPPORT_H_ () {1;}' unless defined(&_NETIPSEC_IPSEC_SUPPORT_H_);
    if(defined(&_KERNEL)) {
	if(defined(&IPSEC) || defined(&IPSEC_SUPPORT)) {
	    eval 'sub IPSEC_CAP_OPERABLE () {1;}' unless defined(&IPSEC_CAP_OPERABLE);
	    eval 'sub IPSEC_CAP_BYPASS_FILTER () {2;}' unless defined(&IPSEC_CAP_BYPASS_FILTER);
	    eval 'sub IPSEC_MODULE_ENABLED () {0x1;}' unless defined(&IPSEC_MODULE_ENABLED);
	    eval 'sub IPSEC_ENABLED {
	        my($proto) = @_;
    		eval q((($proto   &_ipsec_support)-> &enabled &  &IPSEC_MODULE_ENABLED));
	    }' unless defined(&IPSEC_ENABLED);
	    eval 'sub TCPMD5_ENABLED () {
	        eval q( &IPSEC_ENABLED( &tcp));
	    }' unless defined(&TCPMD5_ENABLED);
	    if(defined(&TCP_SIGNATURE)) {
		eval 'sub TCPMD5_INPUT () {( &m, ...) (* ($tcp_ipsec_support->{methods}->{input}))( &m,  &__VA_ARGS__);}' unless defined(&TCPMD5_INPUT);
		eval 'sub TCPMD5_OUTPUT () {( &m, ...) (* ($tcp_ipsec_support->{methods}->{output}))( &m,  &__VA_ARGS__);}' unless defined(&TCPMD5_OUTPUT);
		eval 'sub TCPMD5_PCBCTL {
		    my($inp, $sopt) = @_;
    		    eval q((* ($tcp_ipsec_support->{methods}->{pcbctl}))($inp, $sopt));
		}' unless defined(&TCPMD5_PCBCTL);
	    }
 elsif(defined(&IPSEC_SUPPORT)) {
		eval 'sub TCPMD5_INPUT () {( &m, ...)  &tcpmd5_kmod_input( &tcp_ipsec_support,  &m,  &__VA_ARGS__);}' unless defined(&TCPMD5_INPUT);
		eval 'sub TCPMD5_OUTPUT () {( &m, ...)  &tcpmd5_kmod_output( &tcp_ipsec_support,  &m,  &__VA_ARGS__);}' unless defined(&TCPMD5_OUTPUT);
		eval 'sub TCPMD5_PCBCTL {
		    my($inp, $sopt) = @_;
    		    eval q( &tcpmd5_kmod_pcbctl( &tcp_ipsec_support, $inp, $sopt));
		}' unless defined(&TCPMD5_PCBCTL);
	    }
	}
	if(defined(&IPSEC)) {
	    eval 'sub IPSEC_INPUT () {( &proto,  &m, ...) (*( &proto   &_ipsec_support)-> ($methods->{input}))( &m,  &__VA_ARGS__);}' unless defined(&IPSEC_INPUT);
	    eval 'sub IPSEC_CHECK_POLICY () {( &proto,  &m, ...) (*( &proto   &_ipsec_support)-> ($methods->{check_policy}))( &m,  &__VA_ARGS__);}' unless defined(&IPSEC_CHECK_POLICY);
	    eval 'sub IPSEC_FORWARD {
	        my($proto, $m) = @_;
    		eval q((*($proto   &_ipsec_support)-> ($methods->{forward}))($m));
	    }' unless defined(&IPSEC_FORWARD);
	    eval 'sub IPSEC_OUTPUT () {( &proto,  &m, ...) (*( &proto   &_ipsec_support)-> ($methods->{output}))( &m,  &__VA_ARGS__);}' unless defined(&IPSEC_OUTPUT);
	    eval 'sub IPSEC_PCBCTL {
	        my($proto, $inp, $sopt) = @_;
    		eval q((*($proto   &_ipsec_support)-> ($methods->{pcbctl}))($inp, $sopt));
	    }' unless defined(&IPSEC_PCBCTL);
	    eval 'sub IPSEC_CAPS () {( &proto,  &m, ...) (*( &proto   &_ipsec_support)-> ($methods->{capability}))( &m,  &__VA_ARGS__);}' unless defined(&IPSEC_CAPS);
	    eval 'sub IPSEC_HDRSIZE {
	        my($proto, $inp) = @_;
    		eval q((*($proto   &_ipsec_support)-> ($methods->{hdrsize}))($inp));
	    }' unless defined(&IPSEC_HDRSIZE);
	    eval 'sub UDPENCAP_INPUT () {( &m, ...) (* ($ipv4_ipsec_support->{methods}->{udp_input}))( &m,  &__VA_ARGS__);}' unless defined(&UDPENCAP_INPUT);
	    eval 'sub UDPENCAP_PCBCTL {
	        my($inp, $sopt) = @_;
    		eval q((* ($ipv4_ipsec_support->{methods}->{udp_pcbctl}))($inp, $sopt));
	    }' unless defined(&UDPENCAP_PCBCTL);
	}
 elsif(defined(&IPSEC_SUPPORT)) {
	    eval 'sub UDPENCAP_INPUT () {( &m, ...)  &ipsec_kmod_udp_input( &ipv4_ipsec_support,  &m,  &__VA_ARGS__);}' unless defined(&UDPENCAP_INPUT);
	    eval 'sub UDPENCAP_PCBCTL {
	        my($inp, $sopt) = @_;
    		eval q( &ipsec_kmod_udp_pcbctl( &ipv4_ipsec_support, $inp, $sopt));
	    }' unless defined(&UDPENCAP_PCBCTL);
	    eval 'sub IPSEC_INPUT () {( &proto, ...)  &ipsec_kmod_input( &proto   &_ipsec_support,  &__VA_ARGS__);}' unless defined(&IPSEC_INPUT);
	    eval 'sub IPSEC_CHECK_POLICY () {( &proto, ...)  &ipsec_kmod_check_policy( &proto   &_ipsec_support,  &__VA_ARGS__);}' unless defined(&IPSEC_CHECK_POLICY);
	    eval 'sub IPSEC_FORWARD () {( &proto, ...)  &ipsec_kmod_forward( &proto   &_ipsec_support,  &__VA_ARGS__);}' unless defined(&IPSEC_FORWARD);
	    eval 'sub IPSEC_OUTPUT () {( &proto, ...)  &ipsec_kmod_output( &proto   &_ipsec_support,  &__VA_ARGS__);}' unless defined(&IPSEC_OUTPUT);
	    eval 'sub IPSEC_PCBCTL () {( &proto, ...)  &ipsec_kmod_pcbctl( &proto   &_ipsec_support,  &__VA_ARGS__);}' unless defined(&IPSEC_PCBCTL);
	    eval 'sub IPSEC_CAPS () {( &proto, ...)  &ipsec_kmod_capability( &proto   &_ipsec_support,  &__VA_ARGS__);}' unless defined(&IPSEC_CAPS);
	    eval 'sub IPSEC_HDRSIZE () {( &proto, ...)  &ipsec_kmod_hdrsize( &proto   &_ipsec_support,  &__VA_ARGS__);}' unless defined(&IPSEC_HDRSIZE);
	}
    }
}
1;
