require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NFSCLIENT_NFS_H_)) {
    eval 'sub _NFSCLIENT_NFS_H_ () {1;}' unless defined(&_NFSCLIENT_NFS_H_);
    if(defined(&_KERNEL)) {
	require './nfsclient/opt_nfs.ph';
    }
    require 'nfsclient/nfsargs.ph';
    eval 'sub NFS_TICKINTVL () {10;}' unless defined(&NFS_TICKINTVL);
    eval 'sub NFS_HZ () {( &hz /  &nfs_ticks);}' unless defined(&NFS_HZ);
    eval 'sub NFS_TIMEO () {(1*  &NFS_HZ);}' unless defined(&NFS_TIMEO);
    eval 'sub NFS_MINTIMEO () {(1*  &NFS_HZ);}' unless defined(&NFS_MINTIMEO);
    eval 'sub NFS_MAXTIMEO () {(60*  &NFS_HZ);}' unless defined(&NFS_MAXTIMEO);
    eval 'sub NFS_MINIDEMTIMEO () {(5*  &NFS_HZ);}' unless defined(&NFS_MINIDEMTIMEO);
    eval 'sub NFS_MAXREXMIT () {100;}' unless defined(&NFS_MAXREXMIT);
    eval 'sub NFS_RETRANS () {10;}' unless defined(&NFS_RETRANS);
    eval 'sub NFS_RETRANS_TCP () {2;}' unless defined(&NFS_RETRANS_TCP);
    eval 'sub NFS_MAXGRPS () {16;}' unless defined(&NFS_MAXGRPS);
    unless(defined(&NFS_MINATTRTIMO)) {
	eval 'sub NFS_MINATTRTIMO () {3;}' unless defined(&NFS_MINATTRTIMO);
    }
    unless(defined(&NFS_MAXATTRTIMO)) {
	eval 'sub NFS_MAXATTRTIMO () {60;}' unless defined(&NFS_MAXATTRTIMO);
    }
    unless(defined(&NFS_MINDIRATTRTIMO)) {
	eval 'sub NFS_MINDIRATTRTIMO () {3;}' unless defined(&NFS_MINDIRATTRTIMO);
    }
    unless(defined(&NFS_MAXDIRATTRTIMO)) {
	eval 'sub NFS_MAXDIRATTRTIMO () {60;}' unless defined(&NFS_MAXDIRATTRTIMO);
    }
    unless(defined(&NFS_ACCESSCACHESIZE)) {
	eval 'sub NFS_ACCESSCACHESIZE () {8;}' unless defined(&NFS_ACCESSCACHESIZE);
    }
    eval 'sub NFS_WSIZE () {8192;}' unless defined(&NFS_WSIZE);
    eval 'sub NFS_RSIZE () {8192;}' unless defined(&NFS_RSIZE);
    eval 'sub NFS_READDIRSIZE () {8192;}' unless defined(&NFS_READDIRSIZE);
    eval 'sub NFS_DEFRAHEAD () {1;}' unless defined(&NFS_DEFRAHEAD);
    eval 'sub NFS_MAXRAHEAD () {4;}' unless defined(&NFS_MAXRAHEAD);
    eval 'sub NFS_MAXASYNCDAEMON () {64;}' unless defined(&NFS_MAXASYNCDAEMON);
    eval 'sub NFS_DIRBLKSIZ () {4096;}' unless defined(&NFS_DIRBLKSIZ);
    if(defined(&_KERNEL)) {
	eval 'sub DIRBLKSIZ () {512;}' unless defined(&DIRBLKSIZ);
    }
    eval 'sub NFS_MAXDEADTHRESH () {9;}' unless defined(&NFS_MAXDEADTHRESH);
    eval 'sub NFS_CMPFH {
        my($n, $f, $s) = @_;
	    eval q((-> &n_fhsize ==  && ! &bcmp(-> &n_fhp, ($f), ($s))));
    }' unless defined(&NFS_CMPFH);
    eval 'sub NFS_ISV3 {
        my($v) = @_;
	    eval q(( &VFSTONFS(($v)-> &v_mount)-> &nm_flag &  &NFSMNT_NFSV3));
    }' unless defined(&NFS_ISV3);
    eval 'sub NFS_ISV4 {
        my($v) = @_;
	    eval q(( &VFSTONFS(($v)-> &v_mount)-> &nm_flag &  &NFSMNT_NFSV4));
    }' unless defined(&NFS_ISV4);
    eval 'sub NFSSTA_HASWRITEVERF () {0x40000;}' unless defined(&NFSSTA_HASWRITEVERF);
    eval 'sub NFSSTA_GOTFSINFO () {0x100000;}' unless defined(&NFSSTA_GOTFSINFO);
    eval 'sub NFSSTA_SNDLOCK () {0x1000000;}' unless defined(&NFSSTA_SNDLOCK);
    eval 'sub NFSSTA_WANTSND () {0x2000000;}' unless defined(&NFSSTA_WANTSND);
    eval 'sub NFSSTA_TIMEO () {0x10000000;}' unless defined(&NFSSTA_TIMEO);
    eval 'sub NFSSTA_LOCKTIMEO () {0x20000000;}' unless defined(&NFSSTA_LOCKTIMEO);
    if(defined(&NFS_NPROCS)) {
	require 'nfsclient/nfsstats.ph';
    }
    eval 'sub NFS_NFSSTATS () {1;}' unless defined(&NFS_NFSSTATS);
    if(defined(&_KERNEL)) {
	if(defined(&MALLOC_DECLARE)) {
	}
	eval 'sub NFSIGNORE_SOERROR {
	    my($s, $e) = @_;
    	    eval q((($e) !=  &EINTR  && ($e) !=  &EIO  && ($e) !=  &ERESTART  && ($e) !=  &EWOULDBLOCK  && (($s) &  &PR_CONNREQUIRED) == 0));
	}' unless defined(&NFSIGNORE_SOERROR);
	eval 'sub WEBNFS_ESC_CHAR () {ord(\'%\');}' unless defined(&WEBNFS_ESC_CHAR);
	eval 'sub WEBNFS_SPECCHAR_START () {0x80;}' unless defined(&WEBNFS_SPECCHAR_START);
	eval 'sub WEBNFS_NATIVE_CHAR () {0x80;}' unless defined(&WEBNFS_NATIVE_CHAR);
	eval 'sub HEXTOC {
	    my($c) = @_;
    	    eval q((($c) >= ord(\'a\' ? ((c) - (\'a\' - 10)) : 	    ((c) >= \'A\' ? ((c) - (\'A\' - 10)) : ((c) - \'0\')))));
	}' unless defined(&HEXTOC);
	eval 'sub HEXSTRTOI {
	    my($p) = @_;
    	    eval q((( &HEXTOC($p->[0]) << 4) +  &HEXTOC($p->[1])));
	}' unless defined(&HEXSTRTOI);
	eval 'sub NFS_SIGREP {
	    my($rep) = @_;
    	    eval q( &nfs_sigintr(($rep)-> &r_nmp, ($rep), ($rep)-> &r_td));
	}' unless defined(&NFS_SIGREP);
	if(defined(&NFS_DEBUG)) {
	    eval 'sub NFS_DEBUG_ASYNCIO () {1;}' unless defined(&NFS_DEBUG_ASYNCIO);
	    eval 'sub NFS_DEBUG_WG () {2;}' unless defined(&NFS_DEBUG_WG);
	    eval 'sub NFS_DEBUG_RC () {4;}' unless defined(&NFS_DEBUG_RC);
	    eval 'sub NFS_DPF {
	        my($cat, $args) = @_;
    		eval q( &do {  &if ( &nfs_debug &  &NFS_DEBUG_$cat)  &printf $args; }  &while (0));
	    }' unless defined(&NFS_DPF);
	} else {
	    eval 'sub NFS_DPF {
	        my($cat, $args) = @_;
    		eval q();
	    }' unless defined(&NFS_DPF);
	}
	eval 'sub NFS_MINRTO () {( &NFS_HZ >> 2);}' unless defined(&NFS_MINRTO);
	eval 'sub NFS_MAXRTO () {(20*  &NFS_HZ);}' unless defined(&NFS_MAXRTO);
	eval("sub NFS_DEFAULT_TIMER () { 0; }") unless defined(&NFS_DEFAULT_TIMER);
	eval("sub NFS_GETATTR_TIMER () { 1; }") unless defined(&NFS_GETATTR_TIMER);
	eval("sub NFS_LOOKUP_TIMER () { 2; }") unless defined(&NFS_LOOKUP_TIMER);
	eval("sub NFS_READ_TIMER () { 3; }") unless defined(&NFS_READ_TIMER);
	eval("sub NFS_WRITE_TIMER () { 4; }") unless defined(&NFS_WRITE_TIMER);
	eval 'sub NFS_MAX_TIMER () {( &NFS_WRITE_TIMER);}' unless defined(&NFS_MAX_TIMER);
	eval 'sub NFS_INITRTT () {( &NFS_HZ << 3);}' unless defined(&NFS_INITRTT);
    }
}
1;
