require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NFSSERVER_NFS_H_)) {
    eval 'sub _NFSSERVER_NFS_H_ () {1;}' unless defined(&_NFSSERVER_NFS_H_);
    if(defined(&_KERNEL)) {
	require './nfsserver/opt_nfs.ph';
    }
    require 'nfs/nfssvc.ph';
    eval 'sub NFS_TICKINTVL () {10;}' unless defined(&NFS_TICKINTVL);
    eval 'sub NFS_HZ () {( &hz /  &nfs_ticks);}' unless defined(&NFS_HZ);
    eval 'sub NFS_TIMEO () {(1*  &NFS_HZ);}' unless defined(&NFS_TIMEO);
    eval 'sub NFS_MINTIMEO () {(1*  &NFS_HZ);}' unless defined(&NFS_MINTIMEO);
    eval 'sub NFS_MAXTIMEO () {(60*  &NFS_HZ);}' unless defined(&NFS_MAXTIMEO);
    eval 'sub NFS_MINIDEMTIMEO () {(5*  &NFS_HZ);}' unless defined(&NFS_MINIDEMTIMEO);
    eval 'sub NFS_MAXUIDHASH () {64;}' unless defined(&NFS_MAXUIDHASH);
    unless(defined(&NFS_GATHERDELAY)) {
	eval 'sub NFS_GATHERDELAY () {10;}' unless defined(&NFS_GATHERDELAY);
    }
    if(defined(&_KERNEL)) {
	eval 'sub DIRBLKSIZ () {512;}' unless defined(&DIRBLKSIZ);
    }
    eval 'sub NFS_SRVMAXDATA {
        my($n) = @_;
	    eval q(((($n)-> &nd_flag &  &ND_NFSV3) ? ((($n)-> &nd_nam2) ?  &NFS_MAXDGRAMDATA :  &NFS_MAXDATA) :  &NFS_V2MAXDATA));
    }' unless defined(&NFS_SRVMAXDATA);
    eval 'sub B_INVAFTERWRITE () { &B_NOCACHE;}' unless defined(&B_INVAFTERWRITE);
    unless(defined(&IO_METASYNC)) {
	eval 'sub IO_METASYNC () {0;}' unless defined(&IO_METASYNC);
    }
    eval 'sub NFSRV_SNDLOCK () {0x1000000;}' unless defined(&NFSRV_SNDLOCK);
    eval 'sub NFSRV_WANTSND () {0x2000000;}' unless defined(&NFSRV_WANTSND);
    if(defined(&NFS_NPROCS)) {
	require 'nfsserver/nfsrvstats.ph';
    }
    eval 'sub NFS_NFSRVSTATS () {1;}' unless defined(&NFS_NFSRVSTATS);
    eval 'sub NFS_NFSPRIVPORT () {2;}' unless defined(&NFS_NFSPRIVPORT);
    if(defined(&_KERNEL)) {
	eval 'sub NFSD_LOCK_ASSERT () {
	    eval q( &mtx_assert( &nfsd_mtx,  &MA_OWNED));
	}' unless defined(&NFSD_LOCK_ASSERT);
	eval 'sub NFSD_UNLOCK_ASSERT () {
	    eval q( &mtx_assert( &nfsd_mtx,  &MA_NOTOWNED));
	}' unless defined(&NFSD_UNLOCK_ASSERT);
	eval 'sub NFSD_LOCK_DONTCARE () {
	    eval q();
	}' unless defined(&NFSD_LOCK_DONTCARE);
	eval 'sub NFSD_LOCK () {
	    eval q( &mtx_lock( &nfsd_mtx));
	}' unless defined(&NFSD_LOCK);
	eval 'sub NFSD_UNLOCK () {
	    eval q( &mtx_unlock( &nfsd_mtx));
	}' unless defined(&NFSD_UNLOCK);
	if(defined(&MALLOC_DECLARE)) {
	}
	unless(defined(&NFS_WDELAYHASHSIZ)) {
	    eval 'sub NFS_WDELAYHASHSIZ () {16;}' unless defined(&NFS_WDELAYHASHSIZ);
	}
	eval 'sub NWDELAYHASH {
	    my($sock, $f) = @_;
    	    eval q((($sock)-> $ns_wdelayhashtbl[(*(( &u_int32_t *)($f))) %  &NFS_WDELAYHASHSIZ]));
	}' unless defined(&NWDELAYHASH);
	eval 'sub ND_NFSV3 () {0x8;}' unless defined(&ND_NFSV3);
	eval 'sub WEBNFS_ESC_CHAR () {ord(\'%\');}' unless defined(&WEBNFS_ESC_CHAR);
	eval 'sub WEBNFS_SPECCHAR_START () {0x80;}' unless defined(&WEBNFS_SPECCHAR_START);
	eval 'sub WEBNFS_NATIVE_CHAR () {0x80;}' unless defined(&WEBNFS_NATIVE_CHAR);
	eval 'sub HEXTOC {
	    my($c) = @_;
    	    eval q((($c) >= ord(\'a\' ? ((c) - (\'a\' - 10)) : 	    ((c) >= \'A\' ? ((c) - (\'A\' - 10)) : ((c) - \'0\')))));
	}' unless defined(&HEXTOC);
	eval 'sub HEXSTRTOI {
	    my($p) = @_;
    	    eval q((( &HEXTOC($p->[0]) << 4) +  &HEXTOC($p->[1])));
	}' unless defined(&HEXSTRTOI);
	if(defined(&NFS_DEBUG)) {
	    eval 'sub NFS_DEBUG_ASYNCIO () {1;}' unless defined(&NFS_DEBUG_ASYNCIO);
	    eval 'sub NFS_DEBUG_WG () {2;}' unless defined(&NFS_DEBUG_WG);
	    eval 'sub NFS_DEBUG_RC () {4;}' unless defined(&NFS_DEBUG_RC);
	    eval 'sub NFS_DPF {
	        my($cat, $args) = @_;
    		eval q( &do {  &if ( &nfs_debug &  &NFS_DEBUG_$cat)  &printf $args; }  &while (0));
	    }' unless defined(&NFS_DPF);
	} else {
	    eval 'sub NFS_DPF {
	        my($cat, $args) = @_;
    		eval q();
	    }' unless defined(&NFS_DPF);
	}
	eval 'sub NFSRV_FLAG_BUSY () {0x1;}' unless defined(&NFSRV_FLAG_BUSY);
	if(defined(&_SYS_SYSPROTO_H_)) {
	}
    }
}
1;
