require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&UCL_H_)) {
    eval 'sub UCL_H_ () {1;}' unless defined(&UCL_H_);
    require 'string.ph';
    require 'stddef.ph';
    require 'stdlib.ph';
    require 'stdint.ph';
    require 'stdbool.ph';
    require 'stdarg.ph';
    require 'stdio.ph';
    if(defined(&_WIN32)) {
	eval 'sub UCL_EXTERN () { &__declspec( &dllexport);}' unless defined(&UCL_EXTERN);
    } else {
	eval 'sub UCL_EXTERN () {1;}' unless defined(&UCL_EXTERN);
    }
    if(defined(&__cplusplus)) {
    }
    unless(defined(&UCL_ALLOC)) {
	eval 'sub UCL_ALLOC {
	    my($size) = @_;
    	    eval q( &malloc($size));
	}' unless defined(&UCL_ALLOC);
    }
    unless(defined(&UCL_FREE)) {
	eval 'sub UCL_FREE {
	    my($size, $ptr) = @_;
    	    eval q( &free($ptr));
	}' unless defined(&UCL_FREE);
    }
    if((defined(&__GNUC__) ? &__GNUC__ : undef) > 3|| ((defined(&__GNUC__) ? &__GNUC__ : undef) == 3 && (defined(&__GNUC_MINOR__) ? &__GNUC_MINOR__ : undef) >= 4)) {
	eval 'sub UCL_WARN_UNUSED_RESULT () { &__attribute__(( &warn_unused_result));}' unless defined(&UCL_WARN_UNUSED_RESULT);
    } else {
	eval 'sub UCL_WARN_UNUSED_RESULT () {1;}' unless defined(&UCL_WARN_UNUSED_RESULT);
    }
    if(defined(&__GNUC__)) {
	eval 'sub UCL_DEPRECATED {
	    my($func) = @_;
    	    eval q($func  &__attribute__ (( &deprecated)));
	}' unless defined(&UCL_DEPRECATED);
    }
 elsif(defined(&_MSC_VER)) {
	eval 'sub UCL_DEPRECATED {
	    my($func) = @_;
    	    eval q( &__declspec( &deprecated) $func);
	}' unless defined(&UCL_DEPRECATED);
    } else {
	eval 'sub UCL_DEPRECATED {
	    my($func) = @_;
    	    eval q($func);
	}' unless defined(&UCL_DEPRECATED);
    }
    eval("sub UCL_EOK () { 0; }") unless defined(&UCL_EOK);
    eval("sub UCL_ESYNTAX () { 1; }") unless defined(&UCL_ESYNTAX);
    eval("sub UCL_EIO () { 2; }") unless defined(&UCL_EIO);
    eval("sub UCL_ESTATE () { 3; }") unless defined(&UCL_ESTATE);
    eval("sub UCL_ENESTED () { 4; }") unless defined(&UCL_ENESTED);
    eval("sub UCL_EMACRO () { 5; }") unless defined(&UCL_EMACRO);
    eval("sub UCL_EINTERNAL () { 6; }") unless defined(&UCL_EINTERNAL);
    eval("sub UCL_ESSL () { 7; }") unless defined(&UCL_ESSL);
    eval("sub UCL_EMERGE () { 8; }") unless defined(&UCL_EMERGE);
    eval("sub UCL_OBJECT () { 0; }") unless defined(&UCL_OBJECT);
    eval("sub UCL_ARRAY () { 1; }") unless defined(&UCL_ARRAY);
    eval("sub UCL_INT () { 2; }") unless defined(&UCL_INT);
    eval("sub UCL_FLOAT () { 3; }") unless defined(&UCL_FLOAT);
    eval("sub UCL_STRING () { 4; }") unless defined(&UCL_STRING);
    eval("sub UCL_BOOLEAN () { 5; }") unless defined(&UCL_BOOLEAN);
    eval("sub UCL_TIME () { 6; }") unless defined(&UCL_TIME);
    eval("sub UCL_USERDATA () { 7; }") unless defined(&UCL_USERDATA);
    eval("sub UCL_NULL () { 8; }") unless defined(&UCL_NULL);
    eval("sub UCL_EMIT_JSON () { 0; }") unless defined(&UCL_EMIT_JSON);
    eval("sub UCL_EMIT_JSON_COMPACT () { 1; }") unless defined(&UCL_EMIT_JSON_COMPACT);
    eval("sub UCL_EMIT_CONFIG () { 2; }") unless defined(&UCL_EMIT_CONFIG);
    eval("sub UCL_EMIT_YAML () { 3; }") unless defined(&UCL_EMIT_YAML);
    eval("sub UCL_EMIT_MSGPACK () { 4; }") unless defined(&UCL_EMIT_MSGPACK);
    eval("sub UCL_EMIT_MAX () { 5; }") unless defined(&UCL_EMIT_MAX);
    eval("sub UCL_PARSER_DEFAULT () { 0; }") unless defined(&UCL_PARSER_DEFAULT);
    eval("sub UCL_PARSER_KEY_LOWERCASE () { (1<<0); }") unless defined(&UCL_PARSER_KEY_LOWERCASE);
    eval("sub UCL_PARSER_ZEROCOPY () { (1<<1); }") unless defined(&UCL_PARSER_ZEROCOPY);
    eval("sub UCL_PARSER_NO_TIME () { (1<<2); }") unless defined(&UCL_PARSER_NO_TIME);
    eval("sub UCL_PARSER_NO_IMPLICIT_ARRAYS () { (1<<3); }") unless defined(&UCL_PARSER_NO_IMPLICIT_ARRAYS);
    eval("sub UCL_PARSER_SAVE_COMMENTS () { (1<<4); }") unless defined(&UCL_PARSER_SAVE_COMMENTS);
    eval("sub UCL_PARSER_DISABLE_MACRO () { (1<<5); }") unless defined(&UCL_PARSER_DISABLE_MACRO);
    eval("sub UCL_PARSER_NO_FILEVARS () { (1<<6); }") unless defined(&UCL_PARSER_NO_FILEVARS);
    eval("sub UCL_STRING_RAW () { 0x0; }") unless defined(&UCL_STRING_RAW);
    eval("sub UCL_STRING_ESCAPE () { (1<<0); }") unless defined(&UCL_STRING_ESCAPE);
    eval("sub UCL_STRING_TRIM () { (1<<1); }") unless defined(&UCL_STRING_TRIM);
    eval("sub UCL_STRING_PARSE_BOOLEAN () { (1<<2); }") unless defined(&UCL_STRING_PARSE_BOOLEAN);
    eval("sub UCL_STRING_PARSE_INT () { (1<<3); }") unless defined(&UCL_STRING_PARSE_INT);
    eval("sub UCL_STRING_PARSE_DOUBLE () { (1<<4); }") unless defined(&UCL_STRING_PARSE_DOUBLE);
    eval("sub UCL_STRING_PARSE_TIME () { (1<<5); }") unless defined(&UCL_STRING_PARSE_TIME);
    eval("sub UCL_STRING_PARSE_NUMBER () { UCL_STRING_PARSE_INT|UCL_STRING_PARSE_DOUBLE|UCL_STRING_PARSE_TIME; }") unless defined(&UCL_STRING_PARSE_NUMBER);
    eval("sub UCL_STRING_PARSE () { UCL_STRING_PARSE_BOOLEAN|UCL_STRING_PARSE_NUMBER; }") unless defined(&UCL_STRING_PARSE);
    eval("sub UCL_STRING_PARSE_BYTES () { (1<<6); }") unless defined(&UCL_STRING_PARSE_BYTES);
    eval("sub UCL_OBJECT_ALLOCATED_KEY () { (1<<0); }") unless defined(&UCL_OBJECT_ALLOCATED_KEY);
    eval("sub UCL_OBJECT_ALLOCATED_VALUE () { (1<<1); }") unless defined(&UCL_OBJECT_ALLOCATED_VALUE);
    eval("sub UCL_OBJECT_NEED_KEY_ESCAPE () { (1<<2); }") unless defined(&UCL_OBJECT_NEED_KEY_ESCAPE);
    eval("sub UCL_OBJECT_EPHEMERAL () { (1<<3); }") unless defined(&UCL_OBJECT_EPHEMERAL);
    eval("sub UCL_OBJECT_MULTILINE () { (1<<4); }") unless defined(&UCL_OBJECT_MULTILINE);
    eval("sub UCL_OBJECT_MULTIVALUE () { (1<<5); }") unless defined(&UCL_OBJECT_MULTIVALUE);
    eval("sub UCL_OBJECT_INHERITED () { (1<<6); }") unless defined(&UCL_OBJECT_INHERITED);
    eval("sub UCL_OBJECT_BINARY () { (1<<7); }") unless defined(&UCL_OBJECT_BINARY);
    eval("sub UCL_DUPLICATE_APPEND () { 0; }") unless defined(&UCL_DUPLICATE_APPEND);
    eval("sub UCL_DUPLICATE_MERGE () { 1; }") unless defined(&UCL_DUPLICATE_MERGE);
    eval("sub UCL_DUPLICATE_REWRITE () { 2; }") unless defined(&UCL_DUPLICATE_REWRITE);
    eval("sub UCL_DUPLICATE_ERROR () { 3; }") unless defined(&UCL_DUPLICATE_ERROR);
    eval("sub UCL_PARSE_UCL () { 0; }") unless defined(&UCL_PARSE_UCL);
    eval("sub UCL_PARSE_MSGPACK () { 1; }") unless defined(&UCL_PARSE_MSGPACK);
    eval("sub UCL_PARSE_CSEXP () { 2; }") unless defined(&UCL_PARSE_CSEXP);
    eval("sub UCL_PARSE_AUTO () { 3; }") unless defined(&UCL_PARSE_AUTO);
    eval 'sub ucl_object_find_key () { &ucl_object_lookup;}' unless defined(&ucl_object_find_key);
    eval 'sub ucl_object_find_any_key () { &ucl_object_lookup_any;}' unless defined(&ucl_object_find_any_key);
    eval 'sub ucl_object_find_keyl () { &ucl_object_lookup_len;}' unless defined(&ucl_object_find_keyl);
    eval 'sub ucl_lookup_path () { &ucl_object_lookup_path;}' unless defined(&ucl_lookup_path);
    eval 'sub ucl_lookup_path_char () { &ucl_object_lookup_path_char;}' unless defined(&ucl_lookup_path_char);
    eval 'sub ucl_iterate_object () { &ucl_object_iterate;}' unless defined(&ucl_iterate_object);
    eval("sub UCL_ITERATE_EXPLICIT () { 1<<0; }") unless defined(&UCL_ITERATE_EXPLICIT);
    eval("sub UCL_ITERATE_IMPLICIT () { 1<<1; }") unless defined(&UCL_ITERATE_IMPLICIT);
    eval("sub UCL_ITERATE_BOTH () { (1<<0)|(1<<1); }") unless defined(&UCL_ITERATE_BOTH);
    eval("sub UCL_SCHEMA_OK () { 0; }") unless defined(&UCL_SCHEMA_OK);
    eval("sub UCL_SCHEMA_TYPE_MISMATCH () { 1; }") unless defined(&UCL_SCHEMA_TYPE_MISMATCH);
    eval("sub UCL_SCHEMA_INVALID_SCHEMA () { 2; }") unless defined(&UCL_SCHEMA_INVALID_SCHEMA);
    eval("sub UCL_SCHEMA_MISSING_PROPERTY () { 3; }") unless defined(&UCL_SCHEMA_MISSING_PROPERTY);
    eval("sub UCL_SCHEMA_CONSTRAINT () { 4; }") unless defined(&UCL_SCHEMA_CONSTRAINT);
    eval("sub UCL_SCHEMA_MISSING_DEPENDENCY () { 5; }") unless defined(&UCL_SCHEMA_MISSING_DEPENDENCY);
    eval("sub UCL_SCHEMA_EXTERNAL_REF_MISSING () { 6; }") unless defined(&UCL_SCHEMA_EXTERNAL_REF_MISSING);
    eval("sub UCL_SCHEMA_EXTERNAL_REF_INVALID () { 7; }") unless defined(&UCL_SCHEMA_EXTERNAL_REF_INVALID);
    eval("sub UCL_SCHEMA_INTERNAL_ERROR () { 8; }") unless defined(&UCL_SCHEMA_INTERNAL_ERROR);
    eval("sub UCL_SCHEMA_UNKNOWN () { 9; }") unless defined(&UCL_SCHEMA_UNKNOWN);
    if(defined(&__cplusplus)) {
    }
    eval 'sub ucl_obj_todouble_safe () { &ucl_object_todouble_safe;}' unless defined(&ucl_obj_todouble_safe);
    eval 'sub ucl_obj_todouble () { &ucl_object_todouble;}' unless defined(&ucl_obj_todouble);
    eval 'sub ucl_obj_tostring () { &ucl_object_tostring;}' unless defined(&ucl_obj_tostring);
    eval 'sub ucl_obj_tostring_safe () { &ucl_object_tostring_safe;}' unless defined(&ucl_obj_tostring_safe);
    eval 'sub ucl_obj_tolstring () { &ucl_object_tolstring;}' unless defined(&ucl_obj_tolstring);
    eval 'sub ucl_obj_tolstring_safe () { &ucl_object_tolstring_safe;}' unless defined(&ucl_obj_tolstring_safe);
    eval 'sub ucl_obj_toint () { &ucl_object_toint;}' unless defined(&ucl_obj_toint);
    eval 'sub ucl_obj_toint_safe () { &ucl_object_toint_safe;}' unless defined(&ucl_obj_toint_safe);
    eval 'sub ucl_obj_toboolean () { &ucl_object_toboolean;}' unless defined(&ucl_obj_toboolean);
    eval 'sub ucl_obj_toboolean_safe () { &ucl_object_toboolean_safe;}' unless defined(&ucl_obj_toboolean_safe);
    eval 'sub ucl_obj_get_key () { &ucl_object_find_key;}' unless defined(&ucl_obj_get_key);
    eval 'sub ucl_obj_get_keyl () { &ucl_object_find_keyl;}' unless defined(&ucl_obj_get_keyl);
    eval 'sub ucl_obj_unref () { &ucl_object_unref;}' unless defined(&ucl_obj_unref);
    eval 'sub ucl_obj_ref () { &ucl_object_ref;}' unless defined(&ucl_obj_ref);
    eval 'sub ucl_obj_free () { &ucl_object_free;}' unless defined(&ucl_obj_free);
}
1;
