require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SECURITY_AUDIT_KERNEL_H_)) {
    eval 'sub _SECURITY_AUDIT_KERNEL_H_ () {1;}' unless defined(&_SECURITY_AUDIT_KERNEL_H_);
    unless(defined(&_KERNEL)) {
	die("no user-serviceable parts inside");
    }
    require 'bsm/audit.ph';
    require 'sys/file.ph';
    require 'sys/sysctl.ph';
    if(defined(&AUDIT)) {
	eval 'sub AUDITING_TD {
	    my($td) = @_;
    	    eval q((($td)-> &td_pflags &  &TDP_AUDITREC));
	}' unless defined(&AUDITING_TD);
	eval 'sub AUDIT_ARG_ADDR {
	    my($addr) = @_;
    	    eval q( &do {  &if ( &AUDITING_TD( &curthread))  &audit_arg_addr(($addr)); }  &while (0));
	}' unless defined(&AUDIT_ARG_ADDR);
	eval 'sub AUDIT_ARG_ARGV {
	    my($argv, $argc, $length) = @_;
    	    eval q( &do {  &if ( &AUDITING_TD( &curthread))  &audit_arg_argv(($argv), ($argc), ($length)); }  &while (0));
	}' unless defined(&AUDIT_ARG_ARGV);
	eval 'sub AUDIT_ARG_ATFD1 {
	    my($atfd) = @_;
    	    eval q( &do {  &if ( &AUDITING_TD( &curthread))  &audit_arg_atfd1(($atfd)); }  &while (0));
	}' unless defined(&AUDIT_ARG_ATFD1);
	eval 'sub AUDIT_ARG_ATFD2 {
	    my($atfd) = @_;
    	    eval q( &do {  &if ( &AUDITING_TD( &curthread))  &audit_arg_atfd2(($atfd)); }  &while (0));
	}' unless defined(&AUDIT_ARG_ATFD2);
	eval 'sub AUDIT_ARG_AUDITON {
	    my($udata) = @_;
    	    eval q( &do {  &if ( &AUDITING_TD( &curthread))  &audit_arg_auditon(($udata)); }  &while (0));
	}' unless defined(&AUDIT_ARG_AUDITON);
	eval 'sub AUDIT_ARG_CMD {
	    my($cmd) = @_;
    	    eval q( &do {  &if ( &AUDITING_TD( &curthread))  &audit_arg_cmd(($cmd)); }  &while (0));
	}' unless defined(&AUDIT_ARG_CMD);
	eval 'sub AUDIT_ARG_DEV {
	    my($dev) = @_;
    	    eval q( &do {  &if ( &AUDITING_TD( &curthread))  &audit_arg_dev(($dev)); }  &while (0));
	}' unless defined(&AUDIT_ARG_DEV);
	eval 'sub AUDIT_ARG_EGID {
	    my($egid) = @_;
    	    eval q( &do {  &if ( &AUDITING_TD( &curthread))  &audit_arg_egid(($egid)); }  &while (0));
	}' unless defined(&AUDIT_ARG_EGID);
	eval 'sub AUDIT_ARG_ENVV {
	    my($envv, $envc, $length) = @_;
    	    eval q( &do {  &if ( &AUDITING_TD( &curthread))  &audit_arg_envv(($envv), ($envc), ($length)); }  &while (0));
	}' unless defined(&AUDIT_ARG_ENVV);
	eval 'sub AUDIT_ARG_EXIT {
	    my($status, $retval) = @_;
    	    eval q( &do {  &if ( &AUDITING_TD( &curthread))  &audit_arg_exit(($status), ($retval)); }  &while (0));
	}' unless defined(&AUDIT_ARG_EXIT);
	eval 'sub AUDIT_ARG_EUID {
	    my($euid) = @_;
    	    eval q( &do {  &if ( &AUDITING_TD( &curthread))  &audit_arg_euid(($euid)); }  &while (0));
	}' unless defined(&AUDIT_ARG_EUID);
	eval 'sub AUDIT_ARG_FD {
	    my($fd) = @_;
    	    eval q( &do {  &if ( &AUDITING_TD( &curthread))  &audit_arg_fd(($fd)); }  &while (0));
	}' unless defined(&AUDIT_ARG_FD);
	eval 'sub AUDIT_ARG_FILE {
	    my($p, $fp) = @_;
    	    eval q( &do {  &if ( &AUDITING_TD( &curthread))  &audit_arg_file(($p), ($fp)); }  &while (0));
	}' unless defined(&AUDIT_ARG_FILE);
	eval 'sub AUDIT_ARG_FFLAGS {
	    my($fflags) = @_;
    	    eval q( &do {  &if ( &AUDITING_TD( &curthread))  &audit_arg_fflags(($fflags)); }  &while (0));
	}' unless defined(&AUDIT_ARG_FFLAGS);
	eval 'sub AUDIT_ARG_GID {
	    my($gid) = @_;
    	    eval q( &do {  &if ( &AUDITING_TD( &curthread))  &audit_arg_gid(($gid)); }  &while (0));
	}' unless defined(&AUDIT_ARG_GID);
	eval 'sub AUDIT_ARG_GROUPSET {
	    my($gidset, $gidset_size) = @_;
    	    eval q( &do {  &if ( &AUDITING_TD( &curthread))  &audit_arg_groupset(($gidset), ($gidset_size)); }  &while (0));
	}' unless defined(&AUDIT_ARG_GROUPSET);
	eval 'sub AUDIT_ARG_MODE {
	    my($mode) = @_;
    	    eval q( &do {  &if ( &AUDITING_TD( &curthread))  &audit_arg_mode(($mode)); }  &while (0));
	}' unless defined(&AUDIT_ARG_MODE);
	eval 'sub AUDIT_ARG_OWNER {
	    my($uid, $gid) = @_;
    	    eval q( &do {  &if ( &AUDITING_TD( &curthread))  &audit_arg_owner(($uid), ($gid)); }  &while (0));
	}' unless defined(&AUDIT_ARG_OWNER);
	eval 'sub AUDIT_ARG_PID {
	    my($pid) = @_;
    	    eval q( &do {  &if ( &AUDITING_TD( &curthread))  &audit_arg_pid(($pid)); }  &while (0));
	}' unless defined(&AUDIT_ARG_PID);
	eval 'sub AUDIT_ARG_PROCESS {
	    my($p) = @_;
    	    eval q( &do {  &if ( &AUDITING_TD( &curthread))  &audit_arg_process(($p)); }  &while (0));
	}' unless defined(&AUDIT_ARG_PROCESS);
	eval 'sub AUDIT_ARG_RGID {
	    my($rgid) = @_;
    	    eval q( &do {  &if ( &AUDITING_TD( &curthread))  &audit_arg_rgid(($rgid)); }  &while (0));
	}' unless defined(&AUDIT_ARG_RGID);
	eval 'sub AUDIT_ARG_RIGHTS {
	    my($rights) = @_;
    	    eval q( &do {  &if ( &AUDITING_TD( &curthread))  &audit_arg_rights(($rights)); }  &while (0));
	}' unless defined(&AUDIT_ARG_RIGHTS);
	eval 'sub AUDIT_ARG_FCNTL_RIGHTS {
	    my($fcntlrights) = @_;
    	    eval q( &do {  &if ( &AUDITING_TD( &curthread))  &audit_arg_fcntl_rights(($fcntlrights)); }  &while (0));
	}' unless defined(&AUDIT_ARG_FCNTL_RIGHTS);
	eval 'sub AUDIT_ARG_RUID {
	    my($ruid) = @_;
    	    eval q( &do {  &if ( &AUDITING_TD( &curthread))  &audit_arg_ruid(($ruid)); }  &while (0));
	}' unless defined(&AUDIT_ARG_RUID);
	eval 'sub AUDIT_ARG_SIGNUM {
	    my($signum) = @_;
    	    eval q( &do {  &if ( &AUDITING_TD( &curthread))  &audit_arg_signum(($signum)); }  &while (0));
	}' unless defined(&AUDIT_ARG_SIGNUM);
	eval 'sub AUDIT_ARG_SGID {
	    my($sgid) = @_;
    	    eval q( &do {  &if ( &AUDITING_TD( &curthread))  &audit_arg_sgid(($sgid)); }  &while (0));
	}' unless defined(&AUDIT_ARG_SGID);
	eval 'sub AUDIT_ARG_SOCKET {
	    my($sodomain, $sotype, $soprotocol) = @_;
    	    eval q( &do {  &if ( &AUDITING_TD( &curthread))  &audit_arg_socket(($sodomain), ($sotype), ($soprotocol)); }  &while (0));
	}' unless defined(&AUDIT_ARG_SOCKET);
	eval 'sub AUDIT_ARG_SOCKADDR {
	    my($td, $dirfd, $sa) = @_;
    	    eval q( &do {  &if ( &AUDITING_TD( &curthread))  &audit_arg_sockaddr(($td), ($dirfd), ($sa)); }  &while (0));
	}' unless defined(&AUDIT_ARG_SOCKADDR);
	eval 'sub AUDIT_ARG_SUID {
	    my($suid) = @_;
    	    eval q( &do {  &if ( &AUDITING_TD( &curthread))  &audit_arg_suid(($suid)); }  &while (0));
	}' unless defined(&AUDIT_ARG_SUID);
	eval 'sub AUDIT_ARG_TEXT {
	    my($text) = @_;
    	    eval q( &do {  &if ( &AUDITING_TD( &curthread))  &audit_arg_text(($text)); }  &while (0));
	}' unless defined(&AUDIT_ARG_TEXT);
	eval 'sub AUDIT_ARG_UID {
	    my($uid) = @_;
    	    eval q( &do {  &if ( &AUDITING_TD( &curthread))  &audit_arg_uid(($uid)); }  &while (0));
	}' unless defined(&AUDIT_ARG_UID);
	eval 'sub AUDIT_ARG_UPATH1 {
	    my($td, $dirfd, $upath) = @_;
    	    eval q( &do {  &if ( &AUDITING_TD( &curthread))  &audit_arg_upath1(($td), ($dirfd), ($upath)); }  &while (0));
	}' unless defined(&AUDIT_ARG_UPATH1);
	eval 'sub AUDIT_ARG_UPATH2 {
	    my($td, $dirfd, $upath) = @_;
    	    eval q( &do {  &if ( &AUDITING_TD( &curthread))  &audit_arg_upath2(($td), ($dirfd), ($upath)); }  &while (0));
	}' unless defined(&AUDIT_ARG_UPATH2);
	eval 'sub AUDIT_ARG_VALUE {
	    my($value) = @_;
    	    eval q( &do {  &if ( &AUDITING_TD( &curthread))  &audit_arg_value(($value)); }  &while (0));
	}' unless defined(&AUDIT_ARG_VALUE);
	eval 'sub AUDIT_ARG_VNODE1 {
	    my($vp) = @_;
    	    eval q( &do {  &if ( &AUDITING_TD( &curthread))  &audit_arg_vnode1(($vp)); }  &while (0));
	}' unless defined(&AUDIT_ARG_VNODE1);
	eval 'sub AUDIT_ARG_VNODE2 {
	    my($vp) = @_;
    	    eval q( &do {  &if ( &AUDITING_TD( &curthread))  &audit_arg_vnode2(($vp)); }  &while (0));
	}' unless defined(&AUDIT_ARG_VNODE2);
	eval 'sub AUDIT_SYSCALL_ENTER {
	    my($code, $td) = @_;
    	    eval q( &do {  &if ( &audit_enabled) {  &audit_syscall_enter($code, $td); } }  &while (0));
	}' unless defined(&AUDIT_SYSCALL_ENTER);
	eval 'sub AUDIT_SYSCALL_EXIT {
	    my($error, $td) = @_;
    	    eval q( &do {  &if ( ($td->{td_pflags}) &  &TDP_AUDITREC)  &audit_syscall_exit($error, $td); }  &while (0));
	}' unless defined(&AUDIT_SYSCALL_EXIT);
	eval 'sub AUDIT_SYSCLOSE {
	    my($td, $fd) = @_;
    	    eval q( &do {  &if ( ($td->{td_pflags}) &  &TDP_AUDITREC)  &audit_sysclose($td, $fd); }  &while (0));
	}' unless defined(&AUDIT_SYSCLOSE);
    } else {
	eval 'sub AUDIT_ARG_ADDR {
	    my($addr) = @_;
    	    eval q();
	}' unless defined(&AUDIT_ARG_ADDR);
	eval 'sub AUDIT_ARG_ARGV {
	    my($argv, $argc, $length) = @_;
    	    eval q();
	}' unless defined(&AUDIT_ARG_ARGV);
	eval 'sub AUDIT_ARG_ATFD1 {
	    my($atfd) = @_;
    	    eval q();
	}' unless defined(&AUDIT_ARG_ATFD1);
	eval 'sub AUDIT_ARG_ATFD2 {
	    my($atfd) = @_;
    	    eval q();
	}' unless defined(&AUDIT_ARG_ATFD2);
	eval 'sub AUDIT_ARG_AUDITON {
	    my($udata) = @_;
    	    eval q();
	}' unless defined(&AUDIT_ARG_AUDITON);
	eval 'sub AUDIT_ARG_CMD {
	    my($cmd) = @_;
    	    eval q();
	}' unless defined(&AUDIT_ARG_CMD);
	eval 'sub AUDIT_ARG_DEV {
	    my($dev) = @_;
    	    eval q();
	}' unless defined(&AUDIT_ARG_DEV);
	eval 'sub AUDIT_ARG_EGID {
	    my($egid) = @_;
    	    eval q();
	}' unless defined(&AUDIT_ARG_EGID);
	eval 'sub AUDIT_ARG_ENVV {
	    my($envv, $envc, $length) = @_;
    	    eval q();
	}' unless defined(&AUDIT_ARG_ENVV);
	eval 'sub AUDIT_ARG_EXIT {
	    my($status, $retval) = @_;
    	    eval q();
	}' unless defined(&AUDIT_ARG_EXIT);
	eval 'sub AUDIT_ARG_EUID {
	    my($euid) = @_;
    	    eval q();
	}' unless defined(&AUDIT_ARG_EUID);
	eval 'sub AUDIT_ARG_FD {
	    my($fd) = @_;
    	    eval q();
	}' unless defined(&AUDIT_ARG_FD);
	eval 'sub AUDIT_ARG_FILE {
	    my($p, $fp) = @_;
    	    eval q();
	}' unless defined(&AUDIT_ARG_FILE);
	eval 'sub AUDIT_ARG_FFLAGS {
	    my($fflags) = @_;
    	    eval q();
	}' unless defined(&AUDIT_ARG_FFLAGS);
	eval 'sub AUDIT_ARG_GID {
	    my($gid) = @_;
    	    eval q();
	}' unless defined(&AUDIT_ARG_GID);
	eval 'sub AUDIT_ARG_GROUPSET {
	    my($gidset, $gidset_size) = @_;
    	    eval q();
	}' unless defined(&AUDIT_ARG_GROUPSET);
	eval 'sub AUDIT_ARG_MODE {
	    my($mode) = @_;
    	    eval q();
	}' unless defined(&AUDIT_ARG_MODE);
	eval 'sub AUDIT_ARG_OWNER {
	    my($uid, $gid) = @_;
    	    eval q();
	}' unless defined(&AUDIT_ARG_OWNER);
	eval 'sub AUDIT_ARG_PID {
	    my($pid) = @_;
    	    eval q();
	}' unless defined(&AUDIT_ARG_PID);
	eval 'sub AUDIT_ARG_PROCESS {
	    my($p) = @_;
    	    eval q();
	}' unless defined(&AUDIT_ARG_PROCESS);
	eval 'sub AUDIT_ARG_RGID {
	    my($rgid) = @_;
    	    eval q();
	}' unless defined(&AUDIT_ARG_RGID);
	eval 'sub AUDIT_ARG_RIGHTS {
	    my($rights) = @_;
    	    eval q();
	}' unless defined(&AUDIT_ARG_RIGHTS);
	eval 'sub AUDIT_ARG_FCNTL_RIGHTS {
	    my($fcntlrights) = @_;
    	    eval q();
	}' unless defined(&AUDIT_ARG_FCNTL_RIGHTS);
	eval 'sub AUDIT_ARG_RUID {
	    my($ruid) = @_;
    	    eval q();
	}' unless defined(&AUDIT_ARG_RUID);
	eval 'sub AUDIT_ARG_SIGNUM {
	    my($signum) = @_;
    	    eval q();
	}' unless defined(&AUDIT_ARG_SIGNUM);
	eval 'sub AUDIT_ARG_SGID {
	    my($sgid) = @_;
    	    eval q();
	}' unless defined(&AUDIT_ARG_SGID);
	eval 'sub AUDIT_ARG_SOCKET {
	    my($sodomain, $sotype, $soprotocol) = @_;
    	    eval q();
	}' unless defined(&AUDIT_ARG_SOCKET);
	eval 'sub AUDIT_ARG_SOCKADDR {
	    my($td, $dirfd, $sa) = @_;
    	    eval q();
	}' unless defined(&AUDIT_ARG_SOCKADDR);
	eval 'sub AUDIT_ARG_SUID {
	    my($suid) = @_;
    	    eval q();
	}' unless defined(&AUDIT_ARG_SUID);
	eval 'sub AUDIT_ARG_TEXT {
	    my($text) = @_;
    	    eval q();
	}' unless defined(&AUDIT_ARG_TEXT);
	eval 'sub AUDIT_ARG_UID {
	    my($uid) = @_;
    	    eval q();
	}' unless defined(&AUDIT_ARG_UID);
	eval 'sub AUDIT_ARG_UPATH1 {
	    my($td, $dirfd, $upath) = @_;
    	    eval q();
	}' unless defined(&AUDIT_ARG_UPATH1);
	eval 'sub AUDIT_ARG_UPATH2 {
	    my($td, $dirfd, $upath) = @_;
    	    eval q();
	}' unless defined(&AUDIT_ARG_UPATH2);
	eval 'sub AUDIT_ARG_VALUE {
	    my($value) = @_;
    	    eval q();
	}' unless defined(&AUDIT_ARG_VALUE);
	eval 'sub AUDIT_ARG_VNODE1 {
	    my($vp) = @_;
    	    eval q();
	}' unless defined(&AUDIT_ARG_VNODE1);
	eval 'sub AUDIT_ARG_VNODE2 {
	    my($vp) = @_;
    	    eval q();
	}' unless defined(&AUDIT_ARG_VNODE2);
	eval 'sub AUDIT_SYSCALL_ENTER {
	    my($code, $td) = @_;
    	    eval q();
	}' unless defined(&AUDIT_SYSCALL_ENTER);
	eval 'sub AUDIT_SYSCALL_EXIT {
	    my($error, $td) = @_;
    	    eval q();
	}' unless defined(&AUDIT_SYSCALL_EXIT);
	eval 'sub AUDIT_SYSCLOSE {
	    my($p, $fd) = @_;
    	    eval q();
	}' unless defined(&AUDIT_SYSCLOSE);
    }
}
1;
