require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SSP_STRING_H)) {
    eval 'sub _SSP_STRING_H () {1;}' unless defined(&_SSP_STRING_H);
    require 'ssp.ph';
    eval {
	my(@REM);
	my(%INCD) = map { $INC{$_} => 1 } (grep { $_ eq "string.ph" } keys(%INC));
	@REM = map { "$_/string.ph" } (grep { not exists($INCD{"$_/string.ph"}) and -f "$_/string.ph" } @INC);
	require "$REM[0]" if @REM;
    };
    warn($@) if $@;
    if((defined(&__SSP_FORTIFY_LEVEL) ? &__SSP_FORTIFY_LEVEL : undef) > 0) {
	undef(&memcpy) if defined(&memcpy);
	undef(&memmove) if defined(&memmove);
	undef(&memset) if defined(&memset);
	undef(&strcat) if defined(&strcat);
	undef(&strcpy) if defined(&strcpy);
	undef(&strncat) if defined(&strncat);
	undef(&strncpy) if defined(&strncpy);
	undef(&mempcpy) if defined(&mempcpy);
	undef(&stpcpy) if defined(&stpcpy);
	undef(&bcopy) if defined(&bcopy);
	undef(&bzero) if defined(&bzero);
	eval 'sub memcpy {
	    my($dest, $src, $len) = @_;
    	    eval q((( &__ssp_bos0 ($dest) !=  -1) ?  &__builtin___memcpy_chk ($dest, $src, $len,  &__ssp_bos0 ($dest)) :  &__memcpy_ichk ($dest, $src, $len)));
	}' unless defined(&memcpy);
	eval 'sub __attribute__ () {
	    eval q((( &__always_inline__))  &void *  &__memcpy_ichk ( &void * &__restrict__  &__dest,  &const  &void * &__restrict__  &__src, \'size_t\'  &__len) {  &__builtin___memcpy_chk ( &__dest,  &__src,  &__len,  &__ssp_bos0 ( &__dest)); });
	}' unless defined(&__attribute__);
	eval 'sub memmove {
	    my($dest, $src, $len) = @_;
    	    eval q((( &__ssp_bos0 ($dest) !=  -1) ?  &__builtin___memmove_chk ($dest, $src, $len,  &__ssp_bos0 ($dest)) :  &__memmove_ichk ($dest, $src, $len)));
	}' unless defined(&memmove);
	eval 'sub __attribute__ () {
	    eval q((( &__always_inline__))  &void *  &__memmove_ichk ( &void * &__dest,  &const  &void * &__src, \'size_t\'  &__len) {  &__builtin___memmove_chk ( &__dest,  &__src,  &__len,  &__ssp_bos0 ( &__dest)); });
	}' unless defined(&__attribute__);
	eval 'sub mempcpy {
	    my($dest, $src, $len) = @_;
    	    eval q((( &__ssp_bos0 ($dest) !=  -1) ?  &__builtin___mempcpy_chk ($dest, $src, $len,  &__ssp_bos0 ($dest)) :  &__mempcpy_ichk ($dest, $src, $len)));
	}' unless defined(&mempcpy);
	eval 'sub __attribute__ () {
	    eval q((( &__always_inline__))  &void *  &__mempcpy_ichk ( &void * &__restrict__  &__dest,  &const  &void * &__restrict__  &__src, \'size_t\'  &__len) {  &__builtin___mempcpy_chk ( &__dest,  &__src,  &__len,  &__ssp_bos0 ( &__dest)); });
	}' unless defined(&__attribute__);
	eval 'sub memset {
	    my($dest, $ch, $len) = @_;
    	    eval q((( &__ssp_bos0 ($dest) !=  -1) ?  &__builtin___memset_chk ($dest, $ch, $len,  &__ssp_bos0 ($dest)) :  &__memset_ichk ($dest, $ch, $len)));
	}' unless defined(&memset);
	eval 'sub __attribute__ () {
	    eval q((( &__always_inline__))  &void *  &__memset_ichk ( &void * &__dest, \'int\'  &__ch, \'size_t\'  &__len) {  &__builtin___memset_chk ( &__dest,  &__ch,  &__len,  &__ssp_bos0 ( &__dest)); });
	}' unless defined(&__attribute__);
	eval 'sub bcopy {
	    my($src, $dest, $len) = @_;
    	    eval q((( &void) (( &__ssp_bos0 ($dest) !=  -1) ?  &__builtin___memmove_chk ($dest, $src, $len,  &__ssp_bos0 ($dest)) :  &__memmove_ichk ($dest, $src, $len))));
	}' unless defined(&bcopy);
	eval 'sub bzero {
	    my($dest, $len) = @_;
    	    eval q((( &void) (( &__ssp_bos0 ($dest) !=  -1) ?  &__builtin___memset_chk ($dest, ord(\'\\\\0\', len, __ssp_bos0 (dest))	   : __memset_ichk (dest, \'\\\\0\'), $len))));
	}' unless defined(&bzero);
	eval 'sub strcpy {
	    my($dest, $src) = @_;
    	    eval q((( &__ssp_bos ($dest) !=  -1) ?  &__builtin___strcpy_chk ($dest, $src,  &__ssp_bos ($dest)) :  &__strcpy_ichk ($dest, $src)));
	}' unless defined(&strcpy);
	eval 'sub __attribute__ () {
	    eval q((( &__always_inline__)) \'char\' *  &__strcpy_ichk (\'char\' * &__restrict__  &__dest,  &const \'char\' * &__restrict__  &__src) {  &__builtin___strcpy_chk ( &__dest,  &__src,  &__ssp_bos ( &__dest)); });
	}' unless defined(&__attribute__);
	eval 'sub stpcpy {
	    my($dest, $src) = @_;
    	    eval q((( &__ssp_bos ($dest) !=  -1) ?  &__builtin___stpcpy_chk ($dest, $src,  &__ssp_bos ($dest)) :  &__stpcpy_ichk ($dest, $src)));
	}' unless defined(&stpcpy);
	eval 'sub __attribute__ () {
	    eval q((( &__always_inline__)) \'char\' *  &__stpcpy_ichk (\'char\' * &__restrict__  &__dest,  &const \'char\' * &__restrict__  &__src) {  &__builtin___stpcpy_chk ( &__dest,  &__src,  &__ssp_bos ( &__dest)); });
	}' unless defined(&__attribute__);
	eval 'sub strncpy {
	    my($dest, $src, $len) = @_;
    	    eval q((( &__ssp_bos ($dest) !=  -1) ?  &__builtin___strncpy_chk ($dest, $src, $len,  &__ssp_bos ($dest)) :  &__strncpy_ichk ($dest, $src, $len)));
	}' unless defined(&strncpy);
	eval 'sub __attribute__ () {
	    eval q((( &__always_inline__)) \'char\' *  &__strncpy_ichk (\'char\' * &__restrict__  &__dest,  &const \'char\' * &__restrict__  &__src, \'size_t\'  &__len) {  &__builtin___strncpy_chk ( &__dest,  &__src,  &__len,  &__ssp_bos ( &__dest)); });
	}' unless defined(&__attribute__);
	eval 'sub strcat {
	    my($dest, $src) = @_;
    	    eval q((( &__ssp_bos ($dest) !=  -1) ?  &__builtin___strcat_chk ($dest, $src,  &__ssp_bos ($dest)) :  &__strcat_ichk ($dest, $src)));
	}' unless defined(&strcat);
	eval 'sub __attribute__ () {
	    eval q((( &__always_inline__)) \'char\' *  &__strcat_ichk (\'char\' * &__restrict__  &__dest,  &const \'char\' * &__restrict__  &__src) {  &__builtin___strcat_chk ( &__dest,  &__src,  &__ssp_bos ( &__dest)); });
	}' unless defined(&__attribute__);
	eval 'sub strncat {
	    my($dest, $src, $len) = @_;
    	    eval q((( &__ssp_bos ($dest) !=  -1) ?  &__builtin___strncat_chk ($dest, $src, $len,  &__ssp_bos ($dest)) :  &__strncat_ichk ($dest, $src, $len)));
	}' unless defined(&strncat);
	eval 'sub __attribute__ () {
	    eval q((( &__always_inline__)) \'char\' *  &__strncat_ichk (\'char\' * &__restrict__  &__dest,  &const \'char\' * &__restrict__  &__src, \'size_t\'  &__len) {  &__builtin___strncat_chk ( &__dest,  &__src,  &__len,  &__ssp_bos ( &__dest)); });
	}' unless defined(&__attribute__);
    }
}
1;
