require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_UFS_FFS_FS_H_)) {
    eval 'sub _UFS_FFS_FS_H_ () {1;}' unless defined(&_UFS_FFS_FS_H_);
    require 'sys/mount.ph';
    require 'ufs/ufs/dinode.ph';
    eval 'sub SBLOCK_FLOPPY () {0;}' unless defined(&SBLOCK_FLOPPY);
    eval 'sub SBLOCK_UFS1 () {8192;}' unless defined(&SBLOCK_UFS1);
    eval 'sub SBLOCK_UFS2 () {65536;}' unless defined(&SBLOCK_UFS2);
    eval 'sub SBLOCK_PIGGY () {262144;}' unless defined(&SBLOCK_PIGGY);
    eval 'sub SBLOCKSIZE () {8192;}' unless defined(&SBLOCKSIZE);
    eval 'sub SBLOCKSEARCH () {{  &SBLOCK_UFS2,  &SBLOCK_UFS1,  &SBLOCK_FLOPPY,  &SBLOCK_PIGGY, -1};}' unless defined(&SBLOCKSEARCH);
    eval 'sub MAXFRAG () {8;}' unless defined(&MAXFRAG);
    eval 'sub MINBSIZE () {4096;}' unless defined(&MINBSIZE);
    eval 'sub MAXMNTLEN () {468;}' unless defined(&MAXMNTLEN);
    eval 'sub MAXVOLLEN () {32;}' unless defined(&MAXVOLLEN);
    eval 'sub NOCSPTRS () {((128/ $sizeof{ &void }) - 4);}' unless defined(&NOCSPTRS);
    eval 'sub FS_MAXCONTIG () {16;}' unless defined(&FS_MAXCONTIG);
    eval 'sub MINFREE () {8;}' unless defined(&MINFREE);
    eval 'sub DEFAULTOPT () { &FS_OPTTIME;}' unless defined(&DEFAULTOPT);
    eval 'sub AVFILESIZ () {16384;}' unless defined(&AVFILESIZ);
    eval 'sub AFPDIR () {64;}' unless defined(&AFPDIR);
    eval 'sub FSMAXSNAP () {20;}' unless defined(&FSMAXSNAP);
    eval 'sub BLK_NOCOPY () {(( &ufs2_daddr_t)(1));}' unless defined(&BLK_NOCOPY);
    eval 'sub BLK_SNAP () {(( &ufs2_daddr_t)(2));}' unless defined(&BLK_SNAP);
    eval 'sub FFS_ADJ_REFCNT () {1;}' unless defined(&FFS_ADJ_REFCNT);
    eval 'sub FFS_ADJ_BLKCNT () {2;}' unless defined(&FFS_ADJ_BLKCNT);
    eval 'sub FFS_BLK_FREE () {3;}' unless defined(&FFS_BLK_FREE);
    eval 'sub FFS_DIR_FREE () {4;}' unless defined(&FFS_DIR_FREE);
    eval 'sub FFS_FILE_FREE () {5;}' unless defined(&FFS_FILE_FREE);
    eval 'sub FFS_SET_FLAGS () {6;}' unless defined(&FFS_SET_FLAGS);
    eval 'sub FFS_ADJ_NDIR () {7;}' unless defined(&FFS_ADJ_NDIR);
    eval 'sub FFS_ADJ_NBFREE () {8;}' unless defined(&FFS_ADJ_NBFREE);
    eval 'sub FFS_ADJ_NIFREE () {9;}' unless defined(&FFS_ADJ_NIFREE);
    eval 'sub FFS_ADJ_NFFREE () {10;}' unless defined(&FFS_ADJ_NFFREE);
    eval 'sub FFS_ADJ_NUMCLUSTERS () {11;}' unless defined(&FFS_ADJ_NUMCLUSTERS);
    eval 'sub FFS_SET_CWD () {12;}' unless defined(&FFS_SET_CWD);
    eval 'sub FFS_SET_DOTDOT () {13;}' unless defined(&FFS_SET_DOTDOT);
    eval 'sub FFS_UNLINK () {14;}' unless defined(&FFS_UNLINK);
    eval 'sub FFS_SET_INODE () {15;}' unless defined(&FFS_SET_INODE);
    eval 'sub FFS_SET_BUFOUTPUT () {16;}' unless defined(&FFS_SET_BUFOUTPUT);
    eval 'sub FFS_MAXID () {16;}' unless defined(&FFS_MAXID);
    eval 'sub FFS_CMD_VERSION () {0x19790518;}' unless defined(&FFS_CMD_VERSION);
    eval 'sub RESID () {(4096- 20);}' unless defined(&RESID);
    if(defined(&CTASSERT)) {
    }
    eval 'sub FS_UFS1_MAGIC () {0x11954;}' unless defined(&FS_UFS1_MAGIC);
    eval 'sub FS_UFS2_MAGIC () {0x19540119;}' unless defined(&FS_UFS2_MAGIC);
    eval 'sub FS_BAD_MAGIC () {0x19960408;}' unless defined(&FS_BAD_MAGIC);
    eval 'sub FS_OKAY () {0x7c269d38;}' unless defined(&FS_OKAY);
    eval 'sub FS_42INODEFMT () {-1;}' unless defined(&FS_42INODEFMT);
    eval 'sub FS_44INODEFMT () {2;}' unless defined(&FS_44INODEFMT);
    eval 'sub FS_OPTTIME () {0;}' unless defined(&FS_OPTTIME);
    eval 'sub FS_OPTSPACE () {1;}' unless defined(&FS_OPTSPACE);
    eval 'sub FS_UNCLEAN () {0x1;}' unless defined(&FS_UNCLEAN);
    eval 'sub FS_DOSOFTDEP () {0x2;}' unless defined(&FS_DOSOFTDEP);
    eval 'sub FS_NEEDSFSCK () {0x4;}' unless defined(&FS_NEEDSFSCK);
    eval 'sub FS_SUJ () {0x8;}' unless defined(&FS_SUJ);
    eval 'sub FS_ACLS () {0x10;}' unless defined(&FS_ACLS);
    eval 'sub FS_MULTILABEL () {0x20;}' unless defined(&FS_MULTILABEL);
    eval 'sub FS_GJOURNAL () {0x40;}' unless defined(&FS_GJOURNAL);
    eval 'sub FS_FLAGS_UPDATED () {0x80;}' unless defined(&FS_FLAGS_UPDATED);
    eval 'sub FS_NFS4ACLS () {0x100;}' unless defined(&FS_NFS4ACLS);
    eval 'sub FS_INDEXDIRS () {0x200;}' unless defined(&FS_INDEXDIRS);
    eval 'sub FS_TRIM () {0x400;}' unless defined(&FS_TRIM);
    eval 'sub ACTIVECGNUM {
        my($fs, $cg) = @_;
	    eval q((($fs)-> $fs_active[($cg) / ( &NBBY * $sizeof{\'int\'})]));
    }' unless defined(&ACTIVECGNUM);
    eval 'sub ACTIVECGOFF {
        my($cg) = @_;
	    eval q((1<< (($cg) % ( &NBBY * $sizeof{\'int\'}))));
    }' unless defined(&ACTIVECGOFF);
    eval 'sub ACTIVESET {
        my($fs, $cg) = @_;
	    eval q( &do {  &if (($fs)-> &fs_active)  &ACTIVECGNUM(($fs), ($cg)) |=  &ACTIVECGOFF(($cg)); }  &while (0));
    }' unless defined(&ACTIVESET);
    eval 'sub ACTIVECLEAR {
        my($fs, $cg) = @_;
	    eval q( &do {  &if (($fs)-> &fs_active)  &ACTIVECGNUM(($fs), ($cg)) &= ~ &ACTIVECGOFF(($cg)); }  &while (0));
    }' unless defined(&ACTIVECLEAR);
    eval 'sub CGSIZE {
        my($fs) = @_;
	    eval q(($sizeof{\'struct cg\'} + $sizeof{ &int32_t} + ($fs)-> &fs_old_cpg * $sizeof{ &int32_t} + ($fs)-> &fs_old_cpg * $sizeof{ &u_int16_t} +  &howmany(($fs)-> &fs_ipg,  &NBBY) +  &howmany(($fs)-> &fs_fpg,  &NBBY) + (($fs)-> &fs_contigsumsize <= 0? 0: ($fs)-> &fs_contigsumsize * $sizeof{ &int32_t} +  &howmany( &fragstoblks($fs, ($fs)-> &fs_fpg),  &NBBY))));
    }' unless defined(&CGSIZE);
    eval 'sub MINCYLGRPS () {4;}' unless defined(&MINCYLGRPS);
    eval 'sub fs_cs {
        my($fs, $indx) = @_;
	    eval q( $fs_csp[$indx]);
    }' unless defined(&fs_cs);
    eval 'sub CG_MAGIC () {0x90255;}' unless defined(&CG_MAGIC);
    eval 'sub cg_chkmagic {
        my($cgp) = @_;
	    eval q((($cgp)-> &cg_magic ==  &CG_MAGIC));
    }' unless defined(&cg_chkmagic);
    eval 'sub cg_inosused {
        my($cgp) = @_;
	    eval q((( &u_int8_t *)(( &u_int8_t *)($cgp) + ($cgp)-> &cg_iusedoff)));
    }' unless defined(&cg_inosused);
    eval 'sub cg_blksfree {
        my($cgp) = @_;
	    eval q((( &u_int8_t *)(( &u_int8_t *)($cgp) + ($cgp)-> &cg_freeoff)));
    }' unless defined(&cg_blksfree);
    eval 'sub cg_clustersfree {
        my($cgp) = @_;
	    eval q((( &u_int8_t *)(( &u_int8_t *)($cgp) + ($cgp)-> &cg_clusteroff)));
    }' unless defined(&cg_clustersfree);
    eval 'sub cg_clustersum {
        my($cgp) = @_;
	    eval q((( &int32_t *)(( &uintptr_t)($cgp) + ($cgp)-> &cg_clustersumoff)));
    }' unless defined(&cg_clustersum);
    eval 'sub fsbtodb {
        my($fs, $b) = @_;
	    eval q((( &daddr_t)($b) << ($fs)-> &fs_fsbtodb));
    }' unless defined(&fsbtodb);
    eval 'sub dbtofsb {
        my($fs, $b) = @_;
	    eval q((($b) >> ($fs)-> &fs_fsbtodb));
    }' unless defined(&dbtofsb);
    eval 'sub cgbase {
        my($fs, $c) = @_;
	    eval q(((( &ufs2_daddr_t)($fs)-> &fs_fpg) * ($c)));
    }' unless defined(&cgbase);
    eval 'sub cgdata {
        my($fs, $c) = @_;
	    eval q(( &cgdmin($fs, $c) + ($fs)-> &fs_metaspace));
    }' unless defined(&cgdata);
    eval 'sub cgmeta {
        my($fs, $c) = @_;
	    eval q(( &cgdmin($fs, $c)));
    }' unless defined(&cgmeta);
    eval 'sub cgdmin {
        my($fs, $c) = @_;
	    eval q(( &cgstart($fs, $c) + ($fs)-> &fs_dblkno));
    }' unless defined(&cgdmin);
    eval 'sub cgimin {
        my($fs, $c) = @_;
	    eval q(( &cgstart($fs, $c) + ($fs)-> &fs_iblkno));
    }' unless defined(&cgimin);
    eval 'sub cgsblock {
        my($fs, $c) = @_;
	    eval q(( &cgstart($fs, $c) + ($fs)-> &fs_sblkno));
    }' unless defined(&cgsblock);
    eval 'sub cgtod {
        my($fs, $c) = @_;
	    eval q(( &cgstart($fs, $c) + ($fs)-> &fs_cblkno));
    }' unless defined(&cgtod);
    eval 'sub cgstart {
        my($fs, $c) = @_;
	    eval q((($fs)-> &fs_magic ==  &FS_UFS2_MAGIC ?  &cgbase($fs, $c) : ( &cgbase($fs, $c) + ($fs)-> &fs_old_cgoffset * (($c) & ~(($fs)-> &fs_old_cgmask)))));
    }' unless defined(&cgstart);
    eval 'sub ino_to_cg {
        my($fs, $x) = @_;
	    eval q(((( &ino_t)($x)) / ($fs)-> &fs_ipg));
    }' unless defined(&ino_to_cg);
    eval 'sub ino_to_fsba {
        my($fs, $x) = @_;
	    eval q((( &ufs2_daddr_t)( &cgimin($fs,  &ino_to_cg($fs, ( &ino_t)($x))) + ( &blkstofrags(($fs), (((( &ino_t)($x)) % ($fs)-> &fs_ipg) /  &INOPB($fs)))))));
    }' unless defined(&ino_to_fsba);
    eval 'sub ino_to_fsbo {
        my($fs, $x) = @_;
	    eval q(((( &ino_t)($x)) %  &INOPB($fs)));
    }' unless defined(&ino_to_fsbo);
    eval 'sub dtog {
        my($fs, $d) = @_;
	    eval q((($d) / ($fs)-> &fs_fpg));
    }' unless defined(&dtog);
    eval 'sub dtogd {
        my($fs, $d) = @_;
	    eval q((($d) % ($fs)-> &fs_fpg));
    }' unless defined(&dtogd);
    eval 'sub blkmap {
        my($fs, $map, $loc) = @_;
	    eval q(((($map)[($loc) /  &NBBY] >> (($loc) %  &NBBY)) & (0xff >> ( &NBBY - ($fs)-> &fs_frag))));
    }' unless defined(&blkmap);
    eval 'sub blkoff {
        my($fs, $loc) = @_;
	    eval q((($loc) & ($fs)-> &fs_qbmask));
    }' unless defined(&blkoff);
    eval 'sub fragoff {
        my($fs, $loc) = @_;
	    eval q((($loc) & ($fs)-> &fs_qfmask));
    }' unless defined(&fragoff);
    eval 'sub lfragtosize {
        my($fs, $frag) = @_;
	    eval q(((( &off_t)($frag)) << ($fs)-> &fs_fshift));
    }' unless defined(&lfragtosize);
    eval 'sub lblktosize {
        my($fs, $blk) = @_;
	    eval q(((( &off_t)($blk)) << ($fs)-> &fs_bshift));
    }' unless defined(&lblktosize);
    eval 'sub smalllblktosize {
        my($fs, $blk) = @_;
	    eval q((($blk) << ($fs)-> &fs_bshift));
    }' unless defined(&smalllblktosize);
    eval 'sub lblkno {
        my($fs, $loc) = @_;
	    eval q((($loc) >> ($fs)-> &fs_bshift));
    }' unless defined(&lblkno);
    eval 'sub numfrags {
        my($fs, $loc) = @_;
	    eval q((($loc) >> ($fs)-> &fs_fshift));
    }' unless defined(&numfrags);
    eval 'sub blkroundup {
        my($fs, $size) = @_;
	    eval q(((($size) + ($fs)-> &fs_qbmask) & ($fs)-> &fs_bmask));
    }' unless defined(&blkroundup);
    eval 'sub fragroundup {
        my($fs, $size) = @_;
	    eval q(((($size) + ($fs)-> &fs_qfmask) & ($fs)-> &fs_fmask));
    }' unless defined(&fragroundup);
    eval 'sub fragstoblks {
        my($fs, $frags) = @_;
	    eval q((($frags) >> ($fs)-> &fs_fragshift));
    }' unless defined(&fragstoblks);
    eval 'sub blkstofrags {
        my($fs, $blks) = @_;
	    eval q((($blks) << ($fs)-> &fs_fragshift));
    }' unless defined(&blkstofrags);
    eval 'sub fragnum {
        my($fs, $fsb) = @_;
	    eval q((($fsb) & (($fs)-> &fs_frag - 1)));
    }' unless defined(&fragnum);
    eval 'sub blknum {
        my($fs, $fsb) = @_;
	    eval q((($fsb) &~ (($fs)-> &fs_frag - 1)));
    }' unless defined(&blknum);
    eval 'sub freespace {
        my($fs, $percentreserved) = @_;
	    eval q(( &blkstofrags(($fs), ($fs)-> ($fs_cstotal->{cs_nbfree})) + ($fs)-> ($fs_cstotal->{cs_nffree}) - ((( &off_t)(($fs)-> &fs_dsize)) * ($percentreserved) / 100)));
    }' unless defined(&freespace);
    eval 'sub blksize {
        my($fs, $ip, $lbn) = @_;
	    eval q(((($lbn) >=  &NDADDR || ($ip)-> &i_size >=  &smalllblktosize($fs, ($lbn) + 1)) ? ($fs)-> &fs_bsize : ( &fragroundup($fs,  &blkoff($fs, ($ip)-> &i_size)))));
    }' unless defined(&blksize);
    eval 'sub sblksize {
        my($fs, $size, $lbn) = @_;
	    eval q(((($lbn) >=  &NDADDR || ($size) >= (($lbn) + 1) << ($fs)-> &fs_bshift) ? ($fs)-> &fs_bsize : ( &fragroundup($fs,  &blkoff($fs, ($size))))));
    }' unless defined(&sblksize);
    eval 'sub NINDIR {
        my($fs) = @_;
	    eval q((($fs)-> &fs_nindir));
    }' unless defined(&NINDIR);
    eval 'sub lbn_offset {
        my($fs,$level) = @_;
	    eval q({  &ufs_lbn_t  &res;  &for ( &res = 1; $level > 0; $level--)  &res *=  &NINDIR($fs); ( &res); });
    }' unless defined(&lbn_offset);
    eval 'sub INOPB {
        my($fs) = @_;
	    eval q((($fs)-> &fs_inopb));
    }' unless defined(&INOPB);
    eval 'sub INOPF {
        my($fs) = @_;
	    eval q((($fs)-> &fs_inopb >> ($fs)-> &fs_fragshift));
    }' unless defined(&INOPF);
    eval 'sub JOP_ADDREF () {1;}' unless defined(&JOP_ADDREF);
    eval 'sub JOP_REMREF () {2;}' unless defined(&JOP_REMREF);
    eval 'sub JOP_NEWBLK () {3;}' unless defined(&JOP_NEWBLK);
    eval 'sub JOP_FREEBLK () {4;}' unless defined(&JOP_FREEBLK);
    eval 'sub JOP_MVREF () {5;}' unless defined(&JOP_MVREF);
    eval 'sub JOP_TRUNC () {6;}' unless defined(&JOP_TRUNC);
    eval 'sub JOP_SYNC () {7;}' unless defined(&JOP_SYNC);
    eval 'sub JREC_SIZE () {32;}' unless defined(&JREC_SIZE);
    eval 'sub SUJ_MIN () {(4* 1024* 1024);}' unless defined(&SUJ_MIN);
    eval 'sub SUJ_MAX () {(32* 1024* 1024);}' unless defined(&SUJ_MAX);
    eval 'sub SUJ_FILE () {".sujournal";}' unless defined(&SUJ_FILE);
    if(defined(&CTASSERT)) {
    }
    eval 'sub UFSSUSPEND () { &_IOW(ord(\'U\'), 1,  &fsid_t);}' unless defined(&UFSSUSPEND);
    eval 'sub UFSRESUME () { &_IO(ord(\'U\'), 2);}' unless defined(&UFSRESUME);
}
1;
