require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_UFS_UFS_INODE_H_)) {
    eval 'sub _UFS_UFS_INODE_H_ () {1;}' unless defined(&_UFS_UFS_INODE_H_);
    require 'sys/lock.ph';
    require 'sys/queue.ph';
    require 'ufs/ufs/dinode.ph';
    eval 'sub doff_t () { &int32_t;}' unless defined(&doff_t);
    eval 'sub IN_ACCESS () {0x1;}' unless defined(&IN_ACCESS);
    eval 'sub IN_CHANGE () {0x2;}' unless defined(&IN_CHANGE);
    eval 'sub IN_UPDATE () {0x4;}' unless defined(&IN_UPDATE);
    eval 'sub IN_MODIFIED () {0x8;}' unless defined(&IN_MODIFIED);
    eval 'sub IN_NEEDSYNC () {0x10;}' unless defined(&IN_NEEDSYNC);
    eval 'sub IN_LAZYMOD () {0x20;}' unless defined(&IN_LAZYMOD);
    eval 'sub IN_LAZYACCESS () {0x40;}' unless defined(&IN_LAZYACCESS);
    eval 'sub IN_EA_LOCKED () {0x80;}' unless defined(&IN_EA_LOCKED);
    eval 'sub IN_EA_LOCKWAIT () {0x100;}' unless defined(&IN_EA_LOCKWAIT);
    eval 'sub IN_TRUNCATED () {0x200;}' unless defined(&IN_TRUNCATED);
    eval 'sub IN_UFS2 () {0x400;}' unless defined(&IN_UFS2);
    eval 'sub i_dirhash () { ($i_un->{dirhash});}' unless defined(&i_dirhash);
    eval 'sub i_snapblklist () { ($i_un->{snapblklist});}' unless defined(&i_snapblklist);
    eval 'sub i_din1 () { ($dinode_u->{din1});}' unless defined(&i_din1);
    eval 'sub i_din2 () { ($dinode_u->{din2});}' unless defined(&i_din2);
    if(defined(&_KERNEL)) {
	eval 'sub ITOUMP {
	    my($ip) = @_;
    	    eval q((($ip)-> &i_ump));
	}' unless defined(&ITOUMP);
	eval 'sub ITODEV {
	    my($ip) = @_;
    	    eval q(( &ITOUMP($ip)-> &um_dev));
	}' unless defined(&ITODEV);
	eval 'sub ITODEVVP {
	    my($ip) = @_;
    	    eval q(( &ITOUMP($ip)-> &um_devvp));
	}' unless defined(&ITODEVVP);
	eval 'sub ITOFS {
	    my($ip) = @_;
    	    eval q(( &ITOUMP($ip)-> &um_fs));
	}' unless defined(&ITOFS);
	eval 'sub ITOVFS {
	    my($ip) = @_;
    	    eval q((($ip)-> ($i_vnode->{v_mount})));
	}' unless defined(&ITOVFS);
	eval 'sub I_IS_UFS1 {
	    my($ip) = @_;
    	    eval q({ (( ($ip->{i_flag}) &  &IN_UFS2) == 0); });
	}' unless defined(&I_IS_UFS1);
	eval 'sub I_IS_UFS2 {
	    my($ip) = @_;
    	    eval q({ (( ($ip->{i_flag}) &  &IN_UFS2) != 0); });
	}' unless defined(&I_IS_UFS2);
	eval 'sub DIP {
	    my($ip, $field) = @_;
    	    eval q(( &I_IS_UFS1($ip) ? ($ip)-> ($i_din1->{d})$field : ($ip)-> ($i_din2->{d})$field));
	}' unless defined(&DIP);
	eval 'sub DIP_SET {
	    my($ip, $field, $val) = @_;
    	    eval q( &do {  &if ( &I_IS_UFS1($ip)) ($ip)-> ($i_din1->{d})$field = ($val);  &else ($ip)-> ($i_din2->{d})$field = ($val); }  &while (0));
	}' unless defined(&DIP_SET);
	eval 'sub SHORTLINK {
	    my($ip) = @_;
    	    eval q(( &I_IS_UFS1 ? -> ($i_din1->{di_db}) : ($ip)-> ($i_din2->{di_db})));
	}' unless defined(&SHORTLINK);
	eval 'sub IS_SNAPSHOT {
	    my($ip) = @_;
    	    eval q((($ip)-> &i_flags &  &SF_SNAPSHOT));
	}' unless defined(&IS_SNAPSHOT);
	eval 'sub VTOI {
	    my($vp) = @_;
    	    eval q((($vp)-> &v_data));
	}' unless defined(&VTOI);
	eval 'sub ITOV {
	    my($ip) = @_;
    	    eval q((($ip)-> &i_vnode));
	}' unless defined(&ITOV);
	eval 'sub DOINGSOFTDEP {
	    my($vp) = @_;
    	    eval q((($vp)-> ($v_mount->{mnt_flag}) & ( &MNT_SOFTDEP |  &MNT_SUJ)));
	}' unless defined(&DOINGSOFTDEP);
	eval 'sub MOUNTEDSOFTDEP {
	    my($mp) = @_;
    	    eval q((($mp)-> &mnt_flag & ( &MNT_SOFTDEP |  &MNT_SUJ)));
	}' unless defined(&MOUNTEDSOFTDEP);
	eval 'sub DOINGSUJ {
	    my($vp) = @_;
    	    eval q((($vp)-> ($v_mount->{mnt_flag}) &  &MNT_SUJ));
	}' unless defined(&DOINGSUJ);
	eval 'sub MOUNTEDSUJ {
	    my($mp) = @_;
    	    eval q((($mp)-> &mnt_flag &  &MNT_SUJ));
	}' unless defined(&MOUNTEDSUJ);
    }
}
1;
