require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_UFS_UFS_QUOTA_H_)) {
    eval 'sub _UFS_UFS_QUOTA_H_ () {1;}' unless defined(&_UFS_UFS_QUOTA_H_);
    eval 'sub MAX_IQ_TIME () {(7*24*60*60);}' unless defined(&MAX_IQ_TIME);
    eval 'sub MAX_DQ_TIME () {(7*24*60*60);}' unless defined(&MAX_DQ_TIME);
    eval 'sub MAXQUOTAS () {2;}' unless defined(&MAXQUOTAS);
    eval 'sub USRQUOTA () {0;}' unless defined(&USRQUOTA);
    eval 'sub GRPQUOTA () {1;}' unless defined(&GRPQUOTA);
    eval 'sub INITQFNAMES () {{ "user", "group", "undefined", };}' unless defined(&INITQFNAMES);
    eval 'sub QUOTAFILENAME () {"quota";}' unless defined(&QUOTAFILENAME);
    eval 'sub QUOTAGROUP () {"operator";}' unless defined(&QUOTAGROUP);
    eval 'sub SUBCMDMASK () {0xff;}' unless defined(&SUBCMDMASK);
    eval 'sub SUBCMDSHIFT () {8;}' unless defined(&SUBCMDSHIFT);
    eval 'sub QCMD {
        my($cmd, $type) = @_;
	    eval q(((($cmd) <<  &SUBCMDSHIFT) | (($type) &  &SUBCMDMASK)));
    }' unless defined(&QCMD);
    eval 'sub Q_QUOTAON () {0x100;}' unless defined(&Q_QUOTAON);
    eval 'sub Q_QUOTAOFF () {0x200;}' unless defined(&Q_QUOTAOFF);
    eval 'sub Q_GETQUOTA32 () {0x300;}' unless defined(&Q_GETQUOTA32);
    eval 'sub Q_SETQUOTA32 () {0x400;}' unless defined(&Q_SETQUOTA32);
    eval 'sub Q_SETUSE32 () {0x500;}' unless defined(&Q_SETUSE32);
    eval 'sub Q_SYNC () {0x600;}' unless defined(&Q_SYNC);
    eval 'sub Q_GETQUOTA () {0x700;}' unless defined(&Q_GETQUOTA);
    eval 'sub Q_SETQUOTA () {0x800;}' unless defined(&Q_SETQUOTA);
    eval 'sub Q_SETUSE () {0x900;}' unless defined(&Q_SETUSE);
    eval 'sub Q_GETQUOTASIZE () {0xa00;}' unless defined(&Q_GETQUOTASIZE);
    eval 'sub dqblk () { &dqblk64;}' unless defined(&dqblk);
    eval 'sub Q_DQHDR64_MAGIC () {"QUOTA64";}' unless defined(&Q_DQHDR64_MAGIC);
    eval 'sub Q_DQHDR64_VERSION () {0x20081104;}' unless defined(&Q_DQHDR64_VERSION);
    if(defined(&_KERNEL)) {
	require 'sys/queue.ph';
	eval 'sub DQ_LOCK () {0x1;}' unless defined(&DQ_LOCK);
	eval 'sub DQ_WANT () {0x2;}' unless defined(&DQ_WANT);
	eval 'sub DQ_MOD () {0x4;}' unless defined(&DQ_MOD);
	eval 'sub DQ_FAKE () {0x8;}' unless defined(&DQ_FAKE);
	eval 'sub DQ_BLKS () {0x10;}' unless defined(&DQ_BLKS);
	eval 'sub DQ_INODS () {0x20;}' unless defined(&DQ_INODS);
	eval 'sub dq_bhardlimit () { ($dq_dqb->{dqb_bhardlimit});}' unless defined(&dq_bhardlimit);
	eval 'sub dq_bsoftlimit () { ($dq_dqb->{dqb_bsoftlimit});}' unless defined(&dq_bsoftlimit);
	eval 'sub dq_curblocks () { ($dq_dqb->{dqb_curblocks});}' unless defined(&dq_curblocks);
	eval 'sub dq_ihardlimit () { ($dq_dqb->{dqb_ihardlimit});}' unless defined(&dq_ihardlimit);
	eval 'sub dq_isoftlimit () { ($dq_dqb->{dqb_isoftlimit});}' unless defined(&dq_isoftlimit);
	eval 'sub dq_curinodes () { ($dq_dqb->{dqb_curinodes});}' unless defined(&dq_curinodes);
	eval 'sub dq_btime () { ($dq_dqb->{dqb_btime});}' unless defined(&dq_btime);
	eval 'sub dq_itime () { ($dq_dqb->{dqb_itime});}' unless defined(&dq_itime);
	eval 'sub NODQUOT () { &NULL;}' unless defined(&NODQUOT);
	eval 'sub FORCE () {0x1;}' unless defined(&FORCE);
	eval 'sub CHOWN () {0x2;}' unless defined(&CHOWN);
	if(defined(&DIAGNOSTIC)) {
	    eval 'sub DQREF {
	        my($dq) = @_;
    		eval q( &dqref($dq));
	    }' unless defined(&DQREF);
	} else {
	    eval 'sub DQREF {
	        my($dq) = @_;
    		eval q(($dq)-> &dq_cnt++);
	    }' unless defined(&DQREF);
	}
	eval 'sub DQI_LOCK {
	    my($dq) = @_;
    	    eval q( &mtx_lock(($dq)-> &dq_lock));
	}' unless defined(&DQI_LOCK);
	eval 'sub DQI_UNLOCK {
	    my($dq) = @_;
    	    eval q( &mtx_unlock(($dq)-> &dq_lock));
	}' unless defined(&DQI_UNLOCK);
	eval 'sub DQI_WAIT {
	    my($dq, $prio, $msg) = @_;
    	    eval q( &do {  &while (($dq)-> &dq_flags &  &DQ_LOCK) { ($dq)-> &dq_flags |=  &DQ_WANT; ( &void)  &msleep(($dq), ($dq)-> &dq_lock, ($prio), ($msg), 0); } }  &while (0));
	}' unless defined(&DQI_WAIT);
	eval 'sub DQI_WAKEUP {
	    my($dq) = @_;
    	    eval q( &do {  &if (($dq)-> &dq_flags &  &DQ_WANT)  &wakeup(($dq)); ($dq)-> &dq_flags &= ~( &DQ_WANT| &DQ_LOCK); }  &while (0));
	}' unless defined(&DQI_WAKEUP);
	if(defined(&SOFTUPDATES)) {
	}
    } else {
	require 'sys/cdefs.ph';
    }
}
1;
