require '_h2ph_pre.ph';

no warnings qw(redefine misc);

require 'sys/_bitset.ph';
require 'sys/_task.ph';
unless(defined(&VM_UMA_INT_H)) {
    eval 'sub VM_UMA_INT_H () {1;}' unless defined(&VM_UMA_INT_H);
    eval 'sub UMA_SLAB_SIZE () { &PAGE_SIZE;}' unless defined(&UMA_SLAB_SIZE);
    eval 'sub UMA_SLAB_MASK () {( &PAGE_SIZE - 1);}' unless defined(&UMA_SLAB_MASK);
    eval 'sub UMA_SLAB_SHIFT () { &PAGE_SHIFT;}' unless defined(&UMA_SLAB_SHIFT);
    eval 'sub UMA_BOOT_PAGES () {64;}' unless defined(&UMA_BOOT_PAGES);
    eval 'sub UMA_BOOT_PAGES_ZONES () {32;}' unless defined(&UMA_BOOT_PAGES_ZONES);
    eval 'sub UMA_MAX_WASTE () {10;}' unless defined(&UMA_MAX_WASTE);
    eval 'sub UMA_HASH_SIZE_INIT () {32;}' unless defined(&UMA_HASH_SIZE_INIT);
    eval 'sub UMA_HASH {
        my($h, $s) = @_;
	    eval q((((( &uintptr_t)$s) >>  &UMA_SLAB_SHIFT) & ($h)-> &uh_hashmask));
    }' unless defined(&UMA_HASH);
    eval 'sub UMA_HASH_INSERT {
        my($h, $s, $mem) = @_;
	    eval q( &SLIST_INSERT_HEAD(($h)-> $uh_slab_hash[ &UMA_HASH(($h), ($mem))], ($s),  &us_hlink));
    }' unless defined(&UMA_HASH_INSERT);
    eval 'sub UMA_HASH_REMOVE {
        my($h, $s, $mem) = @_;
	    eval q( &SLIST_REMOVE(($h)-> $uh_slab_hash[ &UMA_HASH(($h), ($mem))], ($s),  &uma_slab,  &us_hlink));
    }' unless defined(&UMA_HASH_REMOVE);
    if(defined(&__amd64__)) {
	eval 'sub UMA_ALIGN () { &__aligned( &CACHE_LINE_SIZE);}' unless defined(&UMA_ALIGN);
    } else {
	eval 'sub UMA_ALIGN () {1;}' unless defined(&UMA_ALIGN);
    }
    eval 'sub SLAB_SETSIZE () {( &PAGE_SIZE /  &UMA_SMALLEST_UNIT);}' unless defined(&SLAB_SETSIZE);
    if(defined(&INVARIANTS)) {
    }
    eval 'sub us_link () { ($us_type->{_us_link});}' unless defined(&us_link);
    eval 'sub us_size () { ($us_type->{_us_size});}' unless defined(&us_size);
    eval 'sub UMA_ZFLAG_MULTI () {0x4000000;}' unless defined(&UMA_ZFLAG_MULTI);
    eval 'sub UMA_ZFLAG_DRAINING () {0x8000000;}' unless defined(&UMA_ZFLAG_DRAINING);
    eval 'sub UMA_ZFLAG_BUCKET () {0x10000000;}' unless defined(&UMA_ZFLAG_BUCKET);
    eval 'sub UMA_ZFLAG_INTERNAL () {0x20000000;}' unless defined(&UMA_ZFLAG_INTERNAL);
    eval 'sub UMA_ZFLAG_FULL () {0x40000000;}' unless defined(&UMA_ZFLAG_FULL);
    eval 'sub UMA_ZFLAG_CACHEONLY () {0x80000000;}' unless defined(&UMA_ZFLAG_CACHEONLY);
    eval 'sub UMA_ZFLAG_INHERIT () {( &UMA_ZFLAG_INTERNAL |  &UMA_ZFLAG_CACHEONLY |  &UMA_ZFLAG_BUCKET);}' unless defined(&UMA_ZFLAG_INHERIT);
    eval 'sub zone_first_keg {
        my($zone) = @_;
	    eval q({  &uma_klink_t  &klink;  &klink =  &LIST_FIRST( ($zone->{uz_kegs})); ( &klink !=  &NULL) ?  ($klink->{kl_keg}) :  &NULL; });
    }' unless defined(&zone_first_keg);
    undef(&UMA_ALIGN) if defined(&UMA_ALIGN);
    if(defined(&_KERNEL)) {
	eval 'sub KEG_LOCK_INIT {
	    my($k, $lc) = @_;
    	    eval q( &do {  &if (($lc))  &mtx_init(($k)-> &uk_lock, ($k)-> &uk_name, ($k)-> &uk_name,  &MTX_DEF |  &MTX_DUPOK);  &else  &mtx_init(($k)-> &uk_lock, ($k)-> &uk_name, \\"UMA zone\\",  &MTX_DEF |  &MTX_DUPOK); }  &while (0));
	}' unless defined(&KEG_LOCK_INIT);
	eval 'sub KEG_LOCK_FINI {
	    my($k) = @_;
    	    eval q( &mtx_destroy(($k)-> &uk_lock));
	}' unless defined(&KEG_LOCK_FINI);
	eval 'sub KEG_LOCK {
	    my($k) = @_;
    	    eval q( &mtx_lock(($k)-> &uk_lock));
	}' unless defined(&KEG_LOCK);
	eval 'sub KEG_UNLOCK {
	    my($k) = @_;
    	    eval q( &mtx_unlock(($k)-> &uk_lock));
	}' unless defined(&KEG_UNLOCK);
	eval 'sub ZONE_LOCK_INIT {
	    my($z, $lc) = @_;
    	    eval q( &do {  &if (($lc))  &mtx_init(($z)-> &uz_lock, ($z)-> &uz_name, ($z)-> &uz_name,  &MTX_DEF |  &MTX_DUPOK);  &else  &mtx_init(($z)-> &uz_lock, ($z)-> &uz_name, \\"UMA zone\\",  &MTX_DEF |  &MTX_DUPOK); }  &while (0));
	}' unless defined(&ZONE_LOCK_INIT);
	eval 'sub ZONE_LOCK {
	    my($z) = @_;
    	    eval q( &mtx_lock(($z)-> &uz_lockptr));
	}' unless defined(&ZONE_LOCK);
	eval 'sub ZONE_TRYLOCK {
	    my($z) = @_;
    	    eval q( &mtx_trylock(($z)-> &uz_lockptr));
	}' unless defined(&ZONE_TRYLOCK);
	eval 'sub ZONE_UNLOCK {
	    my($z) = @_;
    	    eval q( &mtx_unlock(($z)-> &uz_lockptr));
	}' unless defined(&ZONE_UNLOCK);
	eval 'sub ZONE_LOCK_FINI {
	    my($z) = @_;
    	    eval q( &mtx_destroy(($z)-> &uz_lock));
	}' unless defined(&ZONE_LOCK_FINI);
	eval 'sub vtoslab {
	    my($va) = @_;
    	    eval q({  &vm_page_t  &p;  &p =  &PHYS_TO_VM_PAGE( &pmap_kextract($va)); (( &uma_slab_t) ($p->{plinks}->{s}->{pv})); });
	}' unless defined(&vtoslab);
	eval 'sub vsetslab {
	    my($va,$slab) = @_;
    	    eval q({  &vm_page_t  &p;  &p =  &PHYS_TO_VM_PAGE( &pmap_kextract($va));  ($p->{plinks}->{s}->{pv}) = $slab; });
	}' unless defined(&vsetslab);
    }
}
1;
