require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_VM_MAP_)) {
    eval 'sub _VM_MAP_ () {1;}' unless defined(&_VM_MAP_);
    require 'sys/lock.ph';
    require 'sys/sx.ph';
    require 'sys/_mutex.ph';
    eval 'sub MAP_ENTRY_NOSYNC () {0x1;}' unless defined(&MAP_ENTRY_NOSYNC);
    eval 'sub MAP_ENTRY_IS_SUB_MAP () {0x2;}' unless defined(&MAP_ENTRY_IS_SUB_MAP);
    eval 'sub MAP_ENTRY_COW () {0x4;}' unless defined(&MAP_ENTRY_COW);
    eval 'sub MAP_ENTRY_NEEDS_COPY () {0x8;}' unless defined(&MAP_ENTRY_NEEDS_COPY);
    eval 'sub MAP_ENTRY_NOFAULT () {0x10;}' unless defined(&MAP_ENTRY_NOFAULT);
    eval 'sub MAP_ENTRY_USER_WIRED () {0x20;}' unless defined(&MAP_ENTRY_USER_WIRED);
    eval 'sub MAP_ENTRY_BEHAV_NORMAL () {0x;}' unless defined(&MAP_ENTRY_BEHAV_NORMAL);
    eval 'sub MAP_ENTRY_BEHAV_SEQUENTIAL () {0x40;}' unless defined(&MAP_ENTRY_BEHAV_SEQUENTIAL);
    eval 'sub MAP_ENTRY_BEHAV_RANDOM () {0x80;}' unless defined(&MAP_ENTRY_BEHAV_RANDOM);
    eval 'sub MAP_ENTRY_BEHAV_RESERVED () {0xc0;}' unless defined(&MAP_ENTRY_BEHAV_RESERVED);
    eval 'sub MAP_ENTRY_BEHAV_MASK () {0xc0;}' unless defined(&MAP_ENTRY_BEHAV_MASK);
    eval 'sub MAP_ENTRY_IN_TRANSITION () {0x100;}' unless defined(&MAP_ENTRY_IN_TRANSITION);
    eval 'sub MAP_ENTRY_NEEDS_WAKEUP () {0x200;}' unless defined(&MAP_ENTRY_NEEDS_WAKEUP);
    eval 'sub MAP_ENTRY_NOCOREDUMP () {0x400;}' unless defined(&MAP_ENTRY_NOCOREDUMP);
    eval 'sub MAP_ENTRY_GROWS_DOWN () {0x1000;}' unless defined(&MAP_ENTRY_GROWS_DOWN);
    eval 'sub MAP_ENTRY_GROWS_UP () {0x2000;}' unless defined(&MAP_ENTRY_GROWS_UP);
    eval 'sub MAP_ENTRY_WIRE_SKIPPED () {0x4000;}' unless defined(&MAP_ENTRY_WIRE_SKIPPED);
    eval 'sub MAP_ENTRY_VN_WRITECNT () {0x8000;}' unless defined(&MAP_ENTRY_VN_WRITECNT);
    eval 'sub MAP_ENTRY_GUARD () {0x10000;}' unless defined(&MAP_ENTRY_GUARD);
    eval 'sub MAP_ENTRY_STACK_GAP_DN () {0x20000;}' unless defined(&MAP_ENTRY_STACK_GAP_DN);
    eval 'sub MAP_ENTRY_STACK_GAP_UP () {0x40000;}' unless defined(&MAP_ENTRY_STACK_GAP_UP);
    if(defined(&_KERNEL)) {
	eval 'sub vm_map_entry_behavior {
	    my($entry) = @_;
    	    eval q({ ( ($entry->{eflags}) &  &MAP_ENTRY_BEHAV_MASK); });
	}' unless defined(&vm_map_entry_behavior);
	eval 'sub vm_map_entry_user_wired_count {
	    my($entry) = @_;
    	    eval q({  &if ( ($entry->{eflags}) &  &MAP_ENTRY_USER_WIRED) (1); (0); });
	}' unless defined(&vm_map_entry_user_wired_count);
	eval 'sub vm_map_entry_system_wired_count {
	    my($entry) = @_;
    	    eval q({ ( ($entry->{wired_count}) -  &vm_map_entry_user_wired_count($entry)); });
	}' unless defined(&vm_map_entry_system_wired_count);
    }
    eval 'sub min_offset () { ($header->{end});}' unless defined(&min_offset);
    eval 'sub max_offset () { ($header->{start});}' unless defined(&max_offset);
    eval 'sub MAP_WIREFUTURE () {0x1;}' unless defined(&MAP_WIREFUTURE);
    eval 'sub MAP_BUSY_WAKEUP () {0x2;}' unless defined(&MAP_BUSY_WAKEUP);
    if(defined(&_KERNEL)) {
	if(defined(&KLD_MODULE)) {
	    eval 'sub vm_map_max {
	        my($map) = @_;
    		eval q( &vm_map_max_KBI(($map)));
	    }' unless defined(&vm_map_max);
	    eval 'sub vm_map_min {
	        my($map) = @_;
    		eval q( &vm_map_min_KBI(($map)));
	    }' unless defined(&vm_map_min);
	    eval 'sub vm_map_pmap {
	        my($map) = @_;
    		eval q( &vm_map_pmap_KBI(($map)));
	    }' unless defined(&vm_map_pmap);
	} else {
	    eval 'sub vm_map_max {
	        my($map) = @_;
    		eval q({ ( ($map->{max_offset})); });
	    }' unless defined(&vm_map_max);
	    eval 'sub vm_map_min {
	        my($map) = @_;
    		eval q({ ( ($map->{min_offset})); });
	    }' unless defined(&vm_map_min);
	    eval 'sub vm_map_pmap {
	        my($map) = @_;
    		eval q({ ( ($map->{p$map})); });
	    }' unless defined(&vm_map_pmap);
	    eval 'sub vm_map_modflags {
	        my($map,$set,$clear) = @_;
    		eval q({  ($map->{flags}) = ( ($map->{flags}) | $set) & ~$clear; });
	    }' unless defined(&vm_map_modflags);
	}
    }
    if(defined(&_KERNEL)) {
	eval 'sub vmspace_pmap {
	    my($vmspace) = @_;
    	    eval q({  ($vmspace->{vm_pmap}); });
	}' unless defined(&vmspace_pmap);
    }
    if(defined(&_KERNEL)) {
	eval 'sub vm_map_lock {
	    my($map) = @_;
    	    eval q( &_vm_map_lock($map,  &LOCK_FILE,  &LOCK_LINE));
	}' unless defined(&vm_map_lock);
	eval 'sub vm_map_unlock {
	    my($map) = @_;
    	    eval q( &_vm_map_unlock($map,  &LOCK_FILE,  &LOCK_LINE));
	}' unless defined(&vm_map_unlock);
	eval 'sub vm_map_unlock_and_wait {
	    my($map, $timo) = @_;
    	    eval q( &_vm_map_unlock_and_wait($map, $timo,  &LOCK_FILE,  &LOCK_LINE));
	}' unless defined(&vm_map_unlock_and_wait);
	eval 'sub vm_map_lock_read {
	    my($map) = @_;
    	    eval q( &_vm_map_lock_read($map,  &LOCK_FILE,  &LOCK_LINE));
	}' unless defined(&vm_map_lock_read);
	eval 'sub vm_map_unlock_read {
	    my($map) = @_;
    	    eval q( &_vm_map_unlock_read($map,  &LOCK_FILE,  &LOCK_LINE));
	}' unless defined(&vm_map_unlock_read);
	eval 'sub vm_map_trylock {
	    my($map) = @_;
    	    eval q( &_vm_map_trylock($map,  &LOCK_FILE,  &LOCK_LINE));
	}' unless defined(&vm_map_trylock);
	eval 'sub vm_map_trylock_read {
	    my($map) = @_;
    	    eval q( &_vm_map_trylock_read($map,  &LOCK_FILE,  &LOCK_LINE));
	}' unless defined(&vm_map_trylock_read);
	eval 'sub vm_map_lock_upgrade {
	    my($map) = @_;
    	    eval q( &_vm_map_lock_upgrade($map,  &LOCK_FILE,  &LOCK_LINE));
	}' unless defined(&vm_map_lock_upgrade);
	eval 'sub vm_map_lock_downgrade {
	    my($map) = @_;
    	    eval q( &_vm_map_lock_downgrade($map,  &LOCK_FILE,  &LOCK_LINE));
	}' unless defined(&vm_map_lock_downgrade);
    }
    eval 'sub MAX_KMAP () {10;}' unless defined(&MAX_KMAP);
    eval 'sub MAP_INHERIT_SHARE () {0x1;}' unless defined(&MAP_INHERIT_SHARE);
    eval 'sub MAP_COPY_ON_WRITE () {0x2;}' unless defined(&MAP_COPY_ON_WRITE);
    eval 'sub MAP_NOFAULT () {0x4;}' unless defined(&MAP_NOFAULT);
    eval 'sub MAP_PREFAULT () {0x8;}' unless defined(&MAP_PREFAULT);
    eval 'sub MAP_PREFAULT_PARTIAL () {0x10;}' unless defined(&MAP_PREFAULT_PARTIAL);
    eval 'sub MAP_DISABLE_SYNCER () {0x20;}' unless defined(&MAP_DISABLE_SYNCER);
    eval 'sub MAP_CHECK_EXCL () {0x40;}' unless defined(&MAP_CHECK_EXCL);
    eval 'sub MAP_CREATE_GUARD () {0x80;}' unless defined(&MAP_CREATE_GUARD);
    eval 'sub MAP_DISABLE_COREDUMP () {0x100;}' unless defined(&MAP_DISABLE_COREDUMP);
    eval 'sub MAP_PREFAULT_MADVISE () {0x200;}' unless defined(&MAP_PREFAULT_MADVISE);
    eval 'sub MAP_VN_WRITECOUNT () {0x400;}' unless defined(&MAP_VN_WRITECOUNT);
    eval 'sub MAP_STACK_GROWS_DOWN () {0x1000;}' unless defined(&MAP_STACK_GROWS_DOWN);
    eval 'sub MAP_STACK_GROWS_UP () {0x2000;}' unless defined(&MAP_STACK_GROWS_UP);
    eval 'sub MAP_ACC_CHARGED () {0x4000;}' unless defined(&MAP_ACC_CHARGED);
    eval 'sub MAP_ACC_NO_CHARGE () {0x8000;}' unless defined(&MAP_ACC_NO_CHARGE);
    eval 'sub MAP_CREATE_STACK_GAP_UP () {0x10000;}' unless defined(&MAP_CREATE_STACK_GAP_UP);
    eval 'sub MAP_CREATE_STACK_GAP_DN () {0x20000;}' unless defined(&MAP_CREATE_STACK_GAP_DN);
    eval 'sub VM_FAULT_NORMAL () {0;}' unless defined(&VM_FAULT_NORMAL);
    eval 'sub VM_FAULT_WIRE () {1;}' unless defined(&VM_FAULT_WIRE);
    eval 'sub VM_FAULT_DIRTY () {2;}' unless defined(&VM_FAULT_DIRTY);
    eval 'sub VM_FAULT_READ_AHEAD_MIN () {7;}' unless defined(&VM_FAULT_READ_AHEAD_MIN);
    eval 'sub VM_FAULT_READ_AHEAD_INIT () {15;}' unless defined(&VM_FAULT_READ_AHEAD_INIT);
    eval 'sub VM_FAULT_READ_AHEAD_MAX () { &min( &atop( &MAXPHYS) - 1,  &UINT8_MAX);}' unless defined(&VM_FAULT_READ_AHEAD_MAX);
    eval 'sub VMFS_NO_SPACE () {0;}' unless defined(&VMFS_NO_SPACE);
    eval 'sub VMFS_ANY_SPACE () {1;}' unless defined(&VMFS_ANY_SPACE);
    eval 'sub VMFS_OPTIMAL_SPACE () {2;}' unless defined(&VMFS_OPTIMAL_SPACE);
    eval 'sub VMFS_SUPER_SPACE () {3;}' unless defined(&VMFS_SUPER_SPACE);
    eval 'sub VMFS_ALIGNED_SPACE {
        my($x) = @_;
	    eval q((($x) << 8));
    }' unless defined(&VMFS_ALIGNED_SPACE);
    eval 'sub VM_MAP_WIRE_SYSTEM () {0;}' unless defined(&VM_MAP_WIRE_SYSTEM);
    eval 'sub VM_MAP_WIRE_USER () {1;}' unless defined(&VM_MAP_WIRE_USER);
    eval 'sub VM_MAP_WIRE_NOHOLES () {0;}' unless defined(&VM_MAP_WIRE_NOHOLES);
    eval 'sub VM_MAP_WIRE_HOLESOK () {2;}' unless defined(&VM_MAP_WIRE_HOLESOK);
    eval 'sub VM_MAP_WIRE_WRITE () {4;}' unless defined(&VM_MAP_WIRE_WRITE);
    if(defined(&_KERNEL)) {
    }
}
1;
