require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_VM_OBJECT_)) {
    eval 'sub _VM_OBJECT_ () {1;}' unless defined(&_VM_OBJECT_);
    require 'sys/queue.ph';
    require 'sys/_lock.ph';
    require 'sys/_mutex.ph';
    require 'sys/_pctrie.ph';
    require 'sys/_rwlock.ph';
    require 'vm/_vm_radix.ph';
    unless(defined(&VM_PAGE_HAVE_PGLIST)) {
	eval 'sub VM_PAGE_HAVE_PGLIST () {1;}' unless defined(&VM_PAGE_HAVE_PGLIST);
    }
    eval 'sub OBJ_FICTITIOUS () {0x1;}' unless defined(&OBJ_FICTITIOUS);
    eval 'sub OBJ_UNMANAGED () {0x2;}' unless defined(&OBJ_UNMANAGED);
    eval 'sub OBJ_POPULATE () {0x4;}' unless defined(&OBJ_POPULATE);
    eval 'sub OBJ_DEAD () {0x8;}' unless defined(&OBJ_DEAD);
    eval 'sub OBJ_NOSPLIT () {0x10;}' unless defined(&OBJ_NOSPLIT);
    eval 'sub OBJ_UMTXDEAD () {0x20;}' unless defined(&OBJ_UMTXDEAD);
    eval 'sub OBJ_PIPWNT () {0x40;}' unless defined(&OBJ_PIPWNT);
    eval 'sub OBJ_PG_DTOR () {0x80;}' unless defined(&OBJ_PG_DTOR);
    eval 'sub OBJ_MIGHTBEDIRTY () {0x100;}' unless defined(&OBJ_MIGHTBEDIRTY);
    eval 'sub OBJ_TMPFS_NODE () {0x200;}' unless defined(&OBJ_TMPFS_NODE);
    eval 'sub OBJ_TMPFS_DIRTY () {0x400;}' unless defined(&OBJ_TMPFS_DIRTY);
    eval 'sub OBJ_COLORED () {0x1000;}' unless defined(&OBJ_COLORED);
    eval 'sub OBJ_ONEMAPPING () {0x2000;}' unless defined(&OBJ_ONEMAPPING);
    eval 'sub OBJ_DISCONNECTWNT () {0x4000;}' unless defined(&OBJ_DISCONNECTWNT);
    eval 'sub OBJ_TMPFS () {0x8000;}' unless defined(&OBJ_TMPFS);
    eval 'sub IDX_TO_OFF {
        my($idx) = @_;
	    eval q(((( &vm_ooffset_t)($idx)) <<  &PAGE_SHIFT));
    }' unless defined(&IDX_TO_OFF);
    eval 'sub OFF_TO_IDX {
        my($off) = @_;
	    eval q((( &vm_pindex_t)((( &vm_ooffset_t)($off)) >>  &PAGE_SHIFT)));
    }' unless defined(&OFF_TO_IDX);
    eval 'sub UOFF_TO_IDX {
        my($off) = @_;
	    eval q(((( &vm_pindex_t)($off)) >>  &PAGE_SHIFT));
    }' unless defined(&UOFF_TO_IDX);
    eval 'sub OBJ_MAX_SIZE () {( &UOFF_TO_IDX( &UINT64_MAX) + 1);}' unless defined(&OBJ_MAX_SIZE);
    if(defined(&_KERNEL)) {
	eval 'sub OBJPC_SYNC () {0x1;}' unless defined(&OBJPC_SYNC);
	eval 'sub OBJPC_INVAL () {0x2;}' unless defined(&OBJPC_INVAL);
	eval 'sub OBJPC_NOSYNC () {0x4;}' unless defined(&OBJPC_NOSYNC);
	eval 'sub OBJPR_CLEANONLY () {0x1;}' unless defined(&OBJPR_CLEANONLY);
	eval 'sub OBJPR_NOTMAPPED () {0x2;}' unless defined(&OBJPR_NOTMAPPED);
	eval 'sub kernel_object () {( &kernel_object_store);}' unless defined(&kernel_object);
	eval 'sub kmem_object () {( &kmem_object_store);}' unless defined(&kmem_object);
	eval 'sub VM_OBJECT_ASSERT_LOCKED {
	    my($object) = @_;
    	    eval q( &rw_assert(($object)-> &lock,  &RA_LOCKED));
	}' unless defined(&VM_OBJECT_ASSERT_LOCKED);
	eval 'sub VM_OBJECT_ASSERT_RLOCKED {
	    my($object) = @_;
    	    eval q( &rw_assert(($object)-> &lock,  &RA_RLOCKED));
	}' unless defined(&VM_OBJECT_ASSERT_RLOCKED);
	eval 'sub VM_OBJECT_ASSERT_WLOCKED {
	    my($object) = @_;
    	    eval q( &rw_assert(($object)-> &lock,  &RA_WLOCKED));
	}' unless defined(&VM_OBJECT_ASSERT_WLOCKED);
	eval 'sub VM_OBJECT_ASSERT_UNLOCKED {
	    my($object) = @_;
    	    eval q( &rw_assert(($object)-> &lock,  &RA_UNLOCKED));
	}' unless defined(&VM_OBJECT_ASSERT_UNLOCKED);
	eval 'sub VM_OBJECT_LOCK_DOWNGRADE {
	    my($object) = @_;
    	    eval q( &rw_downgrade(($object)-> &lock));
	}' unless defined(&VM_OBJECT_LOCK_DOWNGRADE);
	eval 'sub VM_OBJECT_RLOCK {
	    my($object) = @_;
    	    eval q( &rw_rlock(($object)-> &lock));
	}' unless defined(&VM_OBJECT_RLOCK);
	eval 'sub VM_OBJECT_RUNLOCK {
	    my($object) = @_;
    	    eval q( &rw_runlock(($object)-> &lock));
	}' unless defined(&VM_OBJECT_RUNLOCK);
	eval 'sub VM_OBJECT_SLEEP {
	    my($object, $wchan, $pri, $wmesg, $timo) = @_;
    	    eval q( &rw_sleep(($wchan), ($object)-> &lock, ($pri), ($wmesg), ($timo)));
	}' unless defined(&VM_OBJECT_SLEEP);
	eval 'sub VM_OBJECT_TRYRLOCK {
	    my($object) = @_;
    	    eval q( &rw_try_rlock(($object)-> &lock));
	}' unless defined(&VM_OBJECT_TRYRLOCK);
	eval 'sub VM_OBJECT_TRYWLOCK {
	    my($object) = @_;
    	    eval q( &rw_try_wlock(($object)-> &lock));
	}' unless defined(&VM_OBJECT_TRYWLOCK);
	eval 'sub VM_OBJECT_TRYUPGRADE {
	    my($object) = @_;
    	    eval q( &rw_try_upgrade(($object)-> &lock));
	}' unless defined(&VM_OBJECT_TRYUPGRADE);
	eval 'sub VM_OBJECT_WLOCK {
	    my($object) = @_;
    	    eval q( &rw_wlock(($object)-> &lock));
	}' unless defined(&VM_OBJECT_WLOCK);
	eval 'sub VM_OBJECT_WOWNED {
	    my($object) = @_;
    	    eval q( &rw_wowned(($object)-> &lock));
	}' unless defined(&VM_OBJECT_WOWNED);
	eval 'sub VM_OBJECT_WUNLOCK {
	    my($object) = @_;
    	    eval q( &rw_wunlock(($object)-> &lock));
	}' unless defined(&VM_OBJECT_WUNLOCK);
    }
}
1;
