require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_VM_PAGE_)) {
    eval 'sub _VM_PAGE_ () {1;}' unless defined(&_VM_PAGE_);
    require 'vm/pmap.ph';
    if((defined(&PAGE_SIZE) ? &PAGE_SIZE : undef) == 4096) {
	eval 'sub VM_PAGE_BITS_ALL () {0xff;}' unless defined(&VM_PAGE_BITS_ALL);
    }
 elsif((defined(&PAGE_SIZE) ? &PAGE_SIZE : undef) == 8192) {
	eval 'sub VM_PAGE_BITS_ALL () {0xffff;}' unless defined(&VM_PAGE_BITS_ALL);
    }
 elsif((defined(&PAGE_SIZE) ? &PAGE_SIZE : undef) == 16384) {
	eval 'sub VM_PAGE_BITS_ALL () {0xffffffff;}' unless defined(&VM_PAGE_BITS_ALL);
    }
 elsif((defined(&PAGE_SIZE) ? &PAGE_SIZE : undef) == 32768) {
	eval 'sub VM_PAGE_BITS_ALL () {0xffffffffffffffff;}' unless defined(&VM_PAGE_BITS_ALL);
    }
    eval 'sub VPO_UNUSED01 () {0x1;}' unless defined(&VPO_UNUSED01);
    eval 'sub VPO_SWAPSLEEP () {0x2;}' unless defined(&VPO_SWAPSLEEP);
    eval 'sub VPO_UNMANAGED () {0x4;}' unless defined(&VPO_UNMANAGED);
    eval 'sub VPO_SWAPINPROG () {0x8;}' unless defined(&VPO_SWAPINPROG);
    eval 'sub VPO_NOSYNC () {0x10;}' unless defined(&VPO_NOSYNC);
    eval 'sub VPB_BIT_SHARED () {0x1;}' unless defined(&VPB_BIT_SHARED);
    eval 'sub VPB_BIT_EXCLUSIVE () {0x2;}' unless defined(&VPB_BIT_EXCLUSIVE);
    eval 'sub VPB_BIT_WAITERS () {0x4;}' unless defined(&VPB_BIT_WAITERS);
    eval 'sub VPB_BIT_FLAGMASK () {( &VPB_BIT_SHARED |  &VPB_BIT_EXCLUSIVE |  &VPB_BIT_WAITERS);}' unless defined(&VPB_BIT_FLAGMASK);
    eval 'sub VPB_SHARERS_SHIFT () {3;}' unless defined(&VPB_SHARERS_SHIFT);
    eval 'sub VPB_SHARERS {
        my($x) = @_;
	    eval q(((($x) & ~ &VPB_BIT_FLAGMASK) >>  &VPB_SHARERS_SHIFT));
    }' unless defined(&VPB_SHARERS);
    eval 'sub VPB_SHARERS_WORD {
        my($x) = @_;
	    eval q((($x) <<  &VPB_SHARERS_SHIFT |  &VPB_BIT_SHARED));
    }' unless defined(&VPB_SHARERS_WORD);
    eval 'sub VPB_ONE_SHARER () {(1<<  &VPB_SHARERS_SHIFT);}' unless defined(&VPB_ONE_SHARER);
    eval 'sub VPB_SINGLE_EXCLUSIVER () { &VPB_BIT_EXCLUSIVE;}' unless defined(&VPB_SINGLE_EXCLUSIVER);
    eval 'sub VPB_UNBUSIED () { &VPB_SHARERS_WORD(0);}' unless defined(&VPB_UNBUSIED);
    eval 'sub PQ_NONE () {255;}' unless defined(&PQ_NONE);
    eval 'sub PQ_INACTIVE () {0;}' unless defined(&PQ_INACTIVE);
    eval 'sub PQ_ACTIVE () {1;}' unless defined(&PQ_ACTIVE);
    eval 'sub PQ_LAUNDRY () {2;}' unless defined(&PQ_LAUNDRY);
    eval 'sub PQ_COUNT () {3;}' unless defined(&PQ_COUNT);
    unless(defined(&VM_PAGE_HAVE_PGLIST)) {
	eval 'sub VM_PAGE_HAVE_PGLIST () {1;}' unless defined(&VM_PAGE_HAVE_PGLIST);
    }
    eval 'sub vm_pagequeue_assert_locked {
        my($pq) = @_;
	    eval q( &mtx_assert(($pq)-> &pq_mutex,  &MA_OWNED));
    }' unless defined(&vm_pagequeue_assert_locked);
    eval 'sub vm_pagequeue_lock {
        my($pq) = @_;
	    eval q( &mtx_lock(($pq)-> &pq_mutex));
    }' unless defined(&vm_pagequeue_lock);
    eval 'sub vm_pagequeue_lockptr {
        my($pq) = @_;
	    eval q((($pq)-> &pq_mutex));
    }' unless defined(&vm_pagequeue_lockptr);
    eval 'sub vm_pagequeue_unlock {
        my($pq) = @_;
	    eval q( &mtx_unlock(($pq)-> &pq_mutex));
    }' unless defined(&vm_pagequeue_unlock);
    if(defined(&_KERNEL)) {
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub vm_pagequeue_cnt_add {
	    my($pq,$addend) = @_;
    	    eval q({  ($pq->{pq_cnt}) += $addend;  &atomic_add_int( ($pq->{pq_vcnt}), $addend); });
	}' unless defined(&vm_pagequeue_cnt_add);
	eval 'sub vm_pagequeue_cnt_inc {
	    my($pq) = @_;
    	    eval q( &vm_pagequeue_cnt_add(($pq), 1));
	}' unless defined(&vm_pagequeue_cnt_inc);
	eval 'sub vm_pagequeue_cnt_dec {
	    my($pq) = @_;
    	    eval q( &vm_pagequeue_cnt_add(($pq), -1));
	}' unless defined(&vm_pagequeue_cnt_dec);
    }
    if(defined(&__arm__)) {
	eval 'sub PDRSHIFT () { &PDR_SHIFT;}' unless defined(&PDRSHIFT);
    }
 elsif(!defined(&PDRSHIFT)) {
	eval 'sub PDRSHIFT () {21;}' unless defined(&PDRSHIFT);
    }
    eval 'sub pa_index {
        my($pa) = @_;
	    eval q((($pa) >>  &PDRSHIFT));
    }' unless defined(&pa_index);
    eval 'sub PA_LOCKPTR {
        my($pa) = @_;
	    eval q((( $pa_lock[ &pa_index($pa) %  &PA_LOCK_COUNT])));
    }' unless defined(&PA_LOCKPTR);
    eval 'sub PA_LOCKOBJPTR {
        my($pa) = @_;
	    eval q(( &PA_LOCKPTR(($pa))));
    }' unless defined(&PA_LOCKOBJPTR);
    eval 'sub PA_LOCK {
        my($pa) = @_;
	    eval q( &mtx_lock( &PA_LOCKPTR($pa)));
    }' unless defined(&PA_LOCK);
    eval 'sub PA_TRYLOCK {
        my($pa) = @_;
	    eval q( &mtx_trylock( &PA_LOCKPTR($pa)));
    }' unless defined(&PA_TRYLOCK);
    eval 'sub PA_UNLOCK {
        my($pa) = @_;
	    eval q( &mtx_unlock( &PA_LOCKPTR($pa)));
    }' unless defined(&PA_UNLOCK);
    eval 'sub PA_UNLOCK_COND {
        my($pa) = @_;
	    eval q( &do {  &if (($pa) != 0) {  &PA_UNLOCK(($pa)); ($pa) = 0; } }  &while (0));
    }' unless defined(&PA_UNLOCK_COND);
    eval 'sub PA_LOCK_ASSERT {
        my($pa, $a) = @_;
	    eval q( &mtx_assert( &PA_LOCKPTR($pa), ($a)));
    }' unless defined(&PA_LOCK_ASSERT);
    if(defined(&KLD_MODULE)) {
	eval 'sub vm_page_lock {
	    my($m) = @_;
    	    eval q( &vm_page_lock_KBI(($m),  &LOCK_FILE,  &LOCK_LINE));
	}' unless defined(&vm_page_lock);
	eval 'sub vm_page_unlock {
	    my($m) = @_;
    	    eval q( &vm_page_unlock_KBI(($m),  &LOCK_FILE,  &LOCK_LINE));
	}' unless defined(&vm_page_unlock);
	eval 'sub vm_page_trylock {
	    my($m) = @_;
    	    eval q( &vm_page_trylock_KBI(($m),  &LOCK_FILE,  &LOCK_LINE));
	}' unless defined(&vm_page_trylock);
    } else {
	eval 'sub vm_page_lockptr {
	    my($m) = @_;
    	    eval q(( &PA_LOCKPTR( &VM_PAGE_TO_PHYS(($m)))));
	}' unless defined(&vm_page_lockptr);
	eval 'sub vm_page_lock {
	    my($m) = @_;
    	    eval q( &mtx_lock( &vm_page_lockptr(($m))));
	}' unless defined(&vm_page_lock);
	eval 'sub vm_page_unlock {
	    my($m) = @_;
    	    eval q( &mtx_unlock( &vm_page_lockptr(($m))));
	}' unless defined(&vm_page_unlock);
	eval 'sub vm_page_trylock {
	    my($m) = @_;
    	    eval q( &mtx_trylock( &vm_page_lockptr(($m))));
	}' unless defined(&vm_page_trylock);
    }
    if(defined(&INVARIANTS)) {
	eval 'sub vm_page_assert_locked {
	    my($m) = @_;
    	    eval q( &vm_page_assert_locked_KBI(($m),  &__FILE__,  &__LINE__));
	}' unless defined(&vm_page_assert_locked);
	eval 'sub vm_page_lock_assert {
	    my($m, $a) = @_;
    	    eval q( &vm_page_lock_assert_KBI(($m), ($a),  &__FILE__,  &__LINE__));
	}' unless defined(&vm_page_lock_assert);
    } else {
	eval 'sub vm_page_assert_locked {
	    my($m) = @_;
    	    eval q();
	}' unless defined(&vm_page_assert_locked);
	eval 'sub vm_page_lock_assert {
	    my($m, $a) = @_;
    	    eval q();
	}' unless defined(&vm_page_lock_assert);
    }
    eval 'sub PGA_WRITEABLE () {0x1;}' unless defined(&PGA_WRITEABLE);
    eval 'sub PGA_REFERENCED () {0x2;}' unless defined(&PGA_REFERENCED);
    eval 'sub PGA_EXECUTABLE () {0x4;}' unless defined(&PGA_EXECUTABLE);
    eval 'sub PG_FICTITIOUS () {0x4;}' unless defined(&PG_FICTITIOUS);
    eval 'sub PG_ZERO () {0x8;}' unless defined(&PG_ZERO);
    eval 'sub PG_MARKER () {0x10;}' unless defined(&PG_MARKER);
    eval 'sub PG_NODUMP () {0x80;}' unless defined(&PG_NODUMP);
    eval 'sub PG_UNHOLDFREE () {0x100;}' unless defined(&PG_UNHOLDFREE);
    eval 'sub ACT_DECLINE () {1;}' unless defined(&ACT_DECLINE);
    eval 'sub ACT_ADVANCE () {3;}' unless defined(&ACT_ADVANCE);
    eval 'sub ACT_INIT () {5;}' unless defined(&ACT_INIT);
    eval 'sub ACT_MAX () {64;}' unless defined(&ACT_MAX);
    if(defined(&_KERNEL)) {
	require 'sys/systm.ph';
	require 'machine/atomic.ph';
	eval 'sub VM_PAGE_TO_PHYS {
	    my($entry) = @_;
    	    eval q((($entry)-> &phys_addr));
	}' unless defined(&VM_PAGE_TO_PHYS);
	eval 'sub VM_ALLOC_NORMAL () {0;}' unless defined(&VM_ALLOC_NORMAL);
	eval 'sub VM_ALLOC_INTERRUPT () {1;}' unless defined(&VM_ALLOC_INTERRUPT);
	eval 'sub VM_ALLOC_SYSTEM () {2;}' unless defined(&VM_ALLOC_SYSTEM);
	eval 'sub VM_ALLOC_CLASS_MASK () {3;}' unless defined(&VM_ALLOC_CLASS_MASK);
	eval 'sub VM_ALLOC_WAITOK () {0x8;}' unless defined(&VM_ALLOC_WAITOK);
	eval 'sub VM_ALLOC_WAITFAIL () {0x10;}' unless defined(&VM_ALLOC_WAITFAIL);
	eval 'sub VM_ALLOC_WIRED () {0x20;}' unless defined(&VM_ALLOC_WIRED);
	eval 'sub VM_ALLOC_ZERO () {0x40;}' unless defined(&VM_ALLOC_ZERO);
	eval 'sub VM_ALLOC_NOOBJ () {0x100;}' unless defined(&VM_ALLOC_NOOBJ);
	eval 'sub VM_ALLOC_NOBUSY () {0x200;}' unless defined(&VM_ALLOC_NOBUSY);
	eval 'sub VM_ALLOC_IFCACHED () {0x400;}' unless defined(&VM_ALLOC_IFCACHED);
	eval 'sub VM_ALLOC_IFNOTCACHED () {0x800;}' unless defined(&VM_ALLOC_IFNOTCACHED);
	eval 'sub VM_ALLOC_IGN_SBUSY () {0x1000;}' unless defined(&VM_ALLOC_IGN_SBUSY);
	eval 'sub VM_ALLOC_NODUMP () {0x2000;}' unless defined(&VM_ALLOC_NODUMP);
	eval 'sub VM_ALLOC_SBUSY () {0x4000;}' unless defined(&VM_ALLOC_SBUSY);
	eval 'sub VM_ALLOC_NOWAIT () {0x8000;}' unless defined(&VM_ALLOC_NOWAIT);
	eval 'sub VM_ALLOC_COUNT_SHIFT () {16;}' unless defined(&VM_ALLOC_COUNT_SHIFT);
	eval 'sub VM_ALLOC_COUNT {
	    my($count) = @_;
    	    eval q((($count) <<  &VM_ALLOC_COUNT_SHIFT));
	}' unless defined(&VM_ALLOC_COUNT);
	if(defined(&M_NOWAIT)) {
	    eval 'sub malloc2vm_flags {
	        my($malloc_flags) = @_;
    		eval q({ \'int\'  &pflags;  &KASSERT(($malloc_flags &  &M_USE_RESERVE) == 0|| ($malloc_flags &  &M_NOWAIT) != 0, (\\"M_USE_RESERVE requires M_NOWAIT\\"));  &pflags = ($malloc_flags &  &M_USE_RESERVE) != 0?  &VM_ALLOC_INTERRUPT :  &VM_ALLOC_SYSTEM;  &if (($malloc_flags &  &M_ZERO) != 0)  &pflags |=  &VM_ALLOC_ZERO;  &if (($malloc_flags &  &M_NODUMP) != 0)  &pflags |=  &VM_ALLOC_NODUMP;  &if (($malloc_flags &  &M_NOWAIT))  &pflags |=  &VM_ALLOC_NOWAIT;  &if (($malloc_flags &  &M_WAITOK))  &pflags |=  &VM_ALLOC_WAITOK; ( &pflags); });
	    }' unless defined(&malloc2vm_flags);
	}
	eval 'sub PS_ALL_DIRTY () {0x1;}' unless defined(&PS_ALL_DIRTY);
	eval 'sub PS_ALL_VALID () {0x2;}' unless defined(&PS_ALL_VALID);
	eval 'sub PS_NONE_BUSY () {0x4;}' unless defined(&PS_NONE_BUSY);
	if(defined(&INVARIANTS) || defined(&INVARIANT_SUPPORT)) {
	}
	eval 'sub vm_page_assert_sbusied {
	    my($m) = @_;
    	    eval q( &KASSERT( &vm_page_sbusied($m), (\\"vm_page_assert_sbusied: page %p not shared busy @ %s:%d\\", ($m),  &__FILE__,  &__LINE__)));
	}' unless defined(&vm_page_assert_sbusied);
	eval 'sub vm_page_assert_unbusied {
	    my($m) = @_;
    	    eval q( &KASSERT(! &vm_page_busied($m), (\\"vm_page_assert_unbusied: page %p busy @ %s:%d\\", ($m),  &__FILE__,  &__LINE__)));
	}' unless defined(&vm_page_assert_unbusied);
	eval 'sub vm_page_assert_xbusied {
	    my($m) = @_;
    	    eval q( &KASSERT( &vm_page_xbusied($m), (\\"vm_page_assert_xbusied: page %p not exclusive busy @ %s:%d\\", ($m),  &__FILE__,  &__LINE__)));
	}' unless defined(&vm_page_assert_xbusied);
	eval 'sub vm_page_busied {
	    my($m) = @_;
    	    eval q((($m)-> &busy_lock !=  &VPB_UNBUSIED));
	}' unless defined(&vm_page_busied);
	eval 'sub vm_page_sbusy {
	    my($m) = @_;
    	    eval q( &do {  &if (! &vm_page_trysbusy($m))  &panic(\\"%s: page %p failed shared busying\\",  &__func__, ($m)); }  &while (0));
	}' unless defined(&vm_page_sbusy);
	eval 'sub vm_page_tryxbusy {
	    my($m) = @_;
    	    eval q(( &atomic_cmpset_acq_int(($m)-> &busy_lock,  &VPB_UNBUSIED,  &VPB_SINGLE_EXCLUSIVER)));
	}' unless defined(&vm_page_tryxbusy);
	eval 'sub vm_page_xbusied {
	    my($m) = @_;
    	    eval q(((($m)-> &busy_lock &  &VPB_SINGLE_EXCLUSIVER) != 0));
	}' unless defined(&vm_page_xbusied);
	eval 'sub vm_page_xbusy {
	    my($m) = @_;
    	    eval q( &do {  &if (! &vm_page_tryxbusy($m))  &panic(\\"%s: page %p failed exclusive busying\\",  &__func__, ($m)); }  &while (0));
	}' unless defined(&vm_page_xbusy);
	eval 'sub vm_page_xunbusy {
	    my($m) = @_;
    	    eval q( &do {  &if (! &atomic_cmpset_rel_int(($m)-> &busy_lock,  &VPB_SINGLE_EXCLUSIVER,  &VPB_UNBUSIED))  &vm_page_xunbusy_hard($m); }  &while (0));
	}' unless defined(&vm_page_xunbusy);
	if(defined(&INVARIANTS)) {
	    eval 'sub VM_PAGE_OBJECT_LOCK_ASSERT {
	        my($m) = @_;
    		eval q( &vm_page_object_lock_assert($m));
	    }' unless defined(&VM_PAGE_OBJECT_LOCK_ASSERT);
	    eval 'sub VM_PAGE_ASSERT_PGA_WRITEABLE {
	        my($m, $bits) = @_;
    		eval q( &vm_page_assert_pga_writeable($m, $bits));
	    }' unless defined(&VM_PAGE_ASSERT_PGA_WRITEABLE);
	} else {
	    eval 'sub VM_PAGE_OBJECT_LOCK_ASSERT {
	        my($m) = @_;
    		eval q(( &void)0);
	    }' unless defined(&VM_PAGE_OBJECT_LOCK_ASSERT);
	    eval 'sub VM_PAGE_ASSERT_PGA_WRITEABLE {
	        my($m, $bits) = @_;
    		eval q(( &void)0);
	    }' unless defined(&VM_PAGE_ASSERT_PGA_WRITEABLE);
	}
	if((defined(&BYTE_ORDER) ? &BYTE_ORDER : undef) == (defined(&BIG_ENDIAN) ? &BIG_ENDIAN : undef)) {
	}
	if((defined(&BYTE_ORDER) ? &BYTE_ORDER : undef) == (defined(&BIG_ENDIAN) ? &BIG_ENDIAN : undef)) {
	}
	if(defined(&KLD_MODULE) || defined(&INVARIANTS)) {
	} else {
	}
	eval 'sub vm_page_replace_checked {
	    my($mnew,$object,$pindex,$mold) = @_;
    	    eval q({  &vm_page_t  &mret;  &mret =  &vm_page_replace($mnew, $object, $pindex);  &KASSERT( &mret == $mold, (\\"invalid page replacement, mold=%p, mret=%p\\", $mold,  &mret)); ( &void)$mold; ( &void) &mret; });
	}' unless defined(&vm_page_replace_checked);
	eval 'sub vm_page_active {
	    my($m) = @_;
    	    eval q({ ( ($m->{queue}) ==  &PQ_ACTIVE); });
	}' unless defined(&vm_page_active);
	eval 'sub vm_page_inactive {
	    my($m) = @_;
    	    eval q({ ( ($m->{queue}) ==  &PQ_INACTIVE); });
	}' unless defined(&vm_page_inactive);
	eval 'sub vm_page_in_laundry {
	    my($m) = @_;
    	    eval q({ ( ($m->{queue}) ==  &PQ_LAUNDRY); });
	}' unless defined(&vm_page_in_laundry);
    }
}
1;
