require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_X86_APICVAR_H_)) {
    eval 'sub _X86_APICVAR_H_ () {1;}' unless defined(&_X86_APICVAR_H_);
    eval 'sub MAX_APIC_ID () {0xfe;}' unless defined(&MAX_APIC_ID);
    eval 'sub APIC_ID_ALL () {0xff;}' unless defined(&APIC_ID_ALL);
    eval 'sub APIC_IO_INTS () {( &IDT_IO_INTS + 16);}' unless defined(&APIC_IO_INTS);
    eval 'sub APIC_NUM_IOINTS () {191;}' unless defined(&APIC_NUM_IOINTS);
    eval 'sub APIC_TIMER_INT () {( &APIC_IO_INTS +  &APIC_NUM_IOINTS);}' unless defined(&APIC_TIMER_INT);
    eval 'sub APIC_LOCAL_INTS () {240;}' unless defined(&APIC_LOCAL_INTS);
    eval 'sub APIC_ERROR_INT () { &APIC_LOCAL_INTS;}' unless defined(&APIC_ERROR_INT);
    eval 'sub APIC_THERMAL_INT () {( &APIC_LOCAL_INTS + 1);}' unless defined(&APIC_THERMAL_INT);
    eval 'sub APIC_CMC_INT () {( &APIC_LOCAL_INTS + 2);}' unless defined(&APIC_CMC_INT);
    eval 'sub APIC_IPI_INTS () {( &APIC_LOCAL_INTS + 3);}' unless defined(&APIC_IPI_INTS);
    eval 'sub IPI_RENDEZVOUS () {( &APIC_IPI_INTS);}' unless defined(&IPI_RENDEZVOUS);
    eval 'sub IPI_INVLTLB () {( &APIC_IPI_INTS + 1);}' unless defined(&IPI_INVLTLB);
    eval 'sub IPI_INVLPG () {( &APIC_IPI_INTS + 2);}' unless defined(&IPI_INVLPG);
    eval 'sub IPI_INVLRNG () {( &APIC_IPI_INTS + 3);}' unless defined(&IPI_INVLRNG);
    eval 'sub IPI_INVLCACHE () {( &APIC_IPI_INTS + 4);}' unless defined(&IPI_INVLCACHE);
    eval 'sub IPI_BITMAP_VECTOR () {( &APIC_IPI_INTS + 5);}' unless defined(&IPI_BITMAP_VECTOR);
    eval 'sub IPI_AST () {0;}' unless defined(&IPI_AST);
    eval 'sub IPI_PREEMPT () {1;}' unless defined(&IPI_PREEMPT);
    eval 'sub IPI_HARDCLOCK () {2;}' unless defined(&IPI_HARDCLOCK);
    eval 'sub IPI_BITMAP_LAST () { &IPI_HARDCLOCK;}' unless defined(&IPI_BITMAP_LAST);
    eval 'sub IPI_IS_BITMAPED {
        my($x) = @_;
	    eval q((($x) <=  &IPI_BITMAP_LAST));
    }' unless defined(&IPI_IS_BITMAPED);
    eval 'sub IPI_STOP () {( &APIC_IPI_INTS + 6);}' unless defined(&IPI_STOP);
    eval 'sub IPI_SUSPEND () {( &APIC_IPI_INTS + 7);}' unless defined(&IPI_SUSPEND);
    if(defined(&__i386__)) {
	eval 'sub IPI_LAZYPMAP () {( &APIC_IPI_INTS + 8);}' unless defined(&IPI_LAZYPMAP);
	eval 'sub IPI_DYN_FIRST () {( &APIC_IPI_INTS + 9);}' unless defined(&IPI_DYN_FIRST);
    } else {
	eval 'sub IPI_DYN_FIRST () {( &APIC_IPI_INTS + 8);}' unless defined(&IPI_DYN_FIRST);
    }
    eval 'sub IPI_DYN_LAST () {(253);}' unless defined(&IPI_DYN_LAST);
    eval 'sub IPI_NMI_FIRST () {254;}' unless defined(&IPI_NMI_FIRST);
    eval 'sub IPI_TRACE () {254;}' unless defined(&IPI_TRACE);
    eval 'sub IPI_STOP_HARD () {255;}' unless defined(&IPI_STOP_HARD);
    eval 'sub APIC_SPURIOUS_INT () {255;}' unless defined(&APIC_SPURIOUS_INT);
    unless(defined(&LOCORE)) {
	eval 'sub APIC_IPI_DEST_SELF () {-1;}' unless defined(&APIC_IPI_DEST_SELF);
	eval 'sub APIC_IPI_DEST_ALL () {-2;}' unless defined(&APIC_IPI_DEST_ALL);
	eval 'sub APIC_IPI_DEST_OTHERS () {-3;}' unless defined(&APIC_IPI_DEST_OTHERS);
	eval 'sub APIC_BUS_UNKNOWN () {-1;}' unless defined(&APIC_BUS_UNKNOWN);
	eval 'sub APIC_BUS_ISA () {0;}' unless defined(&APIC_BUS_ISA);
	eval 'sub APIC_BUS_EISA () {1;}' unless defined(&APIC_BUS_EISA);
	eval 'sub APIC_BUS_PCI () {2;}' unless defined(&APIC_BUS_PCI);
	eval 'sub APIC_BUS_MAX () { &APIC_BUS_PCI;}' unless defined(&APIC_BUS_MAX);
	eval 'sub IRQ_EXTINT () {( &NUM_IO_INTS + 1);}' unless defined(&IRQ_EXTINT);
	eval 'sub IRQ_NMI () {( &NUM_IO_INTS + 2);}' unless defined(&IRQ_NMI);
	eval 'sub IRQ_SMI () {( &NUM_IO_INTS + 3);}' unless defined(&IRQ_SMI);
	eval 'sub IRQ_DISABLED () {( &NUM_IO_INTS + 4);}' unless defined(&IRQ_DISABLED);
	eval 'sub lapic_create {
	    my($apic_id,$boot_cpu) = @_;
    	    eval q({  ($apic_ops->{create})($apic_id, $boot_cpu); });
	}' unless defined(&lapic_create);
	eval 'sub lapic_init {
	    my($addr) = @_;
    	    eval q({  ($apic_ops->{init})($addr); });
	}' unless defined(&lapic_init);
	eval 'sub lapic_xapic_mode {
	    my($void) = @_;
    	    eval q({  ($apic_ops->{xapic_mode})(); });
	}' unless defined(&lapic_xapic_mode);
	eval 'sub lapic_is_x2apic {
	    my($void) = @_;
    	    eval q({ ( ($apic_ops->{is_x2apic})()); });
	}' unless defined(&lapic_is_x2apic);
	eval 'sub lapic_setup {
	    my($boot) = @_;
    	    eval q({  ($apic_ops->{setup})($boot); });
	}' unless defined(&lapic_setup);
	eval 'sub lapic_dump {
	    my($str) = @_;
    	    eval q({  ($apic_ops->{dump})($str); });
	}' unless defined(&lapic_dump);
	eval 'sub lapic_disable {
	    my($void) = @_;
    	    eval q({  ($apic_ops->{disable})(); });
	}' unless defined(&lapic_disable);
	eval 'sub lapic_eoi {
	    my($void) = @_;
    	    eval q({  ($apic_ops->{eoi})(); });
	}' unless defined(&lapic_eoi);
	eval 'sub lapic_id {
	    my($void) = @_;
    	    eval q({ ( ($apic_ops->{id})()); });
	}' unless defined(&lapic_id);
	eval 'sub lapic_intr_pending {
	    my($vector) = @_;
    	    eval q({ ( ($apic_ops->{intr_pending})($vector)); });
	}' unless defined(&lapic_intr_pending);
	eval 'sub apic_cpuid {
	    my($apic_id) = @_;
    	    eval q({ ( ($apic_ops->{cpuid})($apic_id)); });
	}' unless defined(&apic_cpuid);
	eval 'sub apic_alloc_vector {
	    my($apic_id,$irq) = @_;
    	    eval q({ ( ($apic_ops->{alloc_vector})($apic_id, $irq)); });
	}' unless defined(&apic_alloc_vector);
	eval 'sub apic_alloc_vectors {
	    my($apic_id,$irqs,$count,$align) = @_;
    	    eval q({ ( ($apic_ops->{alloc_vectors})($apic_id, $irqs, $count, $align)); });
	}' unless defined(&apic_alloc_vectors);
	eval 'sub apic_enable_vector {
	    my($apic_id,$vector) = @_;
    	    eval q({  ($apic_ops->{enable_vector})($apic_id, $vector); });
	}' unless defined(&apic_enable_vector);
	eval 'sub apic_disable_vector {
	    my($apic_id,$vector) = @_;
    	    eval q({  ($apic_ops->{disable_vector})($apic_id, $vector); });
	}' unless defined(&apic_disable_vector);
	eval 'sub apic_free_vector {
	    my($apic_id,$vector,$irq) = @_;
    	    eval q({  ($apic_ops->{free_vector})($apic_id, $vector, $irq); });
	}' unless defined(&apic_free_vector);
	eval 'sub lapic_enable_pmc {
	    my($void) = @_;
    	    eval q({ ( ($apic_ops->{enable_pmc})()); });
	}' unless defined(&lapic_enable_pmc);
	eval 'sub lapic_disable_pmc {
	    my($void) = @_;
    	    eval q({  ($apic_ops->{disable_pmc})(); });
	}' unless defined(&lapic_disable_pmc);
	eval 'sub lapic_reenable_pmc {
	    my($void) = @_;
    	    eval q({  ($apic_ops->{reenable_pmc})(); });
	}' unless defined(&lapic_reenable_pmc);
	eval 'sub lapic_enable_cmc {
	    my($void) = @_;
    	    eval q({  ($apic_ops->{enable_cmc})(); });
	}' unless defined(&lapic_enable_cmc);
	eval 'sub lapic_enable_mca_elvt {
	    my($void) = @_;
    	    eval q({ ( ($apic_ops->{enable_mca_elvt})()); });
	}' unless defined(&lapic_enable_mca_elvt);
	eval 'sub lapic_ipi_raw {
	    my($icrlo,$dest) = @_;
    	    eval q({  ($apic_ops->{ipi_raw})($icrlo, $dest); });
	}' unless defined(&lapic_ipi_raw);
	eval 'sub lapic_ipi_vectored {
	    my($vector,$dest) = @_;
    	    eval q({  ($apic_ops->{ipi_vectored})($vector, $dest); });
	}' unless defined(&lapic_ipi_vectored);
	eval 'sub lapic_ipi_wait {
	    my($delay) = @_;
    	    eval q({ ( ($apic_ops->{ipi_wait})($delay)); });
	}' unless defined(&lapic_ipi_wait);
	eval 'sub lapic_ipi_alloc {
	    my($ipifunc) = @_;
    	    eval q({ ( ($apic_ops->{ipi_alloc})($ipifunc)); });
	}' unless defined(&lapic_ipi_alloc);
	eval 'sub lapic_ipi_free {
	    my($vector) = @_;
    	    eval q({ ( ($apic_ops->{ipi_free})($vector)); });
	}' unless defined(&lapic_ipi_free);
	eval 'sub lapic_set_lvt_mask {
	    my($apic_id,$lvt,$masked) = @_;
    	    eval q({ ( ($apic_ops->{set_lvt_mask})($apic_id, $lvt, $masked)); });
	}' unless defined(&lapic_set_lvt_mask);
	eval 'sub lapic_set_lvt_mode {
	    my($apic_id,$lvt,$mode) = @_;
    	    eval q({ ( ($apic_ops->{set_lvt_mode})($apic_id, $lvt, $mode)); });
	}' unless defined(&lapic_set_lvt_mode);
	eval 'sub lapic_set_lvt_polarity {
	    my($apic_id,$lvt,$pol) = @_;
    	    eval q({ ( ($apic_ops->{set_lvt_polarity})($apic_id, $lvt, $pol)); });
	}' unless defined(&lapic_set_lvt_polarity);
	eval 'sub lapic_set_lvt_triggermode {
	    my($apic_id,$lvt,$trigger) = @_;
    	    eval q({ ( ($apic_ops->{set_lvt_triggermode})($apic_id, $lvt, $trigger)); });
	}' unless defined(&lapic_set_lvt_triggermode);
	if(defined(&_SYS_SYSCTL_H_)) {
	}
    }
}
1;
