require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_ENDIAN_H_)) {
    eval 'sub _MACHINE_ENDIAN_H_ () {1;}' unless defined(&_MACHINE_ENDIAN_H_);
    require 'sys/cdefs.ph';
    require 'sys/_types.ph';
    eval 'sub _QUAD_HIGHWORD () {1;}' unless defined(&_QUAD_HIGHWORD);
    eval 'sub _QUAD_LOWWORD () {0;}' unless defined(&_QUAD_LOWWORD);
    eval 'sub _LITTLE_ENDIAN () {1234;}' unless defined(&_LITTLE_ENDIAN);
    eval 'sub _BIG_ENDIAN () {4321;}' unless defined(&_BIG_ENDIAN);
    eval 'sub _PDP_ENDIAN () {3412;}' unless defined(&_PDP_ENDIAN);
    eval 'sub _BYTE_ORDER () { &_LITTLE_ENDIAN;}' unless defined(&_BYTE_ORDER);
    if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : undef)) {
	eval 'sub LITTLE_ENDIAN () { &_LITTLE_ENDIAN;}' unless defined(&LITTLE_ENDIAN);
	eval 'sub BIG_ENDIAN () { &_BIG_ENDIAN;}' unless defined(&BIG_ENDIAN);
	eval 'sub PDP_ENDIAN () { &_PDP_ENDIAN;}' unless defined(&PDP_ENDIAN);
	eval 'sub BYTE_ORDER () { &_BYTE_ORDER;}' unless defined(&BYTE_ORDER);
    }
    eval 'sub __bswap16_gen {
        my($x) = @_;
	    eval q(( &__uint16_t)(($x) << 8| ($x) >> 8));
    }' unless defined(&__bswap16_gen);
    eval 'sub __bswap32_gen {
        my($x) = @_;
	    eval q(((( &__uint32_t) &__bswap16(($x) & 0xffff) << 16) |  &__bswap16(($x) >> 16)));
    }' unless defined(&__bswap32_gen);
    eval 'sub __bswap64_gen {
        my($x) = @_;
	    eval q(((( &__uint64_t) &__bswap32(($x) & 0xffffffff) << 32) |  &__bswap32(($x) >> 32)));
    }' unless defined(&__bswap64_gen);
    if(defined(&__GNUCLIKE_BUILTIN_CONSTANT_P)) {
	eval 'sub __bswap16 {
	    my($x) = @_;
    	    eval q((( &__uint16_t)( &__builtin_constant_p($x) ?  &__bswap16_gen(( &__uint16_t)($x)) :  &__bswap16_var($x))));
	}' unless defined(&__bswap16);
	eval 'sub __bswap32 {
	    my($x) = @_;
    	    eval q(( &__builtin_constant_p($x) ?  &__bswap32_gen(( &__uint32_t)($x)) :  &__bswap32_var($x)));
	}' unless defined(&__bswap32);
	eval 'sub __bswap64 {
	    my($x) = @_;
    	    eval q(( &__builtin_constant_p($x) ?  &__bswap64_gen(( &__uint64_t)($x)) :  &__bswap64_var($x)));
	}' unless defined(&__bswap64);
    } else {
	eval 'sub __bswap16 {
	    my($x) = @_;
    	    eval q( &__bswap16_var($x));
	}' unless defined(&__bswap16);
	eval 'sub __bswap32 {
	    my($x) = @_;
    	    eval q( &__bswap32_var($x));
	}' unless defined(&__bswap32);
	eval 'sub __bswap64 {
	    my($x) = @_;
    	    eval q( &__bswap64_var($x));
	}' unless defined(&__bswap64);
    }
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub __bswap32_var {
        my($_x) = @_;
	    eval q({ });
    }' unless defined(&__bswap32_var);
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub __bswap64_var {
        my($_x) = @_;
	    eval q({ });
    }' unless defined(&__bswap64_var);
    eval 'sub __htonl {
        my($x) = @_;
	    eval q( &__bswap32($x));
    }' unless defined(&__htonl);
    eval 'sub __htons {
        my($x) = @_;
	    eval q( &__bswap16($x));
    }' unless defined(&__htons);
    eval 'sub __ntohl {
        my($x) = @_;
	    eval q( &__bswap32($x));
    }' unless defined(&__ntohl);
    eval 'sub __ntohs {
        my($x) = @_;
	    eval q( &__bswap16($x));
    }' unless defined(&__ntohs);
}
1;
