require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_REG_H_)) {
    eval 'sub _MACHINE_REG_H_ () {1;}' unless defined(&_MACHINE_REG_H_);
    require 'machine/_types.ph';
    if(defined(&__i386__)) {
	eval 'sub tFS () {(0);}' unless defined(&tFS);
	eval 'sub tES () {(1);}' unless defined(&tES);
	eval 'sub tDS () {(2);}' unless defined(&tDS);
	eval 'sub tEDI () {(3);}' unless defined(&tEDI);
	eval 'sub tESI () {(4);}' unless defined(&tESI);
	eval 'sub tEBP () {(5);}' unless defined(&tEBP);
	eval 'sub tISP () {(6);}' unless defined(&tISP);
	eval 'sub tEBX () {(7);}' unless defined(&tEBX);
	eval 'sub tEDX () {(8);}' unless defined(&tEDX);
	eval 'sub tECX () {(9);}' unless defined(&tECX);
	eval 'sub tEAX () {(10);}' unless defined(&tEAX);
	eval 'sub tERR () {(12);}' unless defined(&tERR);
	eval 'sub tEIP () {(13);}' unless defined(&tEIP);
	eval 'sub tCS () {(14);}' unless defined(&tCS);
	eval 'sub tEFLAGS () {(15);}' unless defined(&tEFLAGS);
	eval 'sub tESP () {(16);}' unless defined(&tESP);
	eval 'sub tSS () {(17);}' unless defined(&tSS);
	eval 'sub tGS () {(18);}' unless defined(&tGS);
    }
    if(defined(&__i386__)) {
	eval 'sub __reg32 () { &reg;}' unless defined(&__reg32);
	eval 'sub __fpreg32 () { &fpreg;}' unless defined(&__fpreg32);
	eval 'sub __dbreg32 () { &dbreg;}' unless defined(&__dbreg32);
    } else {
	eval 'sub __reg32 () { &reg32;}' unless defined(&__reg32);
	eval 'sub __reg64 () { &reg;}' unless defined(&__reg64);
	eval 'sub __fpreg32 () { &fpreg32;}' unless defined(&__fpreg32);
	eval 'sub __fpreg64 () { &fpreg;}' unless defined(&__fpreg64);
	eval 'sub __dbreg32 () { &dbreg32;}' unless defined(&__dbreg32);
	eval 'sub __dbreg64 () { &dbreg;}' unless defined(&__dbreg64);
	eval 'sub __HAVE_REG32 () {1;}' unless defined(&__HAVE_REG32);
    }
    eval 'sub DBREG_DR7_LOCAL_ENABLE () {0x1;}' unless defined(&DBREG_DR7_LOCAL_ENABLE);
    eval 'sub DBREG_DR7_GLOBAL_ENABLE () {0x2;}' unless defined(&DBREG_DR7_GLOBAL_ENABLE);
    eval 'sub DBREG_DR7_LEN_1 () {0x;}' unless defined(&DBREG_DR7_LEN_1);
    eval 'sub DBREG_DR7_LEN_2 () {0x1;}' unless defined(&DBREG_DR7_LEN_2);
    eval 'sub DBREG_DR7_LEN_4 () {0x3;}' unless defined(&DBREG_DR7_LEN_4);
    eval 'sub DBREG_DR7_LEN_8 () {0x2;}' unless defined(&DBREG_DR7_LEN_8);
    eval 'sub DBREG_DR7_EXEC () {0x;}' unless defined(&DBREG_DR7_EXEC);
    eval 'sub DBREG_DR7_WRONLY () {0x1;}' unless defined(&DBREG_DR7_WRONLY);
    eval 'sub DBREG_DR7_RDWR () {0x3;}' unless defined(&DBREG_DR7_RDWR);
    eval 'sub DBREG_DR7_MASK {
        my($i) = @_;
	    eval q((( &__u_register_t)(0xf) << (($i) * 4+ 16) | 0x3 << ($i) * 2));
    }' unless defined(&DBREG_DR7_MASK);
    eval 'sub DBREG_DR7_SET {
        my($i, $len, $access, $enable) = @_;
	    eval q((( &__u_register_t)(($len) << 2| ($access)) << (($i) * 4+ 16) | ($enable) << ($i) * 2));
    }' unless defined(&DBREG_DR7_SET);
    eval 'sub DBREG_DR7_GD () {0x2000;}' unless defined(&DBREG_DR7_GD);
    eval 'sub DBREG_DR7_ENABLED {
        my($d, $i) = @_;
	    eval q(((($d) & 0x3 << ($i) * 2) != 0));
    }' unless defined(&DBREG_DR7_ENABLED);
    eval 'sub DBREG_DR7_ACCESS {
        my($d, $i) = @_;
	    eval q((($d) >> (($i) * 4+ 16) & 0x3));
    }' unless defined(&DBREG_DR7_ACCESS);
    eval 'sub DBREG_DR7_LEN {
        my($d, $i) = @_;
	    eval q((($d) >> (($i) * 4+ 18) & 0x3));
    }' unless defined(&DBREG_DR7_LEN);
    eval 'sub DBREG_DRX {
        my($d,$x) = @_;
	    eval q((($d)-> $dr[($x)]));
    }' unless defined(&DBREG_DRX);
    undef(&__reg32) if defined(&__reg32);
    undef(&__reg64) if defined(&__reg64);
    undef(&__fpreg32) if defined(&__fpreg32);
    undef(&__fpreg64) if defined(&__fpreg64);
    undef(&__dbreg32) if defined(&__dbreg32);
    undef(&__dbreg64) if defined(&__dbreg64);
    if(defined(&_KERNEL)) {
	if(defined(&COMPAT_FREEBSD32)) {
	}
    }
}
1;
